/*
** FrameArc draws an arc of the oval that fits inside the specified rectangle,
** using the current grafPort's pen pattern, mode, and size.  StartAngle
** indicates where the arc begins and is treated MOD 360.  ArcAngle defines the
** extent of the arc.  The angles are given in positive or negative degrees; a
** positive angle goes clockwise, while a negative angle goes counterclockwise.
** Zero degrees is at 12 o'clock high, 90 (or -270) is at 3 o'clock, 180 (or
** -180) is at 6 o'clock, and 270 (or -90) is at 9 o'clock.  Other angles are
** measured relative to the enclosing rectangle:  A line from the center of the
** rectangle through its top right corner is at 45 degrees, even if the
** rectangle isn't square; a line through the bottom right corner is at 135
** degrees, and so on.
**
** The arc is as wide as the pen width and as tall as the pen height.  It's
** drawn with the pnPat, according to the pattern transfer mode specified by
** pnMode.  The pen location is not changed by this procedure.
*/

#include "../clunkdraw.h"
#include "cdarc.h"

void
FrameArc(rect, startAngle, arcAngle)
const Rect *rect;
short startAngle, arcAngle;
{
    _DrawArc(rect, 1, PaintRgn, startAngle, arcAngle, 0);
}
