/*
**	FONTSRC	Jim Cathey.
**	Program to convert a binary font file to an asm source.
*/

#include <stdio.h>

FILE *infd, *outfd;

main(argc, argv)
int argc;
char *argv[];
{
	int row, bit, byte, chr;
	
	if (argc != 3) {
		fprintf(stderr, "Usage:  %s <infile> <outfile>\n", argv[0]);
		exit(1);
	}
	if ((infd = fopen(argv[1], "r")) == 0) {
		fprintf(stderr, "Can't open %s\n", argv[1]);
		exit(2);
	}

	if ((outfd = fopen(argv[2], "w")) == 0) {
		fprintf(stderr, "Can't open %s\n", argv[1]);
		exit(3);
	}
	
	fprintf(outfd, "\t.globl normfnt,boldfnt\nboldfnt equ *\n\n");
	for (chr = 0; chr < 256; chr++) {
		fprintf(outfd, "char%02x", chr);
		for (row = 0; row < 16; row++) {
			byte = getc(infd);
			fprintf(outfd, "\t.dc.b %%");
			for (bit = 0; bit < 8; bit++) 
				fputc((byte & (1<<(7-bit))) ? '1' : '0', outfd);
			fputc('\n', outfd);
		}
		fprintf(outfd, "\n");
		if (ferror(infd) || ferror(outfd)) {
			fprintf(stderr, "File I/O error.");
			exit(4);
		}
		if (chr == 127)
			fprintf(outfd, "\nnormfnt equ *\n\n");
	}
	fprintf(outfd, "\t.end\n");
	fclose(infd);
	fclose(outfd);
	exit(0);
}
