/*
**	M E N U  D E F I N E S
*/
#define	FFILE		1
#define	FQUIT		1
#define FABOUT		2

#define AALARM		2
#define AOFF		1
#define AON			2
#define ASET		4

#define TTIME		3
#define TOFF		1
#define THMS2		3
#define THM2		4
#define THMS		5
#define THM			6
#define TAMPM		7
#define	TANALOG		9
#define	TANABOX		10

#define	DDATE		4
#define DOFF		1
#define	DUSA		3
#define DINT		4
#define DEUR		5

#define	CCOLORS		5
#define	CBLKWHT		1
#define	CBLUE		3
#define	CGREEN		4
#define CRED		5


/*
**	D E F I N E S
*/
#define OFF			0
#define ON			1
#define DONT_CARE	2

#define HMS2		1
#define HM2			2
#define HMS			3
#define HM			4
#define AMPM		5
#define ANALOG		6
#define ANABOX		7

#define USA			1
#define INTL		2
#define EUR			3

#define	BLKWHT		0
#define	BLUE		1
#define	GREEN		2
#define	RED			3

#define SEC			1
#define	MIN			2
#define	HOUR		3
#define DAY			4
#define MONTH		5
#define YEAR		6

#define	INITIALIZE	2

#define	MINAWIDTH	160
#define	MINAHEIGHT	160
#define MINDWIDTH	140
#define	MINDHEIGHT	64
#define MAXWIDTH	630
#define MAXHEIGHT	430

#define OFFSET_LEFT 15
#define OFFSET_TOP	10

/*
** buffer sizes
*/
#define TBUF_SIZE	50			/* Temporary buffer size */

struct alarm_set
{
	int			state;						/* alarm on or off */
	int			value;						/* alarm time value */
	char		sun;
	char		mon;
	char		tue;
	char		wed;
	char		thu;
	char		fri;
	char		sat;
};
typedef struct alarm_set Alarm_set;

struct timesetup
{
	Rect	watch_box;						/* watch display rectangle */
	short	h_xcord, h_ycord;				/* hand x and y coordinates */
	short	scale_factor, fudge_factor;		/* drawing scale and fudge factors */
	short	center, radius;					/* clock center and radius values */
	short	pwidth, pheight;				/* pen width and height values */

	int		old_hour, old_min, old_sec;
	int		old_year, old_mon, old_day;

	int		alarm_mode;						/* alarm status, on or off */
	Alarm_set	alarm_hr, alarm_min, alarm_sec;
	Alarm_set	alarm_year, alarm_mon, alarm_day;
	Alarm_set	alarm_bells, alarm_len;

	int		color_mode;						/* color display values */
	int		date_mode;						/* usa, intl, eur */
	int		time_mode;						/* time display mode */
};
typedef struct timesetup Time_setup;

/*
** The basic display building blocks are defined here
*/
struct user_polys
{
	PolyHandle	temp_poly;
	PolyHandle	user_poly;
	int			present_state;
};
typedef struct user_polys User_polys;

struct user_digit
{
	User_polys	led[7];
	int		digit_mask;
};
typedef struct user_digit Digits;

struct user_colon
{
	User_polys	top;
	User_polys	bot;
};
typedef struct user_colon Colons;

struct user_slash
{
	User_polys slant;
};
typedef struct user_slash Slash;

/*
** The Digital Clock display is defined with these two structs
*/
struct user_segments
{
	Digits	least;
	Digits	most;
	Colons	colon;
};
typedef struct user_segments Segments;

struct digital_clock
{
	Segments	seconds;
	Segments	minutes;
	Segments	hours;
};
typedef struct digital_clock Clock;

/*
** The Date display is defined with these two structs
*/
struct date_segments
{
	Digits	least;
	Digits	most;
	Slash	slash;
};
typedef struct date_segments DSegments;

struct digital_date
{
	DSegments	day;
	DSegments	month;
	DSegments	year;
};
typedef struct digital_date Date;
