
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

#include <isc/keycodes.h>
#include <isc/window.h>
#include <isc/controls.h>
#include <isc/textedit.h>
#include <isc/dlgman.h>

#include "clock.h"
#include "Dalarm.h"

extern Time_setup	clockdata;
extern struct tm	*ltime;
extern DMItem		Dalarm[];
extern int			windowid;

extern int			errno;

DMDcb	*cbp;

static char rcsid[] = "$Header: /usr/users/window/clock/RCS/clock_alrm.c,v 1.1 1994/03/22 18:36:11 daleb Exp $";
/*eject*/
do_alarm_set()
{
	int	group, retval;
	EventRecord	*ep;

	retval = 0;
	cbp = DMNew(Dalarm, windowid, 0);
	if (clockdata.time_mode == HMS ||
		clockdata.time_mode == HM  ||
		clockdata.time_mode == AMPM) {
		DMItemGrpEnable(cbp, 7);
		DMItemGrpShow(cbp, 7);
	}
	else {
		DMItemGrpDisable(cbp, 7);
		DMItemGrpHide(cbp, 7);
	}
	if (clockdata.alarm_day.state != OFF) {
		DMItemGrpEnable(cbp, 51);
		DMItemGrpShow(cbp, 51);
	}
	else {
		DMItemGrpDisable(cbp, 51);
		DMItemGrpHide(cbp, 51);
	}
	group = DMCollect(cbp);
	if (group == DMok) {
		retval = 1;
	}
	DMDisposeNoInval(cbp);
	return retval;
}
/*eject*/
/*
**	PREFILLS FOR ALARM DIALOG RADIO BUTTONS
*/
int	PF_seconds(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_sec.state == dip->usercode) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_minutes(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_min.state == dip->usercode) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_hours(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_hr.state == dip->usercode) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_ampm(DMDcb *cbp, DMItem *dip, int *value)
{
	if (ltime->tm_hour > 11 &&
		dip->usercode == 1) {
		*value = 1;
	}
	else if (ltime->tm_hour < 12 &&
		dip->usercode == 0) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_days(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_day.state == dip->usercode) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_month(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_mon.state == dip->usercode) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_year(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_year.state == dip->usercode) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}
/*eject*/
/*
**	PREFILLS FOR ALARM DIALOG CHECK BOXES
*/
int	PF_sun(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_day.sun) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_mon(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_day.mon) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_tue(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_day.tue) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_wed(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_day.wed) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_thu(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_day.thu) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_fri(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_day.fri) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}

int	PF_sat(DMDcb *cbp, DMItem *dip, int *value)
{
	if (clockdata.alarm_day.sat) {
		*value = 1;
	}
	else {
		*value = 0;
	}
}
/*eject*/
/*
**	PREFILLS FOR ALARM TEXT EDIT BOXES
*/
int	PF_te_seconds(DMDcb *cbp, DMItem *dip, char *cp)
{
	mysprintf(cp, "%d", clockdata.alarm_sec.value);
}

int	PF_te_minutes(DMDcb *cbp, DMItem *dip, char *cp)
{
	mysprintf(cp, "%d", clockdata.alarm_min.value);
}

int	PF_te_hours(DMDcb *cbp, DMItem *dip, char *cp)
{
	mysprintf(cp, "%d", clockdata.alarm_hr.value);
}

int	PF_te_days(DMDcb *cbp, DMItem *dip, char *cp)
{
	mysprintf(cp, "%d", clockdata.alarm_day.value);
}

int	PF_te_month(DMDcb *cbp, DMItem *dip, char *cp)
{
	mysprintf(cp, "%d", clockdata.alarm_mon.value);
}

int	PF_te_year(DMDcb *cbp, DMItem *dip, char *cp)
{
	mysprintf(cp, "%d", clockdata.alarm_year.value);
}
/*eject*/
/*
**	VALIDATIONS FOR ALARM DIALOG RADIO BUTTONS
*/
int	VAL_seconds(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	if(!value) {
		clockdata.alarm_sec.state = dip->usercode;
		if (clockdata.alarm_sec.state == ON) {
			DMTEActivate(cbp, DALARM_seconds);
		}
		return(DM_PASS);
	}
	else {
		return(DM_FAIL);
	}
}

int	VAL_minutes(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	if(!value) {
		clockdata.alarm_min.state = dip->usercode;
		if (clockdata.alarm_min.state == ON) {
			DMTEActivate(cbp, DALARM_minutes);
		}
		return(DM_PASS);
	}
	else {
		return(DM_FAIL);
	}
}

int	VAL_hours(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	if(!value) {
		clockdata.alarm_hr.state = dip->usercode;
		if (clockdata.alarm_hr.state == ON) {
			DMTEActivate(cbp, DALARM_hours);
		}
		return(DM_PASS);
	}
	else {
		return(DM_FAIL);
	}
}

int	VAL_ampm(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	if(!value) {
		clockdata.alarm_hr.sun = dip->usercode;
		return(DM_PASS);
	}
	else {
		return(DM_FAIL);
	}
}

int	VAL_days(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	if(!value) {
		clockdata.alarm_day.state = dip->usercode;
		if (clockdata.alarm_day.state == ON) {
			DMTEActivate(cbp, DALARM_days);
			DMItemGrpEnable(cbp, 51);
			DMItemGrpShow(cbp, 51);
		}
		else {
			DMItemGrpDisable(cbp, 51);
			DMItemGrpHide(cbp, 51);
		}
		return(DM_PASS);
	}
	else {
		return(DM_FAIL);
	}
}

int	VAL_month(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	if(!value) {
		clockdata.alarm_mon.state = dip->usercode;
		if (clockdata.alarm_mon.state == ON) {
			DMTEActivate(cbp, DALARM_months);
		}
		return(DM_PASS);
	}
	else {
		return(DM_FAIL);
	}
}

int	VAL_year(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	if(!value) {
		clockdata.alarm_year.state = dip->usercode;
		if (clockdata.alarm_year.state == ON) {
			DMTEActivate(cbp, DALARM_years);
		}
		return(DM_PASS);
	}
	else {
		return(DM_FAIL);
	}
}
/*eject*/
/*
**	VALIDATIONS FOR ALARM DIALOG CHECK BOXES
*/
int	VAL_sun(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	clockdata.alarm_day.sun = !value;
	return(DM_PASS);
}

int	VAL_mon(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	clockdata.alarm_day.mon = !value;
	return(DM_PASS);
}

int	VAL_tue(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	clockdata.alarm_day.tue = !value;
	return(DM_PASS);
}

int	VAL_wed(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	clockdata.alarm_day.wed = !value;
	return(DM_PASS);
}

int	VAL_thu(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	clockdata.alarm_day.thu = !value;
	return(DM_PASS);
}

int	VAL_fri(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	clockdata.alarm_day.fri = !value;
	return(DM_PASS);
}

int	VAL_sat(DMDcb *cbp, DMItem *dip, unsigned char when, short value, short partcode)
{
	clockdata.alarm_day.sat = !value;
	return(DM_PASS);
}
/*eject*/
/*
**	VALIDATIONS FOR ALARM DIALOG TEXT EDIT BOXES
*/
int	VAL_te_seconds(DMDcb *cbp, DMItem *dip, unsigned char when, DMTEVal *arg)
{
	int		result;

	if (when == DMWhileBefore) {
		return(DMValNumeric(cbp, dip, when, arg->keycode, 2, 1, 60));
	}
	else {
		if ((result = DMValNumeric(cbp, dip, when, arg->text, 2, 1, 60)) == DM_PASS) {
			clockdata.alarm_sec.value = (myatoi(arg->text) - 1);
			return DM_PASS;
		}
		else {
			if (clockdata.alarm_sec.state == ON) {
				return DM_FAIL;
			}
			else {
				return DM_PASS;
			}
		}
	}
}

int	VAL_te_minutes(DMDcb *cbp, DMItem *dip, unsigned char when, DMTEVal *arg)
{
	int		result;

	if (when == DMWhileBefore) {
		return(DMValNumeric(cbp, dip, when, arg->keycode, 2, 1, 60));
	}
	else {
		if ((result = DMValNumeric(cbp, dip, when, arg->text, 2, 1, 60)) == DM_PASS) {
			clockdata.alarm_min.value = (myatoi(arg->text) - 1);
			return DM_PASS;
		}
		else {
			if (clockdata.alarm_min.state == ON) {
				return DM_FAIL;
			}
			else {
				return DM_PASS;
			}
		}
	}
}

int	VAL_te_hours(DMDcb *cbp, DMItem *dip, unsigned char when, DMTEVal *arg)
{
	int		result;

	if (when == DMWhileBefore) {
		return(DMValNumeric(cbp, dip, when, arg->keycode, 2, 1, 24));
	}
	else {
		if ((result = DMValNumeric(cbp, dip, when, arg->text, 2, 1, 24)) == DM_PASS) {
			clockdata.alarm_hr.value = (myatoi(arg->text) - 1);
			return DM_PASS;
		}
		else {
			if (clockdata.alarm_hr.state == ON) {
				return DM_FAIL;
			}
			else {
				return DM_PASS;
			}
		}
	}
}

int	VAL_te_days(DMDcb *cbp, DMItem *dip, unsigned char when, DMTEVal *arg)
{
	int		result;

	if (when == DMWhileBefore) {
		return(DMValNumeric(cbp, dip, when, arg->keycode, 2, 1, 31));
	}
	else {
		if ((result = DMValNumeric(cbp, dip, when, arg->text, 2, 1, 31)) == DM_PASS) {
			clockdata.alarm_day.value = myatoi(arg->text);
			return DM_PASS;
		}
		else {
			if (clockdata.alarm_day.state == ON && 
				(clockdata.alarm_day.sun == OFF &&
				 clockdata.alarm_day.mon == OFF &&
				 clockdata.alarm_day.tue == OFF &&
				 clockdata.alarm_day.wed == OFF &&
				 clockdata.alarm_day.thu == OFF &&
				 clockdata.alarm_day.fri == OFF &&
				 clockdata.alarm_day.sat == OFF)) {
				return DM_FAIL;
			}
			else {
				return DM_PASS;
			}
		}
	}
}

int	VAL_te_month(DMDcb *cbp, DMItem *dip, unsigned char when, DMTEVal *arg)
{
	int		result;

	if (when == DMWhileBefore) {
		return(DMValNumeric(cbp, dip, when, arg->keycode, 2, 1, 12));
	}
	else {
		if ((result = DMValNumeric(cbp, dip, when, arg->text, 2, 1, 12)) == DM_PASS) {
			clockdata.alarm_mon.value = (myatoi(arg->text) - 1);
			return DM_PASS;
		}
		else {
			if (clockdata.alarm_mon.state == ON) {
				return DM_FAIL;
			}
			else {
				return DM_PASS;
			}
		}
	}
}

int	VAL_te_year(DMDcb *cbp, DMItem *dip, unsigned char when, DMTEVal *arg)
{
	int		result;

	if (when == DMWhileBefore) {
		return(DMValNumeric(cbp, dip, when, arg->keycode, 4, 1900, 2000));
	}
	else {
		if ((result = DMValNumeric(cbp, dip, when, arg->text, 4, 1900, 2000)) == DM_PASS) {
			clockdata.alarm_year.value = myatoi((arg->text) - 1900);
			return DM_PASS;
		}
		else {
			if (clockdata.alarm_year.state == ON) {
				return DM_FAIL;
			}
			else {
				return DM_PASS;
			}
		}
	}
}
