#include <time.h>
#include <isc/window.h>
#include "clock.h"

extern struct timesetup	clockdata;
extern struct tm *ltime;
extern Date ddigital;

/*
** if any digit of new date is different from old date, change the appropriate
** display elements.  Otherwise, just leave things alone.
*/
draw_date_leds(state)
int state;
{
	short year_pos, month_pos, day_pos;

	switch(clockdata.date_mode) {
		case USA:
			month_pos = 0;
			day_pos =   (30 * clockdata.scale_factor);
			year_pos =  (65 * clockdata.scale_factor);
			break;
		case INTL:
			year_pos =  0;
			month_pos = (30 * clockdata.scale_factor);
			day_pos =   (65 * clockdata.scale_factor);
			break;
		case EUR:
			day_pos =   0;
			month_pos = (30 * clockdata.scale_factor);
			year_pos =  (65 * clockdata.scale_factor);
			break;
	}

	if (state == INITIALIZE) {
		do_segments(DAY,   clockdata.watch_box.edge.left + OFFSET_LEFT + day_pos,   clockdata.watch_box.edge.top + OFFSET_TOP, state);
		do_segments(MONTH, clockdata.watch_box.edge.left + OFFSET_LEFT + month_pos, clockdata.watch_box.edge.top + OFFSET_TOP, state);
		do_segments(YEAR,  clockdata.watch_box.edge.left + OFFSET_LEFT + year_pos,  clockdata.watch_box.edge.top + OFFSET_TOP, state);
	}
	else {
		if (clockdata.old_day != ltime->tm_mday) {
			do_segments(DAY,   clockdata.watch_box.edge.left + OFFSET_LEFT + day_pos,   clockdata.watch_box.edge.top + OFFSET_TOP, state);
		}

		if (clockdata.old_mon != ltime->tm_mon + 1) {
			do_segments(DAY,   clockdata.watch_box.edge.left + OFFSET_LEFT + day_pos,   clockdata.watch_box.edge.top + OFFSET_TOP, state);
			do_segments(MONTH, clockdata.watch_box.edge.left + OFFSET_LEFT + month_pos, clockdata.watch_box.edge.top + OFFSET_TOP, state);
		}

		if (clockdata.old_year != ltime->tm_year) {
			do_segments(DAY,   clockdata.watch_box.edge.left + OFFSET_LEFT + day_pos,   clockdata.watch_box.edge.top + OFFSET_TOP, state);
			do_segments(MONTH, clockdata.watch_box.edge.left + OFFSET_LEFT + month_pos, clockdata.watch_box.edge.top + OFFSET_TOP, state);
			do_segments(YEAR,  clockdata.watch_box.edge.left + OFFSET_LEFT + year_pos,  clockdata.watch_box.edge.top + OFFSET_TOP, state);
		}
	}
}

clear_date_leds(clock)
Date *clock;
{
	int	i;

	for (i = 0; i < 8; i++) {
		clear_this_poly(&clock->day.least.led[i]);
		clear_this_poly(&clock->day.most.led[i]);
		clear_this_poly(&clock->month.least.led[i]);
		clear_this_poly(&clock->month.most.led[i]);
		clear_this_poly(&clock->year.least.led[i]);
		clear_this_poly(&clock->year.most.led[i]);
	}
	clear_this_poly(&clock->day.slash);
	clear_this_poly(&clock->month.slash);
	clear_this_poly(&clock->year.slash);
}
