/*
**	C L O C K
**
**	Written by: Dale Bennett
**	Date: 5-5-90
**
*/

/*
**	I N C L U D E S
#include <string.h>
*/
#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <dnix/fcodes.h>
#include <isc/keycodes.h>
#include <isc/window.h>
#include <isc/controls.h>
#include <isc/textedit.h>
#include "clock.h"

/*
**	E X T E R N S
*/
extern	int		errno;

/*
**	G L O B A L S
**
**	General
*/
Point		hit;
struct tm	*ltime;

/*
**	Window Variables
*/
Rect		icnrect;					/* Window rectangles	*/
Rect		winrect;

short		xpos		= 5;
short		ypos		= 45;

short		width;
short		height;

FontInfo	finfo;

char		*path;
char		title[50]	= "CLOCK";

int			trapqfd;
int			windowid;
int			iconified	= 0;
static int	firstactive = 1;

/*
** Clock Variables
*/
User_polys	hour_hand	= {0,0};
User_polys	min_hand	= {0,0};
Clock		digital;
Date		ddigital;
Time_setup	clockdata;

/*
**	F U N C T I O N S
*/
void 	windowevent();
void 	updateevent();
void	activatevent();
void 	menuevent();
void 	mouseevent();
void	keyevent();
/*eject*/
/*
**	M A I N   F U N C T I O N
*/
main(argc, argv)
int argc;
char *argv[];
{
    int		i, j;
    int		fd;
	int		st_window = frontWindow;
    char	*cp;
	char	buf[100];
	EventRecord *ep;

	/*
	** initialize clock structures
	*/
	clockdata.pwidth			= 1;
	clockdata.pheight			= 1;

	clockdata.alarm_sec.state	= OFF;
	clockdata.alarm_sec.value	= 0;
	clockdata.alarm_min.state	= OFF;
	clockdata.alarm_min.value	= 0;
	clockdata.alarm_hr.state	= OFF;
	clockdata.alarm_hr.value	= 0;
	clockdata.alarm_day.state	= OFF;
	clockdata.alarm_day.value	= 0;
	clockdata.alarm_mon.state	= OFF;
	clockdata.alarm_mon.value	= 0;
	clockdata.alarm_year.state	= OFF;
	clockdata.alarm_year.value	= 0;

	clockdata.alarm_len.value	= 5;
	clockdata.alarm_bells.value	= 2;

	clockdata.alarm_mode		= OFF;
	clockdata.time_mode			= HMS2;
	clockdata.date_mode			= OFF;
	clockdata.color_mode		= BLKWHT;

	/*
	**	Check for any Startup Switches
	*/
	for( i = 1; argc > 1; argc--, i++ ) {
		cp = argv[i] + 2;
		if( strncmp( argv[i], "-a", 2 ) == 0 ) {
			clockdata.time_mode = ANALOG;
		}
		else if (strncmp(argv[i], "-b", 2) == 0) {
			clockdata.alarm_bells.value = myatoi(cp);
		}
		else if (strncmp(argv[i], "-c", 2) == 0) {
			clockdata.color_mode = myatoi(cp);
			if(clockdata.color_mode > RED) {
				clockdata.color_mode = BLKWHT;
			}
		}
		else if (strncmp(argv[i], "-d", 2) == 0) {
			clockdata.time_mode = HMS2;
		}
		else if (strncmp(argv[i], "-i", 2) == 0) {
			iconified = 1;
		}
		else if (strncmp(argv[i], "-l", 2) == 0) {
			clockdata.alarm_len.value = myatoi(cp);
		}
		else if (strncmp(argv[i], "-s", 2) == 0) {
			st_window = secondWindow;
		}
		else if (strncmp(argv[i], "-U", 2) == 0) {
			usage();
			exit(1);
		}
		else if (strncmp(argv[i], "-V", 2) == 0) {
			PrintRelInfo();
			exit(1);
		}
		else if (strncmp(argv[i], "-x", 2) == 0) {
			xpos = (int)myatoi(cp);
		}
		else if (strncmp(argv[i], "-y", 2) == 0) {
			ypos = (int)myatoi(cp);
		}
		else {
			path = argv[i];
		}
	}

	/* 
	**	Initialize graphics toolbox
	*/
	if ((trapqfd = InitGraf()) < 0) {
		strcpy(buf, "Error ");
		strcat(buf, myitoa(-trapqfd));
		strcat(buf, " in GrafInit\n");
		write(2, buf, strlen(buf));
		exit(1);
	}

	/* 
	**	Establish connection to a window manager
	*/
	if ((fd = ConnectGraf(path)) < 0) {
		strcpy(buf, "Error ");
		strcat(buf, myitoa(-fd));
		strcat(buf, " in ConnectGraf\n");
		write(2, buf, strlen(buf));
		exit(1);
	}

	/*
	**	Create a window
	*/
	initial_window_size();
	SetRect(&winrect, xpos, ypos, xpos+width, ypos+height);
	SetRect(&icnrect, 0, 0, 32, 32);
	windowid = NewWindow(&winrect, title, showWindow, documentProc, 
			   st_window, hasGoAway|hasZoom|hasSendToBack|hasGrow|hasDrag, fd);
	SetPort(windowid);

	/*
	**	Put up Menus
	*/
    NewMenu(FFILE, "File");
	AppendMenu(FFILE, "/QQuit;About...");

	NewMenu(AALARM, "Alarm");
	AppendMenu(AALARM, "Off;On;-;Set...");
	CheckItem(AALARM, AOFF, clockdata.alarm_mode == OFF);
	CheckItem(AALARM, AON, clockdata.alarm_mode == ON);
	DisableMenu(AALARM);

	NewMenu(TTIME, "Time");
	AppendMenu(TTIME, "Off;-;23:59:59;23:59;12:59:59;12:59;12:59am;-;Analog;Boxes");
	CheckItem(TTIME, TOFF, clockdata.time_mode == OFF);
	CheckItem(TTIME, THMS2, clockdata.time_mode == HMS2);
	CheckItem(TTIME, THM2, clockdata.time_mode == HM2);
	CheckItem(TTIME, THMS, clockdata.time_mode == HMS);
	CheckItem(TTIME, THM, clockdata.time_mode == HM);
	CheckItem(TTIME, TAMPM, clockdata.time_mode == AMPM);
	CheckItem(TTIME, TANALOG, clockdata.time_mode == ANALOG);
	CheckItem(TTIME, TANABOX, clockdata.time_mode == ANABOX);
	DisableItem(TTIME, TOFF);
	DisableItem(TTIME, TAMPM);

	NewMenu(DDATE, "Date");
	AppendMenu(DDATE, "Off;-;USA;International;European");
	CheckItem(DDATE, DOFF, clockdata.date_mode == OFF);
	CheckItem(DDATE, DUSA, clockdata.date_mode == USA);
	CheckItem(DDATE, DINT, clockdata.date_mode == INTL);
	CheckItem(DDATE, DEUR, clockdata.date_mode == EUR);
	DisableMenu(DDATE);

    NewMenu(CCOLORS, "Color");
	AppendMenu(CCOLORS, "None;-;One;Two;Three");
	CheckItem(CCOLORS, CBLKWHT, clockdata.color_mode == BLKWHT);
	CheckItem(CCOLORS, CBLUE, clockdata.color_mode == BLUE);
	CheckItem(CCOLORS, CGREEN, clockdata.color_mode == GREEN);
	CheckItem(CCOLORS, CRED, clockdata.color_mode == RED);
	DisableMenu(CCOLORS);

	/*
	**	Bind events
	*/
	Event(windowEvt, windowevent);
	Event(updateEvt, updateevent);
    Event(activateEvt, activatevent);
	Event(menuEvt, menuevent);
	Event(mouseEvt, mouseevent);
	Event(keyEvt, keyevent);

	/*
	**	Set modes
	*/
	MouseMode(F_KEYDOWN | F_KEYUP | F_MOUSE1);
	PenMode(srcOr);

	/*
	**	Initialize Controls
	*/
	InitControls();
    TEInit(0, normalText);

	clear_clock(&digital, INITIALIZE);
	clear_date(&ddigital, INITIALIZE);
	clear_this_poly(&min_hand, INITIALIZE);
	clear_this_poly(&hour_hand, INITIALIZE);

	do_size_calc();

	if (iconified)
	{
		IconifyWindow(windowid);
	}

	timer(0, -1, 0);	/* start timer, -1 indicates don't paint hands */

	/*
	**	Loop until a release occurs or exit if an error occurs
	*/
#ifdef DEBUG
	fprintf(stderr, "enter GetEvent loop\n");
#endif
	for(;;) {
		ep = GetEvent(noWindow, noEvent);
		if(ep < 0) {
			strcpy(buf, "ERROR, GetEvent(noWindow, noEvent) returned 0x");
			strcat(buf, myitoa(ep));
			strcat(buf, "\n");
			write(2, buf, strlen(buf));
			exit(1);
		}
 	}
}
/*eject*/
/*
**	W I N D O W   E V E N T S
*/
void windowevent(ep)
EventRecord *ep;
{
	Rect rect;

#ifdef DEBUG
	fprintf(stderr, "enter windowevent\n");
#endif
	SetPort(ep->who);
	switch (ep->message & F_KEYMASK) {
		case windowGoaway:
			exit(0);
			break;

		case windowMove:
			xpos += ep->where.edge.left;
			ypos += ep->where.edge.top;
			MoveWindow(ep->who, xpos, ypos, 0);
			break;

		case windowResize:
			if (!iconified) {
				clear_window();
				if (clockdata.time_mode == ANALOG ||
					clockdata.time_mode == ANABOX) {
					clear_this_poly(&hour_hand);
					clear_this_poly(&min_hand);
				}
				height += ep->where.edge.top;
				width += ep->where.edge.left;
				calc_window_size();
				SizeWindow(ep->who, width, height, updateRequest);
			}
			break;

		case windowZoom:
			if (clockdata.time_mode == ANALOG ||
				clockdata.time_mode == ANABOX) {
				clear_this_poly(&hour_hand);
				clear_this_poly(&min_hand);
			}
			if (iconified) {
				/* Zoom Up */
			    UnIconifyWindow(ep->who);
			    EnableMenu(FFILE);
/*			    EnableMenu(AALARM);*/
			    EnableMenu(TTIME);
/*			    EnableMenu(DDATE);*/
/*			    EnableMenu(CCOLORS);*/
			}
			else {
				/* Zoom Down */
			    IconifyWindow(ep->who);
			    DisableMenu(FFILE);
			    DisableMenu(AALARM);
			    DisableMenu(TTIME);
			    DisableMenu(DDATE);
			    DisableMenu(CCOLORS);
			}
			iconified = !iconified;
			do_size_calc();
			break;
	}
#ifdef DEBUG
	fprintf(stderr, "exit windowevent\n");
#endif
}
/*eject*/
/*
**	U P D A T E   E V E N T S
*/
void updateevent(ep)
EventRecord *ep;
{
	Rect	rect;

#ifdef DEBUG
	fprintf(stderr, "enter updateevent\n");
#endif
	SetPort(ep->who);
	BeginUpdateRect(ep->who, &ep->where);
	if (clockdata.time_mode == ANALOG ||
		clockdata.time_mode == ANABOX) {
		clear_this_poly(&hour_hand);
		clear_this_poly(&min_hand);
	}
	else {
		if (clockdata.time_mode != OFF) {
			clear_clock(&digital, ON);
		}
		if (clockdata.date_mode != OFF) {
			clear_date(&ddigital, ON);
		}
	}
	clockdata.old_sec = 0;
	clockdata.old_min = 0;
	clockdata.old_hour = 0;
	clockdata.old_day = 0;
	clockdata.old_mon = 0;
	clockdata.old_year = 0;
	do_size_calc();
	if(!iconified) {
		draw_clk_face();
		if (clockdata.time_mode == ANALOG ||
			clockdata.time_mode == ANABOX) {
			draw_analog_arms();
		}
		else {
			if (clockdata.time_mode != OFF) {
				draw_digital_leds(ON);
			}
			if (clockdata.date_mode != OFF) {
				draw_date_leds(ON);
			}
		}
	}
	else {
		draw_icon();
		draw_analog_arms();
	}
	EndUpdate(ep->who);
#ifdef DEBUG
	fprintf(stderr, "exit updateevent\n");
#endif
}
/*eject*/
/*
**	A C T I V A T E   E V E N T S
*/
void
activatevent(ep)
EventRecord *ep;
{
	short i;

#ifdef DEBUG
	fprintf(stderr, "enter activatevent\n");
#endif
	if (firstactive) {
		/* Skip first activate event because all the controls */
		/* were created active.  Saves on startup time. */
		firstactive = 0;
#ifdef DEBUG
		fprintf(stderr, "exit activatevent\n");
#endif
		return;
	}
	if (iconified) {
		/* Iconified window is inactive, do nothing. */
#ifdef DEBUG
		fprintf(stderr, "exit activatevent\n");
#endif
		return;
	}

	SetPort(ep->who);
	if (ep->message & 1) {
		/* Activating? */
		Notify(windowid, noNotify);
	}
	else {
		/* Deactivating. */
		;
    }
#ifdef DEBUG
	fprintf(stderr, "exit activatevent\n");
#endif
}
/*eject*/
/*
**	M E N U   E V E N T S
*/
void menuevent(ep)
EventRecord *ep;
{
	short		save_width, save_height;
	int			save_alarm_mode, save_time_mode, save_date_mode;
	int			menuid, menuitem;
	int			epmsg;
	Rect		tr, rect;

#ifdef DEBUG
	fprintf(stderr, "enter menuevent\n");
#endif
	BeginMenu(ep->message);
	menuid = ep->message >> 16;
	menuitem = ep->message & 0xffff;
	epmsg = ep->message;
	switch(menuid) {
		case FFILE:
			switch(menuitem) {
				case FQUIT:
					exit(0);
					break;

				case FABOUT:
					save_time_mode = clockdata.time_mode;
					save_date_mode = clockdata.date_mode;
					if (clockdata.time_mode != OFF) {
						clockdata.time_mode = OFF;
					}
					if (clockdata.date_mode != OFF) {
						clockdata.date_mode = OFF;
					}
					clear_window();
					save_width = width;
					save_height = height;
					if (width < 375) {
						width = 375;
					}
					if (height < 210) {
						height = 210;
					}
					SizeWindow(ep->who, width, height, updateRequest);
					do_about();
					clockdata.time_mode = save_time_mode;
					clockdata.date_mode = save_date_mode;
					if (width != save_width ||
						height != save_height) {
						width = save_width;
						height = save_height;
					}
					SizeWindow(ep->who, width, height, updateRequest);
					clear_window();
					break;
			}
			break;

		case AALARM:
			switch(menuitem) {
				case AOFF:
					clockdata.alarm_mode = OFF;
					break;

				case AON:
					clockdata.alarm_mode = ON;
					break;

				case ASET:
					save_time_mode = clockdata.time_mode;
					save_date_mode = clockdata.date_mode;
					save_alarm_mode = clockdata.alarm_mode;
					if (clockdata.time_mode != OFF) {
/*						clockdata.time_mode = OFF;*/
					}
					if (clockdata.date_mode != OFF) {
						clockdata.date_mode = OFF;
					}
					clear_window();
					save_width = width;
					save_height = height;
					if (width < 350) {
						width = 350;
					}
					if (height < 375) {
						height = 375;
					}
					SizeWindow(ep->who, width, height, updateRequest);
					clockdata.alarm_mode = INITIALIZE;
					if (do_alarm_set()) {
						clockdata.alarm_mode = ON;
					}
					else {
						clockdata.alarm_mode = save_alarm_mode;
					}
					clockdata.time_mode = save_time_mode;
					clockdata.date_mode = save_date_mode;
					if (width != save_width ||
						height != save_height) {
						width = save_width;
						height = save_height;
					}
					SizeWindow(ep->who, width, height, updateRequest);
					clear_window();
					break;
			}
			CheckItem(AALARM, AOFF, clockdata.alarm_mode == OFF);
			CheckItem(AALARM, AON, clockdata.alarm_mode == ON);
			break;

		case TTIME:
			switch(menuitem) {
				case TOFF:
					clockdata.time_mode = OFF;
					break;

				case THMS2:
					clockdata.time_mode = HMS2;
					break;

				case THM2:
					clockdata.time_mode = HM2;
					break;

				case THMS:
					clockdata.time_mode = HMS;
					break;

				case THM:
					clockdata.time_mode = HM;
					break;

				case TAMPM:
					clockdata.time_mode = AMPM;
					break;

				case TANALOG:
					clockdata.time_mode = ANALOG;
					break;

				case TANABOX:
					clockdata.time_mode = ANABOX;
					break;
			}
			CheckItem(TTIME, TOFF, clockdata.time_mode == OFF);
			CheckItem(TTIME, THMS2, clockdata.time_mode == HMS2);
			CheckItem(TTIME, THM2, clockdata.time_mode == HM2);
			CheckItem(TTIME, THMS, clockdata.time_mode == HMS);
			CheckItem(TTIME, THM, clockdata.time_mode == HM);
			CheckItem(TTIME, TAMPM, clockdata.time_mode == AMPM);
			CheckItem(TTIME, TANALOG, clockdata.time_mode == ANALOG);
			CheckItem(TTIME, TANABOX, clockdata.time_mode == ANABOX);
			clear_window();
			if (!iconified) {
				calc_window_size();
				SizeWindow(ep->who, width, height, updateRequest);
			}
			break;

		case DDATE:
			switch(menuitem) {
				case DOFF:
					clockdata.date_mode = OFF;
					break;

				case DUSA:
					clockdata.date_mode = USA;
					break;

				case DINT:
					clockdata.date_mode = INTL;
					break;

				case DEUR:
					clockdata.date_mode = EUR;
					break;
			}
			CheckItem(DDATE, DOFF, clockdata.date_mode == OFF);
			CheckItem(DDATE, DUSA, clockdata.date_mode == USA);
			CheckItem(DDATE, DINT, clockdata.date_mode == INTL);
			CheckItem(DDATE, DEUR, clockdata.date_mode == EUR);
			clear_window();
			if (!iconified) {
				calc_window_size();
				SizeWindow(ep->who, width, height, updateRequest);
			}
			break;

		case CCOLORS:
			switch(menuitem) {
				case  CBLKWHT:
					clockdata.color_mode = BLKWHT;
					break;

				case  CBLUE:
					clockdata.color_mode = BLUE;
					break;

				case  CGREEN:
					clockdata.color_mode = GREEN;
					break;

				case  CRED:
					clockdata.color_mode = RED;
					break;
			}
			CheckItem(CCOLORS, CBLKWHT, clockdata.color_mode == BLKWHT);
			CheckItem(CCOLORS, CBLUE, clockdata.color_mode == BLUE);
			CheckItem(CCOLORS, CGREEN, clockdata.color_mode == GREEN);
			CheckItem(CCOLORS, CRED, clockdata.color_mode == RED);
			clear_window();
			break;
	}
	EndMenu(epmsg);
#ifdef DEBUG
	fprintf(stderr, "exit menuevent\n");
#endif
}
/*eject*/
/*
**	M O U S E   E V E N T S
*/
void mouseevent(ep)
EventRecord *ep;
{
#ifdef DEBUG
	fprintf(stderr, "enter mouseevent\n");
#endif
	if (ep->message & F_KEYDOWN) {
		/* Button Pressed */
		Notify(windowid, noNotify);
		hit = ep->where.corner.topLeft;
	}
#ifdef DEBUG
	fprintf(stderr, "exit mouseevent\n");
#endif
}
/*eject*/
/*
**	K E Y   E V E N T S
*/
void keyevent(ep)
EventRecord *ep;
{
	long		c;
	int			i;

#ifdef DEBUG
	fprintf(stderr, "enter keyevent\n");
#endif
	c = ep->message;
	if (c & F_KEYUP) {
		return;
	}
	Notify(windowid, noNotify);

	c &= (F_FUNC | F_CTRL | F_ALT | F_SHIFT | F_KEYMASK);
	switch(c) {
		case (K_ESC | F_FUNC):
			break;
		case (F_CTRL | 'p'):
			break;
		case (F_FUNC | K_BACKSP):
			break;
	}
#ifdef DEBUG
	fprintf(stderr, "exit keyevent\n");
#endif
}
/*eject*/
clear_window()
{
	Rect	rect;

#ifdef DEBUG
	fprintf(stderr, "enter clear_window\n");
#endif
	HiliteClear();
	SetRect(&rect, 0, 0, width, height);
	EraseRect(&rect);
	InvalRect(&rect);
#ifdef DEBUG
	fprintf(stderr, "exit clear_window\n");
#endif
}
/*eject*/
/*
**	Setup timer to update every second
*/
timer(own_id, rpar, reqnum)
void *own_id;
int rpar;
short reqnum;
{
	long	nowtime;
	static int (*timernode)() = timer;
	int	day_set, loop;

	/*
	**	first set up a new no wait nap
	*/
	dnix(F_NOWAIT + F_NAP, 1000, 0, 0, 0, 0, trapqfd, &timernode);

	/*
	**	Get the time information
	*/
	time(&nowtime);
	ltime = localtime(&nowtime);

	/*
	**	if the alarm clock is turned on, then check if its time to sound
	**	the alarm.  If it is, sound the alarm alarm_len seconds.
	*/
	day_set = OFF;
	if (clockdata.alarm_mode == ON) {
		if ((clockdata.alarm_sec.state == ON &&
			(ltime->tm_sec >= clockdata.alarm_sec.value)) ||
			 clockdata.alarm_sec.state == DONT_CARE) {
			if ((clockdata.alarm_min.state == ON &&
				(ltime->tm_min == clockdata.alarm_min.value)) ||
				 clockdata.alarm_min.state == DONT_CARE) {
				if ((clockdata.alarm_hr.state == ON &&
					(ltime->tm_hour == clockdata.alarm_hr.value)) ||
					 clockdata.alarm_hr.state == DONT_CARE) {
					if (clockdata.alarm_day.state == ON &&
						(ltime->tm_mday == clockdata.alarm_day.value)) {
						day_set = ON;
					}
					else if (clockdata.alarm_day.state == ON) {
						switch (ltime->tm_wday) {
							case 0:
								if (clockdata.alarm_day.sun) {
									day_set = ON;
								}
								break;
								
							case 1:
								if (clockdata.alarm_day.mon) {
									day_set = ON;
								}
								break;

							case 2:
								if (clockdata.alarm_day.tue) {
									day_set = ON;
								}
								break;

							case 3:
								if (clockdata.alarm_day.wed) {
									day_set = ON;
								}
								break;

							case 4:
								if (clockdata.alarm_day.thu) {
									day_set = ON;
								}
								break;

							case 5:
								if (clockdata.alarm_day.fri) {
									day_set = ON;
								}
								break;

							case 6:
								if (clockdata.alarm_day.sat) {
									day_set = ON;
								}
								break;
						}
					}
					else if (clockdata.alarm_day.state == DONT_CARE) {
						day_set = ON;
					}
					if (day_set) {
						if ((clockdata.alarm_mon.state == ON &&
							(ltime->tm_mon == clockdata.alarm_mon.value)) ||
							 clockdata.alarm_mon.state == DONT_CARE) {
							if ((clockdata.alarm_year.state == ON &&
								(ltime->tm_year == clockdata.alarm_year.value)) ||
								 clockdata.alarm_year.state == DONT_CARE) {
								clockdata.alarm_bells.state = ON;
							}
							else {
								clockdata.alarm_bells.state = OFF;
							}
						}
						else {
							clockdata.alarm_bells.state = OFF;
						}
					}
					else {
						clockdata.alarm_bells.state = OFF;
					}
				}
				else {
					clockdata.alarm_bells.state = OFF;
				}
			}
			else {
				clockdata.alarm_bells.state = OFF;
			}
		}
		else {
			clockdata.alarm_bells.state = OFF;
		}
	}

	/*
	** ring the alarm and flash the notify icon when the alarm time
	** has been reached.
	*/
	if (clockdata.alarm_bells.state == ON) {
		if (clockdata.alarm_len.state) {
			Notify(windowid, clockNotify);
			for (loop = 0; loop < clockdata.alarm_bells.value; loop++) {
				Bell();
			}
			clockdata.alarm_len.state--;
		}
	}
	else {
		clockdata.alarm_len.state = clockdata.alarm_len.value;
	}

	/*
	**	Finally paint the hands
	*/
	if (rpar >= 0) {
		/*
		** this is the normal route taken
		*/
		if (clockdata.time_mode == ANALOG ||
			clockdata.time_mode == ANABOX) {
			draw_analog_arms();
		}
		else {
			if (clockdata.time_mode != OFF) {
				draw_digital_leds(ON);
			}
			if (clockdata.date_mode != OFF) {
				draw_date_leds(ON);
			}
		}
	}
	else {
		/*
		** this is done the first time anything is displayed
		*/
		if (clockdata.time_mode != ANALOG &&
			clockdata.time_mode != ANABOX) {
			if (clockdata.time_mode != OFF) {
				draw_digital_leds(INITIALIZE);
			}
			if (clockdata.date_mode != OFF) {
				draw_date_leds(INITIALIZE);
			}
		}
	}
}
