#include <isc/window.h>

extern Icon clock_icon;
char *p;

/*
** miscellaneous routines go here
*/
usage()
{
	p = "\nusage: clock [-acdiUVxy] [filename]\n";
	write(1, p, strlen(p));
	p = "    a     analog\n";
	write(1, p, strlen(p));
	p = "    c[n]  color where n=0-3\n";
	write(1, p, strlen(p));
	p = "    d     digital\n";
	write(1, p, strlen(p));
	p = "    i     iconify\n";
	write(1, p, strlen(p));
	p = "    U     Usage\n";
	write(1, p, strlen(p));
	p = "    V     version\n";
	write(1, p, strlen(p));
	p = "    x     horizontal position\n";
	write(1, p, strlen(p));
	p = "    y     vertical position\n";
	write(1, p, strlen(p));
	p = "\n";
	write(1, p, strlen(p));
}

/*
**	D R A W   I C O N
*/
draw_icon()
{
    Rect scratch;

    SetRect(&scratch, 0, 0, 32, 32);
    PlotIcon(&scratch, &clock_icon);
}

/*
** This routine converts a numeric character string to an integer
** and returns the integer.
*/
myatoi(p)
register char *p;
{
	register short val;
	register char chr;

	val = 0;
	while(1) {
		chr = *p++ - '0';
		if (chr < 0 || chr > 9) {
			break;
		}
		val = (val * 10) + chr;
	}
	return val;
}

/*
** This routine converts an integer value to a character string
** and returns a pointer to the string.
*/
char *
myitoa(val)
int val;
{
	static char buf[20];
	char *p;
	int test;

	p = buf;
	test = 1000000;
	if (val < 0) {
		val = -val;
		*p++ = '-';
	}
	while (test > val) {
		test /= 10;
	}
	if (val) {
		while (test) {
			*p++ = val / test + '0';
			val %= test;
			test /= 10;
		}
	}
	else {
		*p++ = '0';
	}
	*p = 0;
	return buf;
}

/*eject*/
/*
** Sprintf replacement.
**
** Handles format strings containing:
**
**	 %s, %[0][1..9]d, %[0][1..9]x, %[0][1..9]X
**
** It's much smaller than the standard one.
*/
mysprintf(buffer, fmt, arglist)
char *buffer, *fmt;
char *arglist;
{
    register char *p, *q, *p2;
    short ndigits;
    int leadfill;
    char *itoa();
    union arg {
		long lng;
		char *ptr;
    } *argptr;
	
    argptr = (union arg *) &arglist;
    p = fmt;
    q = buffer;
    while (*p) {				/* While there's some format string. */
		if (*p == '%') {		/* Is it a format control? */
			p++;				/* Yes, which one (skip over % char)? */
			if (*p == '0')
				leadfill = *p++;
			else
				leadfill = ' ';
			if (*p >= '1' && *p <= '9')	/* Format output length? */
				ndigits = *p++ - '0';
			else
				ndigits = 0;
			if (*p == 's') {
				p2 = argptr++->ptr; /* String. */
			} else if (*p == 'd') {
				p2 = itoa(argptr++->lng, 10, leadfill, ndigits);
			} else if (*p == 'x' || *p == 'X') {
				p2 = itoa(argptr++->lng, 16, leadfill, ndigits);
			}
			p++;				/* Skip over format control. */
			while (*p2)			/* Copy the inclusion. */
				*q++ = *p2++;
		} else					/* No, it's a literal -- copy it. */
			*q++ = *p++;
    }
    *q = 0;						/* Null-terminate it. */
	return q - buffer;			/* Return the number of characters processed. */
}
/*eject*/
char *
itoa(val, radix, leadfill, ndigits)
int val, radix, leadfill, ndigits;
{
    short i;
    char *p, *p2, out;
    static char buf[20];
    unsigned long test, remainder;
	
    p = buf;
    remainder = val;
    i = ndigits;				/* Make sure there're at least the number */
    while (i--)					/* of leading whatevers that we've asked for */
		*p++ = leadfill;		/* as the field width. */
    p2 = p;
    if (radix == 16) {			/* Hex output? */
		test = 0x10000000L;
    } else {
		test = 1000000000L;		/* Decimal output? */
		if (val < 0) {
			remainder = -val;
			*p++ = '-';
		}
    }
    while (test > remainder)	/* Scale down to match number. */
		test /= radix;
    if (remainder)
		while (test) {
			out = remainder / test;
			*p++ = out + ((out >= 10) ? '7' : '0');
			remainder %= test;
			test /= radix;
		}
    else
		*p++ = '0';
    *p = 0;
    if (ndigits) {		/* A field width set? */
		if ((p2 + ndigits) >= p) /* Make sure we never truncate anything. */
			return p - ndigits;
		else
			return p2;
    }
    return buf;			/* No field width, return minimum number. */
}
