#include <time.h>
#include <isc/window.h>
#include "clock.h"

extern struct timesetup	clockdata;
extern struct tm *ltime;
extern Clock digital;

/*
** if any digit of new time is different from old time, change the appropriate
** display elements.  Otherwise, just leave things alone.
*/
draw_digital_leds(state)
int state;
{
	short hour_pos, min_pos, sec_pos;

	hour_pos = 0;
	min_pos =  (30 * clockdata.scale_factor);
	sec_pos =  (65 * clockdata.scale_factor);

	if (state == INITIALIZE) {
		do_segments(SEC,  clockdata.watch_box.edge.left + OFFSET_LEFT + sec_pos,  clockdata.watch_box.edge.top + OFFSET_TOP, state);
		do_segments(MIN,  clockdata.watch_box.edge.left + OFFSET_LEFT + min_pos,  clockdata.watch_box.edge.top + OFFSET_TOP, state);
		do_segments(HOUR, clockdata.watch_box.edge.left + OFFSET_LEFT + hour_pos, clockdata.watch_box.edge.top + OFFSET_TOP, state);
	}
	else {
		if (clockdata.old_sec != ltime->tm_sec) {
			do_segments(SEC,  clockdata.watch_box.edge.left + OFFSET_LEFT + sec_pos,  clockdata.watch_box.edge.top + OFFSET_TOP, state);
		}

		if (clockdata.old_min != ltime->tm_min) {
			do_segments(SEC,  clockdata.watch_box.edge.left + OFFSET_LEFT + sec_pos,  clockdata.watch_box.edge.top + OFFSET_TOP, state);
			do_segments(MIN,  clockdata.watch_box.edge.left + OFFSET_LEFT + min_pos,  clockdata.watch_box.edge.top + OFFSET_TOP, state);
		}

		if (clockdata.old_hour != ltime->tm_hour) {
			do_segments(SEC,  clockdata.watch_box.edge.left + OFFSET_LEFT + sec_pos,  clockdata.watch_box.edge.top + OFFSET_TOP, state);
			do_segments(MIN,  clockdata.watch_box.edge.left + OFFSET_LEFT + min_pos,  clockdata.watch_box.edge.top + OFFSET_TOP, state);
			do_segments(HOUR, clockdata.watch_box.edge.left + OFFSET_LEFT + hour_pos, clockdata.watch_box.edge.top + OFFSET_TOP, state);
		}
	}
}

clear_digital_leds(clock)
Clock *clock;
{
	int	i;

	for (i = 0; i < 8; i++) {
		clear_this_poly(&clock->seconds.least.led[i]);
		clear_this_poly(&clock->seconds.most.led[i]);
		clear_this_poly(&clock->minutes.least.led[i]);
		clear_this_poly(&clock->minutes.most.led[i]);
		clear_this_poly(&clock->hours.least.led[i]);
		clear_this_poly(&clock->hours.most.led[i]);
	}
	clear_this_poly(&clock->seconds.colon.top);
	clear_this_poly(&clock->seconds.colon.bot);
	clear_this_poly(&clock->minutes.colon.top);
	clear_this_poly(&clock->minutes.colon.bot);
}
