/*
** This module is intended to provide automatic version control.
** To get a string containing the current version number for a module,
** call GetVersion(), To print version/release info on stdout, call
** PrintRelInfo().
**
** NOTE:
**   In order for this file to automatically be maintained by the "vbump"
**   program, it is necessary for the STDRelease, STDCheckpt, STDInterim,
**   and STDLnkdate variables be defined exactly as shown.  You can modify
**   the CONTENTS of the variable but not the format of the line.
*/
#include <stdio.h>

char	STDProgname[] = "Clock Program";
char	STDAuthor[] = "Dale Bennett";
char	STDCopyright[] = "Copyright (c) 1990 by ISC-Bunker Ramo Corp.";
char	STDPartno[] = "XXX-XXXX-XXX";
char	STDRelease[] = "1";
char	STDCheckpt[] = "0";
char	STDInterim[] = "0";
char	STDLnkdate[] = "Tue Mar 22 10:07:50 1994";

char	*GetVersion()
{
	static char	versionstr[10];
	char	*strrchr();

	mysprintf(versionstr,"%s.%s.%s",STDRelease,STDCheckpt,STDInterim);
	return(versionstr);
}

char	*GetDate()
{
	static char	datestr[25];
	char	*strrchr();

	mysprintf(datestr,"%s",STDLnkdate);
	return(datestr);
}

PrintRelInfo()
{
	char buf[80];
	int i;

	i = mysprintf(buf, "%s: %s\n", STDProgname, STDCopyright);
	write(2, buf, i);
	i = mysprintf(buf, "PartNumber: %s\n", STDPartno);
	write(2, buf, i);
	i = mysprintf(buf, "Author:     %s\n", STDAuthor);
	write(2, buf, i);
	i = mysprintf(buf, "Version:    %s.%s.%s\n", STDRelease, STDCheckpt, STDInterim);
	write(2, buf, i);
	i = mysprintf(buf, "LinkDate:   %s\n", STDLnkdate);
	write(2, buf, i);
}
