/*
**	D I A L O G   E D I T O R
**
**	Written by: Dennis Weaver
**	Date: 12-14-89
**	Modified 7/14/92 rjn
**
*/

/*
**	I N C L U D E S
*/
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <isc/keycodes.h>
#include <isc/window.h>
#include <isc/controls.h>
#include <isc/textedit.h>
#include <isc/dlgman.h>
#include "dlged.h"
#include "Dgrid.h"
#include "Dinfo.h"

char *version = "4.3";
/*
**	Cursors
*/
Cursor text = {
	{ 0x0000, 0x0630, 0x0140, 0x0080, 0x0080, 0x0080, 0x0080, 0x0080,
	  0x0080, 0x0080, 0x0080, 0x0080, 0x0080, 0x0140, 0x0630, 0x0000 },
	{ 0x0E38, 0x0948, 0x0EB8, 0x0140, 0x0140, 0x0140, 0x0140, 0x0140,
	  0x0140, 0x0140, 0x0140, 0x0140, 0x0140, 0x0EB8, 0x0948, 0x0E38 },
	{ 8,8 }
};
Cursor hand = {
	{ 0x0000, 0x0000, 0x0000, 0x0000, 0x0700, 0x1900, 0x2200, 0x4700,
	  0xC7FE, 0x8C01, 0x97FE, 0xE410, 0x87E0, 0x8420, 0xC7C0, 0xEF80 },
	{ 0x0000, 0x0000, 0x0000, 0x0000, 0x0700, 0x1F00, 0x3E00, 0x7F00,
	  0xFFFE, 0xFFFF, 0xFFFE, 0xFFF0, 0xFFE0, 0xFFE0, 0xFFC0, 0x7F80 },
	{ 9,16 }
};
Cursor tab = {
	{ 0x0000, 0x07C0, 0x0460, 0x0460, 0x0460, 0x7C7C, 0x4386, 0x4286,
	  0x4386, 0x7C7E, 0x3C7E, 0x0460, 0x0460, 0x07E0, 0x03E0, 0x0000 },
	{ 0x0FC0, 0x0FE0, 0x0FF0, 0x0FF0, 0xFFFF, 0xFFFE, 0xFC7F, 0xFC7F,
	  0xFC7F, 0xFFFF, 0x7FFF, 0x7FFF, 0x0FF0, 0x0FF0, 0x07F0, 0x03E0 },
	{ 8,8 }
};

/*
**	ICON
*/
Icon charticon = {
	0x00000000,0x00000000,0x00000000,0x0FFFFFC0,
	0x08000040,0x08000040,0x0991FE70,0x097D0270,
	0x0959FE70,0x08000070,0x0951FE70,0x09F90270,
	0x0959FE70,0x08000070,0x0949FE70,0x09F10270,
	0x0969FE70,0x08000070,0x08000070,0x08F87C70,
	0x09048270,0x09048270,0x09048270,0x08F87C70,
	0x08000070,0x08000070,0x0FFFFFF0,0x03FFFFF0,
	0x03FFFFF0,0x00000000,0x00000000,0x00000000
};

/*
**	Groups
*/
byte	DEDgroup[MAXPD] = {0,0,0,0,1,2,3,4,5,0,31,0,51,52,53,54,55,0,252,253,254,255};
short	DEDfont[MAXPD]  = {0,0,1,2,3,4,5,6,7,27,28,10,-1};
short	DEDstyle[MAXPD]  = {0,normalText,boldText,underlineText,italicText,ghostText,outlineText,0,7,8,9,12,18,24,36};

char datafile[30] = "data";
char filename[300] = "Untitled.c"; /* the '.c' file. */
char hfilename[300] = "Untitled.h"; /* the '.h' file. */
char dlgname[300] = "Untitled";
char dlgnameCaps[300] = "UNTITLED";


/*eject*/
/*
**	M A I N   F U N C T I O N
*/
main(argc, argv)
int argc;
char *argv[];
{
    int i, j;
    int trapqfd, fd;
    Rect winrect;
    char *argp;
    EventRecord *ep;
    int	opt;
    extern char *optarg;
    extern int  optind;

    srconly = 1;
    offsetdp = 1;
    startupfile = 2;
    rubber = ENCLOSE;
    FFSstate = FFSnone;
    width = 634;
    height = 436;
    fullwidth = 634;
    fullheight = 436;
    xpos = 3;
    ypos = 41;
    gridon = 1;
    hgrid = 5;
    vgrid = 5;
    mode = MODEPOINT;
    /*
     **	Check for any Startup Switches
     */
    while ((opt = getopt(argc,argv,"UVcdow:")) != EOF) {
	switch (opt) {
	  case 'c':
	    convert = 1;
	    break;
	  case 'd':
	    debug = IMPORT;
	    break;
	  case 'o':
	    startupfile = 3;
	    break;
	  case 'w':
	    path = optarg;
	    break;
	    break;
	  case 'V':
	    printf("\ndlged, written by Dennis Weaver, Version %s\n",
		   version);
	    exit(0);
	    break;
	  case '?':
	  case 'U':
	  default:
	    printf("\nUsage: dlged [-UVcdow] [filename]\n");
	    printf("    U  Usage\n");
	    printf("    V  version\n");
	    printf("    c  convert and save in ver %s format\n",version);
	    printf("    d  debug information\n");
	    printf("    o  no auto open dialog\n");
	    printf("    w  display on workstation\n");
	    exit(0);
	    break;
	}
    }
    if (optind < argc) {	/* looking for file name */
	strcpy(filename,argv[optind]);
	set_names(filename);
	startupfile = 1;
    }

    /* 
     **	Convert and save file in current format
     */
    if (convert) {
	DedInit1();
	if (startupfile != 1) {
	    fprintf(stderr,"Error, Input file not specified.\n");
	    exit(1);
	}
	fp = fopen(filename,"r");
	if (fp == 0) {		/* open failed */
	    fprintf(stderr,"ERROR, Couldn't open '%s' for reading\n",filename);
	    exit(1);
	}
	DedImport();
	fclose(fp);
	fp = 0;

	fp = fopen(filename,"w");
	if (fp == 0) {		/* open failed */
	    fprintf(stderr,"ERROR, Couldn't open '%s' for writing\n",filename);
	    exit(1);
	}

	hfp = fopen(hfilename,"w");	/* Write .h file also. */
	if (hfp == 0) {
	    fprintf(stderr,"ERROR, Couldn't open '%s' for writting\n",hfilename);
	    exit(1);
	}

	DedExport();
	fclose(fp);
	fclose(hfp);
	exit(0);
    }
    /* 
     **	Initialize graphics toolbox
     */
    if ((trapqfd = InitGraf()) < 0) {
	fprintf(stderr,"Error %d in GrafInit\n",-trapqfd);
	exit(1);
    }

    /* 
     **	Establish connection to a window manager
     */
    if ((fd = ConnectGraf(path)) < 0) {
	fprintf(stderr,"Error %d in ConnectGraf\n",-fd);
	exit(1);
    }
    /*
     **	Create a window
     */
    DedSetTitle(0);
    SetRect(&winrect, xpos, ypos, xpos+width, ypos+height);
    windowid = NewWindow(&winrect, title, showWindow, documentProc, 
			 frontWindow, hasGoAway|hasZoom|hasSendToBack|hasGrow|hasDrag, fd);
    SetPort(windowid);
    MouseMode(F_KEYDOWN | F_KEYUP | F_MOUSE1);
    /*
     **	Put up Menus
     */
    NewMenu(FFILE, "File");
    AppendMenu(FFILE, "/OOpen...;Close;/SSave;Save As...;-;/QQuit");
    
    NewMenu(EDIT, "Edit");
    AppendMenu(EDIT, "/ASelect All;Delete;-;/XCut;/CCopy;/V(Paste;/DDuplicate");
    AppendMenu(EDIT, "-;Layer Control\311;Select by Layer\311;Set Selected to Layer\311");
    AppendMenu(EDIT, "-;Select by User Code\311;Set Selecteds\325 User Code\311");
    AppendMenu(EDIT, "-;Select by Group\311");

    NewMenu(NEW, "New");
    AppendMenu(NEW, "Box;Check Box;Pattern Box;-;Radio Button;Push Button;Double Push Button;-;Text;Text Edit;-;Scroll Bar;Pick List;-;TextBox;Line;UserItem");
    SetItemKey(NEW, BOX, F_FUNC | K_F1);
    SetItemKey(NEW, CHECKBOX, F_FUNC | K_F2);
    SetItemKey(NEW, CNTLBOX, F_FUNC | K_F3);
    SetItemKey(NEW, RADIOBUT, F_FUNC | K_F4);
    SetItemKey(NEW, PUSHBUT, F_FUNC | K_F5);
    SetItemKey(NEW, DPUSHBUT, F_FUNC | K_F6);
    SetItemKey(NEW, TEXT, F_FUNC | K_F7);
    SetItemKey(NEW, TEXTEDIT, F_FUNC | K_F8);
    SetItemKey(NEW, SCROLLBAR, F_FUNC | K_F9);
    SetItemKey(NEW, PICKLIST, F_FUNC | K_F10);
    SetItemKey(NEW, TEXTBOX, F_FUNC | K_F11);
    SetItemKey(NEW, LINE, F_FUNC | K_F12);

    NewMenu(OPTIONS,"Options");
    AppendMenu(OPTIONS,"Point Mode;Text Mode;Define Mode;Tab Sequence Mode;-;Grid On;Set Grid...;-;RubberBand Enclose;Offset Dup/Paste;-;/PPosition Info...");
    CheckItem(OPTIONS, MODEPOINT, 1);
    CheckItem(OPTIONS, RUBBER, 1);
    CheckItem(OPTIONS, OFFSETDP, 1);
    CheckItem(OPTIONS, GRIDON, gridon);

    NewMenu(BORDER, "Border");
    AppendMenu(BORDER, "Drop Shadow;Single Box;Double Box;Triple Box;Invisible;-;Line Width 1;Line Width 2;Line Width 3");

    NewMenu(GROUP, "Group");
    AppendMenu(GROUP, "No Group 0;Other...;-;Exclusive 1;Exclusive 2;Exclusive 3;Exclusive 4;Exclusive 5;-;Active TE 31;-;General 51;General 52;General 53;General 54;General 55;-Exit 251 (val);Exit 252 (no val);Exit 253 (val);Exit 254 (Cancel);Exit 255 (OK)");

    NewMenu(FONT, "Font");
    AppendMenu(FONT, "La Center;Spangle;Pullman;Cle Elum;Woodland;Otis Orchards;Chicago;Los Angeles;Times;Helvetica;Courier");
    
    NewMenu(STYLE, "Style");
    AppendMenu(STYLE, "Normal;<BBold;<UUnderline;<IItalic;Ghost;<OOutline;-;7 Point;8 Point;9 Point;12 Point;18 Point;24 Point;36 Point");
    CheckFFS();
    /*
     **	Bind events
     */
    Event(updateEvt,updateevent);
    Event(mouseEvt,mouseevent);
    Event(windowEvt,windowevent);
    Event(menuEvt,menuevent);
    Event(keyEvt,keyevent);
    SetRect(&window,0,0,width,height);
    PenMode(srcOr);
    /*
     **	Initialization
     */
    DMInit();
    InitControls();
    TEInit(0, normalText);
    PLInit();
    DedInit1();
    DedInit2();
    SetKbdXlate(1);
    SetRect(&noclip,0,0,2000,2000);
    dblclicktime = (unsigned long)GetDblClickTime();

    ep = GetEvent(anyWindow, noEvent); /* Usually doesn't return. */
    if ((long) ep < 0) {
	printf("ERROR, GetEvent(noWindow,noEvent) returned 0x%X\n",ep);
	exit(1);
    }
}

/*
**	D R A W   I C O N
*/
draw_icon()
{
    Rect scratch;

    SetRect(&scratch, 0, 0, 32, 32);
    PlotIcon(&scratch, &charticon);
    ValidRect(&scratch);
}

/*
**	W I N D O W   E V E N T S
*/
void
windowevent(ep)
EventRecord *ep;
{
    Rect rect;

    switch (ep->message & F_KEYMASK) {
      case windowGoaway:
	if (incollect == 0) {
	    DedQuit();
	}
	break;

      case windowMove:
	xpos += ep->where.edge.left;
	ypos += ep->where.edge.top;
	MoveWindow(ep->who, xpos, ypos, 0);
	break;

      case windowResize:
	if (!iconified) {
	    SetRect(&rect, width - 20, height - 20, width, height);
	    EraseRect(&rect);
	    width += ep->where.edge.left;
	    height += ep->where.edge.top;
	    SizeWindow(ep->who, width, height, updateRequest);
	    SetRect(&window, 0, 0, width, height);
	    EraseRect(&window);
	    InvalRect(&window);
	    DrawGrowIcon(ep->who);
	}
	break;

      case windowZoom:
	if (iconified) {
	    UnIconifyWindow(ep->who); /* Zoom Up */
	} else {		/* Zoom Down */
	    IconifyWindow(ep->who);
	    draw_icon();
	}
	EraseRect(&window);
	InvalRect(&window);
	iconified = !iconified;
	break;
    }
}

/*
**	U P D A T E   E V E N T S
*/
void
updateevent(ep)
EventRecord *ep;
{
    BeginUpdate(ep->who);
    if (iconified) {
	draw_icon();
    } else {
	DrawGrowIcon(ep->who);
	FrameRect(&rect);
	if (startupfile == 1) {
	    myopen();
	    startupfile = 0;
	} else if (startupfile == 2) {
	    disablemenus();
	    DedOpen();
	    enablemenus();
	    startupfile = 0;
	} else if (startupfile == 3) {
	    startupfile = 0;
	} else {
	    dspall();
	    if (RfshDlg) DMUpdate(RfshDlg);
	}
    }
    EndUpdate(ep->who);
}

/*
**	M O U S E   E V E N T S
*/
void
mouseevent(ep)
EventRecord *ep;
{
    static int onobj;
    static unsigned long lastclick;
    static short dblclick;
    Rect scratch;
    DedItem *rp;

    if (ep->message & F_KEYDOWN) { /* Button Pressed? */
	hit = ep->where.corner.topLeft;
	if ((rp = onobject(&hit))) { /* On Object? */
	    dblclick = ((ep->when - lastclick) < dblclicktime ? 1 : 0);
	    lastclick = ep->when;
	    if (ep->message & F_CTRL || dblclick) {
		disablemenus();
		DefineObj(rp); /* One-Shot Define Mode */
		enablemenus();
	    } else if (ep->message & F_ALT) {
		DefineText(rp);	/* One-Shot Define Mode */
	    } else if (rp->selected && onhandle(&hit,rp)) {
		stretch(rp);	/* On Handle of Selected Object */
	    } else {		/* No Stretch so Select/Deselect */
		if (rp->selected) {
		    onobj = 1;	/* Object is Selected */
		    if (ep->message & F_SHIFT) { /* Shift Key Down */
			deselect(rp);
		    }
		} else {	/* Object is NOT Selected */
		    if (ep->message & F_SHIFT) { /* Shift Key Down? */
			select(rp); /* Add-select. */
		    } else {	/* Shift Key Up. */
			dupoffsetx = dupoffsety = 0;
			xselect(rp); /* Exclusively select. */
		    }
		}
		move();
	    }
	} else {		/* NOT On Object */
	    if ((ep->message & F_SHIFT) == 0) {
		dupoffsetx = dupoffsety = 0;
		deselectall(1);
	    }
	    rubberband();
	}
    }
}

/*
**	S T R E T C H   R O U T I N E
*/
stretch(rp)
DedItem	*rp;
{
    int first;
    Rect tr, tr2;
    EventRecord *ep;
    
    first = 1;
    tr = rp->rect;
    PenMode(srcXor);
    PenPat((Pattern *) 7);
    for (;;) {
	ep = GetEvent(1 << windowid, 1 << mouseEvt);
	if (ep->message & F_KEYUP) {
	    dirty = 1;
	    PenMode(srcOr);
	    PenPat((Pattern *) 0);
	    erase(rp);
	    InvalRect(&rp->rect);
	    Pt2Rect(&tr.corner.topLeft, &tr.corner.botRight, &rp->rect);
	    switch (rp->type) {
	      case DMCHECKBOX:
	      case DMPUSHBUT:
	      case DMDPUSHBUT:
	      case DMRADIOBUT:
	      case DMSCROLLBAR:
	      case DMPATBOX:
		SizeControl(rp->id, rectwidth(&rp->rect),
			    rectheight(&rp->rect));
		ValidRect(&rp->rect);
		break;

	      case DMTEXTEDIT:
		techange(rp);
		ValidRect(&rp->rect);
		break;

	      case DMTEXT:
		display(rp);
		ValidRect(&rp->rect);
		break;

	      case DMPICKLIST:
		SizeControl(rp->id, DMSBWidth, rectheight(&rp->rect));
		MoveControl(rp->id, rp->rect.edge.right - DMSBWidth,
			    rp->rect.edge.top);
	      case DMBOX:
	      case DMTEXTBOX:
	      case DMLINE:
	      case DMUSERITEM:
		display(rp);
		ValidRect(&rp->rect);
		break;
	    }
	    dspselect(rp);
	    break;
	} else if (ep->message & F_MOUSE1) {
	    if (first)
		first = 0;
	    else
		FrameRect(&tr2);
	    tr.corner.botRight = ep->where.corner.topLeft;
	    if (gridon)
		stretch2grid(&tr);
	    tr2 = tr;
	    Pt2Rect(&tr.corner.topLeft, &tr.corner.botRight, &tr2);
	    FrameRect(&tr2);
	}
    }
}

/*
**	M O V E   R O U T I N E
*/
move()
{
    int first, first2, i;
    Rect tr;
    short dh, dv;
    EventRecord *ep;
    DedItem *rp;

    first = first2 = 1;
    for (;;) {
	ep = GetEvent(1 << windowid, 1 << mouseEvt);
	if (ep->message & F_KEYUP) {
	    PenMode(srcOr);
	    PenPat((Pattern *) 0);
	    rp = &dialog[0];
	    for (first=1,i=0; i<MAXDLG && first2==0; i++,rp++) {
		if (rp->selected) {
		    dirty = 1;
		    switch (rp->type) {
		      case DMBOX:
		      case DMTEXT:
		      case DMTEXTBOX:
		      case DMLINE:
		      case DMUSERITEM:
			erase(rp);
			InvalRect(&rp->rect);
			if (first && (dupoffsetx | dupoffsety)) {
			    dupoffsetx += rp->tmp.edge.left-rp->rect.edge.left;
			    dupoffsety += rp->tmp.edge.top-rp->rect.edge.top;
			    first = 0;
			}
			rp->rect = rp->tmp;
			display(rp);
			break;

		      case DMPICKLIST:
			erase(rp);
			InvalRect(&rp->rect);
			if (first && (dupoffsetx | dupoffsety)) {
			    dupoffsetx += rp->tmp.edge.left-rp->rect.edge.left;
			    dupoffsety += rp->tmp.edge.top-rp->rect.edge.top;
			    first = 0;
			}
			rp->rect = rp->tmp;
			dh = rp->tmp.corner.topLeft.h;
			dv = rp->tmp.corner.topLeft.v;
			rp->rect = rp->tmp;
			MoveControl(rp->id, dh + rectwidth(&rp->rect)
				    - DMSBWidth, dv);
			display(rp);
			dspselect(rp);
			break;

		      case DMCHECKBOX:
		      case DMRADIOBUT:
		      case DMPUSHBUT:
		      case DMDPUSHBUT:
		      case DMSCROLLBAR:
		      case DMPATBOX:
			erase(rp);
			dh = rp->tmp.corner.topLeft.h;
			dv = rp->tmp.corner.topLeft.v;
			MoveControl(rp->id, dh, dv);
			if (first && (dupoffsetx | dupoffsety)) {
			    dupoffsetx += rp->tmp.edge.left-rp->rect.edge.left;
			    dupoffsety += rp->tmp.edge.top-rp->rect.edge.top;
			    first = 0;
			}
			rp->rect = rp->tmp;
			ValidRect(&rp->rect);
			dspselect(rp);
			break;

		      case DMTEXTEDIT:
			erase(rp);
			InvalRect(&rp->rect);
			dh = rp->tmp.corner.topLeft.h;
			dv = rp->tmp.corner.topLeft.v;
			if (first && (dupoffsetx | dupoffsety)) {
			    dupoffsetx += rp->tmp.edge.left-rp->rect.edge.left;
			    dupoffsety += rp->tmp.edge.top-rp->rect.edge.top;
			    first = 0;
			}
			rp->rect = rp->tmp;
			techange(rp);
			dspselect(rp);
			break;
		    }
		}
	    }
	    sort();
	    break;
	} else if (ep->message & F_MOUSE1) {
	    if (thePenMode != srcXor) {
		PenMode(srcXor);
		PenPat((Pattern *) 7);
	    }
	    rp = &dialog[0];
	    for (i=0; i<MAXDLG; i++,rp++) {
		if (rp->selected && rp->type) {
		    if (first2) {
			first = 0;
		    } else {
			FrameRect(&rp->tmp);
		    }
		    dh = ep->where.edge.left - hit.h;
		    dv = ep->where.edge.top - hit.v;
		    rp->tmp = rp->rect;
		    OffsetRect(&rp->tmp, dh, dv);
		    if (gridon)
			snap2grid(&rp->tmp);
		    FrameRect(&rp->tmp);
		}
		if (i==(MAXDLG-1) && first==0)
		    first2 = 0;
	    }
	}
    }
}

/*
**	R U B B E R   B A N D  R O U T I N E
*/
rubberband()
{
    int i, flag;
    Rect tr, tr2, tr3;
    EventRecord *ep;
    DedItem *rp;
    
    flag = FFSnone;
    tr.corner.topLeft = hit;
    tr.corner.botRight = hit;
    tr2= tr;
    for (;;) {
	ep = GetEvent(1 << windowid, 1 << mouseEvt);
	if (ep->message & F_KEYUP) {
	    FrameRect(&tr2);
	    PenMode(srcOr);
	    PenPat((Pattern *) 0);
	    rp = &dialog[0];
	    for (i=0; i<MAXDLG; i++,rp++) {
		if (rubber == TOUCH) {
		    if (rp->type && !(hideflags & (1 << rp->layer))
			&& SectRect(&rp->rect, &tr2, &tr3)) {
			flag = FFSmany;
			select(rp);
		    }
		} else {
		    tr3 = rp->rect;
		    if (!(hideflags & (1 << rp->layer)) &&
			tr2.edge.left <= tr3.edge.left &&
			tr2.edge.top <= tr3.edge.top &&
			tr2.edge.right >= tr3.edge.right &&
			tr2.edge.bottom >= tr3.edge.bottom) {
			flag = FFSmany;
			select(rp);
		    }
		}
	    }
	    MakeFFS(flag);
	    break;
	} else if (ep->message & F_MOUSE1) {
	    if (thePenMode != srcXor) {
		PenMode(srcXor);
		PenPat((Pattern *) 7);
	    }
	    FrameRect(&tr2);
	    tr.corner.botRight = ep->where.corner.topLeft;
	    tr2 = tr;
	    Pt2Rect(&tr.corner.topLeft,&tr.corner.botRight,&tr2);
	    FrameRect(&tr2);
	}
    }
}

/*
**	K E Y   E V E N T S
*/
void
keyevent(ep)
EventRecord *ep;
{
    long c;
    DedItem *rp;
    int i;
    
    c = ep->message;
    if (c & F_KEYUP)
	return;
    c &= (F_FUNC | F_CTRL | F_ALT | F_SHIFT | F_KEYMASK);
    switch (c) {
      case (K_ESC | F_FUNC):
	  DedQuit();
	  break;

      case (F_CTRL | 'p'):
	  printf("\nTYPE RP SELECTED ID\n");
	  rp = dialog;
	  printf("type group value text handle prefill validate\n");
	  for (i=0; i<MAXDLG; i++,rp++) {
	      if (rp->type) {
		  printf("%d 0x%X 0x%X 0x%X %s %s %s %s\n", rp->selected,
			 rp->type, rp->group, rp->value, rp->text, rp->name,
			 rp->prefill, rp->validate);
	      }
	  }
	  break;

      case (F_FUNC | K_BACKSP):
	  deleteselected();
	  break;
    }
}

DisplaySelected()
{
    int i;
    DedItem *rp;
    
    rp = dialog;
    for (i=0; i<MAXDLG; i++,rp++) {
	if (rp->type && rp->selected) {
	    switch (rp->type) {
	      case DMPUSHBUT:
		DisposeControl(rp->id);
		doFontFaceSize2(rp);
		rp->id = dlgNewControl(windowid, &rp->rect, rp->text, 1, 1, 0,
				       1, pushButProc | useWFont, 0,
				       rp->fgColor, rp->bkColor);
		break;

	      case DMDPUSHBUT:
		DisposeControl(rp->id);
		doFontFaceSize2(rp);
		rp->id = dlgNewControl(windowid, &rp->rect, rp->text, 1, 1, 0,
				       1, defButProc | useWFont, 0,
				       rp->fgColor, rp->bkColor);
		break;

	      case DMRADIOBUT:
		DisposeControl(rp->id);
		doFontFaceSize2(rp);
		rp->id = dlgNewControl(windowid, &rp->rect, rp->text, 1, 1, 0,
				       1, radioButProc | useWFont, 0,
				       rp->fgColor, rp->bkColor);
		break;

	      case DMCHECKBOX:
		DisposeControl(rp->id);
		doFontFaceSize2(rp);
		rp->id = dlgNewControl(windowid, &rp->rect, rp->text, 1, 1, 0,
				       1, checkBoxProc | useWFont, 0,
				       rp->fgColor, rp->bkColor);
		break;

	      default:
		erase(rp);
		display(rp);
		break;
	    }
	}
    }
}

StuffFFS(font, face, size, flag)
short font, face, size, flag;
{
    DedItem *rp;
    int i;
    
    rp = dialog;
    for (i=0; i<MAXDLG; i++,rp++) {
	if (rp->type && rp->selected) {
	    switch (rp->type) {
	      case DMTEXT:
	      case DMTEXTEDIT:
	      case DMPUSHBUT:
	      case DMDPUSHBUT:
	      case DMRADIOBUT:
	      case DMCHECKBOX:
	      case DMPATBOX:
	      case DMPICKLIST:
		dirty = 1;
		if (font != -1)
		    rp->font = font;
		if (face != -1 && face != FFSnomatch)
		    if (face == 0)
			rp->attr = 0;
		    else if (flag)
			rp->attr &= (face & ~FFSnomatch);
		    else
			rp->attr |= (face & ~FFSnomatch);
		if (size != -1)
		    rp->fontsize = size;
		if (rp->type == DMTEXTEDIT)
		    techange(rp);
		break;
	    }
	}
    }
}

/*
**	L O C A T E   R O U T I N E S
*/
DedItem *
onobject(pt)
Point *pt;
{
    int i;
    DedItem *orp, *rp;

    orp = 0;
    rp = &dialog[MAXDLG-1];
    for (i=0; i<MAXDLG; i++,rp--) {
	if (rp->type && !(hideflags & (1 << rp->layer))
	    && PtInRect(pt, &rp->rect)) {
	    orp = rp;
	    MakeFFS(rp);
	    break;
	}
    }
    if (i == MAXDLG) {
	MakeFFS(FFSnone);
    }
    return orp;
}

onhandle(ptp, rp)
Point *ptp;
DedItem *rp;
{
    if (PtInRect(ptp, &rp->handle)) {
	FrameRect(&rp->handle);
	return 1;
    }
    return 0;
}

DedItem  *
findslot()
{
    int i;
    DedItem *rp;
    
    rp = &dialog[0];
    for (i=0; i<MAXDLG; i++,rp++) {
	if (rp->type == 0) {
	    break;
	}
    }
    return rp;
}

DedItem *
findnameditem(name)
char *name;
{
    int i;
    DedItem *rp;
    
    rp = &dialog[0];
    for (i=0; i<MAXDLG; i++,rp++) {
	if (!strcmp(name, rp->name))
	    return rp;
	if (rp->type == 0) {
	    break;
	}
    }
    return 0;
}

/*eject*/
/*
**	C R E A T E   R O U T I N E S
*/

dupe()
{
    DedItem *rp, *nrp;
    Rect tr;
    int i;
    byte select[MAXDLG];
    
    rp = dialog;
    for (i=0; i<MAXDLG; i++,rp++) { /* Save selection status. */
	select[i] = rp->selected;
    }
    deselectall(0);
    rp = dialog;
    for (i=0; i<MAXDLG; i++,rp++) {
	if (select[i] && rp->type) {
	    nrp = dupitem(rp);
	    nrp->selected = 1;
	    dspselect(nrp);
	}
    }
    sort();
}

DedItem *
dupitem(rp)
DedItem	*rp;
{
    DedItem *nrp;
    Rect tr;
    int i;
    char *cp, *cp2, *cp3;

    nrp = findslot();
    cp = nrp->text;
    cp2 = nrp->name;
    cp3 = nrp->tabto;
    *nrp = *rp;
    nrp->text = cp;
    nrp->name = cp2;
    nrp->tabto = cp3;
    strcpy(nrp->text, rp->text);
    strcpy(nrp->name, rp->name);
    if (offsetdp) {
	if (!(dupoffsetx | dupoffsety)) { /* No auto-offset? */
	    dupoffsetx = 5 * hgrid; /* Make up a default then. */
	    dupoffsety = 5 * vgrid;
	}
	OffsetRect(&nrp->rect, dupoffsetx, dupoffsety);
    }
    switch (rp->type) {
      case DMCHECKBOX:
	doFontFaceSize2(rp);
	nrp->id = dlgNewControl(windowid, &nrp->rect, nrp->text, 1, 1, 0, 1,
				checkBoxProc | useWFont, 0, rp->fgColor,
				rp->bkColor);
	break;

      case DMPATBOX:
	SetCDefProc(dlgControl);
	nrp->id = dlgNewControl(windowid, &nrp->rect, "", 1, 1, 0, 0xFF,
				cntlBoxProc, 0, rp->fgColor, rp->bkColor);
	SetCtlValues(nrp->id, nrp->selected, nrp->pattern);
	SetCDefProc(0);
	break;

      case DMRADIOBUT:
	doFontFaceSize2(rp);
	nrp->id = dlgNewControl(windowid, &nrp->rect, nrp->text, 1, 1, 0, 1,
				radioButProc | useWFont, 0, rp->fgColor,
				rp->bkColor);
	break;

      case DMPUSHBUT:
	doFontFaceSize2(rp);
	nrp->id = dlgNewControl(windowid, &nrp->rect, nrp->text, 1, 1, 0, 1,
				pushButProc | useWFont, 0, rp->fgColor,
				rp->bkColor);
	break;

      case DMDPUSHBUT:
	doFontFaceSize2(rp);
	nrp->id = dlgNewControl(windowid, &nrp->rect, nrp->text, 1, 1, 0, 1,
				defButProc | useWFont, 0, rp->fgColor,
				rp->bkColor);
	break;

      case DMSCROLLBAR:
	nrp->id = dlgNewControl(windowid, &nrp->rect, rp->text, 1, 1, 0, 1,
				scrollBarProc, 0, rp->fgColor, rp->bkColor);
	break;

      case DMPICKLIST:
	pickscrollrect(&nrp->rect, &tr);
	nrp->id = dlgNewControl(windowid, &tr, rp->text, 1, 1, 0, 1,
				scrollBarProc, 0, rp->fgColor, rp->bkColor);
	break;

      case DMTEXTEDIT:
	nrp->id = dlgTENew(nrp);
	break;
    }
    return nrp;
}

techange(rp)
DedItem	*rp;
{
    Rect tr;
    
    erase(rp);
    TEDispose(rp->id);
    rp->id = dlgTENew(rp);
}
/*eject*/
/*
**	S O R T   R O U T I N E S
*/
/*
**	Qsort Field Struct Compare Function
**
**	result of -1 puts rp1 before rp2 in array
**	result of  1 puts rp1 after  rp2 in array
*/
dlgeditsort(rp1, rp2)
DedItem	*rp1, *rp2;
{
    int result;
    Rect r1, r2;
    
    r1 = rp1->rect;
    r2 = rp2->rect;
    /*
     **	Sort by Used / Unused (used to top)
     */
    if (rp1->type != 0 && rp2->type == 0)
	result = -1;
    else if (rp1->type == 0 && rp2->type != 0)
	result = 1;
    else if (rp1->type == 0 && rp2->type == 0)
	result = 0;
    /*
     **	Both Used,
     **	Sort by Top/Left Position (top/left most to top)
     */
    else if (r1.edge.top < r2.edge.top)
	result = -1;
    else if (r1.edge.top > r2.edge.top)
	result = 1;
    else if (r1.edge.left < r2.edge.left)
	result = -1;
    else if (r1.edge.left > r2.edge.left)
	result = 1;
    /*
     **	Top / Left Equal,
     **	Sort by Size (bigger to top)
     */
    else if (rectwidth(&r1) > rectwidth(&r2))
	result = -1;
    else if (rectwidth(&r1) < rectwidth(&r2))
	result = 1;
    else if (rectheight(&r1) > rectheight(&r2))
	result = -1;
    else if (rectheight(&r1) < rectheight(&r2))
	result = 1;
    /*
     **	Rects Equal,
     **	Sort by type (box objects to the top)
     */
    else if (rp1->type == DMBOX && rp2->type != DMBOX)
	result = -1;
    else if (rp1->type != DMBOX && rp2->type == DMBOX)
	result = 1;
    /*
     **	Both objects are boxes,
     **	Sort by Selected (selected to bottom)
     */
    else if (!rp1->selected && rp2->selected)
	result = -1;
    else if (rp1->selected && !rp2->selected)
	result = 1;
    else
	result = 0;
    return result;
}

/*
**	Sort Field Structs
*/
sort()
{
    int i;
    DedItem *rp;
    
    qsort((char *) dialog, MAXDLG, sizeof(DedItem), dlgeditsort);
}

/*
**	D E F I N E   M O D E   R O U T I N E S
*/
setgrid()
{
    DMDcb *cb, *prevcb;
    int group;
    char buf[20];
    
    cb = DMNew(Dgrid, windowid, 0);
    incollect = 1;
    InitCursor();
    prevcb = RfshDlg;
    RfshDlg = cb;
    group = DMCollect(cb);
    if (group == DMok) {
	DMGet(cb, DGRID_hgrid, buf);
	hgrid = atoi(buf);
	DMGet(cb, DGRID_vgrid, buf);
	vgrid = atoi(buf);
    }
    DMDispose(cb);
    incollect = 0;
    RfshDlg = prevcb;
}

void
modedefine(ep)
EventRecord *ep;
{
    DedItem *rp;
    
    if (ep->what == mouseEvt && (ep->message & F_KEYDOWN)) {
	if ((rp = onobject(&ep->where.corner.topLeft))) {
	    InitCursor();
	    DefineObj(rp);
	    SetCursor(&hand);
	}
    }
}

void
modedefinetab(ep)
EventRecord *ep;
{
    int i;
    DedItem *rp, *p;
    
    if (ep->what == mouseEvt && (ep->message & F_KEYDOWN)) {
	if ((rp = onobject(&ep->where.corner.topLeft))) {
	    if (rp->type == DMTEXTEDIT && *rp->name) {
		p = dialog;
		for (i=0; i<MAXDLG; i++,p++) {
		    if (p->selected && p != rp) {
			dirty = 1;
			strcpy(p->tabto, rp->name);
		    }
		}
		xselect(rp);
	    } else {		/* Not a named TE field. */
		Bell();
	    }
	}
    }
}

/*
 **	O N   S C R E E N   E D I T   D R I V E R
 */
DefineText(rp)
DedItem	*rp;
{
    mode = MODETEXT;
    SetCursor(&text);
    modetextfunc(0, rp);
    InitCursor();
    mode = MODEPOINT;
}

void
modetext(ep)
EventRecord *ep;
{
    modetextfunc(ep, 0);
}

modetextfunc(ep, rp)
EventRecord *ep;
DedItem	*rp;
{
    Rect tr;
    byte type;

    if (ep && ep->message & F_KEYDOWN) {
	rp = onobject(&ep->where.corner.topLeft);
    }
    if (rp) {
	switch (rp->type) {
	  case DMCHECKBOX:
	  case DMPUSHBUT:
	  case DMDPUSHBUT:
	  case DMSCROLLBAR:
	  case DMRADIOBUT:
	  case DMTEXT:
	  case DMTEXTEDIT:
	    /*
	     **	Mouse Clicked on a dialog item
	     **	so hide the item & put up a text
	     **	edit box
	     */
	    type = rp->type;
	    rp->type = 0;
	    if (type == DMTEXT)
		erase(rp);
	    else if (type != DMTEXTEDIT)
		DisposeControl(rp->id);
	    drivete(rp);
	    rp->type = type;
	    tr = rp->rect;
	    doFontFaceSize(rp);
	    switch (rp->type) {
	      case DMCHECKBOX:
		rp->id = dlgNewControl(windowid, &tr, rp->text, 1, 1, 0, 1,
				       checkBoxProc | useWFont, 0,
				       rp->fgColor, rp->bkColor);
		break;

	      case DMRADIOBUT:
		rp->id = dlgNewControl(windowid, &tr, rp->text, 1, 1, 0, 1,
				       radioButProc | useWFont, 0,
				       rp->fgColor, rp->bkColor);
		break;

	      case DMPUSHBUT:
		rp->id = dlgNewControl(windowid, &tr, rp->text, 1, 1, 0, 1,
				       pushButProc | useWFont, 0,
				       rp->fgColor, rp->bkColor);
		break;

	      case DMDPUSHBUT:
		rp->id = dlgNewControl(windowid, &tr, rp->text, 1, 1, 0, 1,
				       defButProc | useWFont, 0,
				       rp->fgColor, rp->bkColor);
		break;

	      case DMSCROLLBAR:
		rp->id = dlgNewControl(windowid, &tr, rp->text, 1, 1, 0, 1,
				       scrollBarProc, 0,
				       rp->fgColor, rp->bkColor);
		break;

	      case DMTEXT:
		display(rp);
		break;

	      case DMTEXTEDIT:
		rp->id = dlgTENew(rp);
		break;
	    }
	}
    }
}

/*eject*/
/*
 **	Handle single edit window
 */
drivete(rp)
DedItem *rp;
{
    DedItem *lrp;
    Rect tr;
    EventRecord *ep;
    void *id, *previd;
    int sw;
    short extend;
    
    /*
     **	Create a Text Edit Window
     */
    previd = 0;
    if (debug)
	printf("TE ENTER\n");
    if (rp->type != TEXTEDIT) {
	tr = rp->rect;
	if (rectheight(&rp->rect) < 20) {
	    tr.edge.bottom = tr.edge.top + 20;
	}
	EraseRect(&tr);
	InsetRect(&tr, 3, 3);
	doFontFaceSize(rp);
	rp->id = TENew(&tr, &tr);
    }
    TECROnly(1, rp->id);
    TEAutoView(1, rp->id);
    InsetRect(&tr, -3, -3);
    TESetText(rp->text, rp->max ? rp->max : 100, rp->id);
    TESetSelect(0, StringLen(rp->text), rp->id);
    TEActivate(rp->id);
    TEUpdate(&tr,rp->id);
    FrameRect(&tr);
    while (mode == MODETEXT) {
	ep = GetEvent(1 << windowid, 1 << mouseEvt | 1 << keyEvt);
	if (debug)
	    printf(" TE Keydown 0x%X\n");
	if (ep->what == keyEvt) {
	    /*
	     **	Key Event
	     */
	    dirty = 1;
	    if (debug)
		printf(" TEKey 0x%X\n", ep->message);
	    ObscureCursor();
	    TEKey(ep->message, rp->id);
	} else if (ep->what == mouseEvt
		   && ep->message & (F_KEYDOWN | F_MOUSE1)) {
	    /*
	     **	Mouse Event
	     */
	    if (PtInRect(&ep->where.corner.topLeft, &rp->rect)) {
		/*
		 **	Still on same control
		 */
		if (debug)
		    printf(" TEClick\n");
		extend = ep->message & F_SHIFT ? 1 : 0;
		TEClick(&ep->where.corner.topLeft, extend, rp->id);
	    } else {
		/*
		 **	Mouse Clicked on NO dialog item or
		 **	on a different dialog item
		 */
		break;
	    }
	}
    }
    if (debug) {
	printf("TE BUG OUT\n");
    }
    gettext(rp->text, rp->id);
    TEDispose(rp->id);
    EraseRect(&tr);
    InvalRect(&tr);
}

newitem(rp)
DedItem	*rp;
{
    Rect tr;
    
    switch (rp->type) {
      case DMBOX:
      case DMTEXT:
      case DMTEXTBOX:
      case DMLINE:
      case DMUSERITEM:
	doFontFaceSize(rp);
	display(rp);
	break;

      case DMPICKLIST:
	pickscrollrect(&rp->rect, &tr);
	rp->id = dlgNewControl(windowid, &tr, rp->text, 1, 1, 0, 1,
			       scrollBarProc, 0, rp->fgColor, rp->bkColor);
	display(rp);
	break;

      case DMCHECKBOX:
	doFontFaceSize(rp);
	rp->id = dlgNewControl(windowid, &rp->rect, rp->text, 1, 1, 0, 1,
			       checkBoxProc | useWFont, 0, rp->fgColor,
			       rp->bkColor);
	break;

      case DMPATBOX:
	SetCDefProc(dlgControl);
	rp->id = dlgNewControl(windowid, &rp->rect, "", 1, 1, 0, 0xFF,
			       cntlBoxProc, 0, rp->fgColor, rp->bkColor);
	SetCtlValues(rp->id, 0, rp->pattern);
	SetCDefProc(0);
	break;

      case DMRADIOBUT:
	doFontFaceSize(rp);
	rp->id = dlgNewControl(windowid, &rp->rect, rp->text, 1, 1, 0, 1,
			       radioButProc | useWFont, 0, rp->fgColor,
			       rp->bkColor);
	break;

      case DMPUSHBUT:
	doFontFaceSize(rp);
	rp->id = dlgNewControl(windowid, &rp->rect, rp->text, 1, 1, 0, 1,
			       pushButProc | useWFont, 0, rp->fgColor,
			       rp->bkColor);
	break;

      case DMDPUSHBUT:
	doFontFaceSize(rp);
	rp->id = dlgNewControl(windowid, &rp->rect, rp->text, 1, 1, 0, 1,
			       defButProc | useWFont, 0, rp->fgColor,
			       rp->bkColor);
	break;

      case DMSCROLLBAR:
	doFontFaceSize(rp);
	rp->id = dlgNewControl(windowid, &rp->rect, rp->text, 1, 1, 0, 1,
			       scrollBarProc, 0, rp->fgColor, rp->bkColor);
	break;

      case DMTEXTEDIT:
	rp->id = dlgTENew(rp);
	break;
    }
}

/*
**	H O U S E K E E P I N G   R O U T I N E S
*/
MakeFFS(dep)
DedItem	*dep;
{
    int i, first;
    short tmp;
    
    first = 1;
    tmp = 0;
    if (dep == (DedItem *) FFSmany) {
	/*
	 **	RubberBand Multi Select, Check all used attributes
	 **	and only show font and size if all selected match
	 */
	FFSstate = FFSmany;
	curface = -1;
	dep = &dialog[0];
	for (i=0; i<MAXDLG; i++,dep++) {
	    if (dep->selected) {
		switch (dep->type) {
		  case DMTEXT:
		  case DMTEXTEDIT:
		  case DMPUSHBUT:
		  case DMDPUSHBUT:
		  case DMRADIOBUT:
		  case DMCHECKBOX:
		  case DMPATBOX:
		  case DMPICKLIST:
		    curface &= dep->attr;
		    tmp |= dep->attr;
		    if (first) {
			curfont = dep->font;
			cursize = dep->fontsize;
			first = 0;
		    } else {
			if (curfont != dep->font) {
			    curfont = -1;
			}
			if (cursize != dep->fontsize) {
			    cursize = -1;
			}
		    }
		}
	    }
	}
	if (curface == 0 && tmp != 0) {
	    curface = FFSnomatch;
	}
    } else if (dep == (DedItem *) FFSnone) {
	/*
	 **	No Item Selected, so Check "running" FFS
	 */
	FFSstate = FFSnone;
	curfont = runfont;
	curface = runface;
	cursize = runsize;
    } else {
	/*
	 **	Single Item Selected
	 */
	switch (dep->type) {
	  case DMTEXT:
	  case DMTEXTEDIT:
	  case DMPUSHBUT:
	  case DMDPUSHBUT:
	  case DMRADIOBUT:
	  case DMCHECKBOX:
	  case DMPATBOX:
	  case DMPICKLIST:
	    FFSstate = FFSone;
	    curfont = dep->font;
	    curface = dep->attr;
	    cursize = dep->fontsize;
	}
    }
    CheckFFS();
}

CheckFFS()
{
    int i, j;
    short tmp;
    
    /*
     **	All Style Checks OFF
     */
    for (i=0; i<MAXSTYLE; i++) {
	CheckItem(STYLE, i, 0);
    }
    /*
     **	All Font Checks OFF
     */
    for (i=0; i<MAXPD; i++) {
	CheckItem(FONT, i, 0);
    }
    /*
     **	Check Font
     */
    for (i=1; DEDfont[i]!=-1; i++) {
	if (curfont == DEDfont[i]) {
	    CheckItem(FONT, i, 1);
	}
    }
    /*
     **	Check all in Face
     */
    if (curface == 0) {
	CheckItem(STYLE, Fnormal, 1);
    } else if (curface != FFSnomatch) {
	for (tmp=1,j=0; j<8; j++) {
	    if (tmp & curface) {
		for (i=1; i<=Foutline; i++) {
		    if (tmp == DEDstyle[i]) {
			CheckItem(STYLE, i, 1);
		    }
		}
	    }
	    tmp <<= 1;
	}
    }
    /*
     **	Check Size
     */
    if (cursize == 0)
	tmp = 12;
    else
	tmp = cursize;
    for (i=Foutline+1; i<MAXSTYLE; i++) {
	if (tmp == DEDstyle[i]) {
	    CheckItem(STYLE, i, 1);
	}
    }
}

clear(rp)
DedItem	*rp;
{
    memset(rp, 0, sizeof(DedItem));
}

printrect(rp)
Rect *rp;
{
    if (debug) {		
	FrameRect(rp);
	printf("l=%d, t=%d, r=%d, b=%d\n",rp->edge.left,rp->edge.top,rp->edge.right,rp->edge.bottom);
	printf("h=%d, w=%d\n",rp->edge.bottom-rp->edge.top,rp->edge.right-rp->edge.left);
    }
}

snap2grid(rp)
Rect *rp;
{
    short dh, dv, h, v;

    h = ((((rp->edge.left + (hgrid / 2)) / hgrid)) * hgrid);
    v = ((((rp->edge.top + (vgrid / 2)) / vgrid)) * vgrid);
    dh = h - rp->edge.left;
    dv = v - rp->edge.top;
    OffsetRect(rp, dh, dv);
}

stretch2grid(rp)
Rect *rp;
{
    short dh, dv, h, v;

    rp->edge.right = ((((rp->edge.right + (hgrid / 2)) / hgrid)) * hgrid);
    rp->edge.bottom = ((((rp->edge.bottom + (vgrid / 2)) / vgrid)) * vgrid);
}

short
rectwidth(rp)
Rect *rp;
{
    return rp->edge.right - rp->edge.left;
}

short
rectheight(rp)
Rect *rp;
{
    return rp->edge.bottom - rp->edge.top;
}

countitems()
{
    DedItem *rp;
    int i, j;

    j = 0;
    rp = dialog;
    for (i=0; i<MAXDLG; i++,rp++) {
	if (rp->type)
	    j++;
    }
    return j;
}

/*
 **	Get text & null terminate it
 */
gettext(cp, cid)
char *cp;
void *cid;
{
    int count;
    
    count = TEGetText(cp, cid);
    cp[count] = 0;
}

DedInit1()
{
    int i;
    
    memset(dialog, 0, sizeof dialog);
    /*
     **	Setup dialog item text pointers
     */
    memset(dedtext, 0, sizeof dedtext);
    for (i=0; i<MAXDLG; i++) {
	dialog[i].text = (char*)&dedtext[i];
    }
    /*
     **	Setup dialog item name pointers
     */
    memset(dedname, 0, sizeof dedname);
    for (i=0; i<MAXDLG; i++) {
	dialog[i].name = (char*)&dedname[i];
    }

    /*
     **	Setup dialog item tab-sequence name pointers.
     */
    memset(dedtabs, 0, sizeof dedtabs);
    for (i=0; i<MAXDLG; i++) {
	dialog[i].tabto = (char*)&dedtabs[i];
    }

    dummyfont = dummysize = 0;
}

DedInit2()
{
    Rect tr;

    SetRect(&tr, 0, 0, 700, 500);
    EraseRect(&tr);
    TextFont(0);		/* Set-Up Initial Font. */
    TextSize(12);
    TextFace(normalText);
    GetFontInfo(&fi);
    dirty = 0;
}

DedSetTitle(flag)
{
    sprintf(title, "Dialog %s", filename);
    if (flag)
	SetWTitle(windowid, title);
}

/*
**	D R A W  /  D I S P L A Y   R O U T I N E S
*/
displayinfo()
{
    DMDcb *cb, *prevcb;
    char buf[10];
    Rect *rp;
    DedItem *dp;
    int i;

    cb = DMNew(Dinfo, windowid, 0);
    incollect = 1;
    prevcb = RfshDlg;
    RfshDlg = cb;
    dp = &dialog[0];
    for (i=0; i<MAXDLG; i++,dp++) {
	if (dp->selected) {
	    break;
	}
    }
    rp = &dp->rect;
    sprintf(buf, "%d", rp->edge.left);
    DMSetText(cb, DINFO_left, buf);
    sprintf(buf, "%d", rp->edge.top);
    DMSetText(cb, DINFO_top, buf);
    sprintf(buf, "%d", rp->edge.right);
    DMSetText(cb, DINFO_right, buf);
    sprintf(buf, "%d", rp->edge.bottom);
    DMSetText(cb, DINFO_bottom, buf);
    sprintf(buf, "%d", rectwidth(rp));
    DMSetText(cb, DINFO_width, buf);
    sprintf(buf, "%d", rectheight(rp));
    DMSetText(cb, DINFO_height, buf);
    DMCollect(cb);
    DMDispose(cb);
    incollect = 0;
    ClipRect(&noclip);
    RfshDlg = prevcb;
    return;
}

select(rp)
DedItem	*rp;
{
    rp->selected = 1;
    display(rp);
}

xselect(rp)
DedItem	*rp;
{
    deselectall(1);
    select(rp);
}

deselect(rp)
DedItem	*rp;
{
    if (rp->selected) {
	rp->selected = 0;
	erase(rp);
	display(rp);
	InvalRect(&rp->rect);
    }
}

deselectall(invalwanted)
int invalwanted;
{
    int i;
    DedItem *rp;

    rp = &dialog[0];
    for (i=0; i<MAXDLG; i++, rp++) {
	if (rp->selected) {
	    erase(rp);
	    if (invalwanted) {
		InvalRect(&rp->rect);
	    }
	    rp->selected = 0;
	    display(rp);
	}
    }
}

selectall()
{
    int i;
    DedItem *rp;

    dupoffsetx = dupoffsety = 0;
    rp = &dialog[0];
    eraseselected();
    for (i=0; i<MAXDLG; i++, rp++) {
	if (rp->type) {
	    rp->selected = 1;
	}
    }
    dspall();
}

delete(rp)
DedItem *rp;
{
    if (rp->type) {
	erase(rp);
	rp->type = rp->selected = 0;
    }
}

deleteselected()
{
    int i;
    DedItem *rp;

    rp = dialog;
    for (i=0; i<MAXDLG; i++,rp++) {
	if (rp->selected) {
	    delete(rp);
	}
    }
    dspall();
}

erase(rp)
DedItem *rp;
{
    EraseRect(&rp->rect);
}

eraseselected()
{
    int i;
    DedItem *rp;

    rp = dialog;
    for (i=0; i<MAXDLG; i++,rp++) {
	if (rp->selected) {
	    erase(rp);
	}
    }
}

copy()
{
    freeclip();
    putinclip();
}

cut()
{
    freeclip();
    putinclip();
    deleteselected();
    sort();
}

paste()
{
    DedClip *clip;
    DedItem *dip;
    DedItem *ndip;
    int i;
    char *cp1, *cp2;

    deselectall(0);
    clip = clipboard;
    for (i=0; i<MAXDLG && clip->dip; i++,clip++) {
	ndip = dupitem(clip->dip);
	ndip->selected = 1;
	display(ndip);
	dspselect(ndip);
    }
    sort();
}

freeclip()
{
    DedClip *clip;
    int i;

    clip = clipboard;
    for (i=0; i<MAXDLG; i++,clip++) {
	if (clip->dip) {
	    if (clip->dip->name) {
		free(clip->dip->name);
	    }
	    if (clip->dip->text) {
		free(clip->dip->text);
	    }
	    free(clip->dip);
	    clip->dip = 0;
	}
    }
}

putinclip()
{
    DedClip *clip;
    DedItem *dip;
    int i;

    dip = dialog;
    clip = clipboard;
    for (i=0; i<MAXDLG; i++,dip++) {
	if (dip->selected && dip->type) { /* Make copy of Dialog Editor Item */
	    EnableItem(EDIT, PASTE);
	    clip->dip = (DedItem *) malloc(sizeof(DedItem));
	    *clip->dip = *dip;
	    clip->dip->name = (char *) malloc(StringLen(dip->name));
	    strcpy(clip->dip->name, dip->name);
	    clip->dip->text = (char *) malloc(StringLen(dip->text));
	    strcpy(clip->dip->text, dip->text);
	    clip++;
	}
    }
}

/*
**	Common TENew Func
*/
void *
dlgTENew(rp)
DedItem	*rp;
{
    Rect tr;
    void *id;

    tr = rp->rect;
    InsetRect(&tr, 3, 3);
    doFontFaceSize(rp);
    id = TENew(&tr, &tr);
    if (rp->value & DItecenterJust) {
	TESetJust(teJustCenter, id);
    } else if (rp->value & DIterightJust) {
	TESetJust(teJustRight, id);
    }	
    TECROnly(1, id);
    TESetText(rp->text, StringLen(rp->text), id);
    TEUpdate(&tr, id);
    FrameRect(&rp->rect);
    return id;
}

setdefinemode()
{
    CheckItem(OPTIONS, mode, 0);
    Event(mouseEvt, modedefine);
    Event(keyEvt, modedefine);
    mode = MODEDEFINE;
    SetCursor(&hand);
    CheckItem(OPTIONS, mode, 1);
}

setdefinetabmode()
{
    CheckItem(OPTIONS, mode, 0);
    Event(mouseEvt, modedefinetab);
    Event(keyEvt, modedefinetab);
    mode = MODETAB;
    SetCursor(&tab);
    CheckItem(OPTIONS, mode, 1);
}

setpointmode()
{
    CheckItem(OPTIONS, mode, 0);
    Event(mouseEvt, mouseevent);
    Event(keyEvt, keyevent);
    mode = MODEPOINT;
    InitCursor();
    CheckItem(OPTIONS, mode, 1);
}

setFontFaceSize(rp) 
DedItem *rp;
{
    dmFontFaceSize(curfont,curface,cursize);
    rp->font = curfont;
    rp->attr = curface;
    rp->fontsize = cursize;
}

doFontFaceSize(rp)
DedItem *rp;
{
    dmFontFaceSize(rp->font, rp->attr, rp->fontsize);
}

doFontFaceSize2(rp)
DedItem *rp;
{
    dmFontFaceSize(rp->font, -1, rp->fontsize);
}

set_names(name)
char name[300];
{
    char *cp;

    cp = name;
    while (*cp && *cp != '.') /* Force '.c' suffix. */
	cp++;
    *cp++ = '.';
    *cp++ = 'c';
    *cp = 0;
    strcpy(filename,name);

    strcpy(hfilename,name);
    cp = hfilename;
    while (*cp && *cp != '.') /* Force '.h' suffix. */
	cp++;
    *cp++ = '.';
    *cp++ = 'h';
    *cp = 0;

    cp = strrchr(name,'/');	/* Dump the path... keep the file name only. */
    if (cp) 
	cp++; 
    else 
	cp = name;
    strcpy(dlgname,cp);
    if ((cp = strpbrk(dlgname, "."))) { /* Knock off the '.h' suffix. */
	*cp = 0;
    }

    strcpy(dlgnameCaps,dlgname);
    cp = dlgnameCaps;
    while (*cp) {
	if (*cp >= 'a' && *cp <= 'z') {
	    *cp -= 'a' - 'A';
	}
	cp++;
    }
}

