/*
** Menu Defines
*/

#define	FFILE		1
#define	FOPEN		1
#define	FCLOSE		2
#define	FSAVE		3
#define	FSAVEAS		4
#define	FQUIT		6

#define	EDIT		3
#define	SELECTALL	1
#define	DELETE		2
#define	CUT		4
#define	COPY		5
#define	PASTE		6
#define	DUP		7
#define LCONTROL	9
#define LSELECT		10
#define LSET		11
#define USEL		13
#define USET		14
#define GSEL		16


#define NEW		4
#define	BOX		1
#define CHECKBOX	2
#define	CNTLBOX		3
#define RADIOBUT	5
#define	PUSHBUT		6
#define	DPUSHBUT	7
#define TEXT		9
#define TEXTEDIT	10
#define	SCROLLBAR	12
#define	PICKLIST	13
#define	TEXTBOX		15
#define	LINE		16
#define	USERITEM	17

#define	OPTIONS		5
#define	MODEPOINT	1
#define	MODETEXT	2
#define	MODEDEFINE	3
#define	MODETAB		4
#define	GRIDON		6
#define	SETGRID		7
#define	RUBBER		9
#define	OFFSETDP	10
#define	OBJINFO		12

#define	BORDER		7
#define	SHADOW		1
#define	SINGLE		2
#define	DOUBLE		3
#define	TRIPLE		4
#define	INVISIBLE	5
#define	PENWIDTH1	7
#define	PENWIDTH2	8
#define	PENWIDTH3	9

#define	GROUP		8
#define	NONE0		1
#define	OTHER		2
#define	EXCLUSIVE1	4
#define	EXCLUSIVE2	5
#define	EXCLUSIVE3	6
#define	EXCLUSIVE4	7
#define	EXCLUSIVE5	8
#define	ACTIVATE1	10
#define	GENERAL1	12
#define	GENERAL2	13
#define	GENERAL3	14
#define	GENERAL4	15
#define	GENERAL5	16
#define	EXIT1		18
#define	EXIT2		19
#define	EXIT3		20
#define	EXIT4		21
#define	EXIT5		22

#define	FORECOLOR	1
#define	BACKCOLOR	0

#define	FONT		9

#define	STYLE		10
#define	Fnormal		1
#define	Fbold		2
#define	Funderline	3
#define	Fitalic		4
#define	Fghost		5
#define	Foutline	6

#define	MAXDLG		300
#define	MAXPD		30
#define	XY		7

#define	IMPORT		1
#define	TOUCH		1
#define	ENCLOSE		2

#define FFSnone 	0
#define	FFSone		1
#define FFSmany 	2
#define	FFSnomatch	(short)(0x8000)



/* ------------------- */
/*  Allocated in .c  */
/* ------------------- */

/*
**	DIALOG EDITOR ITEM STRUCT
*/
typedef struct deditem {
	Rect	rect;		/* gadget size */
	Rect	tmp;		/* tmp gadget size */
	Rect	active;		/* gadget active area */
	Rect	handle;		/* handle area */
	byte	type;		/* CBOX or CONTROL etc */
	byte	group;		/* grouping for radio buttons, 255 reserved */
	byte	when;		/* tabbing sequence number */
	byte	xfermode;	/* Color transfer mode */
	short	fgColor;	/* Foreground color. */
	short	bkColor;	/* Background color. */
	int	keycode;	/* function key equivelent */
	short	value;		/* initial/final value */
	short	min;		/* min allowed value */
	short	max;		/* max allowed value */
	short	ident;		/* item identifier. */
	char	*text;		/* ASCII string */
	char	*name;		/* name */
	char	*tabto;		/* Tab-to item name (for TE's). */
	short	font;		/* font */
	short	fontsize;	/* font size */
	short	attr;		/* object attributes */
	char	prefill[30];	/* prefill function */
	char	validate[30];	/* validate function */
	short	cntlid;		/* controll ID */
	UINT	usercode;	/* any value for app use */
	byte	selected;	/* selected */
	byte	layer;		/* layer of item (editor only). */
	void	*id;		/* control id */
	short	otherfont;
	short	othersize;
} DedItem;

/*
**	E X T E R N S
*/
extern char *version;
extern	int	dir_count;
extern	char	directory[];
extern	int	errno;
extern	DMItem	Dsaveas[];
extern	DMItem	Dcontrol[];
extern	DMItem	Dsbar[];
extern	DMItem	Dtextedit[];
extern  DMItem	Dbox[];
extern	DMItem	Dsavechg[];
extern	DMItem	Dgrid[];
extern	DMItem	Dtext[];
extern	DMItem	Dpat[];
extern	DMItem	Dpicklist[];
extern	DMItem	Derror[];
extern	DMItem	Dinfo[];
extern	DMItem	Dgroup[];
extern	long	dlgControl();

/*
**	F U N C T I O N S
*/
void	keyevent(EventRecord *);
void	menuevent(EventRecord *);
void	mouseevent(EventRecord *);
void	updateevent(EventRecord *);
void	windowevent(EventRecord *);

void	modedefine(EventRecord *);
void	modetext(EventRecord *);

void	IntlFontSize(short, short);

char		*strchr(char *, const char *);
short		rectwidth(Rect	*);
short		rectheight(Rect	*);
void 		*dlgTENew(DedItem	*);
DedItem		*onobject(Point	*);
DedItem		*findslot();
DedItem		*dupitem(DedItem	*);
ControlID	dlgNewControl(short, Rect *, char *, short, short, short,
					  short, short, long, short, short);
DedItem *findnameditem(char *name);

/*
** Clipboard
*/
typedef struct dedclip {
	DedItem	*dip;
} DedClip;


/*
** Got to have 'dedname[]' & 'dedtext[]' because the damn
** controls expect a pointer to text that does not move,
** but sort moves the text unless done like this
*/
/*eject*/

/*
** G L O B A L S
*/
static short savefgColor;
static short savebkColor;
DedItem	dialog[MAXDLG];
char	dedtext[MAXDLG][150];
char	dedname[MAXDLG][60];
char	dedtabs[MAXDLG][60];
DedClip	clipboard[MAXDLG];

static short dummyfont, dummysize;

extern Cursor text;
extern byte DEDgroup[MAXPD];
extern short DEDfont[MAXPD];
extern short DEDstyle[MAXPD];

/*
**	General
*/
int	sw;
char	*path;
char	*Routines[MAXDLG * 2];
Rect	rect;
Rect	noclip;
int	gridon;
int	hgrid;
int	vgrid;
int dupoffsetx, dupoffsety;
extern char datafile[30];
extern char filename[300];
extern char hfilename[300];
extern char dlgname[300];
extern char dlgnameCaps[300];
int	backedup;
int	mode;
int	debug;
int	startupfile;
int	convert;
int	DialogSize;
int	dirty;
int	rubber;
int	offsetdp;
int	srconly;
int	valpat;
int	FFSstate;
short	runface;
short	runsize;
short	runfont;
short	curface;
short	cursize;
short	curfont;
short	incollect;
FontInfo fi;
FILE	*fp;
FILE	*hfp;
DMDcb	*RfshDlg;
DedItem	*DefPtr;
int hideflags;

/*
**	Window Variables
*/
int		windowid;
int		width;
int		height;
int		fullwidth;
int		fullheight;
int		xpos;
int		ypos;
int		iconified;
char		title[300];
Rect		window;
Point		hit, drag;
unsigned long	dblclicktime;
extern Icon charticon;
