
/*
**	D I A L O G   E D I T O R   F I L E   P I C K E R
**
**	Stolen from: Brian Antoine
**	Integrated by: Dennis Weaver
**	Date: 7-16-91
**
*/
/*
**	I N C L U D E S
*/
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <malloc.h>
#include <sys/stat.h>
#include <sys/times.h>
#include <dnix/fcodes.h>
#include <isc/window.h>
#include <isc/keycodes.h>
#include <isc/cd_clunkdraw.h>
#include <isc/textedit.h>
#include <isc/controls.h>
#include <isc/dlgman.h>
#include "Dopen.h"
/*eject*/
/*
**	Module Function Declarations
*/
int namecomp();

/*
**	External Variables
*/
extern	char	filename[];
extern	Rect	window;
extern	int		srconly;
extern	short	incollect;
extern	int		windowid;
extern	DMItem	Dopen[];
extern	DMDcb	*RfshDlg;
/*
**	Module Defines
*/
#define	MAX_FILENAME	100
#define	MAX_DIR			100
#define	MAX_FILE		200
/*
**	Module Globals
*/
short	dir_count;
char	directory[MAX_FILENAME];
char	*dir[MAX_DIR];
char	*file[MAX_FILE];
Cursor	watch_cursor = {
	{0x0000, 0x07C0, 0x07C0, 0x07C0, 0x0820, 0x1110, 0x2108, 0x2108,
	 0x2208, 0x2408, 0x1010, 0x0820, 0x07C0, 0x07C0, 0x07C0, 0x0000},
	{0x0FE0, 0x0FE0, 0x0FE0, 0x1FE0, 0x1FF0, 0x3FF8, 0x7FFC, 0x7FFC,
	 0x7FFC, 0x7FFC, 0x3FF8, 0x1FF0, 0x1FE0, 0x0FE0, 0x0FE0, 0x0FE0},
	{8,8}};
/*eject*/
/*
**	O P E N   R O U T I N E S
*/
DedOpen()
{
	DMDcb	*cb;
	DMDcb	*prevcb;
	int		group;
	int		answer;
	char	newname[30];
	SFDialog sf;

	answer = ask2save();
	if(answer == DMok) {
		/*
		**	Save Current Dialog
		*/
		save();
	}
	if(answer == DMok || answer == DMno) {
		/*
		**	Get Name of Dialog & Open
		*/
	    sf.options = SF_GETFILE;
	    sf.initialname = filename;
	    sf.shellmatch = "*.c";
	    sf.regexpmatch = 0;
	    sf.title = 0;
	    if (FilePicker(&sf) < 0) { /* Try std filepicker, if it fails */
		cb = DMNew(Dopen,windowid,0); /* use the built-in dialog. */
		incollect = 1;
		prevcb = RfshDlg;
		RfshDlg = cb;
		DMSetPickItem(cb,DOPEN_directories,dir_count-1);
		DMKeys2Pick(cb,DOPEN_files);
		group = DMCollect(cb);
		if(group == DMok) {
			DMGet(cb,DOPEN_filename,filename);
			DMDispose(cb);
			DedInit1();
			DedInit2();
			DedSetTitle();
			myopen();
		}
		else {
			DMDispose(cb);
		}
		incollect = 0;
		RfshDlg = prevcb;
	    } else {		/* FilePicker worked */
		if (sf.returnedname) {
		    strcpy(filename, sf.returnedname);
		    free(sf.returnedname);
		    DedInit1();
		    DedInit2();
		    DedSetTitle();
		    myopen();
		}
	    }
	}
}
/*
**	Support Routines for Open Dialog
*/
PFfilename(dialog, item, buffer)
DMDcb *dialog;
DMItem *item;
char *buffer;
{
	strcpy(buffer, filename);
}

PFdirectories(dialog, item, pick)
DMDcb *dialog;
DMItem *item;
DMPick *pick;
{
	char *cp;

	/*
	** look for a directory slash
	*/
	strcpy(directory, filename);
	cp = strrchr(directory, '/');
	if(cp) {
		*(++cp) = 0;
	}
	else {
		getcwd(directory, MAX_FILENAME);
		strcat(directory, "/");
	}
	/*
	** gen the list of directorys to get to our current location
	*/
	dir_count = Build_Dir_List();
	pick->length = dir_count;
	pick->arrayhead = &dir[0];
}

PFfiles(dialog, item, pick)
DMDcb *dialog;
DMItem *item;
DMPick *pick;
{
	/*
	** show us as busy
	*/
	SetCursor(&watch_cursor);
	FlushWindow();
	/*
	** gen the list of files in the current directory
	*/
	pick->length = Build_File_List();
	pick->arrayhead = &file[0];
	InitCursor();
}

PFsrconly(dialog, item, value)
DMDcb	*dialog;
DMItem	*item;
int		*value;
{
	*value = srconly;
}

VALdirectories(dialog, item, when, index, partcode)
DMDcb *dialog;
DMItem *item;
unsigned char when;
short index, partcode;
{
	DMPick list;
	short i;
	char tempname[MAX_FILENAME];

	if(partcode == inListDbl)  {
		/* inListDbl */
		/*
		** build the new directory head
		*/
		tempname[0] = 0;
		for (i = 0; i <= index; i++) {
			strcat(tempname, dir[i]);
		}
		if(strcmp(directory, tempname)) {
			/*
			** its different then the current head
			*/
			SetCursor(&watch_cursor);
			FlushWindow();
			strcpy(directory, tempname);
			dir_count = Build_Dir_List();
			list.length = dir_count;
			list.arrayhead = &dir[0];
			list.selitem = 0;
			list.topitem = 0;
			list.redrawitem = 0;
			DMModifyPick(dialog, DOPEN_directories, &list);
			DMSetPickItem(dialog, DOPEN_directories, dir_count-1);
			list.length = Build_File_List();
			list.arrayhead = &file[0];
			list.selitem = 0;
			list.topitem = 0;
			list.redrawitem = 0;
			DMModifyPick(dialog, DOPEN_files, &list);
			InitCursor();
		}
	}
	ClipRect(&window);
	return(DM_PASS);
}

VALfiles(dialog, item, when, index, partcode)
DMDcb	*dialog;
DMItem	*item;
unsigned char	when;
short	index;
short	partcode;
{
	DMPick	list;
	int		status = DM_PASS;
	char	tempname[MAX_FILENAME];

	if(partcode == inListDbl) {
		/*
		** did we select a directory
		*/
		if(strchr(file[index], '/')) {
			strcpy(tempname, directory);
			strcat(tempname, file[index]);
			if(access(tempname, 05)) {
				status = DM_FAIL;
			}
			else {
				SetCursor(&watch_cursor);
				FlushWindow();
				strcat(directory, file[index]);
				dir_count = Build_Dir_List();
				list.length = dir_count;
				list.arrayhead = &dir[0];
				list.selitem = 0;
				list.topitem = 0;
				list.redrawitem = 0;
				DMModifyPick(dialog, DOPEN_directories, &list);
				DMSetPickItem(dialog, DOPEN_directories, dir_count-1);
				list.length = Build_File_List();
				list.arrayhead = &file[0];
				list.selitem = 0;
				list.topitem = 0;
				list.redrawitem = 0;
				DMModifyPick(dialog, DOPEN_files, &list);
				InitCursor();
			}
		}
		else {
			/*
			** we selected a file
			*/
			strcpy(tempname,directory);
			strcat(tempname,file[index]);
			DMSetText(dialog,DOPEN_filename,tempname);
			status = DMok;
		}
	}
	else if(partcode == inList) {
		strcpy(tempname,directory);
		strcat(tempname,file[index]);
		DMSetText(dialog,DOPEN_filename,tempname);
	}
	ClipRect(&window);
	return(status);
}

VALok(dialog, item, when, value)
DMDcb *dialog;
DMItem *item;
unsigned char when;
short value;
{
	ControlID 	cid;
	DMPick		list;
	int			i;
	struct stat	statbuf;
	char		buffer[MAX_FILENAME], *cp;
	short		index;

	/*
	**	stuff filename if empty or it's a directory
	*/
	DMGet(dialog,DOPEN_filename,buffer);
	if(buffer[strlen(buffer)-1] == '/' || buffer[0] == 0) {
		DMGet(dialog,DOPEN_files,&index);
		strcpy(buffer,directory);
		strcat(buffer,file[index]);
		DMSetText(dialog,DOPEN_filename,buffer);
	}
	/*
	** is filename a directory
	*/
	if(!stat(buffer, &statbuf)) {
		/* stat ok */
		if(S_ISDIR(statbuf.st_mode)) {
			for(cp = buffer; *cp; cp++);
			if(*(cp-1) != '/') {
				*(cp++) = '/';
				*cp = 0;
			}
			/*
			** switch to the new directory
			*/
			SetCursor(&watch_cursor);
			FlushWindow();
			strcpy(directory, buffer);
			dir_count = Build_Dir_List();
			list.length = dir_count;
			list.arrayhead = &dir[0];
			list.selitem = 0;
			list.topitem = 0;
			list.redrawitem = 0;
			DMModifyPick(dialog, DOPEN_directories, &list);
			DMSetPickItem(dialog, DOPEN_directories, dir_count-1);
			list.length = Build_File_List();
			list.arrayhead = &file[0];
			list.selitem = 0;
			list.topitem = 0;
			list.redrawitem = 0;
			DMModifyPick(dialog, DOPEN_files, &list);
			InitCursor();
		}
	}
	return(DM_PASS);
}

VALfilename(dialog, item, when, buffer)
DMDcb *dialog;
DMItem *item;
unsigned char when;
DMTEVal *buffer;
{
	struct stat	statbuf;

	if(buffer->text[strlen(buffer->text)-1] == '/' || buffer->text[0] == 0) {
		return(DM_FAIL_NO_BELL);
	}
	if(!stat(buffer, &statbuf)) {
		if(S_ISREG(statbuf.st_mode)) {
			return(DM_PASS);
		}
	}
	ClipRect(&window);
	return(DM_FAIL);
}

VALsrconly(dialog, item, when, value, partcode)
DMDcb	*dialog;
DMItem	*item;
unsigned char	when;
short	value;
short	partcode;
{
	DMPick	list;

	srconly = value ? 0:1;
	SetCursor(&watch_cursor);
	FlushWindow();
	list.length = Build_File_List();
	list.arrayhead = &file[0];
	list.selitem = 0;
	list.topitem = 0;
	list.redrawitem = 0;
	DMModifyPick(dialog, DOPEN_files, &list);
	InitCursor();
}
/*
** build a list of files,
** returning the count of files found.
*/
Build_File_List()
{
	register DIR	*dp;
	register struct dirent *dep;
	register int 	count = 0;
	struct	stat	statbuf;
	char			tempname[1024];
	int				len;

	/*
	** open the directory
	*/
	dp = opendir(directory);
	if(!dp) {
		return(0);
	}
	/*
	** build the picklist
	*/
	while((dep = readdir(dp))) {
		/*
		** skip some obvious junk
		*/
		if(dep->d_name[0] == '.') {
			continue;
		}
		/*
		** try to stat the item
		*/
		strcpy(tempname, directory);
		strcat(tempname, dep->d_name);
		if(stat(tempname, &statbuf)) {
			continue;
		}
		/*
		** it must be a file or a directory
		*/
		if(!S_ISREG(statbuf.st_mode) && !S_ISDIR(statbuf.st_mode)) {
			continue;
		}
		/*
		**	".c" files only
		*/
		if(S_ISREG(statbuf.st_mode) && srconly) {
			len = strlen(dep->d_name);
			if(dep->d_name[len-2] != '.' || dep->d_name[len-1] != 'c') {
				continue;
			}
		}
		/*
		** try to add it to the list
		*/
		if(count < MAX_FILE) {
			if(!file[count]) {
				file[count] = malloc(sizeof(struct dirent));
				if(!file[count]) {
					break;
				}
			}
			strcpy(file[count], dep->d_name);
			if(S_ISDIR(statbuf.st_mode)) {
				strcat(file[count], "/");
			}
			count++;
		}
	}
	/*
	** cleanup
	*/
	closedir(dp);
	if(count) {
		shellsort(&file[0], count, sizeof(char *), namecomp);
	}
	return(count);
}

Build_Dir_List()
{
	register int count = 0;
	register char *src = directory, *dst;

	/*
	** pick the directory apart
	*/
	while(*src && count < MAX_DIR) {
		/*
		** get us some storage if needed
		*/
		if(!dir[count]) {
			dir[count] = malloc(sizeof(struct dirent));
			if(!dir[count]) {
				break;
			}
		}
		/*
		** copy out the next directory
		*/
		dst = dir[count];
		do {
			*dst++ = *src;
		} while ( *src && *(src++) != '/' );
		*dst = 0;
		count++;
	}
	return(count);
}

/*
** Shell sort with the calling sequence of qsort.
*/
#define A(v, i)  ((v) + ((i) * size))

shellsort(v, n, size, compar)
char *v;
int n, size;
int (*compar)();
{
	register int j;
	int gap, i;

	for(gap = n/2; gap > 0; gap /= 2) {
		for(i = gap; i < n; i++) {
			for(j = i-gap; j >= 0; j -= gap) {
				if((*compar)(A(v,j), A(v,j+gap)) <= 0) {
					break;
				}
				qexch(A(v,j), A(v,j+gap), size);
			}
		}
	}
}

static qexch(p1, p2, n)
char *p1, *p2;
int n;
{
	register char save;

	while(n--) {
		save = *p1;
		*p1++ = *p2;
		*p2++ = save;
	}
}

/*
** compare two names
*/
namecomp(a, b)
char **a, **b;
{
	return( strcmp(*a, *b) );
}

FreeLists()
{
	register int i;

	for(i = 0; i < MAX_DIR; i++) {
		if ( dir[i] ) free(dir[i]);
		dir[i] = NULL;
	}
	for(i = 0; i < MAX_FILE; i++) {
		if(file[i]) {
			free(file[i]);
		}
		file[i] = NULL;
	}
}
