/*
**	I N C L U D E S
*/
#include <stdio.h>
#include <string.h>
#include <isc/keycodes.h>
#include <isc/window.h>
#include <isc/controls.h>
#include <isc/textedit.h>
#include <isc/dlgman.h>
#include "dlged.h"
#include "Dgroup.h"
#include "Dlayer.h"
#include "Dsellayer.h"
#include "Dsetlayer.h"
#include "Dseluser.h"
#include "Dsetuser.h"
#include "Dselgroup.h"

disablemenus()
{
    DisableItem(FFILE, FOPEN);
    DisableItem(FFILE, FCLOSE);
    DisableItem(FFILE, FSAVE);
    DisableItem(FFILE, FSAVEAS);
    DisableMenu(EDIT);
    DisableMenu(NEW);
    DisableMenu(OPTIONS);
    DisableMenu(BORDER);
    DisableMenu(GROUP);
    DisableMenu(FONT);
    DisableMenu(STYLE);
}

enablemenus()
{
    EnableItem(FFILE, FOPEN);
    EnableItem(FFILE, FCLOSE);
    EnableItem(FFILE, FSAVE);
    EnableItem(FFILE, FSAVEAS);
    EnableMenu(EDIT);
    EnableMenu(NEW);
    EnableMenu(OPTIONS);
    EnableMenu(BORDER);
    EnableMenu(GROUP);
    EnableMenu(FONT);
    EnableMenu(STYLE);
}

/*
**	M E N U   E V E N T S
*/
void
menuevent(ep)
EventRecord *ep;
{
    int menuid, menuitem, epmsg, i, sw, sh;
    Rect tr;
    DedItem *rp;
    short runattr, runmask;
    DMDcb *cb, *prevcb;
    int group;
    char buf[10];

    BeginMenu(ep->message);
    NoMenuKeyXlate();
    menuid = ep->message >> 16;
    menuitem = ep->message & 0xFFFF;
    epmsg = ep->message;
    switch (menuid) {
      case FFILE:
	switch (menuitem) {
	  case FOPEN:
	    DedOpen();
	    break;

	  case FCLOSE:
	    DedClose();
	    break;

	  case FSAVE:
	    save();
	    break;

	  case FSAVEAS:
	    saveas();
	    break;

	  case FQUIT:
	    DedQuit();
	    break;
	}
	break;

      case EDIT:
	switch (menuitem) {
	  case SELECTALL:
	    selectall();
	    MakeFFS(FFSmany);
	    CheckFFS();
	    break;

	  case DELETE:
	    dirty = 1;
	    deleteselected();
	    break;

	  case CUT:
	    dirty = 1;
	    cut();
	    break;

	  case COPY:
	    copy();
	    break;

	  case PASTE:
	    dirty = 1;
	    paste();
	    break;

	  case DUP:
	    dirty = 1;
	    dupe();
	    break;

	  case LCONTROL:
	    cb = DMNew(Dlayer, windowid, 0);
	    incollect = 1;
	    InitCursor();
	    prevcb = RfshDlg;
	    RfshDlg = cb;
	    group = DMCollect(cb);
	    if (group == DMok) {
		hideflags = 0;
		if (DMGet(cb, DLAYER_layer1, &i), i)
		    hideflags |= 2;
		if (DMGet(cb, DLAYER_layer2, &i), i)
		    hideflags |= 4;
		if (DMGet(cb, DLAYER_layer3, &i), i)
		    hideflags |= 8;
		if (DMGet(cb, DLAYER_layer4, &i), i)
		    hideflags |= 16;
		rp = &dialog[0];
		for (i=0; i<MAXDLG; i++, rp++) { /* Hiding selected items? */
		    if (rp->selected && (hideflags & (1 << rp->layer))) {
			rp->selected = 0; /* Deselect. */
		    }
		}
		EraseRect(&window); /* Force a full redraw. */
		InvalRect(&window);
	    }
	    DMDispose(cb);
	    incollect = 0;
	    RfshDlg = prevcb;
	    break;

	  case LSELECT:
	    cb = DMNew(Dsellayer, windowid, 0);
	    incollect = 1;
	    InitCursor();
	    prevcb = RfshDlg;
	    RfshDlg = cb;
	    group = DMCollect(cb);
	    if (group == DMok) {
		DMGet(cb, DSELLAYER_layer, buf);
		group = atoi(buf);
		rp = dialog;
		for (i=0; i<MAXDLG; i++,rp++) {
		    if (group == rp->layer)
			select(rp);
		}
	    }
	    DMDispose(cb);
	    incollect = 0;
	    RfshDlg = prevcb;
	    break;

	  case LSET:
	    cb = DMNew(Dsetlayer, windowid, 0);
	    incollect = 1;
	    InitCursor();
	    prevcb = RfshDlg;
	    RfshDlg = cb;
	    group = DMCollect(cb);
	    if (group == DMok) {
		dirty = 1;
		DMGet(cb, DSETLAYER_layer, buf);
		group = atoi(buf);
		rp = dialog;
		for (i=0; i<MAXDLG; i++,rp++) {
		    if (rp->selected) {
			rp->layer = group;
			if (hideflags & (1 << group)) /* Joining a hidden */
			    erase(rp); /* group?  Hide it then. */
		    }
		}
	    }
	    DMDispose(cb);
	    incollect = 0;
	    RfshDlg = prevcb;
	    break;

	  case USEL:
	    cb = DMNew(Dseluser, windowid, 0);
	    incollect = 1;
	    InitCursor();
	    prevcb = RfshDlg;
	    RfshDlg = cb;
	    group = DMCollect(cb);
	    if (group == DMok) {
		DMGet(cb, DSELUSER_usercode, buf);
		sscanf(buf, "%x", &group);
		rp = dialog;
		for (i=0; i<MAXDLG; i++,rp++) {
		    if (group == rp->usercode)
			select(rp);
		}
	    }
	    DMDispose(cb);
	    incollect = 0;
	    RfshDlg = prevcb;
	    break;

	  case USET:
	    cb = DMNew(Dsetuser, windowid, 0);
	    incollect = 1;
	    InitCursor();
	    prevcb = RfshDlg;
	    RfshDlg = cb;
	    group = DMCollect(cb);
	    if (group == DMok) {
		dirty = 1;
		DMGet(cb, DSETUSER_usercode, buf);
		sscanf(buf, "%x", &group);
		rp = dialog;
		for (i=0; i<MAXDLG; i++,rp++) {
		    if (rp->selected)
			rp->usercode = group;
		}
	    }
	    DMDispose(cb);
	    incollect = 0;
	    RfshDlg = prevcb;
	    break;

	  case GSEL:
	    cb = DMNew(Dselgroup, windowid, 0);
	    incollect = 1;
	    InitCursor();
	    prevcb = RfshDlg;
	    RfshDlg = cb;
	    group = DMCollect(cb);
	    if (group == DMok) {
		DMGet(cb, DSELGROUP_group, buf);
		group = atoi(buf);
		rp = dialog;
		for (i=0; i<MAXDLG; i++,rp++) {
		    if (group == rp->group)
			select(rp);
		}
	    }
	    DMDispose(cb);
	    incollect = 0;
	    RfshDlg = prevcb;
	    break;
	}
	break;

      case NEW:
	dirty = 1;
	rp = findslot();
	rp->group = 0;
	rp->fgColor = FORECOLOR;/* Use default colors for new items. */
	rp->bkColor = BACKCOLOR;
	switch (menuitem) {
	  case BOX:
	    SetRect(&tr, 20, 20, 60, 60);
	    FrameRect(&tr);
	    rp->rect = tr;
	    rp->type = DMBOX;
	    rp->xfermode = srcCopy;
	    rp->attr = (BSINGLE | BPENWIDTH1);
	    break;

	  case TEXTBOX:
	    SetRect(&tr, 20, 20, 52, 52);
	    rp->rect = tr;
	    rp->type = DMTEXTBOX;
	    rp->xfermode = srcCopy;
	    display(rp);
	    break;

	  case LINE:
	    SetRect(&tr, 20, 20, 80, 80);
	    rp->rect = tr;
	    rp->type = DMLINE;
	    rp->xfermode = srcCopy;
	    rp->attr = 0;
	    display(rp);
	    break;

	  case USERITEM:
	    SetRect(&tr, 20, 20, 80, 80);
	    rp->rect = tr;
	    rp->type = DMUSERITEM;
	    rp->xfermode = srcCopy;
	    display(rp);
	    break;

	  case CHECKBOX:
	    SetRect(&tr, 20, 20, 108, 34);
	    rp->rect = tr;
	    rp->type = DMCHECKBOX;
	    rp->xfermode = srcOr;
	    strcpy(rp->text, "Check Box");
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid, &tr, "Check Box", 1, 1, 0, 1,
				   checkBoxProc | useWFont, 0, rp->fgColor,
				   rp->bkColor);
	    break;

	  case RADIOBUT:
	    SetRect(&tr, 20, 20, 128, 34);
	    rp->rect = tr;
	    rp->type = DMRADIOBUT;
	    rp->group = DMexclusive1;
	    rp->xfermode = srcOr;
	    strcpy(rp->text, "Radio Button");
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid, &tr, "Radio Button", 1, 1, 0, 1,
				   radioButProc | useWFont, 0, rp->fgColor,
				   rp->bkColor);
	    break;

	  case CNTLBOX:
	    SetRect(&tr, 20, 20, 50, 50);
	    rp->rect = tr;
	    rp->type = DMPATBOX;
	    rp->group = DMexclusive2;
	    rp->xfermode = srcOr;
	    rp->pattern = 11;
	    strcpy(rp->text, "");
	    SetCDefProc(dlgControl);
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid, &tr, "", 1, 1, 0, 0xFF,
				   cntlBoxProc | useWFont, 0, rp->fgColor,
				   rp->bkColor);
	    SetCtlValues(rp->id, 0, 11);
	    SetCDefProc(0);
	    break;

	  case PUSHBUT:
	    SetRect(&tr, 20, 20, 120, 40);
	    rp->rect = tr;
	    rp->type = DMPUSHBUT;
	    rp->xfermode = srcOr;
	    strcpy(rp->text, "Push Button");
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid, &tr, "Push Button", 1, 1, 0, 1,
				   pushButProc | useWFont, 0, rp->fgColor,
				   rp->bkColor);
	    break;

	  case DPUSHBUT:
	    SetRect(&tr, 20, 20, 120, 48);
	    rp->rect = tr;
	    rp->type = DMDPUSHBUT;
	    rp->xfermode = srcOr;
	    strcpy(rp->text, "Push Button");
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid, &tr, "Push Button", 1, 1, 0, 1,
				   defButProc | useWFont, 0, rp->fgColor,
				   rp->bkColor);
	    SetCDefProc(0);
	    break;

	  case SCROLLBAR:
	    SetRect(&tr, 20, 20, 37, 100);
	    rp->rect = tr;
	    rp->type = DMSCROLLBAR;
	    rp->xfermode = srcCopy;
	    strcpy(rp->text, "");
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid, &tr, "Scroll Bar", 1, 1, 0, 1,
				   scrollBarProc, 0, rp->fgColor, rp->bkColor);
	    break;

	  case PICKLIST:
	    SetRect(&tr, 20, 20, 200, 120);
	    rp->rect = tr;
	    rp->type = DMPICKLIST;
	    FrameRect(&tr);
	    rp->xfermode = srcOr;
	    strcpy(rp->text, "");
	    pickscrollrect(&rp->rect, &tr);
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid, &tr, "Scroll Bar", 1, 1, 0, 1,
				   scrollBarProc, 0, rp->fgColor, rp->bkColor);
	    break;

	  case TEXT:
	    setFontFaceSize(rp);
	    GetFontInfo(&fi);
	    strcpy(rp->text, "Text");
	    sw = (LocalStringWidth(theFont, theFace, theSize, rp->text)) + 20;
	    sh = fi.ascent + fi.descent + 2;
	    SetRect(&tr, 20, 20, 20 + sw, 20 + sh);
	    rp->rect = tr;
	    rp->type = DMTEXT;
	    rp->xfermode = srcOr;
	    rp->TXTflags = (leftJust | vcenterJust);
	    dsptext(rp);
	    break;

	  case TEXTEDIT:
	    SetRect(&tr, 20, 20, 160, 40);
	    rp->rect = tr;
	    rp->type = DMTEXTEDIT;
	    rp->xfermode = srcOr;
	    rp->value = DItebox | DItescroll;
	    setFontFaceSize(rp);
	    rp->attr = runface | DDIghostText | DDIghostFrame;
	    strcpy(rp->text, "");
	    rp->id = dlgTENew(rp);
	    break;
	}
	sort();
	break;

      case OPTIONS:
	switch (menuitem) {
	  case MODEPOINT:
	    setpointmode();
	    break;

	  case MODETEXT:
	    CheckItem(OPTIONS, mode, 0);
	    Event(mouseEvt, modetext);
	    Event(keyEvt, modetext);
	    mode = MODETEXT;
	    SetCursor(&text);
	    CheckItem(OPTIONS, mode, 1);
	    break;

	  case MODEDEFINE:
	    setdefinemode();
	    break;

	  case MODETAB:
	    setdefinetabmode();
	    break;

	  case GRIDON:
	    if (gridon)
		gridon = 0;
	    else
		gridon = 1;
	    CheckItem(OPTIONS, GRIDON, gridon);
	    break;

	  case SETGRID:
	    setgrid();
	    break;

	  case RUBBER:
	    if (rubber == TOUCH) {
		rubber = ENCLOSE;
		CheckItem(OPTIONS, RUBBER, 0);
	    } else {
		rubber = TOUCH;
		CheckItem(OPTIONS, RUBBER, 1);
	    }
	    break;

	  case OFFSETDP:
	    if (offsetdp) {
		offsetdp = 0;
		CheckItem(OPTIONS, OFFSETDP, 0);
	    } else {
		offsetdp = 1;
		CheckItem(OPTIONS, OFFSETDP, 1);
	    }
	    break;

	  case OBJINFO:
	    displayinfo();
	    break;
	}
	break;

      case GROUP:
	if (menuitem == OTHER) {
	    cb = DMNew(Dgroup, windowid, 0);
	    incollect = 1;
	    InitCursor();
	    prevcb = RfshDlg;
	    RfshDlg = cb;
	    group = DMCollect(cb);
	    if (group == DMok) {
		dirty = 1;
		DMGet(cb, DGROUP_group, buf);
		group = atoi(buf);
		DMDispose(cb);
		incollect = 0;
		RfshDlg = prevcb;
	    } else {
		DMDispose(cb);
		incollect = 0;
		RfshDlg = prevcb;
		break;
	    }
	} else {
	    group = DEDgroup[menuitem];
	}
	rp = dialog;
	for (i = 0; i < MAXDLG; i++, rp++) {
	    if (rp->type && rp->selected) {
		dirty = 1;
		rp->group = group;
		switch (rp->type) {
		  case DMPUSHBUT:
		  case DMDPUSHBUT:
		    switch (rp->group) {
		      case DMok:
			rp->keycode = (K_ENTER | F_FUNC);
			break;

		      case DMcancel:
			rp->keycode = (K_ESC | F_FUNC);
			break;
		    }
		    break;
		}
	    }
	}
	break;

      case BORDER:
	runattr = 0;
	runmask = 0;
	switch (menuitem) {
	  case SHADOW:
	    runmask = BORDEDMASK;
	    runattr &= ~(BDOUBLE | BTRIPLE | BSINGLE);
	    runattr |= BSHADOW;
	    break;

	  case SINGLE:
	    runmask = BORDEDMASK;
	    runattr &= ~(BSHADOW | BDOUBLE | BTRIPLE);
	    runattr |= BSINGLE;
	    break;

	  case DOUBLE:
	    runmask = BORDEDMASK;
	    runattr &= ~(BSHADOW | BSINGLE | BTRIPLE);
	    runattr |= BDOUBLE;
	    break;

	  case TRIPLE:
	    runmask = BORDEDMASK;
	    runattr &= ~(BSHADOW | BSINGLE | BDOUBLE);
	    runattr |= BTRIPLE;
	    break;

	  case INVISIBLE:
	    runmask = BORDEDMASK;
	    runattr &= ~BORDEDMASK;
	    break;

	  case PENWIDTH1:
	    runmask = PENMASK;
	    runattr &= ~(BPENWIDTH2 | BPENWIDTH3);
	    runattr |= BPENWIDTH1;
	    break;

	  case PENWIDTH2:
	    runmask = PENMASK;
	    runattr &= ~(BPENWIDTH1 | BPENWIDTH3);
	    runattr |= BPENWIDTH2;
	    break;

	  case PENWIDTH3:
	    runmask = PENMASK;
	    runattr &= ~(BPENWIDTH1 | BPENWIDTH2);
	    runattr |= BPENWIDTH3;
	    break;
	}
	rp = dialog;
	for (i = 0; i < MAXDLG; i++, rp++) {
	    if (rp->type == BOX && rp->selected) {
		dirty = 1;
		rp->attr &= ~runmask;
		rp->attr |= runattr;
		erase(rp);
		dspall();
	    }
	}
	break;

      case FONT:
	curfont = DEDfont[menuitem];
	StuffFFS(curfont, -1, -1, 0);
	DisplaySelected();
	CheckFFS();
	if (FFSstate == FFSnone) {
	    runfont = curfont;
	}
	break;

      case STYLE:
	switch (menuitem) {
	  case Fnormal:
	    curface = 0;
	    StuffFFS(-1, curface, -1, 0);
	    break;

	  case Fbold:
	  case Funderline:
	  case Fitalic:
	  case Fghost:
	  case Foutline:
	    if (curface & (DEDstyle[menuitem])) {
		curface &= ~(DEDstyle[menuitem]);
		StuffFFS(-1, ~(DEDstyle[menuitem]), -1, 1);
	    } else {
		curface |= (DEDstyle[menuitem]);
		StuffFFS(-1, DEDstyle[menuitem], -1, 0);
	    }
	    break;

	  default:
	    cursize = DEDstyle[menuitem];
	    StuffFFS(-1, -1, cursize, 0);
	    break;
	}
	if (FFSstate == FFSnone) {
	    runface = curface;
	    runsize = cursize;
	}
	DisplaySelected();
	CheckFFS();
	break;
    }
    EndMenu(epmsg);
}

PFhidelay1(cbp, dip, when)
DMDcb *cbp;
DMItem *dip;
int *when;
{
    if (hideflags & 2) {
	*when = 1;
    }
}

PFhidelay2(cbp, dip, when)
DMDcb *cbp;
DMItem *dip;
int *when;
{
    if (hideflags & 4) {
	*when = 1;
    }
}
PFhidelay3(cbp, dip, when)
DMDcb *cbp;
DMItem *dip;
int *when;
{
    if (hideflags & 8) {
	*when = 1;
    }
}

PFhidelay4(cbp, dip, when)
DMDcb *cbp;
DMItem *dip;
int *when;
{
    if (hideflags & 16) {
	*when = 1;
    }
}
