/*
** Dialog import/export routines.
*/

#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <isc/keycodes.h>
#include <isc/window.h>
#include <isc/controls.h>
#include <isc/textedit.h>
#include <isc/dlgman.h>
#include "dlged.h"
#include "Derror.h"
#include "Dsaveas.h"
#include "Dsavechg.h"

/*
** do we want filename~ backup files
*/
#undef EMACS_STYLE_BACKUPS

/*
 **	C L O S E   R O U T I N E S
 */
DedQuit()
{
    int answer;

    answer = ask2save();
    if (answer == DMok) {
	save();
    }
    if (answer == DMok || answer == DMno) {
	exit(1);
    }
}

DedClose()
{
    int answer;

    answer = ask2save();
    if (answer == DMok) {
	save();
    }
    if (answer == DMok || answer == DMno) {
	set_names("Untitled");
	DedSetTitle(1);
	DedInit1();
	DedInit2();
    }
}

saveas()
{
    char *cp;
    DMDcb *rrp;
    DMDcb *prevcb;
    int group;

    rrp = DMNew(Dsaveas, windowid, 0);
    incollect = 1;
    prevcb = RfshDlg;
    RfshDlg = rrp;
    group = DMCollect(rrp);
    if (group == DMok) {
	DMGet(rrp, DSAVEAS_filename, filename);
	DMDispose(rrp);
	set_names(filename);
	DedSetTitle(1);
	save();
    } else {
	DMDispose(rrp);
    }
    incollect = 0;
    RfshDlg = prevcb;
}

save()
{
    DMDcb *cbp;
    DMDcb *prevcb;
    char buf[200];
    char *cp;

    if (fp == 0) {
#ifdef EMACS_STYLE_BACKUPS
	if (!backedup)
	    backup(filename);
#endif
	fp = fopen(filename, "w");
    }
    if (fp == 0) {
	cbp = DMNew(Derror, windowid, 0);
	incollect = 1;
	prevcb = RfshDlg;
	RfshDlg = cbp;
	sprintf(buf, "ERROR, Couldn't open '%s' for writing", filename);
	DMSetText(cbp, DERROR_errortext, buf);
	Bell();
	DMCollect(cbp);
	DMDispose(cbp);
	incollect = 0;
	RfshDlg = prevcb;
	return;
    }
#ifdef EMACS_STYLE_BACKUPS
    if (!backedup)
	backup(hfilename);
    backedup = 1;
#endif
    hfp = fopen(hfilename, "w"); /* Write .h file also. */
    if (hfp == 0) {
	cbp = DMNew(Derror, windowid, 0);
	incollect = 1;
	prevcb = RfshDlg;
	RfshDlg = cbp;
	sprintf(buf, "ERROR, Couldn't open '%s' for writing", hfilename);
	DMSetText(cbp, DERROR_errortext, buf);
	Bell();
	DMCollect(cbp);
	DMDispose(cbp);
	incollect = 0;
	RfshDlg = prevcb;
	return;
    }
    DedExport();

    fclose(fp);
    fclose(hfp);
    fp = 0;
    hfp = 0;
}

#ifdef EMACS_STYLE_BACKUPS
/*
** Save a backup copy of a file.
*/

backup(s)
char *s;
{
    struct stat st;
    char name[300];

    if (!stat(s, &st)) {
	if (st.st_nlink == 1) {	/* Don't break links to do it. */
	    strncpy(name, s, sizeof(name) - 1);
	    strcat(name, "~");
	    if (!link(s, name)) {
		unlink(s);
	    }
	}
    }
}
#endif

DedExport()
{
    char buf[256];
    char tmps[256];
    char *cp;
    int i;
    Rect tr;
    Rect sr;
    DedItem *rp;

 /*
  * For all the whiners in the world, here is a check to see if you
  * ignorantly omitted the required bounding box, and if you forgot we
  * calculate and then insert one. 
  */
    sort();
    SetRect(&tr, 32000, 32000, 0, 0);
    rp = dialog;
    for (i = 0; i < MAXDLG; i++, rp++) {
	if (rp->type) {
	    UnionRect(&tr, &rp->rect, &tr);
	}
    }
    SectRect(&tr, &dialog[0].rect, &sr);
    if (dialog[0].type != DMBOX || !EqualRect(&tr, &sr)) {
	rp = findslot();
	memset(rp, 0, sizeof(DedItem));
	rp->type = DMBOX;
	rp->attr = BAUTO;
	rp->rect = tr;
	sort();
    }
    rp = dialog;
    for (i = 0; i < MAXDLG; i++, rp++) {
	if (i > 0 && rp->type == DMBOX && rp->attr == BAUTO) {
	/* get rid of dlged automatic box */
	    rp->type = 0;
	    sort();
	}
    }
    fixuptabseqexp();
    dirty = 0;
    Routines[0] = 0;
 /*
  * WRITE THE DIALOG.H FILE 
  */
    fprintf(hfp, "/*\n**  WARNING - DO NOT MODIFY THIS FILE!\n");
    fprintf(hfp, "**  CREATED AUTOMATICALLY BY THE DIALOG EDITOR!\n*/\n");

 /*
  *	Conditional for International (Chinese & Taiwan) font and size. 
  */
    fprintf(hfp, "\n#ifdef SIXTEENBITCHARS\n");
    fprintf(hfp, "#define INTL_FONT(font,size) font,size\n");
    fprintf(hfp, "#else\n");
    fprintf(hfp, "#define INTL_FONT(font,size)\n");
    fprintf(hfp, "#endif /* SIXTEENBITCHARS */\n");

 /*
  * WRITE THE DIALOG.C FILE 
  */
    fprintf(fp, "#include <isc/window.h>\n");
    fprintf(fp, "#include <isc/dlgman.h>\n");
    fprintf(fp, "#include \"%s.h\"\n", dlgname);
    fprintf(fp, "\n/*\n**  D I A L O G  '%s'\n", dlgname);
    fprintf(fp, "**\n**  WARNING - DO NOT MODIFY THIS FILE!\n");
    fprintf(fp, "**  CHANGES SHOULD ONLY BE MADE USING THE DIALOG EDITOR!\n");
    fprintf(fp, "**  TO RENAME A FILE, USE THE DIALOG EDITOR AND 'SAVEAS'!\n*/\n");

 /*
  * Dialog Saved parameters 
  */
    fprintf(fp, "\n/* Dialog Parameters %s %d %d %d */\n", version, gridon,
	    hgrid, vgrid);

 /*
  * Dialog Item Text 
  */
    fprintf(fp, "\n/* Dialog Item Text */\n");
    rp = dialog;
    for (i = 0; i < MAXDLG; i++, rp++) {
	if (rp->type && rp->text && rp->text[0]) {
	    fprintf(fp, "static const char %sT%d[] = \"%s\";\n",
		    dlgname, i, rp->text);
	}
    }

 /*
  * Dialog Item Identifiers -> DIALOG.C, DIALOG.H and rp->ident. 
  */
    fprintf(hfp, "\n/* Dialog Item Identifiers for %s.c */\n", dlgname);
    fprintf(fp, "\n/* Dialog Item Identifiers */\n");
    fprintf(fp, "/*  WARNING- THESE COMMENTS ARE USED BY THE DIALOG EDITOR! */\n");
    fprintf(fp, "/*  Runtime definitions are in the file %s.h */\n", dlgname);
    rp = dialog;
    for (i = 0; i < MAXDLG; i++, rp++) {
	rp->ident = i;
	if (rp->type && rp->name && rp->name[0]) {
	    fprintf(hfp, "#define %s_%s\t%d\n", dlgnameCaps, rp->name, i);
	    fprintf(fp, "/* %s_%s = %d */\n", dlgnameCaps, rp->name, i);
	}
    }

 /*
  * Dialog Items 
  */
    fprintf(fp, "\n/* Dialog Definition */\n");
    fprintf(fp, "DMItem %s[] = {\n", dlgname);
    rp = dialog;
    for (i = 0; i < MAXDLG; i++, rp++) {
	if (rp->type) {
	    cp = buf;
	    cp += sprintf(cp, "  {");
	    cp += sprintf(cp, "%d,%d,%d,", rp->type, rp->group, rp->keycode);
	    if (rp->type == DMBOX && i == 0) {
	    /* first item is always box with value used as numele */
		cp += sprintf(cp, "%d,%d,%d,", countitems(), rp->min, rp->max);
	    } else {
		cp += sprintf(cp, "%d,%d,%d,", rp->value, rp->min, rp->max);
	    }
	    cp += sprintf(cp, "%d,%d,%d,", rp->font, rp->fontsize, rp->attr);
	    cp += sprintf(cp, "%d,", rp->when);
	    cp += sprintf(cp, "%d,", rp->xfermode);
	    cp += sprintf(cp, "%d,", rp->fgColor);
	    cp += sprintf(cp, "%d,", rp->bkColor);
	    tr = rp->rect;
	    cp += sprintf(cp, "{%d,%d,%d,%d},", tr.edge.top, tr.edge.left,
			  tr.edge.bottom, tr.edge.right);

	    if (rp->prefill[0]) { /* PREFILL */
		cp += sprintf(cp, "%s,", rp->prefill);
	    } else {
		cp += sprintf(cp, "0,");
	    }

	    if (rp->validate[0]) { /* VALIDATE */
		cp += sprintf(cp, "%s,", rp->validate);
	    } else {
		cp += sprintf(cp, "0,");
	    }
	    cp += sprintf(cp, "%d,", rp->usercode);

	    if (rp->text && rp->text[0]) { /* DIALOG ITEM TEXT */
		cp += sprintf(cp, "%sT%d", dlgname, i);
	    } else {
		cp += sprintf(cp, "0");
	    }
	    cp += sprintf(cp, ",0,");	/* extend: future extension */
	    cp += sprintf(cp, "%d,", rp->ident);

	    cp += sprintf(cp, "INTL_FONT(%d,%d)", rp->otherfont, rp->othersize);
	    if (rp->layer)
		cp += sprintf(cp, "}, /* Layer %d */\n", rp->layer);
	    else
		cp += sprintf(cp, "},\n");
	    fputs(buf, fp);
	}
    }
    fprintf(fp, "};\n\n");

 /*
  * EXTERNAL FUNCTION PROTOTYPES -> DIALOG.H 
  */
    fprintf(hfp, "\n/* External Function Prototypes */\n");
    fprintf(hfp, "extern DMItem\t%s[%d];\n", dlgname, countitems());

    rp = dialog;
    for (i = 0; i < MAXDLG; i++, rp++) {

	if (rp->prefill[0]) {
	    if (update_proto_list(rp->prefill)) {
		switch (rp->type) {
		  case DMTEXT:
		  case DMTEXTBOX:
		  case DMTEXTEDIT:
		/* Text Edit / Literal Text Prefill */
		    strcpy(tmps, "char *cp");
		    break;
		  case DMPICKLIST:
		/* Pick List Prefill */
		    strcpy(tmps, "DMPick *psp");
		    break;
		  case DMCHECKBOX:
		  case DMRADIOBUT:
		  case DMPUSHBUT:
		  case DMDPUSHBUT:
		  case DMBOX:
		  case DMSCROLLBAR:
		  case DMPATBOX:
		/* Control Prefill */
		    strcpy(tmps, "int *value");
		    break;
		  default:
		    strcpy(tmps, "...");
		    break;
		}
		fprintf(hfp, "extern int\t%s(DMDcb *cbp, DMItem *dip, %s);\n",
			rp->prefill, tmps);
	    }
	}
	if (rp->type && rp->validate[0]) {
	    if (update_proto_list(rp->validate)) {
		switch (rp->type) {
		  case DMTEXT:
		  case DMTEXTEDIT:
		/* Text Edit / Literal Text Validations */
		    strcpy(tmps, "DMTEVal *arg");
		    break;
		  case DMPICKLIST:
		/* Pick List Validation */
		    strcpy(tmps, "short value, short partcode");
		    break;
		  case DMCHECKBOX:
		  case DMRADIOBUT:
		  case DMPUSHBUT:
		  case DMDPUSHBUT:
		  case DMBOX:
		  case DMSCROLLBAR:
		  case DMPATBOX:
		/* Control Validation */
		    strcpy(tmps, "short value, short partcode");
		    break;
		  default:
		    strcpy(tmps, "...");
		    break;
		}
		fprintf(hfp, "extern int\t%s(DMDcb *cbp, DMItem *dip, "
			"unsigned char when, %s);\n", rp->validate, tmps);
	    }
	}
    }
}

ask2save()
{
    DMDcb *cb;
    DMDcb *prevcb;
    int group = DMno;

    if (dirty) {
	cb = DMNew(Dsavechg, windowid, 0);
	incollect = 1;
	prevcb = RfshDlg;
	RfshDlg = cb;
	group = DMCollect(cb);
	DMDispose(cb);
	incollect = 0;
	RfshDlg = prevcb;
    }
    return (group);
}

myopen()
{
    DMDcb *cbp;
    DMDcb *prevcb;
    char buf[200];

    if (fp == 0) {
	fp = fopen(filename, "r");
    }
    if (fp == 0) {
    /* open failed */
	cbp = DMNew(Derror, windowid, 0);
	incollect = 1;
	prevcb = RfshDlg;
	RfshDlg = cbp;
	sprintf(buf, "ERROR, Couldn't open '%s' for reading", filename);
	DMSetText(cbp, DERROR_errortext, buf);
	Bell();
	DMCollect(cbp);
	DMDispose(cbp);
	incollect = 0;
	RfshDlg = prevcb;
	ClipRect(&noclip);
	PenPat((Pattern *) 0);
	return;
    }
    DedImport();
    fclose(fp);
    fp = 0;
#ifdef EMACS_STYLE_BACKUPS
    backedup = 0;
#endif
}

DedImport()
{
    char tagdlg[] = "**  D I A L O G";
    char tagname[30] = "xxxx";
    char tagident[30] = "xxxx";
    char tagtext[30] = "xxxx";
    char tagtext2[40] = "xxxx";
    char tagitem[] = "DMItem";
    char tagparam[] = "/* Dialog Parameters";

    char buf[256];
    char *cp, *cp2;
    int index = 0;
    int first = 1;
    int i;
    float dlgversion;
    DedItem *rp;

    dirty = 0;
    while (fgets(buf, sizeof buf - 1, fp)) {
	if (buf[0] == '#')	/* Skip #include lines. */
	    continue;
	if (!strncmp(buf, tagdlg, StringLen(tagdlg))) {
	/*
	 * Get DIALOG name from comment 
	 */
	    sscanf(buf, "**  D I A L O G  '%s'", dlgname);
	    dlgname[StringLen(dlgname) - 1] = 0;
	    set_names(dlgname);

	    sprintf(tagname, "char %sN", dlgname);	/* version < 4.0 */
	    sprintf(tagident, "/* %s_", dlgnameCaps);	/* version >= 4.0 */
	    sprintf(tagtext, "char %sT", dlgname);
	    sprintf(tagtext2, "static const char %sT", dlgname);
	    if (debug == IMPORT)
		printf("->%s\n", dlgname);
	} else if (!strncmp(buf, tagparam, strlen(tagdlg))) {
	/*
	 * Get DIALOG parameters 
	 */
	    sscanf(buf, "/* Dialog Parameters %f %d %d %d", &dlgversion,
		   &gridon, &hgrid, &vgrid);
	    if (debug == IMPORT)
		printf("gridon=%d, hgrid=%d, vgrid=%d\n", gridon, hgrid, vgrid);
	    CheckItem(OPTIONS, GRIDON, gridon);
	} else if (!strncmp(buf, tagname, strlen(tagname))) {
	/*
	 * Get DLG ITEM name from char string.
	 * Item names are used in versions < 4.0 
	 */
	    cp = buf + StringLen(tagname);
	    index = atoi(cp);
	    if ((cp = strpbrk(cp, "\""))) {
		cp2 = (char *) &dedname[index];
		cp++;
		while (*cp != '"') {
		    *cp2++ = *cp++;
		}
		*cp2 = 0;
	    }
	    if (debug == IMPORT)
		printf("item #%d name ->%s\n", index, &dedname[index]);
	} else if (!strncmp(buf, tagident, index = StringLen(tagident))) {
	/*
	 * Get DLG ITEM identifiers from char string.
	 * Item identifiers are used in versions >= 4.0 
	 */
	    cp = buf + index;
	    cp2 = cp;
	    if (cp2 = strpbrk(cp, "=")) {
		cp2++;
		index = atoi(cp2);

		cp2 = (char *) &dedname[index];
		while (*cp != ' ') {
		    *cp2++ = *cp++;
		}
		*cp2 = 0;
	    }
	    if (debug == IMPORT)
		printf("item #%d identifier ->%s\n", index, &dedname[index]);
	} else if (!strncmp(buf, tagtext, index = StringLen(tagtext))
		   || !strncmp(buf, tagtext2, index = StringLen(tagtext2))) {
	/*
	 * Get DLG ITEM text from char string 
	 */
	    cp = buf + index;
	    index = atoi(cp);
	    if (cp = strpbrk(cp, "\"")) {
		cp2 = (char *) &dedtext[index];
		cp++;
		while (*cp != '"') {
		    *cp2++ = *cp++;
		}
		*cp2 = 0;
	    }
	    if (debug == IMPORT)
		printf("item #%d text ->%s\n", index, &dedtext[index]);
	} else if (!strncmp(buf, tagitem, StringLen(tagitem))) {
	/*
	 * Get DLG ITEM 
	 */
	    rp = dialog;
	    while (fgets(buf, sizeof buf - 1, fp)) {
		if (cp = strpbrk(buf, "{")) {
		    rp->type = (byte) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    rp->group = (byte) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    rp->keycode = atoi(++cp);
		    cp = strpbrk(cp, ",");
		    if (first && rp->type == DMBOX) {
			atoi(++cp);
		    } else {
			rp->value = (short) atoi(++cp);
		    }
		    cp = strpbrk(cp, ",");
		    rp->min = (short) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    rp->max = (short) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    rp->font = (short) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    rp->fontsize = (short) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    rp->attr = (short) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    rp->when = (byte) atoi(++cp);

		    if (dlgversion >= 4.0) {
			cp = strpbrk(cp, ",");
			rp->xfermode = (byte) atoi(++cp);
			cp = strpbrk(cp, ",");
			rp->fgColor = (short) atoi(++cp);
			cp = strpbrk(cp, ",");
			rp->bkColor = (short) atoi(++cp);
		    } else {
			rp->fgColor = FORECOLOR; /* Use default colors. */
			rp->bkColor = BACKCOLOR;
		    }

		    cp = strpbrk(cp, "{");
		    rp->rect.edge.top = (short) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    rp->rect.edge.left = (short) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    rp->rect.edge.bottom = (short) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    rp->rect.edge.right = (short) atoi(++cp);
		    cp = strpbrk(cp, ",");
		    cp++;
		    cp = strtok(cp, ",");
		    if (*cp != '0') {
			strcpy(rp->prefill, cp);
		    }
		    cp = strtok(NULL, ",");
		    if (*cp != '0') {
			strcpy(rp->validate, cp);
		    }
		    cp = strtok(NULL, ",");
		    rp->usercode = (UINT) atoi(cp);

		    if (dlgversion >= 4.0) {
			cp = strtok(NULL, ",");	/* skip text */
			cp = strtok(NULL, ",");	/* skip extend */
			cp = strtok(NULL, ",");	/* isolate ident */
			rp->ident = (short) atoi(cp);
		    }
		    cp += 2;

		    while (*cp++) {
				if (strncmp(cp, "TL_FONT", 7) == 0) {
					cp = strpbrk(cp, "(");
					rp->otherfont = (short) atoi(++cp);
					cp = strpbrk(cp, ",");
					rp->othersize = (short) atoi(++cp);
					break;
				}
		    }

		    if (cp = strpbrk(cp, "r")) {	/* Layer value? */
			cp += 2;
			rp->layer = atoi(cp);
		    }
		    if (!convert) {
			newitem(rp);
		    }
		    if (debug == IMPORT) {
			if (rp->text) {
			    printf("\trp->text = %s\n", rp->text);
			}
			printf("rp->type=%d, rp->group=%d, rp->keycode=%d, "
			       "rp->value=%d\n", rp->type, rp->group,
			       rp->keycode, rp->value);
		    }
		    rp++;
		    first = 0;
		}
	    }
	}
    }
    fixuptabseqimp();
    if (dlgversion < 0.3) {
	rp = dialog;
	for (i = 0; i < MAXDLG; i++, rp++) {
	    if (rp->type == DMTEXTEDIT) {
		rp->value |= DItebox;
	    }
	}
    }
}

/*
** Convert item names of next-in-tab-sequence fields to the
** item numbers (for export).
*/

static
fixuptabseqexp()
{
    DedItem *rp, *rp2;
    int i;

    rp = dialog;
    for (i=0; i<MAXDLG; i++,rp++)
	if (rp->type == DMTEXTEDIT)
	    if (*rp->tabto)
		if (rp2 = findnameditem(rp->tabto))
		    rp->NextTE = rp2 - dialog;
}

/*
** Convert item numbers of next-in-tab-sequence fields to the
** item names (for import).
*/

static
fixuptabseqimp()
{
    DedItem *rp, *rp2;
    int i;

    rp = dialog;
    for (i=0; i<MAXDLG; i++,rp++)
	if (rp->type == DMTEXTEDIT)
	    if (rp->NextTE)
		strcpy(rp->tabto, dialog[rp->NextTE].name);
}

/*
** update_proto_list()
**
** If the char string "routine" is not in Routine[] then add it and
** return 1, else return 0.
*/

update_proto_list(routine)
char *routine;
{
    int i;

    for (i=0; Routines[i]; i++) {
	if (!strcmp(Routines[i], routine)) {
	    return 0;
	}
    }
    Routines[i++] = routine;
    Routines[i] = 0;
    return 1;
}

