#include <stdio.h>
#include <string.h>
#include <isc/keycodes.h>
#include <isc/window.h>
#include <isc/controls.h>
#include <isc/textedit.h>
#include <isc/dlgman.h>
#include "dlged.h"

display(rp)
DedItem *rp;
{
    if (hideflags & (1 << rp->layer))	/* Hidden layer? */
	return;
    PenMode(srcOr);
    PenPat((Pattern *) 0);
    TextMode(srcCopy);
    switch (rp->type) {
      case DMBOX:
	dspbox(rp);
	break;

      case DMCHECKBOX:
      case DMRADIOBUT:
      case DMPUSHBUT:
      case DMDPUSHBUT:
      case DMSCROLLBAR:
      case DMPATBOX:
	dspcontrol(rp);
	break;

      case DMTEXT:
	dsptext(rp);
	break;

      case DMTEXTEDIT:
	dsptextedit(rp);
	break;

      case DMPICKLIST:
	dsppicklist(rp);
	break;

      case DMTEXTBOX:
	dsptextbox(rp);
	break;

      case DMLINE:
	dspline(rp);
	break;

      case DMUSERITEM:
	dspusritem(rp);
	break;
    }
}

dsptextbox(rp)
DedItem *rp;
{
    Rect tr;
    int just;

    tr = rp->rect;
    FrameRect(&tr);
    InsetRect(&tr, 3, 3);
    just = teJustLeft;
    if (rp->value & DItecenterJust) {
	just = teJustCenter;
    } else if (rp->value & DIterightJust) {
	just = teJustRight;
    }
    TextBox(rp->text, StringLen(rp->text), &tr, just);
    if (rp->selected) {
	dspselect(rp);
    }
}

dspline(rp)
DedItem *rp;
{
    short savefgColor, savebkColor, attr;
    int size;

    savefgColor = savebkColor = -1;
    if (rp->fgColor != theForeColor) {
	savefgColor = theForeColor;
	ForeColor(rp->fgColor);
    }
    if (rp->bkColor != theBackColor) {
	savebkColor = theBackColor;
	BackColor(rp->bkColor);
    }
    size = 1;
    attr = rp->attr;
    if (attr & BPENWIDTH2) {	/* Do line size. */
	size = 2;
    } else if (attr & BPENWIDTH3) {
	size = 3;
    }
    PenSize(size, size);
    PenPat((Pattern *) rp->pattern);
    if (attr & LPENTRTOBL) {
	MoveTo(rp->rect.edge.right - size, rp->rect.edge.top);
	LineTo(rp->rect.edge.left, rp->rect.edge.bottom - size);
    } else {
	MoveTo(rp->rect.edge.left, rp->rect.edge.top);
	LineTo(rp->rect.edge.right - size, rp->rect.edge.bottom - size);
    }
    PenNormal();
    if (savefgColor >= 0)
	ForeColor(savefgColor);
    if (savebkColor >= 0)
	BackColor(savebkColor);
    if (rp->selected) {
	dspselect(rp);
    }
}

dspusritem(rp)
DedItem *rp;
{
    FillRect(&rp->rect, ltgreyPattern);
    PenNormal();
    FrameRect(&rp->rect);
    MoveTo(rp->rect.edge.left, rp->rect.edge.top);
    LineTo(rp->rect.edge.right - 1, rp->rect.edge.bottom - 1);
    MoveTo(rp->rect.edge.right - 1, rp->rect.edge.top);
    LineTo(rp->rect.edge.left, rp->rect.edge.bottom - 1);
    if (rp->selected) {
	dspselect(rp);
    }
}

dsppicklist(rp)
DedItem *rp;
{
    FrameRect(&rp->rect);
    drawcontrol(rp);
    if (rp->selected) {
	dspselect(rp);
    }
}

dspbox(rp)
DedItem *rp;
{
    DMItem item;

    item.rect = rp->rect;
    item.text = rp->text;
    item.value = rp->value;
    item.pattern = rp->pattern;
    item.font = rp->font;
    item.attr = rp->attr;
    item.xfermode = rp->xfermode;
    item.fgColor = rp->fgColor;
    item.bkColor = rp->bkColor;
    item.fontsize = rp->fontsize;

    _dmDrawBox(&item);
    if (rp->selected) {
	dspselect(rp);
    }
}

/*
** A near-duplicate of the code in DM.
*/

_dmDrawBox(dip)
DMItem *dip;
{
    short savefgColor, savebkColor, attr;
    int size;
    Rect tr;

    savefgColor = savebkColor = -1;
    if (dip->fgColor != theForeColor) {
	savefgColor = theForeColor;
	ForeColor(dip->fgColor);
    }
    if (dip->bkColor != theBackColor) {
	savebkColor = theBackColor;
	BackColor(dip->bkColor);
    }
    size = 1;
    tr = dip->rect;
    attr = dip->attr;
    if (attr & BPENWIDTH2) {	/* Do line size. */
	size = 2;
    } else if (attr & BPENWIDTH3) {
	size = 3;
    }
    if (attr & BSINGLE) {	/* Do box borders. */
	PenSize(size, size);
	FrameRect(&tr);
	InsetRect(&tr, size, size);
    } else if (attr & BDOUBLE) {
	PenSize(1, 1);
	FrameRect(&tr);
	PenSize(size, size);
	InsetRect(&tr, 3, 3);
	FrameRect(&tr);
	InsetRect(&tr, size, size);
    } else if (attr & BTRIPLE) {
	PenSize(1, 1);
	FrameRect(&tr);
	InsetRect(&tr, 3, 3);
	PenSize(size, size);
	FrameRect(&tr);
	InsetRect(&tr, size + 2, size + 2);
	PenSize(1, 1);
	FrameRect(&tr);
	InsetRect(&tr, 1, 1);
    } else if (attr & BSHADOW) {
	tr.edge.right -= size;
	tr.edge.bottom -= size;
	PenSize(1, 1);
	FrameRect(&tr);
	MoveTo(tr.edge.left + size, tr.edge.bottom);
	PenSize(size, size);
	LineTo(tr.edge.right, tr.edge.bottom);
	LineTo(tr.edge.right, tr.edge.top + size);
	InsetRect(&tr, 1, 1);
    }
    if (attr & BFILLED) {
	FillRect(&tr, (Pattern *) dip->pattern);
    }
    PenNormal();
    if (savefgColor >= 0)
	ForeColor(savefgColor);
    if (savebkColor >= 0)
	BackColor(savebkColor);
}

dsptext(rp)
DedItem *rp;
{
    drawtext(rp);
    if (rp->selected) {
	FrameRect(&rp->rect);
	dspselect(rp);
    }
}

dsptextedit(rp)
DedItem *rp;
{
    drawte(rp);
    FrameRect(&rp->rect);
    if (rp->selected) {
	FrameRect(&rp->rect);
	dspselect(rp);
    }
}

dspcontrol(rp)
DedItem *rp;
{
    drawcontrol(rp);
    if (rp->selected) {
	dspselect(rp);
    }
}

dspselect(rp)
DedItem *rp;
{
    Rect tr;
    Rect *rectp;

    switch (rp->type) {
      case DMRADIOBUT:
      case DMCHECKBOX:
      case DMPUSHBUT:
      case DMDPUSHBUT:
      case DMSCROLLBAR:
      case DMPATBOX:
      case DMTEXTBOX:
      case DMLINE:
      case DMUSERITEM:
	FrameRect(&rp->rect);
	break;
    }
    rectp = &rp->rect;
    SetRect(&tr, rectp->edge.right - XY, rectp->edge.bottom - XY, rectp->edge.right, rectp->edge.bottom);
    FillRect(&tr, (Pattern *) 7);
    FrameRect(&rp->rect);
    rp->handle = tr;
}

dspall()
{
    int i;
    DedItem *rp;

    rp = &dialog[0];
    for (i = 0; i < MAXDLG; i++, rp++) {
	if (rp->type) {
	    display(rp);
	}
    }
}

drawte(rp)
DedItem *rp;
{
    Rect tr;

    tr = rp->rect;
    InsetRect(&tr, 3, 3);
    TEUpdateErase(&tr, rp->id);
}

drawtext(rp)
DedItem *rp;
{
    DMItem item;

    item.rect = rp->rect;
    item.text = rp->text;
    item.value = rp->value;
    item.font = rp->font;
    item.attr = rp->attr;
    item.xfermode = rp->xfermode;
    item.fgColor = rp->fgColor;
    item.bkColor = rp->bkColor;
    item.fontsize = rp->fontsize;

    _dmDrawText(&item);
}

/*
** A near-duplicate of the code in DM.
*/

_dmDrawText(dip)
DMItem *dip;
{
    short savefgColor, savebkColor;
    short hjust, vjust;
    char *cp;

    hjust = 0;
    vjust = 0;
    cp = dip->text;
    if (cp) {
	hjust = ((dip->TXTflags & JHmask) >> 1);
	if (dip->TXTflags & (topJust | bottomJust)) {
	    vjust = ((dip->TXTflags & JVmask) >> 4);
	} else {
	    vjust = vcenterJust >> 4;
	}
	dmFontFaceSize(dip->font, dip->attr, dip->fontsize);
	savefgColor = savebkColor = -1;
	if (dip->fgColor != theForeColor) {
	    savefgColor = theForeColor;
	    ForeColor(dip->fgColor);
	}
	if (dip->bkColor != theBackColor) {
	    savebkColor = theBackColor;
	    BackColor(dip->bkColor);
	}
	DrawJustText(cp, StringLen(cp), &dip->rect, hjust, vjust);
	if (savefgColor >= 0)
	    ForeColor(savefgColor);
	if (savebkColor >= 0)
	    BackColor(savebkColor);
    }
}

drawcontrol(rp)
DedItem *rp;
{
    savefgColor = theForeColor;
    savebkColor = theBackColor;
    ForeColor(rp->fgColor);
    BackColor(rp->bkColor);

    DrawControl(rp->id);

    ForeColor(savefgColor);
    BackColor(savebkColor);
}

ControlID
dlgNewControl(wid, bRect, title, visible, value, min, max, pID, rCon, fgColor, bkColor)
short wid;
Rect *bRect;
char *title;
short visible, value, min, max;
short pID;
long rCon;
short fgColor, bkColor;
{
    void *id;

    savefgColor = theForeColor;
    savebkColor = theBackColor;
    ForeColor(fgColor);
    BackColor(bkColor);

    id = NewControl(wid, bRect, title, visible, value, min, max, pID, rCon);

    ForeColor(savefgColor);
    BackColor(savebkColor);

    return (id);
}
