#include <stdio.h>
#include <string.h>
#include <isc/keycodes.h>
#include <isc/window.h>
#include <isc/controls.h>
#include <isc/textedit.h>
#include <isc/dlgman.h>
#include "dlged.h"
#include "Dbox.h"
#include "Dcontrol.h"
#include "Derror.h"
#include "Dgrid.h"
#include "Dgroup.h"
#include "Dinfo.h"
#include "Dlayer.h"
#include "Dline.h"
#include "Dopen.h"
#include "Dpat.h"
#include "Dpicklist.h"
#include "Dsaveas.h"
#include "Dsavechg.h"
#include "Dsbar.h"
#include "Dselgroup.h"
#include "Dsellayer.h"
#include "Dseluser.h"
#include "Dsetlayer.h"
#include "Dsetuser.h"
#include "Dtext.h"
#include "Dtextbox.h"
#include "Dtextedit.h"
#include "Duseritem.h"

/*
**  Validation routines.
*/

VALboxpat(cbp, dip, when, value, partcode)
DMDcb *cbp;
DMItem *dip;
unsigned char when;
short value;
short partcode;
{
    valpat = value;
    return 1;
}

VALhgrid(cbp, dip, when, value, partcode)
DMDcb *cbp;
DMItem *dip;
unsigned char when;
short value;
short partcode;
{
    char buf[10];
    ControlID id;
    
    id = cbp->curIid;
    sprintf(buf, "%d", value);
    DMSetText(cbp, DGRID_hgrid, buf);
    return 1;
}

VALvgrid(cbp, dip, when, value, partcode)
DMDcb *cbp;
DMItem *dip;
unsigned char when;
short value;
short partcode;
{
    char buf[10];
    ControlID id;
    
    id = cbp->curIid;
    sprintf(buf, "%d", value);
    DMSetText(cbp, DGRID_vgrid, buf);
    return 1;
}

VALdec(cbp, dip, when, cp)
DMDcb *cbp;
DMItem *dip;
unsigned char when;
DMTEVal *cp;
{
    return DMValNumeric(cbp, dip, when, cp->text, 3, 0, 255);
}

VALdeclong(cbp, dip, when, cp)
DMDcb *cbp;
DMItem *dip;
unsigned char when;
DMTEVal *cp;
{
    return DMValNumeric(cbp, dip, when, cp->text, 10, 0, ~0);
}

VALhex(cbp, dip, when, cp)
DMDcb *cbp;
DMItem *dip;
unsigned char when;
DMTEVal *cp;
{
    return DMValHex(cbp, dip, when, cp->text, 2, 0, 255);
}

VALhexlong(cbp, dip, when, cp)
DMDcb *cbp;
DMItem *dip;
unsigned char when;
DMTEVal *cp;
{
    return DMValHex(cbp, dip, when, cp->text, 8, 0, ~0);
}

VALtabto(cbp, dip, when, cp)
DMDcb *cbp;
DMItem *dip;
unsigned char when;
DMTEVal	*cp;
{
    DedItem *dp, *findnameditem(char *name);

    if (!*cp->text || (dp = findnameditem(cp->text)))
	return DM_PASS;
    else
	return DM_FAIL;
}

/*
**	P R E F I L L   R O U T I N E S
*/

PFboxpat(cbp, dip, value)
DMDcb *cbp;
DMItem *dip;
int *value;
{
    if (DefPtr) {
	if (((DefPtr->attr & BFILLED) /* Matching pattern box? */
	     && (DefPtr->pattern == dip->pattern))
	    || (dip->type == DMRADIOBUT	/* The 'None' button? */
		&& !(DefPtr->attr & BFILLED)))
	    *value = 1;
	else
	    *value = 0;
    }
}

PFbnone(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & BNONE ? 1 : 0;
}

PFbshadow(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & BSHADOW ? 1 : 0;
}

PFbsingle(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & BSINGLE ? 1 : 0;
}

PFbdouble(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & BDOUBLE ? 1 : 0;
}

PFbtriple(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & BTRIPLE ? 1 : 0;
}

PFp1x1(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & BPENWIDTH1 ? 1 : 0;
}

PFp2x2(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & BPENWIDTH2 ? 1 : 0;
}

PFp3x3(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & BPENWIDTH3 ? 1 : 0;
}

PFotherway(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & LPENTRTOBL ? 1 : 0;
}

PFbutinc(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[10];

    sprintf(buf, "%d", DefPtr->font ? DefPtr->font : 1);
    strcpy(cp, buf);
}

PFpageinc(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[10];

    sprintf(buf, "%d", DefPtr->fontsize ? DefPtr->fontsize : 5);
    strcpy(cp, buf);
}

PFtejustleft(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    int tmp;

    tmp = (DefPtr->value & (DItecenterJust | DIterightJust)) ? 0 : 1;
    *ip = tmp;
}

PFtejustcenter(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    int tmp;

    tmp = (DefPtr->value & DItecenterJust) ? 1 : 0;
    *ip = tmp;
}

PFtejustright(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    int tmp;

    tmp = (DefPtr->value & DIterightJust) ? 1 : 0;
    *ip = tmp;
}

PFhgridSB(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    *ip = hgrid;
}

PFvgridSB(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    *ip = vgrid;
}

PFhgrid(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[10];

    sprintf(buf, "%d", hgrid);
    strcpy(cp, buf);
}

PFvgrid(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[10];

    sprintf(buf, "%d", vgrid);
    strcpy(cp, buf);
}

PFtebox(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->value & DItebox ? 1 : 0;
}

PFtemultiline(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->value & DItemultiline ? 1 : 0;
}

PFtewordwrap(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->value & DItewordwrap ? 1 : 0;
}

PFtescroll(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->value & DItescroll ? 1 : 0;
}

PFinvisible(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & DDIinvisible ? 1 : 0;
}

PFinitdisabled(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & DDIinitially ? 1 : 0;
}

PFinithidden(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & DDIhideinit ? 1 : 0;
}

PFghosttext(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & DDIghostText ? 1 : 0;
}

PFghostframe(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = DefPtr->attr & DDIghostFrame ? 1 : 0;
}

PFdefpitch(cbp, dip, i)
DMDcb *cbp;
DMItem *dip;
int *i;
{
    *i = 1;
}

saveasPF(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    strcpy(cp, filename);
}

PFtext(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    if (DefPtr->text && DefPtr->text[0]) {
	strcpy(cp, DefPtr->text);
    }
}

PFname(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    if (DefPtr->name) {
	strcpy(cp, DefPtr->name);
    }
}

PFtabto(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    if (DefPtr->tabto) {
	strcpy(cp, DefPtr->tabto);
    }
}

PFfgcolor(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];
    
    sprintf(buf, "%X", DefPtr->fgColor);
    strcpy(cp, buf);
}

PFbkcolor(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];
    
    sprintf(buf, "%X", DefPtr->bkColor);
    strcpy(cp, buf);
}

PFtype(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];
    
    sprintf(buf, "%X", DefPtr->type);
    strcpy(cp, buf);
}

PFgroup(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];
    
    sprintf(buf, "%X", DefPtr->group);
    strcpy(cp, buf);
}

PFkey(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];
    
    sprintf(buf, "%X", DefPtr->keycode);
    strcpy(cp, buf);
}

PFvalue(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];
    
    sprintf(buf, "%X", DefPtr->value);
    strcpy(cp, buf);
}

PFminvalue(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];
    
    sprintf(buf, "%X", DefPtr->min);
    strcpy(cp, buf);
}

PFmaxvalue(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];

    sprintf(buf, "%X", DefPtr->max);
    strcpy(cp, buf);
}

PFvalidate(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    if (DefPtr->validate[0]) {
	strcpy(cp, DefPtr->validate);
    }
}

PFprefill(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    if (DefPtr->prefill[0]) {
	strcpy(cp,DefPtr->prefill);
    }
}

PFusercode(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];

    sprintf(buf, "%X", DefPtr->usercode);
    strcpy(cp, buf);
}

PFmaxdigits(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];

    sprintf(buf, "%X", DefPtr->max);
    strcpy(cp, buf);
}

PFlayer(cbp, dip, cp)
DMDcb *cbp;
DMItem *dip;
char *cp;
{
    char buf[20];

    sprintf(buf, "%X", DefPtr->layer);
    strcpy(cp, buf);
}

PFrexit(cbp, dip, when)
DMDcb *cbp;
DMItem *dip;
int *when;
{
    if (DefPtr->when & DMdlgexit) {
	*when = 1;
    }
}

PFduring(cbp, dip, when)
DMDcb *cbp;
DMItem *dip;
int *when;
{
    if (DefPtr->when & DMWhileBefore) {
	*when = 1;
    }
}

PFafter(cbp, dip, when)
DMDcb *cbp;
DMItem *dip;
int *when;
{
    if (DefPtr->when & DMWhileAfter) {
	*when = 1;
    }
}

PFrdraw(cbp, dip, when)
DMDcb *cbp;
DMItem *dip;
int *when;
{
    if (DefPtr->when & DMbeforeDrawing) {
	*when = 1;
    }
}

PFexit(cbp, dip, when)
DMDcb *cbp;
DMItem *dip;
int *when;
{
    if (DefPtr->when & DMTEexit) {
	*when = 1;
    }
}

PFenter(cbp, dip, when)
DMDcb *cbp;
DMItem *dip;
int *when;
{
    if (DefPtr->when & DMTEenter) {
	*when = 1;
    }
}

PFtleft(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    short tmp;

    tmp = 1;
    if (DefPtr->TXTflags & (centerJust | rightJust)) {
	tmp = 0;
    }
    *ip = (int) tmp;
}

PFtright(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    short tmp;
    
    tmp = DefPtr->TXTflags & rightJust;
    if (tmp)
	tmp = 1;
    *ip = (int) tmp;
}

PFtcenter(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    short tmp;
    
    tmp = DefPtr->TXTflags & centerJust;
    if (tmp)
	tmp = 1;
    *ip = (int) tmp;
}

PFttop(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    short tmp;
    
    tmp = DefPtr->TXTflags & topJust;
    if (tmp)
	tmp = 1;
    *ip = (int) tmp;
}

PFtvcenter(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    short tmp;
    
    tmp = 1;
    if (DefPtr->TXTflags & (topJust | bottomJust)) {
	tmp = 0;
    }
    *ip = (int) tmp;
}

PFtbottom(cbp, dip, ip)
DMDcb *cbp;
DMItem *dip;
int *ip;
{
    short tmp;
    
    tmp = DefPtr->TXTflags & bottomJust;
    if (tmp)
	tmp = 1;
    *ip = (int) tmp;
}

