/*
**	D I A L O G   E D I T O R
**
**	Written by: Dennis Weaver
**	Date: 12-14-89
**	Modified 7/14/92 rjn
**
*/

/*
**	I N C L U D E S
*/
#include <stdio.h>
#include <string.h>
#include <isc/keycodes.h>
#include <isc/window.h>
#include <isc/controls.h>
#include <isc/textedit.h>
#include <isc/dlgman.h>
#include "dlged.h"
#include "Dbox.h"
#include "Dcontrol.h"
#include "Derror.h"
#include "Dgroup.h"
#include "Dgrid.h"
#include "Dinfo.h"
#include "Dpicklist.h"
#include "Dpat.h"
#include "Dsaveas.h"
#include "Dsbar.h"
#include "Dtext.h"
#include "Dtextedit.h"

/*
** G L O B A L S
*/
static short savefgColor;
static short savebkColor;
DedItem	dialog[MAXDLG];
char	dedtext[MAXDLG][150];
char	dedname[MAXDLG][60];
DedClip	clipboard[MAXDLG];

/*
**	Cursors
*/
Cursor text = {
	{ 0x0000, 0x0630, 0x0140, 0x0080, 0x0080, 0x0080, 0x0080, 0x0080,
	  0x0080, 0x0080, 0x0080, 0x0080, 0x0080, 0x0140, 0x0630, 0x0000 },
	{ 0x0e38, 0x0948, 0x0eb8, 0x0140, 0x0140, 0x0140, 0x0140, 0x0140,
	  0x0140, 0x0140, 0x0140, 0x0140, 0x0140, 0x0eb8, 0x0948, 0x0e38 },
	{ 8,8 }
};
Cursor hand = {
	{ 0x0000, 0x0000, 0x0000, 0x0000, 0x0700, 0x1900, 0x2200, 0x4700,
	  0xc7fe, 0x8c01, 0x97fe, 0xe410, 0x87e0, 0x8420, 0xc7c0, 0xef80 },
	{ 0x0000, 0x0000, 0x0000, 0x0000, 0x0700, 0x1f00, 0x3e00, 0x7f00,
	  0xfffe, 0xffff, 0xfffe, 0xfff0, 0xffe0, 0xffe0, 0xffc0, 0x7f80 },
	{ 9,16 }
};

/*
**	Groups
*/
byte	DEDgroup[MAXPD] = {0,0,0,0,1,2,3,4,5,0,31,0,51,52,53,54,55,0,252,253,254,255};
short	DEDfont[MAXPD]  = {0,0,1,2,3,4,5,6,7,27,28,10,-1};
short	DEDstyle[MAXPD]  = {0,normalText,boldText,underlineText,italicText,ghostText,outlineText,0,7,8,9,12,18,24,36};

/*
**	General
*/
char	*version = "4.0";

int	sw;
char	*path = 0;
char	*cp;
char	*cp2;
char	*Routines[MAXDLG * 2];
Rect	rect;
Rect	noclip;
char	datafile[30] = "data";
int	gridon = 1;
int	hgrid = 5;
int	vgrid = 5;
char	filename[300] = "Untitled.c"; /* the '.c' file. */
char	hfilename[300] = "Untitled.h"; /* the '.h' file. */
char	dlgname[300] = "Untitled";
char	dlgnameCaps[300] = "UNTITLED";
int	mode = MODEPOINT;
int	debug = 0;
int	startupfile = 2;
int	convert = 0;
int	DialogSize = 0;
int	dirty = 0;
int	rubber = ENCLOSE;
int	offsetdp = 1;
int	srconly = 1;
int	valpat;
int	FFSstate = FFSnone;
short	runface = 0;
short	runsize = 0;
short	runfont	 = 0;
short	curface = 0;
short	cursize = 0;
short	curfont	 = 0;
short	incollect = 0;
FontInfo	fi;
FILE	*fp = 0;
FILE	*hfp = 0;
DMDcb	*RfshDlg = 0;
DedItem	*DefPtr;

/*
**	Window Variables
*/
int		windowid;
int		width = 634;
int		height = 436;
int		fullwidth = 634;
int		fullheight = 436;
int		xpos = 3;
int		ypos = 41;
int		iconified;
char		title[300] = "";
Rect		window;
Point		hit, drag;
unsigned long	dblclicktime=0;

/*
**	ICON
*/
Icon charticon = {
	0x00000000,0x00000000,0x00000000,0x0FFFFFC0,
	0x08000040,0x08000040,0x0991FE70,0x097D0270,
	0x0959FE70,0x08000070,0x0951FE70,0x09F90270,
	0x0959FE70,0x08000070,0x0949FE70,0x09F10270,
	0x0969FE70,0x08000070,0x08000070,0x08F87C70,
	0x09048270,0x09048270,0x09048270,0x08F87C70,
	0x08000070,0x08000070,0x0FFFFFF0,0x03FFFFF0,
	0x03FFFFF0,0x00000000,0x00000000,0x00000000
};

/*eject*/
/*
**	M A I N   F U N C T I O N
*/
main(argc, argv)
int argc;
char *argv[];
{
    int i, j;
    int trapqfd, fd;
    Rect winrect;
    char *argp;
    EventRecord *ep;
    int	opt;
    extern char *optarg;
    extern int  optind;

    /*
     **	Check for any Startup Switches
     */
#ifdef SIXTEENBITCHARS
    while((opt = getopt(argc,argv,"L:UVcdow:")) != EOF) {
#else
    while((opt = getopt(argc,argv,"UVcdow:")) != EOF) {
#endif /* SIXTEENBITCHARS */
	switch (opt) {
	  case 'c':
	    convert = 1;
	    break;
	  case 'd':
	    debug = IMPORT;
	    break;
	  case 'o':
	    startupfile = 3;
	    break;
	  case 'w':
	    path = optarg;
	    break;
#ifdef SIXTEENBITCHARS
	  case 'L':
	    if(!set_language(atoi(optarg))) {
		puts("Invalid Language specified");
		exit(2);
	    }
	    switch(atoi(optarg)) {
	      case 0:
		theOtherFont = TAIWAN_FONT;
		theOtherSize = TAIWAN_FONT_SIZE;
		break;
	      case 1:
	      default:
		theOtherFont = CHINESE_FONT;
		theOtherSize = CHINESE_FONT_SIZE;
		break;
	    }
	    break;
#endif /* SIXTEENBITCHARS */
	  case 'V':
	    printf("\ndlged, written by Dennis Weaver, Version %s\n\n",
		   version);
	    exit(0);
	    break;
	  case '?':
	  case 'U':
	  default:
	    printf("\nUsage: dlgedit [-LUVdow] [filename]\n");
	    printf("    L0 Taiwan 16-bit language\n");
	    printf("    L1 Chinese 16-bit language\n");
	    printf("    U  Usage\n");
	    printf("    V  version\n");
	    printf("    c  convert and save in current format\n");
	    printf("    d  debug information\n");
	    printf("    o  no auto open dialog\n");
	    printf("    w  display on workstation\n");
	    exit(0);
	    break;
	}
    }
    if (optind < argc) {	/* looking for file name */
	strcpy(filename,argv[optind]);
	set_names(filename);
	startupfile = 1;
    }

    /* 
     **	Convert and save file in current format
     */
    if (convert) {
	DedInit1();
	if (startupfile != 1) {
	    fprintf(stderr,"Error, Input file not specified.\n");
	    exit(1);
	}
	fp = fopen(filename,"r");
	if(fp == 0) {		/* open failed */
	    fprintf(stderr,"ERROR, Couldn't open '%s' for reading\n",filename);
	    exit(1);
	}
	DedImport();
	fclose(fp);
	fp = 0;

	fp = fopen(filename,"w");
	if(fp == 0) {		/* open failed */
	    fprintf(stderr,"ERROR, Couldn't open '%s' for writing\n",filename);
	    exit(1);
	}

	hfp = fopen(hfilename,"w");	/* Write .h file also. */
	if(hfp == 0) {
	    fprintf(stderr,"ERROR, Couldn't open '%s' for writting\n",hfilename);
	    exit(1);
	}

	DedExport();
	fclose(fp);
	fclose(hfp);
	exit(0);
    }
    /* 
     **	Initialize graphics toolbox
     */
    if ((trapqfd = InitGraf()) < 0) {
	fprintf(stderr,"Error %d in GrafInit\n",-trapqfd);
	exit(1);
    }

    /* 
     **	Establish connection to a window manager
     */
    if ((fd = ConnectGraf(path)) < 0) {
	fprintf(stderr,"Error %d in ConnectGraf\n",-fd);
	exit(1);
    }
    /*
     **	Create a window
     */
    DedSetTitle();
    SetRect(&winrect, xpos, ypos, xpos+width, ypos+height);
    windowid = NewWindow(&winrect, title, showWindow, documentProc, 
			 frontWindow, hasGoAway|hasZoom|hasSendToBack|hasGrow|hasDrag, fd);
    SetPort(windowid);
    MouseMode(F_KEYDOWN | F_KEYUP | F_MOUSE1);
    /*
     **	Put up Menus
     */
    NewMenu(FFILE, "File");
    AppendMenu(FFILE, "/OOpen...;Close;/SSave;Save As...;-;/QQuit");
    
    NewMenu(EDIT, "Edit");
    AppendMenu(EDIT, "/ASelect All;Delete;-;/XCut;/CCopy;/VPaste;/DDuplicate");
    DisableItem(EDIT,PASTE);
    
    NewMenu(NEW, "New");
    AppendMenu(NEW, "Box;Check Box;Pattern Box;-;Radio Button;Push Button;Double Push Button;-;Text;Text Edit;-;Scroll Bar;Pick List;-;Icon;Bitmap");
    SetItemKey(NEW, BOX, F_FUNC | K_F1);
    SetItemKey(NEW, CHECKBOX, F_FUNC | K_F2);
    SetItemKey(NEW, CNTLBOX, F_FUNC | K_F3);
    SetItemKey(NEW, RADIOBUT, F_FUNC | K_F4);
    SetItemKey(NEW, PUSHBUT, F_FUNC | K_F5);
    SetItemKey(NEW, DPUSHBUT, F_FUNC | K_F6);
    SetItemKey(NEW, TEXT, F_FUNC | K_F7);
    SetItemKey(NEW, TEXTEDIT, F_FUNC | K_F8);
    SetItemKey(NEW, SCROLLBAR, F_FUNC | K_F9);
    SetItemKey(NEW, PICKLIST, F_FUNC | K_F10);
    SetItemKey(NEW, ICON, F_FUNC | K_F11);
    SetItemKey(NEW, BITMAP, F_FUNC | K_F12);

    NewMenu(OPTIONS,"Options");
    AppendMenu(OPTIONS,"Point Mode;Text Mode;Define Mode;-;Grid On;Set Grid...;-;RubberBand Enclose;Offset Dup/Paste;-;/PPosition Info...");
    CheckItem(OPTIONS, MODEPOINT, 1);
    CheckItem(OPTIONS, RUBBER, 1);
    CheckItem(OPTIONS, OFFSETDP, 1);
    CheckItem(OPTIONS, GRIDON, gridon);

    NewMenu(BORDER, "Border");
    AppendMenu(BORDER, "Drop Shadow;Single Box;Double Box;Triple Box;Invisible;-;Line Width 1;Line Width 2;Line Width 3");

    NewMenu(GROUP, "Group");
    AppendMenu(GROUP, "No Group 0;Other...;-;Exclusive 1;Exclusive 2;Exclusive 3;Exclusive 4;Exclusive 5;-;Active TE 31;-;General 51;General 52;General 53;General 54;General 55;-Exit 251 (val);Exit 252 (no val);Exit 253 (val);Exit 254 (Cancel);Exit 255 (OK)");

    NewMenu(FONT, "Font");
    AppendMenu(FONT, "La Center;Spangle;Pullman;Cle Elum;Woodland;Otis Orchards;Chicago;Los Angeles;Times;Helvetica;Courier");
    
    NewMenu(STYLE, "Style");
    AppendMenu(STYLE, "Normal;<BBold;<UUnderline;<IItalic;Ghost;<OOutline;-;7 Point;8 Point;9 Point;12 Point;18 Point;24 Point;36 Point");
    CheckFFS();
    /*
     **	Bind events
     */
    Event(updateEvt,updateevent);
    Event(mouseEvt,mouseevent);
    Event(windowEvt,windowevent);
    Event(menuEvt,menuevent);
    Event(keyEvt,keyevent);
    SetRect(&window,0,0,width,height);
    PenMode(srcOr);
    /*
     **	Initialization
     */
    DMInit();
    InitControls();
    TEInit(0, normalText);
    PLInit();
    DedInit1();
    DedInit2();
    SetKbdXlate(1);
    SetRect(&noclip,0,0,2000,2000);
    dblclicktime = (unsigned long)GetDblClickTime();
    /*
     **	Loop untill a release occures or exit if an error occures
     */
    for(;;) {
	ep = GetEvent(noWindow,noEvent);
	if(ep < 0) {
	    printf("ERROR, GetEvent(noWindow,noEvent) returned 0x%x\n",ep);
	    exit(1);
	}
    }
}
/*eject*/

/*
**	D R A W   I C O N
*/
draw_icon()
{
    Rect scratch;

    SetRect(&scratch, 0, 0, 32, 32);
    PlotIcon(&scratch, &charticon);
    ValidRect(&scratch);
}
/*eject*/
/*
**	W I N D O W   E V E N T S
*/
void windowevent(ep)
EventRecord *ep;
{
	Rect rect;
	switch (ep->message & F_KEYMASK) {
		case windowGoaway:
			if(incollect == 0) {
				DedQuit();
			}
			break;
		case windowMove:
			xpos += ep->where.edge.left;
			ypos += ep->where.edge.top;
			MoveWindow(ep->who, xpos, ypos, 0);
			break;
		case windowResize:
			if (!iconified) {
				SetRect(&rect,width-20,height-20,width,height);
				EraseRect(&rect);
				width += ep->where.edge.left;
				height += ep->where.edge.top;
				SizeWindow(ep->who, width, height, updateRequest);
				SetRect(&window,0,0,width,height);
				EraseRect(&window);
				InvalRect(&window);
				DrawGrowIcon(ep->who);
			}
			break;
		case windowZoom:
			if (iconified) {
				/* Zoom Up */
			    UnIconifyWindow(ep->who);
			}
			else {
				/* Zoom Down */
			    IconifyWindow(ep->who);
			    draw_icon();
			}
			EraseRect(&window);
			InvalRect(&window);
			iconified = !iconified;
			break;
	}
}
/*eject*/
/*
**	U P D A T E   E V E N T S
*/
void updateevent(ep)
EventRecord *ep;
{
	BeginUpdate(ep->who);
    if (iconified) {
		draw_icon();
	}
	else {
		DrawGrowIcon(ep->who);
		FrameRect(&rect);
		if(startupfile == 1) {
			myopen();
			startupfile = 0;
		}
		else if(startupfile == 2) {
			enablemenus();
			DedOpen();
			disablemenus();
			startupfile = 0;
		}
		else if(startupfile == 3) {
			startupfile = 0;
		}
		else {
			dspall();
			if(RfshDlg) DMUpdate(RfshDlg);
		}
	}
	EndUpdate(ep->who);
}
/*eject*/
/*
**	M O U S E   E V E N T S
*/
void mouseevent(ep)
EventRecord *ep;
{
	static int				onobj=0;
	static unsigned long	lastclick=0;
	static short			dblclick=0;
	Rect 					scratch;
	DedItem					*rp;

	if(ep->message & F_KEYDOWN) {
		/* Button Pressed */
		hit = ep->where.corner.topLeft;
		if((rp = onobject(&hit))) {
			/* On Object */
			dblclick = ((ep->when - lastclick) < dblclicktime ? 1:0);
			lastclick = ep->when;
			if(ep->message & F_CTRL || dblclick) {
				/* One-Shot Define Mode */
				DefineObj(rp);
			}
			else if(ep->message & F_ALT) {
				/* One-Shot Define Mode */
				DefineText(rp);
			}
			else if(rp->selected && onhandle(&hit,rp)) {
				/* On Handle of Selected Object */
				stretch(rp);
			}
			else {
				/* No Stretch so Select/Deselect */
				if(rp->selected) {
					onobj = 1;
					/* Object is Selected */
					if(ep->message & F_SHIFT) {
						/* Shift Key Down */
						deselect(rp);
					}
				}
				else {
					/* Object is NOT Selected */
					if(ep->message & F_SHIFT) {
						/* Shift Key Down */
						select(rp);
					}
					else {
						/* Shift Key Up */
						xselect(rp);
					}
				}
				move();
			}
		}
		else {
			/* NOT On Object */
			if((ep->message & F_SHIFT) == 0) {
				deselectall(1);
			}
			rubberband();
		}
	}
}
/*eject*/
/*
**	S T R E T C H   R O U T I N E
*/
stretch(rp)
DedItem	*rp;
{
    int			first=1;
    Rect		tr;
    Rect		tr2;
    EventRecord *ep;
    
    tr = rp->rect;
    PenMode(srcXor);
    PenPat((Pattern*)7);
    for(;;) {
	ep = GetEvent(1 << windowid, 1 << mouseEvt);
	if(ep->message & F_KEYUP) {
	    dirty = 1;
	    PenMode(srcOr);
	    PenPat((Pattern*)0);
	    erase(rp);
	    InvalRect(&rp->rect);
	    Pt2Rect(&tr.corner.topLeft,&tr.corner.botRight,&rp->rect);
	    switch(rp->type) {
	      case DMCHECKBOX:
	      case DMPUSHBUT:
	      case DMDPUSHBUT:
	      case DMRADIOBUT:
	      case DMSCROLLBAR:
	      case DMPATBOX:
		SizeControl(rp->id,rectwidth(&rp->rect),rectheight(&rp->rect));
		ValidRect(&rp->rect);
		break;
	      case DMTEXTEDIT:
		techange(rp);
		ValidRect(&rp->rect);
		break;
	      case DMTEXT:
		display(rp);
		ValidRect(&rp->rect);
		break;
	      case DMBOX:
		display(rp);
		break;
	      case DMPICKLIST:
		SizeControl(rp->id,DMSBWidth,rectheight(&rp->rect));
		MoveControl(rp->id,rp->rect.edge.right-DMSBWidth,rp->rect.edge.top);
		display(rp);
		break;
	      case DMICON:
	      case DMBITMAP:
		display(rp);
		break;
	    }
	    dspselect(rp);
	    break;
	}
	else if(ep->message & F_MOUSE1) {
	    if(first)
		first = 0;
	    else {
		FrameRect(&tr2);
	    }
	    tr.corner.botRight = ep->where.corner.topLeft;
	    if(gridon)
		stretch2grid(&tr);
	    tr2 = tr;
	    Pt2Rect(&tr.corner.topLeft,&tr.corner.botRight,&tr2);
	    FrameRect(&tr2);
	}
    }
}
/*eject*/
/*
**	M O V E   R O U T I N E
*/
move()
{
    int			first=1;
    int			first2=1;
    int			i;
    Rect		tr;
    short		dh,dv;
    EventRecord *ep;
    DedItem		*rp;

    for(;;) {
	ep = GetEvent(1 << windowid, 1 << mouseEvt);
	if(ep->message & F_KEYUP) {
	    PenMode(srcOr);
	    PenPat((Pattern*)0);
	    rp = &dialog[0];
	    for(i=0; i<MAXDLG && first2==0; i++,rp++) {
		if(rp->selected) {
		    dirty = 1;
		    switch(rp->type) {
		      case DMBOX:
		      case DMTEXT:
		      case DMICON:
		      case DMBITMAP:
			erase(rp);
			InvalRect(&rp->rect);
			rp->rect = rp->tmp;	
			display(rp);
			break;
		      case DMPICKLIST:
			erase(rp);
			InvalRect(&rp->rect);
			rp->rect = rp->tmp;	
			dh = rp->tmp.corner.topLeft.h;
			dv = rp->tmp.corner.topLeft.v;
			rp->rect = rp->tmp;
			MoveControl(rp->id,dh+rectwidth(rp)-DMSBWidth,dv);
			display(rp);
			dspselect(rp);
			break;
		      case DMCHECKBOX:
		      case DMRADIOBUT:
		      case DMPUSHBUT:
		      case DMDPUSHBUT:
		      case DMSCROLLBAR:
		      case DMPATBOX:
			erase(rp);
			dh = rp->tmp.corner.topLeft.h;
			dv = rp->tmp.corner.topLeft.v;
			MoveControl(rp->id,dh,dv);
			rp->rect = rp->tmp;
			ValidRect(&rp->rect);
			dspselect(rp);
			break;
		      case DMTEXTEDIT:
			erase(rp);
			InvalRect(&rp->rect);
			dh = rp->tmp.corner.topLeft.h;
			dv = rp->tmp.corner.topLeft.v;
			rp->rect = rp->tmp;
			techange(rp);
			dspselect(rp);
			break;
		    }
		}
	    }
	    sort();
	    break;
	}
	else if(ep->message & F_MOUSE1) {
	    if(thePenMode != srcXor) {
		PenMode(srcXor);
		PenPat((Pattern*)7);
	    }
	    rp = &dialog[0];
	    for(i=0; i<MAXDLG; i++,rp++) {
		if(rp->selected && rp->type) {
		    if(first2) {
			first = 0;
		    }
		    else {
			FrameRect(&rp->tmp);
		    }
		    dh = ep->where.edge.left - hit.h;
		    dv = ep->where.edge.top - hit.v;
		    rp->tmp = rp->rect;
		    OffsetRect(&rp->tmp,dh,dv);
		    if(gridon)
			snap2grid(&rp->tmp);
		    FrameRect(&rp->tmp);
		}
		if(i==(MAXDLG-1) && first==0)
		    first2 = 0;
	    }
	}
    }
}
/*eject*/
/*
**	R U B B E R   B A N D  R O U T I N E
*/
rubberband()
{
    int			i;
    Rect		tr;
    Rect		tr2;
    Rect		tr3;
    EventRecord *ep;
    DedItem		*rp;
    int			flag = FFSnone;
    
    tr.corner.topLeft = hit;
    tr.corner.botRight = hit;
    tr2= tr;
    for(;;) {
	ep = GetEvent(1 << windowid, 1 << mouseEvt);
	if(ep->message & F_KEYUP) {
	    FrameRect(&tr2);
	    PenMode(srcOr);
	    PenPat((Pattern*)0);
	    rp = &dialog[0];
	    for(i=0; i<MAXDLG; i++,rp++) {
		if(rubber == TOUCH) {
		    if(rp->type && SectRect(&rp->rect,&tr2,&tr3)) {
			flag = FFSmany;
			select(rp);
		    }
		}
		else {
		    tr3 = rp->rect;
		    if(tr2.edge.left <= tr3.edge.left &&
		       tr2.edge.top <= tr3.edge.top &&
		       tr2.edge.right >= tr3.edge.right &&
		       tr2.edge.bottom >= tr3.edge.bottom) {
			flag = FFSmany;
			select(rp);
		    }
		}
	    }
	    MakeFFS(flag);
	    break;
	}
	else if(ep->message & F_MOUSE1) {
	    if(thePenMode != srcXor) {
		PenMode(srcXor);
		PenPat((Pattern*)7);
	    }
	    FrameRect(&tr2);
	    tr.corner.botRight = ep->where.corner.topLeft;
	    tr2 = tr;
	    Pt2Rect(&tr.corner.topLeft,&tr.corner.botRight,&tr2);
	    FrameRect(&tr2);
	}
    }
}
/*eject*/
/*
**	K E Y   E V E N T S
*/
void keyevent(ep)
EventRecord *ep;
{
    long		c;
    DedItem		*rp;
    int			i;
    
    c = ep->message;
    if(c & F_KEYUP)
	return;
    c &= (F_FUNC | F_CTRL | F_ALT | F_SHIFT | F_KEYMASK);
    switch(c) {
      case (K_ESC | F_FUNC):
	  DedQuit();
	  break;
	case (F_CTRL | 'p'):
	    printf("\nTYPE RP SELECTED ID\n");
	  rp = dialog;
	  printf("type group value text handle prefill validate\n");
	  for(i=0; i<MAXDLG; i++,rp++) {
	      if(rp->type) {
		  printf("%d 0x%x 0x%x 0x%x %s %s %s %s\n",rp->selected,
			 rp->type,rp->group,rp->value,rp->text,rp->name,
			 rp->prefill,rp->validate);
	      }
	  }
	  break;
	case (F_FUNC | K_BACKSP):
	    deleteselected();
	  break;
      }
}
/*eject*/
/*
**	M E N U   E V E N T S
*/
void menuevent(ep)
EventRecord *ep;
{
    int			menuid, menuitem;
    int			epmsg;
    int			i,sw,sh;
    Rect		tr;
    DedItem		*rp;
    short		runattr;
    short		runmask;
    DMDcb		*cb;
    DMDcb		*prevcb;
    int			group;
    char		buf[10];

    BeginMenu(ep->message);
    menuid = ep->message >> 16;
    menuitem = ep->message & 0xffff;
    epmsg = ep->message;
    switch(menuid) {
      case FFILE:
	switch(menuitem) {
	  case  FOPEN:
	    DedOpen();
	    break;
	  case  FCLOSE:
	    DedClose();
	    break;
	  case  FSAVE:
	    save();
	    break;
	  case  FSAVEAS:
	    saveas();
	    break;
	  case  FQUIT:
	    DedQuit();
	    break;
	}
	break;
      case EDIT:
	switch(menuitem) {
	  case SELECTALL:
	    selectall();
	    MakeFFS(FFSmany);
	    CheckFFS();
	    break;
	  case DELETE:
	    dirty = 1;
	    deleteselected();
	    break;
	  case CUT:
	    dirty = 1;
	    cut();
	    break;
	  case COPY:
	    copy();
	    break;
	  case PASTE:
	    dirty = 1;
	    paste();
	    break;
	  case DUP:
	    dirty = 1;
	    dup();
	    break;
	}
	break;
      case NEW:
	dirty = 1;
	rp = findslot();
	rp->group = 0;
	rp->fgColor = FORECOLOR; /* Use default colors for new items. */
	rp->bkColor = BACKCOLOR;
	switch(menuitem) {
	  case BOX:
	    SetRect(&tr,20,20,60,60);
	    FrameRect(&tr);
	    rp->rect = tr;
	    rp->type = DMBOX;
	    rp->xfermode = srcCopy;
	    rp->attr = (BSINGLE | BPENWIDTH1);
	    break;
	  case ICON:
	    SetRect(&tr,20,20,52,52);
	    rp->rect = tr;
	    rp->type = DMICON;
	    rp->xfermode = srcCopy;
	    display(rp);
	    break;
	  case BITMAP:
	    SetRect(&tr,20,20,80,80);
	    rp->rect = tr;
	    rp->type = DMBITMAP;
	    rp->xfermode = srcCopy;
	    display(rp);
	    break;
	  case  CHECKBOX:
	    SetRect(&tr,20,20,108,34);
	    rp->rect = tr;
	    rp->type = DMCHECKBOX;
	    rp->xfermode = srcOr;
	    strcpy(rp->text,"Check Box");
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid,&tr,"Check Box",1,1,0,1,checkBoxProc|useWFont,0,rp->fgColor,rp->bkColor);
	    break;
	  case  RADIOBUT:
	    SetRect(&tr,20,20,128,34);
	    rp->rect = tr;
	    rp->type = DMRADIOBUT;
	    rp->group = DMexclusive1;
	    rp->xfermode = srcOr;
	    strcpy(rp->text,"Radio Button");
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid,&tr,"Radio Button",1,1,0,1,radioButProc|useWFont,0,rp->fgColor,rp->bkColor);
	    break;
	  case  CNTLBOX:
	    SetRect(&tr,20,20,50,50);
	    rp->rect = tr;
	    rp->type = DMPATBOX;
	    rp->group = DMexclusive2;
	    rp->xfermode = srcOr;
	    rp->pattern = 11;
	    strcpy(rp->text,"");
	    SetCDefProc(dlgControl);
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid,&tr,"",1,1,0,0xff,cntlBoxProc|useWFont,0,rp->fgColor,rp->bkColor);
	    SetCtlValues(rp->id,0,11);
	    SetCDefProc(0);
	    break;
	  case  PUSHBUT:
	    SetRect(&tr,20,20,120,40);
	    rp->rect = tr;
	    rp->type = DMPUSHBUT;
	    rp->xfermode = srcOr;
	    strcpy(rp->text,"Push Button");
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid,&tr,"Push Button",1,1,0,1,pushButProc|useWFont,0,rp->fgColor,rp->bkColor);
	    break;
	  case  DPUSHBUT:
	    SetRect(&tr,20,20,120,48);
	    rp->rect = tr;
	    rp->type = DMDPUSHBUT;
	    rp->xfermode = srcOr;
	    strcpy(rp->text,"Push Button");
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid,&tr,"Push Button",1,1,0,1,defButProc|useWFont,0,rp->fgColor,rp->bkColor);
	    SetCDefProc(0);
	    break;
	  case  SCROLLBAR:
	    SetRect(&tr,20,20,37,100);
	    rp->rect = tr;
	    rp->type = DMSCROLLBAR;
	    rp->xfermode = srcCopy;
	    strcpy(rp->text,"");
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid,&tr,"Scroll Bar",1,1,0,1,scrollBarProc,0,rp->fgColor,rp->bkColor);
	    break;
	  case  PICKLIST:
	    SetRect(&tr,20,20,200,120);
	    rp->rect = tr;
	    rp->type = DMPICKLIST;
	    FrameRect(&tr);
	    rp->xfermode = srcOr;
	    strcpy(rp->text,"");
	    pickscrollrect(&rp->rect,&tr);
	    setFontFaceSize(rp);
	    rp->id = dlgNewControl(windowid,&tr,"Scroll Bar",1,1,0,1,scrollBarProc,0,rp->fgColor,rp->bkColor);
	    break;
	  case  TEXT:
	    setFontFaceSize(rp);
	    GetFontInfo(&fi);
	    strcpy(rp->text,"Text");
	    sw = (LocalStringWidth(theFont,theFace,theSize,rp->text)) + 20;
	    sh = fi.ascent + fi.descent + 2;
	    SetRect(&tr,20,20,20+sw,20+sh);
	    rp->rect = tr;
	    rp->type = DMTEXT;
	    rp->xfermode = srcOr;
	    rp->TXTflags = (leftJust | vcenterJust);
	    dsptext(rp);
	    break;
	  case  TEXTEDIT:
	    SetRect(&tr,20,20,160,40);
	    rp->rect = tr;
	    rp->type = DMTEXTEDIT;
	    rp->xfermode = srcOr;
	    rp->value = DMtebox | DMtescroll;
	    setFontFaceSize(rp);
	    rp->attr = runface | DISghostText | DISghostFrame;
	    strcpy(rp->text,"");
	    rp->id = dlgTENew(rp);
	    break;
	}
	sort();
	break;
      case OPTIONS:
	switch(menuitem) {
	  case MODEPOINT:
	    setpointmode();
	    break;
	  case MODETEXT:
	    CheckItem(OPTIONS, mode, 0);
	    Event(mouseEvt,modetext);
	    Event(keyEvt,modetext);
	    mode = MODETEXT;
	    SetCursor(&text);
	    CheckItem(OPTIONS, mode, 1);
	    break;
	  case MODEDEFINE:
	    setdefinemode();
	    break;
	  case GRIDON:
	    if(gridon)
		gridon = 0;
	    else
		gridon = 1;
	    CheckItem(OPTIONS, GRIDON, gridon);
	    break;
	  case SETGRID:
	    setgrid();
	    break;
	  case RUBBER:
	    if(rubber == TOUCH) {
		rubber = ENCLOSE;
		CheckItem(OPTIONS, RUBBER, 0);
	    }
	    else {
		rubber = TOUCH;
		CheckItem(OPTIONS, RUBBER, 1);
	    }
	    break;
	  case OFFSETDP:
	    if(offsetdp) {
		offsetdp = 0;
		CheckItem(OPTIONS, OFFSETDP, 0);
	    }
	    else {
		offsetdp = 1;
		CheckItem(OPTIONS, OFFSETDP, 1);
	    }
	    break;
	  case OBJINFO:
	    displayinfo();
	    break;
	}
	break;
      case GROUP:
	if(menuitem == OTHER) {
	    cb = DMNew(Dgroup,windowid,0);
	    incollect = 1;
	    InitCursor();
	    prevcb = RfshDlg;
	    RfshDlg = cb;
	    group = DMCollect(cb);
	    if(group == DMok) {
		dirty = 1;
		DMGet(cb,DGROUP_group,buf);
		group = atoi(buf);
		DMDispose(cb);
		incollect = 0;
		RfshDlg = prevcb;
	    }
	    else {
		DMDispose(cb);
		incollect = 0;
		RfshDlg = prevcb;
		break;
	    }
	}
	else {
	    group = DEDgroup[menuitem];
	}
	rp = dialog;
	for(i=0; i<MAXDLG; i++,rp++) {
	    if(rp->type && rp->selected) {
		dirty = 1;
		rp->group = group;
		switch(rp->type) {
		  case DMPUSHBUT:
		  case DMDPUSHBUT:
		    switch(rp->group) {
		      case DMok:
			rp->keycode = (K_ENTER | F_FUNC);
			break;
		      case DMcancel:
			rp->keycode = (K_ESC | F_FUNC);
			break;	
		    }
		    break;
		}
	    }
	}
	break;
      case BORDER:
	runattr = 0;
	runmask = 0;
	switch(menuitem) {
	  case  SHADOW:
	    runmask = BORDEDMASK;
	    runattr &= ~(BDOUBLE | BTRIPLE | BSINGLE);
	    runattr |= BSHADOW;
	    break;
	  case SINGLE:
	    runmask = BORDEDMASK;
	    runattr &= ~(BSHADOW | BDOUBLE | BTRIPLE);
	    runattr |= BSINGLE;
	    break;
	  case DOUBLE:
	    runmask = BORDEDMASK;
	    runattr &= ~(BSHADOW | BSINGLE | BTRIPLE);
	    runattr |= BDOUBLE;
	    break;
	  case TRIPLE:
	    runmask = BORDEDMASK;
	    runattr &= ~(BSHADOW | BSINGLE | BDOUBLE);
	    runattr |= BTRIPLE;
	    break;
	  case INVISABLE:
	    runmask = BORDEDMASK;
	    runattr &= ~BORDEDMASK;
	    break;
	  case PENWIDTH1:
	    runmask = PENMASK;
	    runattr &= ~(BPENWIDTH2 | BPENWIDTH3);
	    runattr |= BPENWIDTH1;
	    break;
	  case PENWIDTH2:
	    runmask = PENMASK;
	    runattr &= ~(BPENWIDTH1 | BPENWIDTH3);
	    runattr |= BPENWIDTH2;
	    break;
	  case PENWIDTH3:
	    runmask = PENMASK;
	    runattr &= ~(BPENWIDTH1 | BPENWIDTH2);
	    runattr |= BPENWIDTH3;
	    break;
	}
	rp = dialog;
	for(i=0; i<MAXDLG; i++,rp++) {
	    if(rp->type == BOX && rp->selected) {
		dirty = 1;
		rp->attr &= ~runmask;
		rp->attr |= runattr;
		erase(rp);
		dspall();
	    }
	}
	break;
      case FONT:
	curfont = DEDfont[menuitem];
	StuffFFS(curfont,-1,-1,0);
	DisplaySelected();
	CheckFFS();
	if(FFSstate == FFSnone) {
	    runfont = curfont;
	}
	break;
      case STYLE:
	switch(menuitem) {
	  case Fnormal:
	    curface = 0;
	    StuffFFS(-1,curface,-1,0);
	    break;
	  case Fbold:
	  case Funderline:
	  case Fitalic:
	  case Fghost:
	  case Foutline:
	    if(curface & (DEDstyle[menuitem])) {
		curface &= ~(DEDstyle[menuitem]);
		StuffFFS(-1,~(DEDstyle[menuitem]),-1,1);
	    }
	    else {
		curface |= (DEDstyle[menuitem]);
		StuffFFS(-1,DEDstyle[menuitem],-1,0);
	    }
	    break;
	  default:
	    cursize = DEDstyle[menuitem];
	    StuffFFS(-1,-1,cursize,0);
	    break;
	}
	if(FFSstate == FFSnone) {
	    runface = curface;
	    runsize = cursize;
	}
	DisplaySelected();
	CheckFFS();
	break;
    }
    EndMenu(epmsg);
}

DisplaySelected()
{
    int		i;
    DedItem	*rp;
    
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {
	if(rp->type && rp->selected) {
	    switch(rp->type) {
	      case DMPUSHBUT:
		DisposeControl(rp->id);
		doFontFaceSize2(rp);
		rp->id = dlgNewControl(windowid,&rp->rect,rp->text,1,1,0,1,pushButProc|useWFont,0,rp->fgColor,rp->bkColor);
		break;
	      case DMDPUSHBUT:
		DisposeControl(rp->id);
		doFontFaceSize2(rp);
		rp->id = dlgNewControl(windowid,&rp->rect,rp->text,1,1,0,1,defButProc|useWFont,0,rp->fgColor,rp->bkColor);
		break;
	      case DMRADIOBUT:
		DisposeControl(rp->id);
		doFontFaceSize2(rp);
		rp->id = dlgNewControl(windowid,&rp->rect,rp->text,1,1,0,1,radioButProc|useWFont,0,rp->fgColor,rp->bkColor);
		break;
	      case DMCHECKBOX:
		DisposeControl(rp->id);
		doFontFaceSize2(rp);
		rp->id = dlgNewControl(windowid,&rp->rect,rp->text,1,1,0,1,checkBoxProc|useWFont,0,rp->fgColor,rp->bkColor);
		break;
	      default:
		erase(rp);
		display(rp);
		break;
	    }
	}
    }
}
StuffFFS(font,face,size,flag)
short	font;
short	face;
short	size;
short	flag;
{
    DedItem	*rp;
    int		i;
    
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {
	if(rp->type && rp->selected) {
#ifdef SIXTEENBITCHARS
	    rp->otherfont = theOtherFont;
	    rp->othersize = theOtherSize;
#endif /* SIXTEENBITCHARS */
	    switch(rp->type) {
	      case DMTEXT:
	      case DMTEXTEDIT:
	      case DMPUSHBUT:
	      case DMDPUSHBUT:
	      case DMRADIOBUT:
	      case DMCHECKBOX:
	      case DMPATBOX:
	      case DMPICKLIST:
		dirty = 1;
		if(font != -1)
		    rp->font = font;
		if(face != -1 && face != FFSnomatch)
		    if(face == 0) rp->attr = 0;
		    else if(flag) rp->attr &= (face & ~FFSnomatch);
		    else rp->attr |= (face & ~FFSnomatch);
		if(size != -1)
		    rp->fontsize = size;
		if(rp->type == DMTEXTEDIT)
		    techange(rp);
		break;
	    }
	}
    }
}
/*eject*/
/*
**	L O C A T E   R O U T I N E S
*/
DedItem
*onobject(pt)
Point	*pt;
{
    int		i;
    DedItem	*orp=0;
    DedItem	*rp;
    
    rp = &dialog[MAXDLG-1];
    for(i=0; i<MAXDLG; i++,rp--) {
	if(rp->type && PtInRect(pt,&rp->rect)) {
	    orp = rp;
	    MakeFFS(rp);
	    break;
	}
    }
    if(i == MAXDLG) {
	MakeFFS(FFSnone);
    }
    return(orp);
}

onhandle(ptp,rp)
Point	*ptp;
DedItem	*rp;
{
    int		status=0;
    
    if(PtInRect(ptp,&rp->handle)) {
	FrameRect(&rp->handle);
	status = 1;
    }
    return(status);
}

DedItem 
*findslot()
{
    int		i;
    DedItem	*rp=0;
    
    rp = &dialog[0];
    for(i=0; i<MAXDLG; i++,rp++) {
	if(rp->type == 0) {
	    break;
	}
    }
    return(rp);
}
/*eject*/
/*
**	C R E A T E   R O U T I N E S
*/

dup()
{
    DedItem	*rp;
    DedItem	*nrp;
    Rect	tr;
    int		i;
    byte	select[MAXDLG];
    
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {
	select[i] = rp->selected;
    }
    deselectall(0);
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {
	if(select[i] && rp->type) {
	    nrp = dupitem(rp);
	    nrp->selected = 1;
	    dspselect(nrp);
	}
    }
    sort();
}

DedItem
*dupitem(rp)
DedItem	*rp;
{
    DedItem	*nrp;
    Rect	tr;
    int		i;

    
    nrp = findslot();
    cp = nrp->text;
    cp2 = nrp->name;
    *nrp = *rp;
    nrp->text = cp;
    nrp->name = cp2;
    strcpy(nrp->text,rp->text);
    strcpy(nrp->name,rp->name);
    if(offsetdp) {
	OffsetRect(&nrp->rect,5*hgrid,5*vgrid);
    }
    switch(rp->type) {
      case  DMTEXT:
      case  DMBOX:
      case  DMICON:
      case  DMBITMAP:
	break;
      case  DMCHECKBOX:
	doFontFaceSize2(rp);
	nrp->id = dlgNewControl(windowid,&nrp->rect,nrp->text,1,1,0,1,checkBoxProc|useWFont,0,rp->fgColor,rp->bkColor);
	break;
      case  DMPATBOX:
	SetCDefProc(dlgControl);
	nrp->id = dlgNewControl(windowid,&nrp->rect,"",1,1,0,0xff,cntlBoxProc,0,rp->fgColor,rp->bkColor);
	SetCtlValues(nrp->id,nrp->selected,nrp->pattern);
	SetCDefProc(0);
	break;
      case  DMRADIOBUT:
	doFontFaceSize2(rp);
	nrp->id = dlgNewControl(windowid,&nrp->rect,nrp->text,1,1,0,1,radioButProc|useWFont,0,rp->fgColor,rp->bkColor);
	break;
      case  DMPUSHBUT:
	doFontFaceSize2(rp);
	nrp->id = dlgNewControl(windowid,&nrp->rect,nrp->text,1,1,0,1,pushButProc|useWFont,0,rp->fgColor,rp->bkColor);
	break;
      case  DMDPUSHBUT:
	doFontFaceSize2(rp);
	nrp->id = dlgNewControl(windowid,&nrp->rect,nrp->text,1,1,0,1,defButProc|useWFont,0,rp->fgColor,rp->bkColor);
	break;
      case  DMSCROLLBAR:
	nrp->id = dlgNewControl(windowid,&nrp->rect,rp->text,1,1,0,1,scrollBarProc,0,rp->fgColor,rp->bkColor);
	break;
      case  DMPICKLIST:
	pickscrollrect(&nrp->rect,&tr);
	nrp->id = dlgNewControl(windowid,&tr,rp->text,1,1,0,1,scrollBarProc,0,rp->fgColor,rp->bkColor);
	break;
      case  DMTEXTEDIT:
	nrp->id = dlgTENew(nrp);
	break;
    }
    return(nrp);
}

techange(rp)
DedItem	*rp;
{
    Rect	tr;
    
    erase(rp);
    TEDispose(rp->id);
    rp->id = dlgTENew(rp);
}
/*eject*/
/*
**	S O R T   R O U T I N E S
*/
/*
**	Qsort Field Struct Compare Function
**
**	result of -1 puts rp1 before rp2 in array
**	result of  1 puts rp1 after  rp2 in array
*/
dlgeditsort(rp1,rp2)
DedItem	*rp1;
DedItem	*rp2;
{
    int		result;
    Rect	r1,r2;
    
    r1 = rp1->rect;
    r2 = rp2->rect;
    /*
     **	Sort by Used / Unused (used to top)
     */
    if(rp1->type != 0 && rp2->type == 0)
	result = -1;
    else if(rp1->type == 0 && rp2->type != 0)
	result = 1;
    else if(rp1->type == 0 && rp2->type == 0)
	result = 0;
    /*
     **	Both Used,
     **	Sort by Top/Left Position (top/left most to top)
     */
    else if(r1.edge.top < r2.edge.top)
	result = -1;
    else if(r1.edge.top > r2.edge.top)
	result = 1;
    else if(r1.edge.left < r2.edge.left)
	result = -1;
    else if(r1.edge.left > r2.edge.left)
	result = 1;
    /*
     **	Top / Left Equal,
     **	Sort by Size (bigger to top)
     */
    else if(rectwidth(&r1) > rectwidth(&r2))
	result = -1;
    else if(rectwidth(&r1) < rectwidth(&r2))
	result = 1;
    else if(rectheight(&r1) > rectheight(&r2))
	result = -1;
    else if(rectheight(&r1) < rectheight(&r2))
	result = 1;
    /*
     **	Rects Equal,
     **	Sort by type (box objects to the top)
     */
    else if(rp1->type == DMBOX && rp2->type != DMBOX)
	result = -1;
    else if(rp1->type != DMBOX && rp2->type == DMBOX)
	result = 1;
    /*
     **	Both objects are boxes,
     **	Sort by Selected (selected to bottom)
     */
    else if(!rp1->selected && rp2->selected)
	result = -1;
    else if(rp1->selected && !rp2->selected)
	result = 1;
    else
	result = 0;
    return(result);
}

/*
**	Sort Field Structs
*/
sort()
{
    int		i;
    DedItem	*rp;
    
    qsort((char*)dialog, MAXDLG, sizeof(DedItem), dlgeditsort );
}
/*eject*/
/*
**	D E F I N E   M O D E   R O U T I N E S
*/
setgrid()
{
    DMDcb	*cb;
    DMDcb	*prevcb;
    int		group;
    int		tmp;
    int		when = 0;
    char	buf[20];
    
    cb = DMNew(Dgrid,windowid,0);
    incollect = 1;
    InitCursor();
    prevcb = RfshDlg;
    RfshDlg = cb;
    group = DMCollect(cb);
    if(group == DMok) {
	DMGet(cb,DGRID_hgrid,buf);
	hgrid = atoi(buf);
	DMGet(cb,DGRID_vgrid,buf);
	vgrid = atoi(buf);
    }
    DMDispose(cb);
    incollect = 0;
    RfshDlg = prevcb;
}
void
modedefine(ep)
EventRecord *ep;
{
    DedItem		*rp;
    
    if(ep->message & F_KEYDOWN) {
	if((rp = onobject(&ep->where.corner.topLeft))) {
	    InitCursor();
	    DefineObj(rp);
	    SetCursor(&hand);
	}
    }
}
/*eject*/
DefineObj(rp) 
DedItem		*rp;
{
    DefPtr = rp;
    switch(rp->type) {
      case DMCHECKBOX:
      case DMPUSHBUT:
      case DMDPUSHBUT:
      case DMRADIOBUT:
	DefineControl(rp);
	break;
      case DMSCROLLBAR:
	DefineScrollbar(rp);
	break;
      case DMPATBOX:
	DefinePat(rp);
	break;
      case DMTEXTEDIT:
	DefineTE(rp);
	break;
      case DMTEXT:
	DefineTextObj(rp);
	break;
      case DMBOX:
	DefineBoxObj(rp);
	break;
      case DMPICKLIST:
	DefinePicklist(rp);
	break;
    }
    DefPtr = 0;
}
/*eject*/
DefinePicklist(rp)
DedItem	*rp;
{
    DMDcb	*cb;
    DMDcb	*prevcb;
    int		group;
    int		tmp;
    int		when = 0;
    char	buf[20];
    
    cb = DMNew(Dpicklist,windowid,0);
    incollect = 1;
    prevcb = RfshDlg;
    RfshDlg = cb;
    group = DMCollect(cb);
    if(group == DMok) {
	dirty = 1;
	DMGet(cb,DPICKLIST_name,rp->name);
	
	DMGet(cb,DPICKLIST_validate,&rp->validate);
	
	DMGet(cb,DPICKLIST_type,buf);
	sscanf(buf,"%x",&tmp);
	rp->type = (byte)tmp;
	
	DMGet(cb,DPICKLIST_group,buf);
	sscanf(buf,"%x",&tmp);
	rp->group = (byte)tmp;
	
	DMGet(cb,DPICKLIST_key,buf);
	sscanf(buf,"%x",&rp->keycode);
	
	DMGet(cb,DPICKLIST_prefill,&rp->prefill);
	
	DMGet(cb,DPICKLIST_usercode,buf);
	sscanf(buf,"%x",&rp->usercode);
	
	DMGet(cb,DPICKLIST_valrexit,&tmp);
	if(tmp)
	    when |= DMrexit;
	DMGet(cb,DPICKLIST_valduring,&tmp);
	if(tmp)
	    when |= DMduring;
	rp->when = (byte)when;
    }
    DMDispose(cb);
    incollect = 0;
    RfshDlg = prevcb;
}
/*eject*/
DefineTextObj(rp)
DedItem	*rp;
{
    DMDcb	*cb;
    DMDcb	*prevcb;
    int		group;
    int		value = 0;
    int		tmp;
    char	buf[20];
    
    cb = DMNew(Dtext,windowid,0);
    incollect = 1;
    prevcb = RfshDlg;
    RfshDlg = cb;
    group = DMCollect(cb);
    if(group == DMok) {
	dirty = 1;
	DMGet(cb,DTEXT_name,rp->name);
	DMGet(cb,DTEXT_prefill,rp->prefill);
	DMGet(cb,DTEXT_text,rp->text);
	rp->TXTflags &= ~Jmask;
	DMGet(cb,DTEXT_left,&value);
	if(value) rp->TXTflags |= leftJust;
	DMGet(cb,DTEXT_right,&value);
	if(value) rp->TXTflags |= rightJust;
	DMGet(cb,DTEXT_center,&value);
	if(value) rp->TXTflags |= centerJust;
	DMGet(cb,DTEXT_top,&value);
	if(value) rp->TXTflags |= topJust;
	DMGet(cb,DTEXT_vcenter,&value);
	if(value) rp->TXTflags |= vcenterJust;
	DMGet(cb,DTEXT_bottom,&value);
	if(value) rp->TXTflags |= bottomJust;
	erase(rp);
	
	DMGet(cb,DTEXT_type,buf);
	sscanf(buf,"%x",&tmp);
	rp->type = (byte)tmp;
	
	DMGet(cb,DTEXT_group,buf);
	sscanf(buf,"%x",&tmp);
	rp->group = (byte)tmp;
	
	DMGet(cb,DTEXT_usercode,buf);
	sscanf(buf,"%x",&rp->usercode);

	DMGet(cb,DTEXT_fgcolor,buf);
	sscanf(buf,"%x",&tmp);
	rp->fgColor = (byte)tmp;

	DMGet(cb,DTEXT_bkcolor,buf);
	sscanf(buf,"%x",&tmp);
	rp->bkColor = (byte)tmp;

	display(rp);
    }
    DMDispose(cb);
    incollect = 0;
    RfshDlg = prevcb;
}

PFtxtleft(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    strcpy(cp,"It Works!");
}

PFtleft(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int	*ip;
{
    short tmp = 1;
    
    if(DefPtr->TXTflags & (centerJust | rightJust)) {
	tmp = 0;
    }
    *ip = (int)tmp;
}

PFtright(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int		*ip;
{
    short	tmp = 0;
    
    tmp = DefPtr->TXTflags & rightJust;
    if(tmp) tmp = 1;
    *ip = (int)tmp;
}

PFtcenter(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int		*ip;
{
    short	tmp = 0;
    
    tmp = DefPtr->TXTflags & centerJust;
    if(tmp) tmp = 1;
    *ip = (int)tmp;
}

PFttop(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int		*ip;
{
    short	tmp = 0;
    
    tmp = DefPtr->TXTflags & topJust;
    if(tmp) tmp = 1;
    *ip = (int)tmp;
}

PFtvcenter(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int		*ip;
{
    short	tmp = 1;
    
    if(DefPtr->TXTflags & (topJust | bottomJust)) {
	tmp = 0;
    }
    *ip = (int)tmp;
}

PFtbottom(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int		*ip;
{
    short	tmp = 0;
    
    tmp = DefPtr->TXTflags & bottomJust;
    if(tmp) tmp = 1;
    *ip = (int)tmp;
}
/*eject*/
DefineBoxObj(rp)
DedItem	*rp;
{
    DMDcb	*cb;
    DMDcb	*prevcb;
    int		group;
    int		when = 0;
    int		tmp;
    char	buf[20];
    
    cb = DMNew(Dbox,windowid,0);
    incollect = 1;
    prevcb = RfshDlg;
    RfshDlg = cb;
    group = DMCollect(cb);
    if(group == DMok) {
	dirty = 1;
	DMGet(cb,DBOX_name,rp->name);

	DMGet(cb,DBOX_fgcolor,buf);
	sscanf(buf,"%x",&tmp);
	rp->fgColor = (byte)tmp;

	DMGet(cb,DBOX_bkcolor,buf);
	sscanf(buf,"%x",&tmp);
	rp->bkColor = (byte)tmp;
    }
    DMDispose(cb);
    incollect = 0;
    RfshDlg = prevcb;
}
/*eject*/
DefineControl(rp)
DedItem	*rp;
{
    DMDcb	*cb;
    DMDcb	*prevcb;
    int		group;
    int		tmp;
    int		when = 0;
    char	buf[20];
    
    cb = DMNew(Dcontrol,windowid,0);
    incollect = 1;
    prevcb = RfshDlg;
    RfshDlg = cb;
    group = DMCollect(cb);
    if(group == DMok) {
	dirty = 1;
	DMGet(cb,DCONTROL_text,rp->text);
	
	DMGet(cb,DCONTROL_name,rp->name);
	
	DMGet(cb,DCONTROL_fgcolor,buf);
	sscanf(buf,"%x",&tmp);
	rp->fgColor = (byte)tmp;

	DMGet(cb,DCONTROL_bkcolor,buf);
	sscanf(buf,"%x",&tmp);
	rp->bkColor = (byte)tmp;

	DMGet(cb,DCONTROL_validate,&rp->validate);
	
	DMGet(cb,DCONTROL_type,buf);
	sscanf(buf,"%x",&tmp);
	rp->type = (byte)tmp;
	
	DMGet(cb,DCONTROL_group,buf);
	sscanf(buf,"%x",&tmp);
	rp->group = (byte)tmp;
	
	DMGet(cb,DCONTROL_key,buf);
	sscanf(buf,"%x",&rp->keycode);
	
	DMGet(cb,DCONTROL_value,buf);
	sscanf(buf,"%x",&tmp);
	rp->value = (short)tmp;
	
	DMGet(cb,DCONTROL_minvalue,buf);
	sscanf(buf,"%x",&tmp);
	rp->min = (short)tmp;
	
	DMGet(cb,DCONTROL_maxvalue,buf);
	sscanf(buf,"%x",&tmp);
	rp->max = (short)tmp;
	
	DMGet(cb,DCONTROL_invisible,&tmp);
	if(tmp) rp->attr |= DISinvisible;
	else rp->attr &= ~DISinvisible;
	
	DMGet(cb,DCONTROL_prefill,&rp->prefill);
	
	DMGet(cb,DCONTROL_usercode,buf);
	sscanf(buf,"%x",&rp->usercode);
	
	DMGet(cb,DCONTROL_valrexit,&tmp);
	if(tmp) when |= DMrexit;
	
	DMGet(cb,DCONTROL_valduring,&tmp);
	if(tmp) when |= DMduring;
	
	rp->when = (byte)when;
    }
    DMDispose(cb);
    incollect = 0;
    RfshDlg = prevcb;

    DisposeControl(rp->id);
    newitem(rp);
}
/*eject*/
DefineScrollbar(rp)
DedItem	*rp;
{
    DMDcb	*cb;
    DMDcb	*prevcb;
    int		group;
    int		tmp;
    int		when = 0;
    char	buf[20];
    
    cb = DMNew(Dsbar,windowid,0);
    incollect = 1;
    prevcb = RfshDlg;
    RfshDlg = cb;
    group = DMCollect(cb);
    if(group == DMok) {
	dirty = 1;
	DMGet(cb,DSBAR_name,rp->name);
	
	DMGet(cb,DSBAR_validate,&rp->validate);
	
	DMGet(cb,DSBAR_type,buf);
	sscanf(buf,"%x",&tmp);
	rp->type = (byte)tmp;
	
	DMGet(cb,DSBAR_group,buf);
	sscanf(buf,"%x",&tmp);
	rp->group = (byte)tmp;
	
	DMGet(cb,DSBAR_key,buf);
	sscanf(buf,"%x",&rp->keycode);
	
	DMGet(cb,DSBAR_value,buf);
	sscanf(buf,"%x",&tmp);
	rp->value = (short)tmp;
	
	DMGet(cb,DSBAR_minvalue,buf);
	sscanf(buf,"%x",&tmp);
	rp->min = (short)tmp;
	
	DMGet(cb,DSBAR_maxvalue,buf);
	sscanf(buf,"%x",&tmp);
	rp->max = (short)tmp;
	
	DMGet(cb,DSBAR_butinc,buf);
	sscanf(buf,"%x",&tmp);
	rp->font = (short)tmp;
	
	DMGet(cb,DSBAR_pageinc,buf);
	sscanf(buf,"%x",&tmp);
	rp->fontsize = (short)tmp;
	
	DMGet(cb,DSBAR_invisible,&tmp);
	if(tmp) rp->attr |= DISinvisible;
	else rp->attr &= ~DISinvisible;
	
	DMGet(cb,DSBAR_prefill,&rp->prefill);
	
	DMGet(cb,DSBAR_usercode,buf);
	sscanf(buf,"%x",&rp->usercode);
	
	DMGet(cb,DSBAR_valrexit,&tmp);
	if(tmp) when |= DMrexit;
	
	DMGet(cb,DSBAR_valduring,&tmp);
	if(tmp) when |= DMduring;
	
	rp->when = (byte)when;
    }
    DMDispose(cb);
    incollect = 0;
    RfshDlg = prevcb;
}
/*eject*/
DefineTE(rp)
DedItem	*rp;
{
    DMDcb	*cb;
    DMDcb	*prevcb;
    int		group;
    int		tmp;
    int		when = 0;
    char	buf[20];
    
    cb = DMNew(Dtextedit,windowid,0);
    incollect = 1;
    prevcb = RfshDlg;
    RfshDlg = cb;
    group = DMCollect(cb);
    if(group == DMok) {
	dirty = 1;
	DMGet(cb,DTEXTEDIT_text,rp->text);
	
	DMGet(cb,DTEXTEDIT_name,rp->name);
	
	DMGet(cb,DTEXTEDIT_validate,&rp->validate);
	
	DMGet(cb,DTEXTEDIT_type,buf);
	sscanf(buf,"%x",&tmp);
	rp->type = (byte)tmp;
	
	DMGet(cb,DTEXTEDIT_group,buf);
	sscanf(buf,"%x",&tmp);
	rp->group = (byte)tmp;
	
	DMGet(cb,DTEXTEDIT_key,buf);
	sscanf(buf,"%x",&rp->keycode);
	
	DMGet(cb,DTEXTEDIT_prefill,&rp->prefill);
	
	DMGet(cb,DTEXTEDIT_usercode,buf);
	sscanf(buf,"%x",&rp->usercode);
	
	DMGet(cb,DTEXTEDIT_maxdigits,buf);
	sscanf(buf,"%x",&tmp);
	rp->max = (short)tmp;
	
	DMGet(cb,DTEXTEDIT_valrexit,&tmp);
	if(tmp)
	    when |= DMdlgexit;
	DMGet(cb,DTEXTEDIT_valduring,&tmp);
	if(tmp)
	    when |= DMduring;
	DMGet(cb,DTEXTEDIT_valexit,&tmp);
	if(tmp)
	    when |= DMteexit;
	DMGet(cb,DTEXTEDIT_valenter,&tmp);
	if(tmp)
	    when |= DMteenter;
	rp->when = (byte)when;
	
	rp->value = 0;
	DMGet(cb,DTEXTEDIT_tebox,&tmp);
	if(tmp) rp->value |= DMtebox;
	
	DMGet(cb,DTEXTEDIT_temultiline,&tmp);
	if(tmp) rp->value |= DMtemultiline;
	
	DMGet(cb,DTEXTEDIT_tewordwrap,&tmp);
	if(tmp) rp->value |= DMtewordwrap;
	
	DMGet(cb,DTEXTEDIT_tescroll,&tmp);
	if(tmp) rp->value |= DMtescroll;
	
	rp->value &= ~(DMtecenterJust|DMterightJust);
	TESetJust(teJustLeft,rp->id);
	DMGet(cb,DTEXTEDIT_justcenter,&tmp);
	if(tmp) {
	    rp->value |= DMtecenterJust;
	    TESetJust(teJustCenter,rp->id);
	}
	DMGet(cb,DTEXTEDIT_justright,&tmp);
	if(tmp) {
	    rp->value |= DMterightJust;
	    TESetJust(teJustRight,rp->id);
	}
	drawte(rp);
	
	DMGet(cb,DTEXTEDIT_invisible,&tmp);
	if(tmp) rp->attr |= DISinvisible;
	else rp->attr &= ~DISinvisible;
	
	DMGet(cb,DTEXTEDIT_ghosttext,&tmp);
	if(tmp) rp->attr |= DISghostText;
	else rp->attr &= ~DISghostText;
	
	DMGet(cb,DTEXTEDIT_ghostframe,&tmp);
	if(tmp) rp->attr |= DISghostFrame;
	else  rp->attr &= ~DISghostFrame;
    }
    DMDispose(cb);
    incollect = 0;
    RfshDlg = prevcb;
}
/*eject*/
DefinePat(rp)
DedItem	*rp;
{
    DMDcb	*cb;
    DMDcb	*prevcb;
    int		group;
    int		tmp;
    int		when = 0;
    char	buf[20];
    
    cb = DMNew(Dpat,windowid,0);
    incollect = 1;
    prevcb = RfshDlg;
    RfshDlg = cb;
    group = DMCollect(cb);
    if(group == DMok) {
	dirty = 1;
	DMGet(cb,DPAT_name,rp->name);
	
	DMGet(cb,DPAT_validate,&rp->validate);
	
	DMGet(cb,DPAT_type,buf);
	sscanf(buf,"%x",&tmp);
	rp->type = (byte)tmp;
	
	DMGet(cb,DPAT_group,buf);
	sscanf(buf,"%x",&tmp);
	rp->group = (byte)tmp;
	
	DMGet(cb,DPAT_value,buf);
	sscanf(buf,"%x",&tmp);
	rp->value = (short)tmp;
	
	DMGet(cb,DPAT_usercode,buf);
	sscanf(buf,"%x",&rp->usercode);
	
	DMGet(cb,DPAT_valrexit,&tmp);
	if(tmp)
	    when |= DMrexit;
	DMGet(cb,DPAT_valduring,&tmp);
	if(tmp)
	    when |= DMduring;
	rp->when = (byte)when;
	
	rp->pattern = (short)valpat;
	SetCtlValues(rp->id,rp->selected,rp->pattern);
	drawcontrol(rp);
    }
    DMDispose(cb);
    incollect = 0;
    RfshDlg = prevcb;
}
/*eject*/
/*
 **	O N   S C R E E N   E D I T   D R I V E R
 */
DefineText(rp)
DedItem	*rp;
{
    mode = MODETEXT;
    SetCursor(&text);
    modetextfunc(0,rp);
    InitCursor();
    mode = MODEPOINT;
}
void modetext(ep)
EventRecord *ep;
{
    modetextfunc(ep,0);
}
modetextfunc(ep,rp)
EventRecord *ep;
DedItem	*rp;
{
    Rect	tr;
    byte	type;
    
    if(ep && ep->message & F_KEYDOWN) {
	rp = onobject(&ep->where.corner.topLeft);
    }
    if(rp) {
	switch(rp->type) {
	  case DMCHECKBOX:
	  case DMPUSHBUT:
	  case DMDPUSHBUT:
	  case DMSCROLLBAR:
	  case DMRADIOBUT:
	  case DMTEXT:
	  case DMTEXTEDIT:
	    /*
	     **	Mouse Clicked on a dialog item
	     **	so hide the item & put up a text
	     **	edit box
	     */
	    type = rp->type;
	    rp->type = 0;
	    if(type == DMTEXT)
		erase(rp);
	    else if(type != DMTEXTEDIT)
		DisposeControl(rp->id);
	    drivete(rp);
	    rp->type = type;
	    tr = rp->rect;
	    doFontFaceSize(rp);
	    switch(rp->type) {
	      case DMCHECKBOX:
		rp->id = dlgNewControl(windowid,&tr,rp->text,1,1,0,1,checkBoxProc|useWFont,0,rp->fgColor,rp->bkColor);
		break;
	      case DMRADIOBUT:
		rp->id = dlgNewControl(windowid,&tr,rp->text,1,1,0,1,radioButProc|useWFont,0,rp->fgColor,rp->bkColor);
		break;
	      case DMPUSHBUT:
		rp->id = dlgNewControl(windowid,&tr,rp->text,1,1,0,1,pushButProc|useWFont,0,rp->fgColor,rp->bkColor);
		break;
	      case DMDPUSHBUT:
		rp->id = dlgNewControl(windowid,&tr,rp->text,1,1,0,1,defButProc|useWFont,0,rp->fgColor,rp->bkColor);
		break;
	      case DMSCROLLBAR:
		rp->id = dlgNewControl(windowid,&tr,rp->text,1,1,0,1,scrollBarProc,0,rp->fgColor,rp->bkColor);
		break;
	      case DMTEXT:
		display(rp);
		break;
	      case DMTEXTEDIT:
		rp->id = dlgTENew(rp);
		break;
	    }
	}
    }
}

/*eject*/
/*
 **	Handle single edit window
 */
drivete(rp)
DedItem		*rp;
{
    DedItem		*lrp;
    Rect		tr;
    EventRecord *ep;
    void		*id;
    void		*previd = 0;
    int			sw;
    short		extend;
    
    /*
     **	Create a Text Edit Window
     */
    if(debug) printf("TE ENTER\n");
    if(rp->type != TEXTEDIT) {
	tr = rp->rect;
	if(rectheight(&rp->rect) < 20) {
	    tr.edge.bottom = tr.edge.top + 20;
	}
	EraseRect(&tr);
	InsetRect(&tr,3,3);
	doFontFaceSize(rp);
	rp->id = TENew(&tr, &tr);
    }
    TECROnly(1,rp->id);
    TEAutoView(1,rp->id);
    InsetRect(&tr,-3,-3);
    TESetText(rp->text,rp->max ? rp->max:100,rp->id);
    TESetSelect(0,strlen(rp->text),rp->id);
    TEActivate(rp->id);
    TEUpdate(&tr,rp->id);
    FrameRect(&tr);
    while(mode == MODETEXT) {
	ep = GetEvent(1 << windowid, 1 << mouseEvt | 1 << keyEvt);
	if(debug) printf(" TE Keydown 0x%x\n");
	if(ep->what & keyEvt) {
	    /*
	     **	Key Event
	     */
	    dirty = 1;
	    if(debug) printf(" TEKey 0x%x\n",ep->message);
	    ObscureCursor();
	    TEKey(ep->message,rp->id);
	}
	else if(ep->what & mouseEvt && ep->message & (F_KEYDOWN | F_MOUSE1)) {
	    /*
	     **	Mouse Event
	     */
	    if(PtInRect(&ep->where.corner.topLeft,&rp->rect)) {
		/*
		 **	Still on same control
		 */
		if(debug) printf(" TEClick\n");
		extend = ep->message & F_SHIFT ? 1:0;
		TEClick(&ep->where.corner.topLeft,extend,rp->id);
	    }
	    else {
		/*
		 **	Mouse Clicked on NO dialog item or
		 **	on a different dialog item
		 */
		break;
	    }
	}
    }
    if(debug) {
	printf("TE BUG OUT\n");
    }
    gettext(rp->text,rp->id);
    TEDispose(rp->id);
    EraseRect(&tr);
    InvalRect(&tr);
}
/*eject*/
/*
 **	V A L I D A T E   R O U T I N E S
 */
VALboxpat(cbp,dip,when,value,partcode)
DMDcb	*cbp;
DMItem	*dip;
unsigned char	when;
short	value;
short	partcode;
{
    valpat = value;
    return(1);
}

VALhgrid(cbp,dip,when,value,partcode)
DMDcb	*cbp;
DMItem	*dip;
unsigned char	when;
short	value;
short	partcode;
{
    char		buf[10];
    ControlID	id;
    
    id = cbp->curIid;
    sprintf(buf,"%d",value);
    DMSetText(cbp,DGRID_hgrid,buf);
    return(1);
}

VALvgrid(cbp,dip,when,value,partcode)
DMDcb	*cbp;
DMItem	*dip;
unsigned char	when;
short	value;
short	partcode;
{
    char		buf[10];
    ControlID	id;
    
    id = cbp->curIid;
    sprintf(buf,"%d",value);
    DMSetText(cbp,DGRID_vgrid,buf);
    return(1);
}

VALgroup(cbp,dip,when,cp)
DMDcb	*cbp;
DMItem	*dip;
unsigned char	when;
DMTEVal	*cp;
{
    return(DMValNumeric(cbp,dip,when,cp->text,3,0,255));
}
/*eject*/
/*
 **	P R E F I L L   R O U T I N E S
 */
PFbutinc(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[10];
    
    sprintf(buf,"%d",DefPtr->font ? DefPtr->font:1);
    strcpy(cp,buf);
}

PFpageinc(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[10];
    
    sprintf(buf,"%d",DefPtr->fontsize ? DefPtr->fontsize:5);
    strcpy(cp,buf);
}

PFtejustleft(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int		*ip;
{
    int		tmp;
    
    tmp = (DefPtr->value & (DMtecenterJust|DMterightJust)) ? 0:1;
    *ip = tmp;
}
PFtejustcenter(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int		*ip;
{
    int		tmp;
    
    tmp = (DefPtr->value & DMtecenterJust) ? 1:0;
    *ip = tmp;
}
PFtejustright(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int		*ip;
{
    int		tmp;
    
    tmp = (DefPtr->value & DMterightJust) ? 1:0;
    *ip = tmp;
}
PFhgridSB(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int	*ip;
{
    *ip = hgrid;
}

PFvgridSB(cbp,dip,ip)
DMDcb	*cbp;
DMItem	*dip;
int	*ip;
{
    *ip = vgrid;
}

PFhgrid(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[10];
    
    sprintf(buf,"%d",hgrid);
    strcpy(cp,buf);
}

PFvgrid(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[10];
    
    sprintf(buf,"%d",vgrid);
    strcpy(cp,buf);
}

PFtebox(cbp,dip,i)
DMDcb	*cbp;
DMItem	*dip;
int		*i;
{
    *i = DefPtr->value & DMtebox ? 1:0;
}

PFtemultiline(cbp,dip,i)
DMDcb	*cbp;
DMItem	*dip;
int		*i;
{
    *i = DefPtr->value & DMtemultiline ? 1:0;
}

PFtewordwrap(cbp,dip,i)
DMDcb	*cbp;
DMItem	*dip;
int		*i;
{
    *i = DefPtr->value & DMtewordwrap ? 1:0;
}

PFtescroll(cbp,dip,i)
DMDcb	*cbp;
DMItem	*dip;
int		*i;
{
    *i = DefPtr->value & DMtescroll ? 1:0;
}

PFinvisible(cbp,dip,i)
DMDcb	*cbp;
DMItem	*dip;
int		*i;
{
    *i = DefPtr->attr & DISinvisible ? 1:0;
}

PFghosttext(cbp,dip,i)
DMDcb	*cbp;
DMItem	*dip;
int		*i;
{
    *i = DefPtr->attr & DISghostText ? 1:0;
}

PFghostframe(cbp,dip,i)
DMDcb	*cbp;
DMItem	*dip;
int		*i;
{
    *i = DefPtr->attr & DISghostFrame ? 1:0;
}

PFdefpitch(cbp,dip,i)
DMDcb	*cbp;
DMItem	*dip;
int		*i;
{
    *i = 1;
}

saveasPF(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    strcpy(cp,filename);
}

PFtext(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    if(DefPtr->text && DefPtr->text[0]) {
	strcpy(cp,DefPtr->text);
    }
}

PFname(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    if(DefPtr->name) {
	strcpy(cp,DefPtr->name);
    }
}

PFfgcolor(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[20];
    
    sprintf(buf,"%x",DefPtr->fgColor);
    strcpy(cp,buf);
}

PFbkcolor(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[20];
    
    sprintf(buf,"%x",DefPtr->bkColor);
    strcpy(cp,buf);
}

PFtype(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[20];
    
    sprintf(buf,"%x",DefPtr->type);
    strcpy(cp,buf);
}

PFgroup(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[20];
    
    sprintf(buf,"%x",DefPtr->group);
    strcpy(cp,buf);
}

PFkey(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[20];
    
    sprintf(buf,"%x",DefPtr->keycode);
    strcpy(cp,buf);
}

PFvalue(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[20];
    
    sprintf(buf,"%x",DefPtr->value);
    strcpy(cp,buf);
}

PFminvalue(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[20];
    
    sprintf(buf,"%x",DefPtr->min);
    strcpy(cp,buf);
}

PFmaxvalue(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[20];
    
    sprintf(buf,"%x",DefPtr->max);
    strcpy(cp,buf);
}

PFvalidate(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    if(DefPtr->validate[0]) {
	strcpy(cp,DefPtr->validate);
    }
}

PFprefill(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    if(DefPtr->prefill[0]) {
	strcpy(cp,DefPtr->prefill);
    }
}

PFusercode(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[20];
    
    sprintf(buf,"%x",DefPtr->usercode);
    strcpy(cp,buf);
}

PFmaxdigits(cbp,dip,cp)
DMDcb	*cbp;
DMItem	*dip;
char	*cp;
{
    char	buf[20];
    
    sprintf(buf,"%x",DefPtr->max);
    strcpy(cp,buf);
}

PFrexit(cbp,dip,when)
DMDcb	*cbp;
DMItem	*dip;
int		*when;
{
    if(DefPtr->when & DMdlgexit) {
	*when = 1;
    }
}

PFduring(cbp,dip,when)
DMDcb	*cbp;
DMItem	*dip;
int		*when;
{
    if(DefPtr->when & DMduring) {
	*when = 1;
    }
}

PFexit(cbp,dip,when)
DMDcb	*cbp;
DMItem	*dip;
int		*when;
{
    if(DefPtr->when & DMteexit) {
	*when = 1;
    }
}

PFenter(cbp,dip,when)
DMDcb	*cbp;
DMItem	*dip;
int		*when;
{
    if(DefPtr->when & DMteenter) {
	*when = 1;
    }
}

/*eject*/
/*
 **	C L O S E   R O U T I N E S
 */
DedQuit()
{
    int		answer;
    
    answer = ask2save();
    if(answer == DMok) {
	save();
    }
    if(answer == DMok || answer == DMno) {
	exit(1);
    }
}

DedClose()
{
    int		answer;
    
    answer = ask2save();
    if(answer == DMok) {
	save();
    }
    if(answer == DMok || answer == DMno) {
	set_names("Untitled");
	DedSetTitle();
	DedInit1();
	DedInit2();
    }
}
/*eject*/
saveas()
{
    char	*cp;
    DMDcb	*rrp;
    DMDcb	*prevcb;
    int		group;
    
    rrp = DMNew(Dsaveas,windowid,0);
    incollect = 1;
    prevcb = RfshDlg;
    RfshDlg = rrp;
    group = DMCollect(rrp);
    if(group == DMok) {
	DMGet(rrp,DSAVEAS_filename,filename);
	DMDispose(rrp);
	set_names(filename);
	DedSetTitle();
	save();
    }
    else {
	DMDispose(rrp);
    }
    incollect = 0;
    RfshDlg = prevcb;
}

save()
{
    DMDcb	*cbp;
    DMDcb	*prevcb;
    char	buf[200];
    char	*cp;
    
    if(fp == 0) {
	fp = fopen(filename,"w");
    }
    if(fp == 0) {
	cbp = DMNew(Derror,windowid,0);
	incollect = 1;
	prevcb = RfshDlg;
	RfshDlg = cbp;
	sprintf(buf,"ERROR, Couldn't open '%s' for writing",filename);
	DMSetText(cbp,DERROR_errortext,buf);
	Bell();
	DMCollect(cbp);
	DMDispose(cbp);
	incollect = 0;
	RfshDlg = prevcb;
	return;
    }
    
    hfp = fopen(hfilename,"w");	/* Write .h file also. */
    if(hfp == 0) {
	cbp = DMNew(Derror,windowid,0);
	incollect = 1;
	prevcb = RfshDlg;
	RfshDlg = cbp;
	sprintf(buf,"ERROR, Couldn't open '%s' for writing",hfilename);
	DMSetText(cbp,DERROR_errortext,buf);
	Bell();
	DMCollect(cbp);
	DMDispose(cbp);
	incollect = 0;
	RfshDlg = prevcb;
	return;
    }
    
    DedExport();
    
    fclose(fp);
    fclose(hfp);
    fp = 0;
    hfp = 0;
}
/*eject*/
DedExport()
{
    char	buf[256];
    char	tmps[256];
    char	*cp;
    int		i;
    Rect	tr;
    Rect	sr;
    DedItem	*rp;
    
    /*
     **	For all the whiners in the world, here is a check to see
     **	if you ignorantly omitted the required bounding box, and
     **	if you forgot we calc and then insert one.
     */
    sort();
    SetRect(&tr,32000,32000,0,0);
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {
	if(rp->type) {
	    UnionRect(&tr,&rp->rect,&tr);
	}
    }
    SectRect(&tr,&dialog[0].rect,&sr);
    if(dialog[0].type != DMBOX || !EqualRect(&tr,&sr)) {
	rp = findslot();
	memset(rp,0,sizeof(DedItem));
	rp->type = DMBOX;
	rp->attr = BAUTO;
	rp->rect = tr;
	sort();
    }
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {
	if(i > 0 && rp->type == DMBOX && rp->attr == BAUTO) {
	    /* get rid of dlged automatic box */
	    rp->type = 0;
	    sort();
	}
    }
    dirty = 0;
    Routines[0] = 0;
    /*
     * WRITE THE DIALOG.H FILE 
     */
    sprintf(buf,"/*\n**  WARNING - DO NOT MODIFY THIS FILE!\n");
    fputs(buf,hfp);
    sprintf(buf,"**  CREATED AUTOMATICALLY BY THE DIALOG EDITOR!\n*/\n");
    fputs(buf,hfp);
    
    /*
     **	Conditional for International (Chinese & Taiwan) font and size.
     */
    sprintf(buf,"\n#ifdef SIXTEENBITCHARS\n");
    fputs(buf,hfp);
    sprintf(buf,"#define INTL_FONT(font,size) font,size\n");
    fputs(buf,hfp);
    sprintf(buf,"#else\n");
    fputs(buf,hfp);
    sprintf(buf,"#define INTL_FONT(font,size)\n");
    fputs(buf,hfp);
    sprintf(buf,"#endif SIXTEENBITCHARS\n");
    fputs(buf,hfp);
    
    /* 
     * WRITE THE DIALOG.C FILE
     */
    sprintf(buf,"#include <isc/window.h>\n");
    fputs(buf,fp);
    sprintf(buf,"#include <isc/dlgman.h>\n");
    fputs(buf,fp);
    sprintf(buf,"#include \"%s.h\"\n",dlgname);
    fputs(buf,fp);
    sprintf(buf,"\n/*\n**  D I A L O G  '%s'\n",dlgname);
    fputs(buf,fp);
    sprintf(buf,"**\n**  WARNING - DO NOT MODIFY THIS FILE!\n");
    fputs(buf,fp);
    sprintf(buf,"**  CHANGES SHOULD ONLY BE MADE USING THE DIALOG EDITOR!\n");
    fputs(buf,fp);
    sprintf(buf,"**  TO RENAME A FILE, USE THE DIALOG EDITOR AND 'SAVEAS'!\n*/\n");
    fputs(buf,fp);
    
    /*
     * Dialog Saved parameters
     */
    sprintf(buf,"\n/* Dialog Parameters %s %d %d %d */\n",version,gridon,hgrid,vgrid);
    fputs(buf,fp);
    
    /*
     * Dialog Item Text
     */
    sprintf(buf,"\n/* Dialog Item Text */\n");
    fputs(buf,fp);
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {
	if(rp->type && rp->text && rp->text[0]) {
	    sprintf(buf,"char %sT%d[] = \"%s\";\n",dlgname,i,rp->text);
	    fputs(buf,fp);
	}
    }
    
    /*
     * Dialog Item Identifiers -> DIALOG.C and DIALOG.H
     */
    sprintf(buf,"\n/* Dialog Item Identifiers for %s.c */\n", dlgname);
    fputs(buf,hfp);
    sprintf(buf,"\n/* Dialog Item Identifiers */\n");
    fputs(buf,fp);
    sprintf(buf,"/*  WARNING- THESE COMMENTS ARE USED BY THE DIALOG EDITOR! */\n");
    fputs(buf,fp);
    sprintf(buf,"/*  Runtime definitions are in the file %s.h */\n", dlgname);
    fputs(buf,fp);
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {
	if(rp->type && rp->name && rp->name[0]) {
	    sprintf(buf,"#define %s_%s\t%d\n", dlgnameCaps, rp->name, i);
	    fputs(buf,hfp);
	    
	    sprintf(buf,"/* %s_%s = %d */\n", dlgnameCaps, rp->name, i);
	    fputs(buf,fp);
	}
    }
    
    /*
     **	Dialog Items
     */
    sprintf(buf,"\n/* Dialog Definition */\n");
    fputs(buf,fp);
    sprintf(buf,"DMItem %s[] = {\n",dlgname);
    fputs(buf,fp);
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {
	if(rp->type) {
	    cp = buf;
	    cp += sprintf(cp,"  {");
	    cp += sprintf(cp,"%d,%d,%d,",rp->type,rp->group,rp->keycode);
	    if(rp->type == DMBOX && i == 0) {
		/* first item is always box with value used as numele */
		cp += sprintf(cp,"%d,%d,%d,",countitems(),rp->min,rp->max);
	    }
	    else {
		cp += sprintf(cp,"%d,%d,%d,",rp->value,rp->min,rp->max);
	    }
	    cp += sprintf(cp,"%d,%d,%d,",rp->font,rp->fontsize,rp->attr);
	    cp += sprintf(cp,"%d,",rp->when);
	    cp += sprintf(cp,"%d,",rp->xfermode);
	    cp += sprintf(cp,"%d,",rp->fgColor);
	    cp += sprintf(cp,"%d,",rp->bkColor);
	    tr = rp->rect;
	    cp += sprintf(cp,"{%d,%d,%d,%d},",tr.edge.top,tr.edge.left,tr.edge.bottom,tr.edge.right);
	    /* PREFILL */
	    if(rp->prefill[0]) {
		cp += sprintf(cp,"%s,",rp->prefill);
	    }
	    else {
		cp += sprintf(cp,"0,");
	    }
	    /* VALIDATE */
	    if(rp->validate[0]) {
		cp += sprintf(cp,"%s,",rp->validate);
	    }
	    else {
		cp += sprintf(cp,"0,");
	    }
	    cp += sprintf(cp,"%d,",rp->usercode);
	    
#ifdef 0
	    /* Not used for version 4.0 or greater. */
	    /* DIALOG ITEM NAME */
	    if(rp->name && rp->name[0]) {
		cp += sprintf(cp,"%sN%d,",dlgname,i);
	    }
	    else {
		cp += sprintf(cp,"0,");
	    }
#endif
	    /* DIALOG ITEM TEXT */
	    if(rp->text && rp->text[0]) {
		cp += sprintf(cp,"%sT%d",dlgname,i);
	    }
	    else {
		cp += sprintf(cp,"0");
	    }
	    cp += sprintf(cp,",0,"); /* control id */
	    
#ifdef SIXTEENBITCHARS
	    cp += sprintf(cp,"INTL_FONT(%d,%d)",rp->otherfont,rp->othersize);
#endif /* SIXTEENBITCHARS */
	    
	    cp += sprintf(cp,"},\n");
	    fputs(buf,fp);
	}
    }
    sprintf(buf,"};\n\n");
    fputs(buf,fp);

    /*
     * EXTERNAL FUNCTION PROTOTYPES -> DIALOG.H
     */
    sprintf(buf,"\n/* External Function Prototypes */\n");
    fputs(buf,hfp);

    sprintf(buf,"extern DMItem\t%s[%d];\n", dlgname, countitems());
    fputs(buf,hfp);
    
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {

	if(rp->prefill[0]) {
	    if(update_proto_list(rp->prefill) == 0) {
		continue;
	    }
	    switch (rp->type) {
	      case DMTEXT:
	      case DMTEXTEDIT:
		/*Text Edit / Literal Text Prefill */
		strcpy(tmps,"char *cp");
		break;
	      case DMPICKLIST:
		/* Pick List Prefill */
		strcpy(tmps,"DMPick *psp");
		break;
	      case DMCHECKBOX:
	      case DMRADIOBUT:
	      case DMPUSHBUT:
	      case DMDPUSHBUT:
	      case DMBOX:
	      case DMSCROLLBAR:
	      case DMPATBOX:
	      case DMICON:
	      case DMBITMAP:
		/* Control Prefill */
		strcpy(tmps,"int *value");
		break;
	      default:
		strcpy(tmps,"...");
		break;
	    }
	    sprintf(buf,"extern int	%s(DMDcb *cbp, DMItem *dip, %s);\n",
		    rp->prefill, tmps);
	    fputs(buf,hfp);
	}
	
	if(rp->type && rp->validate[0]) {
	    if(update_proto_list(rp->validate) == 0) {
		continue;
	    }
	    switch (rp->type) {
	      case DMTEXT:
	      case DMTEXTEDIT:
		/*Text Edit / Literal Text Validations */
		strcpy(tmps,"DMTEVal *arg");
		break;
	      case DMPICKLIST:
		/* Pick List Validation */
		strcpy(tmps,"unsigned char when, short index, short partcode");
		break;
	      case DMCHECKBOX:
	      case DMRADIOBUT:
	      case DMPUSHBUT:
	      case DMDPUSHBUT:
	      case DMBOX:
	      case DMSCROLLBAR:
	      case DMPATBOX:
	      case DMICON:
	      case DMBITMAP:
		/* Control Validation */
		strcpy(tmps,"unsigned char when, short value, short partcode");
		break;
	      default:
		strcpy(tmps,"...");
		break;
	    }
	    sprintf(buf,"extern int	%s(DMDcb *cbp, DMItem *dip, %s);\n",
		    rp->validate, tmps);
	    fputs(buf,hfp);
	}
    }	

    
}

ask2save()
{
    DMDcb	*cb;
    DMDcb	*prevcb;
    int		group = DMno;
    
    if(dirty) {
	cb = DMNew(Dsavechg,windowid,0);
	incollect = 1;
	prevcb = RfshDlg;
	RfshDlg = cb;
	group = DMCollect(cb);
	DMDispose(cb);
	incollect = 0;
	RfshDlg = prevcb;
    }
    return(group);
}

myopen()
{
    DMDcb	*cbp;
    DMDcb	*prevcb;
    char	buf[200];
    
    if(fp == 0) {
	fp = fopen(filename,"r");
    }
    if(fp == 0) {
	/* open failed */
	cbp = DMNew(Derror,windowid,0);
	incollect = 1;
	prevcb = RfshDlg;
	RfshDlg = cbp;
	sprintf(buf,"ERROR, Couldn't open '%s' for reading",filename);
	DMSetText(cbp,DERROR_errortext,buf);
	Bell();
	DMCollect(cbp);
	DMDispose(cbp);
	incollect = 0;
	RfshDlg = prevcb;
	ClipRect(&noclip);
	PenPat((Pattern*)0);
	return;
    }
    DedImport();
    fclose(fp);
    fp = 0;
}

DedImport()
{
    char	tagdlg[] 	= "**  D I A L O G";
    char	tagname[30]	= "xxxx";
    char	tagident[30]	= "xxxx";
    char	tagtext[30]	= "xxxx";
    char	tagitem[]	= "DMItem";
    char	tagparam[]	= "/* Dialog Parameters";
    
    char	buf[256];
    char	*cp,*cp2;
    int		index=0;
    int		first = 1;
    int		i;
    float	dlgversion;
    DedItem	*rp;
    
    dirty = 0;
    while(fgets(buf,255,fp)) {
	if((strncmp(buf,tagdlg,strlen(tagdlg))) == 0) {
	    /*
	     **	Get DIALOG name from comment
	     */
	    sscanf(buf,"**  D I A L O G  '%s'",dlgname);
	    dlgname[strlen(dlgname)-1] = 0;
	    set_names(dlgname);

	    sprintf(tagname,"char %sN",dlgname); /* version < 4.0 */
	    sprintf(tagident,"/* %s_",dlgnameCaps); /* version >= 4.0 */
	    sprintf(tagtext,"char %sT",dlgname);
	    if(debug == IMPORT) printf("->%s\n",dlgname);
	}
	else if((strncmp(buf,tagparam,strlen(tagdlg))) == 0) {
	    /*
	     **	Get DIALOG parameters
	     */
	    sscanf(buf,"/* Dialog Parameters %f %d %d %d",&dlgversion,&gridon,&hgrid,&vgrid);
	    if(debug == IMPORT) printf("gridon=%d, hgrid=%d, vgrid=%d\n",gridon,hgrid,vgrid);
	    CheckItem(OPTIONS, GRIDON, gridon);
	}
	else if((strncmp(buf,tagname,strlen(tagname))) == 0) {
	    /*
	     **	Get DLG ITEM name from char string
	     ** Item names are used in versions < 4.0
	     */
	    cp = buf + strlen(tagname);
	    index = atoi(cp);
	    if((cp = strpbrk(cp,"\""))) {
		cp2 = (char*)&dedname[index];
		cp++;
		while(*cp != '"') {
		    *cp2++ = *cp++;
		}
		*cp2 = 0;
	    }
	    if(debug == IMPORT) printf("item #%d name ->%s\n",index,&dedname[index]);
	}
	else if((strncmp(buf,tagident,strlen(tagident))) == 0) {
	    /*
	     **	Get DLG ITEM identifiers from char string
	     ** Item identifiers are used in versions >= 4.0
	     */
	    cp = buf + strlen(tagident);
	    cp2 = cp;
	    if((cp2 = strpbrk(cp,"="))) {
		cp2++;
		index = atoi(cp2);
		
		cp2 = (char*)&dedname[index];
		while(*cp != ' ') {
		    *cp2++ = *cp++;
		}
		*cp2 = 0;
	    }
	    if(debug == IMPORT) printf("item #%d identifier ->%s\n",index,&dedname[index]);
	}
	else if((strncmp(buf,tagtext,strlen(tagtext))) == 0) {
	    /*
	     **	Get DLG ITEM text from char string
	     */
	    cp = buf + strlen(tagtext);
	    index = atoi(cp);
	    if((cp = strpbrk(cp,"\""))) {
		cp2 = (char*)&dedtext[index];
		cp++;
		while(*cp != '"') {
		    *cp2++ = *cp++;
		}
		*cp2 = 0;
	    }
	    if(debug == IMPORT) printf("item #%d text ->%s\n",index,&dedtext[index]);
	}
	else if((strncmp(buf,tagitem,strlen(tagitem))) == 0) {
	    /*
	     **	Get DLG ITEM
	     */
	    rp = dialog;
	    while((fgets(buf,255,fp))) {
		if((cp = strpbrk(buf,"{"))) {
		    rp->type = (byte)atoi(++cp);
		    cp = strpbrk(cp,",");
		    rp->group = (byte)atoi(++cp);
		    cp = strpbrk(cp,",");
		    rp->keycode = atoi(++cp);
		    cp = strpbrk(cp,",");
		    if(first && rp->type == DMBOX) {
			atoi(++cp);
		    }
		    else {
			rp->value = (short)atoi(++cp);
		    }
		    cp = strpbrk(cp,",");
		    rp->min = (short)atoi(++cp);
		    cp = strpbrk(cp,",");
		    rp->max = (short)atoi(++cp);
		    cp = strpbrk(cp,",");
		    rp->font = (short)atoi(++cp);
		    cp = strpbrk(cp,",");
		    rp->fontsize = (short)atoi(++cp);
		    cp = strpbrk(cp,",");
		    rp->attr = (short)atoi(++cp);
		    cp = strpbrk(cp,",");
		    rp->when = (byte)atoi(++cp);

		    if(dlgversion >= 4.0) {
			cp = strpbrk(cp,",");
			rp->xfermode = (byte)atoi(++cp);
			cp = strpbrk(cp,",");
			rp->fgColor = (short)atoi(++cp);
			cp = strpbrk(cp,",");
			rp->bkColor = (short)atoi(++cp);
		    }

		    cp = strpbrk(cp,"{");
		    rp->rect.edge.top = (short)atoi(++cp);
		    cp = strpbrk(cp,",");
		    rp->rect.edge.left = (short)atoi(++cp);
		    cp = strpbrk(cp,",");
		    rp->rect.edge.bottom = (short)atoi(++cp);
		    cp = strpbrk(cp,",");
		    rp->rect.edge.right = (short)atoi(++cp);
		    cp = strpbrk(cp,",");
		    cp++;
		    cp = strtok(cp,",");
		    if(*cp != '0') {
			strcpy(rp->prefill,cp);
		    }
		    cp = strtok(NULL,",");
		    if(*cp != '0') {
			strcpy(rp->validate,cp);
		    }
		    cp = strtok(NULL,",");
		    rp->usercode = (UINT)atoi(cp);
#ifdef SIXTEENBITCHARS
		    rp->otherfont = 0;
		    cp += 2;
		    while (*cp++) {
			if (strncmp(cp, "INTL_FONT", 9) == 0) {
			    cp = strpbrk(cp,"(");
			    rp->otherfont = (short)atoi(++cp);
			    cp = strpbrk(cp,",");
			    rp->othersize = (short)atoi(++cp);
			    break;
			}
		    }
		    if (rp->otherfont == 0) {
			rp->otherfont = theOtherFont;
			rp->othersize = theOtherSize;
		    }
#endif /* SIXTEENBITCHARS */
		    if (!convert) {
			newitem(rp);
		    }
		    if(debug == IMPORT) {
			if (rp->text) {
			    printf("\trp->text = %s\n",rp->text);
			}
			printf("rp->type=%d, rp->group=%d, rp->keycode=%d, rp->value=%d\n",rp->type,rp->group,rp->keycode,rp->value);
		    }
		    rp++;
		    first = 0;
		}
	    }
	}
    }
    if(dlgversion < 0.3) {
	rp = dialog;
	for(i=0; i<MAXDLG; i++,rp++) {
	    if(rp->type == DMTEXTEDIT) {
		rp->value |= DMtebox;
	    }
	}
    }
}
/*eject*/
newitem(rp)
DedItem	*rp;
{
    Rect	tr;
    
    switch(rp->type) {
      case DMBOX:
      case DMTEXT:
      case DMICON:
      case DMBITMAP:
	doFontFaceSize(rp);
	display(rp);
	break;
      case  DMPICKLIST:
	pickscrollrect(&rp->rect,&tr);
	rp->id = dlgNewControl(windowid,&tr,rp->text,1,1,0,1,scrollBarProc,0,rp->fgColor,rp->bkColor);
	display(rp);
	break;
      case  DMCHECKBOX:
	doFontFaceSize(rp);
	rp->id = dlgNewControl(windowid,&rp->rect,rp->text,1,1,0,1,checkBoxProc|useWFont,0,rp->fgColor,rp->bkColor);
	break;
      case DMPATBOX:
	SetCDefProc(dlgControl);
	rp->id = dlgNewControl(windowid,&rp->rect,"",1,1,0,0xff,cntlBoxProc,0,rp->fgColor,rp->bkColor);
	SetCtlValues(rp->id,0,rp->pattern);
	SetCDefProc(0);
	break;
      case  DMRADIOBUT:
	doFontFaceSize(rp);
	rp->id = dlgNewControl(windowid,&rp->rect,rp->text,1,1,0,1,radioButProc|useWFont,0,rp->fgColor,rp->bkColor);
	break;
      case  DMPUSHBUT:
	doFontFaceSize(rp);
	rp->id = dlgNewControl(windowid,&rp->rect,rp->text,1,1,0,1,pushButProc|useWFont,0,rp->fgColor,rp->bkColor);
	break;
      case  DMDPUSHBUT:
	doFontFaceSize(rp);
	rp->id = dlgNewControl(windowid,&rp->rect,rp->text,1,1,0,1,defButProc|useWFont,0,rp->fgColor,rp->bkColor);
	break;
      case  DMSCROLLBAR:
	doFontFaceSize(rp);
	rp->id = dlgNewControl(windowid,&rp->rect,rp->text,1,1,0,1,scrollBarProc,0,rp->fgColor,rp->bkColor);
	break;
      case  DMTEXTEDIT:
	rp->id = dlgTENew(rp);
	break;
    }
}
/*eject*
/*
**	H O U S E K E E P I N G   R O U T I N E S
*/
MakeFFS(dep)
DedItem	*dep;
{
    int		i;
    int		first = 1;
    short	tmp = 0;
    
    if(dep == (DedItem*)FFSmany) {
	/*
	 **	RubberBand Multi Select, Check all used attributes
	 **	and only show font and size if all selected match
	 */
	FFSstate = FFSmany;
	curface = -1;
	dep = &dialog[0];
	for(i=0; i<MAXDLG; i++,dep++) {
	    if(dep->selected) {
		switch(dep->type) {
		  case DMTEXT:
		  case DMTEXTEDIT:
		  case DMPUSHBUT:
		  case DMDPUSHBUT:
		  case DMRADIOBUT:
		  case DMCHECKBOX:
		  case DMPATBOX:
		  case DMPICKLIST:
		    curface &= dep->attr;
		    tmp |= dep->attr;
		    if(first) {
			curfont = dep->font;
			cursize = dep->fontsize;
			first = 0;
		    }
		    else {
			if(curfont != dep->font) {
			    curfont = -1;
			}
			if(cursize != dep->fontsize) {
			    cursize = -1;
			}
		    }
		}
	    }
	}
	if(curface == 0 && tmp != 0) {
	    curface = FFSnomatch;
	}
    }
    else if(dep == (DedItem*)FFSnone) {
	/*
	 **	No Item Selected, so Check "running" FFS
	 */
	FFSstate = FFSnone;
	curfont = runfont;
	curface = runface;
	cursize = runsize;
    }
    else {
	/*
	 **	Single Item Selected
	 */
	switch(dep->type) {
	  case DMTEXT:
	  case DMTEXTEDIT:
	  case DMPUSHBUT:
	  case DMDPUSHBUT:
	  case DMRADIOBUT:
	  case DMCHECKBOX:
	  case DMPATBOX:
	  case DMPICKLIST:
	    FFSstate = FFSone;
	    curfont = dep->font;
	    curface = dep->attr;
	    cursize = dep->fontsize;
	}
    }
    CheckFFS();
}

CheckFFS()
{
    int		i;
    int		j;
    short	tmp;
    
    /*
     **	All Style Checks OFF
     */
    for(i=0; i<MAXSTYLE; i++) {
	CheckItem(STYLE,i,0);
    }
    /*
     **	All Font Checks OFF
     */
    for(i=0; i<MAXPD; i++) {
	CheckItem(FONT,i,0);
    }
    /*
     **	Check Font
     */
    for(i=1; DEDfont[i]!=-1; i++) {
	if(curfont == DEDfont[i]) {
	    CheckItem(FONT,i,1);
	}
    }
    /*
     **	Check all in Face
     */
    if(curface == 0) {
	CheckItem(STYLE,Fnormal,1);
    }
    else if(curface != FFSnomatch) {
	for(tmp=1,j=0; j<8; j++) {
	    if(tmp & curface) {
		for(i=1; i<=Foutline; i++) {
		    if(tmp == DEDstyle[i]) {
			CheckItem(STYLE,i,1);
		    }
		}
	    }
	    tmp = tmp << 1;
	}
    }
    /*
     **	Check Size
     */
    if(cursize == 0)
	tmp = 12;
    else
	tmp = cursize;
    for(i=Foutline+1; i<MAXSTYLE; i++) {
	if(tmp == DEDstyle[i]) {
	    CheckItem(STYLE,i,1);
	}
    }
}

clear(rp)
DedItem	*rp;
{
    memset(rp,0,sizeof(DedItem));
}

printrect(rp)
Rect	*rp;
{
    if(debug) {		
	FrameRect(rp);
	printf("l=%d, t=%d, r=%d, b=%d\n",rp->edge.left,rp->edge.top,rp->edge.right,rp->edge.bottom);
	printf("h=%d, w=%d\n",rp->edge.bottom-rp->edge.top,rp->edge.right-rp->edge.left);
    }
}

snap2grid(rp)
Rect	*rp;
{
    short	dh;
    short	dv;
    short	h;
    short	v;
    
    h = ((((rp->edge.left+(hgrid/2))/hgrid))*hgrid);
    v = ((((rp->edge.top+(vgrid/2))/vgrid))*vgrid);
    dh = h - rp->edge.left;
    dv = v - rp->edge.top;
    OffsetRect(rp,dh,dv);
}

stretch2grid(rp)
Rect	*rp;
{
    short	dh;
    short	dv;
    short	h;
    short	v;
    
    rp->edge.right = ((((rp->edge.right+(hgrid/2))/hgrid))*hgrid);
    rp->edge.bottom = ((((rp->edge.bottom+(vgrid/2))/vgrid))*vgrid);
}

short rectwidth(rp)
Rect	*rp;
{
    return(rp->edge.right - rp->edge.left);
}

short rectheight(rp)
Rect	*rp;
{
    return(rp->edge.bottom - rp->edge.top);
}
countitems()
{
    DedItem	*rp;
    int		i;
    int		j;
    
    j = 0;
    rp = dialog;
    for(i=0; i<MAXDLG; i++,rp++) {
	if(rp->type) {
	    j++;
	}
    }
    return(j);
}

/*
 **	Get text & null terminate it
 */
gettext(cp,cid)
char	*cp;
void	*cid;
{
    int		count;
    
    count = TEGetText(cp, cid);
    cp[count] = 0;
}

DedInit1()
{
    int		i;
    
    memset(dialog,0,sizeof(dialog));
    /*
     **	Setup dialog item text pointers
     */
    memset(dedtext,0,sizeof(dedtext));
    for(i=0; i<MAXDLG; i++) {
	dialog[i].text = (char*)&dedtext[i];
    }
    /*
     **	Setup dialog item name pointers
     */
    memset(dedname,0,sizeof(dedname));
    for(i=0; i<MAXDLG; i++) {
	dialog[i].name = (char*)&dedname[i];
    }
}

DedInit2()
{
    Rect	tr;
    
    SetRect(&tr,0,0,700,500);
    EraseRect(&tr);

    /*
     **	Set-Up Initial Font
     */
    TextFont(0);
    TextSize(12);
    TextFace(normalText);
    GetFontInfo(&fi);
    DMGetFontInfo();
    dirty = 0;
}

DedSetTitle()
{
    sprintf(title,"Dialog Editor %s  %s",version,filename);
    SetWTitle(windowid,title);
}
/*eject*/
/*
**	D R A W  /  D I S P L A Y   R O U T I N E S
*/
displayinfo()
{
	DMDcb	*cb;
	DMDcb	*prevcb;
	char	buf[10];
	Rect	*rp;
	DedItem	*dp;
	int		i;

	cb = DMNew(Dinfo,windowid,0);
	incollect = 1;
	prevcb = RfshDlg;
	RfshDlg = cb;
	dp = &dialog[0];
	for(i=0; i<MAXDLG; i++,dp++) {
		if(dp->selected) {
			break;
		}
	}
	rp = &dp->rect;
	sprintf(buf,"%d",rp->edge.left);
	DMSetText(cb,DINFO_left,buf);
	sprintf(buf,"%d",rp->edge.top);
	DMSetText(cb,DINFO_top,buf);
	sprintf(buf,"%d",rp->edge.right);
	DMSetText(cb,DINFO_right,buf);
	sprintf(buf,"%d",rp->edge.bottom);
	DMSetText(cb,DINFO_bottom,buf);
	sprintf(buf,"%d",rectwidth(rp));
	DMSetText(cb,DINFO_width,buf);
	sprintf(buf,"%d",rectheight(rp));
	DMSetText(cb,DINFO_height,buf);
	DMCollect(cb);
	DMDispose(cb);
	incollect = 0;
	ClipRect(&noclip);
	RfshDlg = prevcb;
	return;
}
select(rp)
DedItem	*rp;
{
	rp->selected = 1;
	display(rp);
}

xselect(rp)
DedItem	*rp;
{
	deselectall(1);
	select(rp);
}

deselect(rp)
DedItem	*rp;
{
	if(rp->selected) {
		rp->selected = 0;
		erase(rp);
		display(rp);
		InvalRect(&rp->rect);
	}
}

deselectall(invalwanted)
int		invalwanted;
{
	int		i;
	DedItem	*rp;

	rp = &dialog[0];
	for(i=0; i<MAXDLG; i++, rp++) {
		if(rp->selected) {
			erase(rp);
			if(invalwanted) {
				InvalRect(&rp->rect);
			}
			rp->selected = 0;
			display(rp);
		}
	}
}

selectall()
{
	int		i;
	DedItem	*rp;

	rp = &dialog[0];
	eraseselected();
	for(i=0; i<MAXDLG; i++, rp++) {
		if(rp->type) {
			rp->selected = 1;
		}
	}
	dspall();
}

delete(rp)
DedItem	*rp;
{
	if(rp->type) {
		erase(rp);
		rp->type = 0;
	}
}

deleteselected()
{
	int		i;
	DedItem	*rp;

	rp = dialog;
	for(i=0; i<MAXDLG; i++,rp++) {
		if(rp->selected) {
			delete(rp);
		}
	}
	dspall();
}

erase(rp)
DedItem	*rp;
{
	EraseRect(&rp->rect);
}

eraseselected()
{
	int		i;
	DedItem	*rp;

	rp = dialog;
	for(i=0; i<MAXDLG; i++,rp++) {
		if(rp->selected) {
			erase(rp);
		}
	}
}

display(rp)
DedItem	*rp;
{
	PenMode(srcOr);
	PenPat((Pattern*)0);
	TextMode(srcCopy);
	switch(rp->type) {
	case DMBOX:
		dspbox(rp);
		break;
	case DMCHECKBOX:
	case DMRADIOBUT:
	case DMPUSHBUT:
	case DMDPUSHBUT:
	case DMSCROLLBAR:
	case DMPATBOX:
		dspcontrol(rp);
		break;
	case DMTEXT:
		dsptext(rp);
		break;
	case DMTEXTEDIT:
		dsptextedit(rp);
		break;
	case DMPICKLIST:
		dsppicklist(rp);
		break;
	case DMICON:
		dspicon(rp);
		break;
	case DMBITMAP:
		dspbitmap(rp);
		break;
	}
}

dspicon(rp)
DedItem	*rp;
{
	BitMap	bm;
	Rect	tr;

	SetRect(&tr,0,0,32,32);
	bm.bounds = tr;
	bm.rowBytes = 4;
	bm.baseAddr = (char*)&charticon;
	CopyBits(&bm,0,&tr,&rp->rect,srcOr,0);
	if(rp->selected) {
		dspselect(rp);
	}
}

dspbitmap(rp)
DedItem	*rp;
{
	BitMap	bm;
	Rect	tr;

	SetRect(&tr,0,0,32,32);
	bm.bounds = tr;
	bm.rowBytes = 4;
	bm.baseAddr = (char*)&charticon;
	CopyBits(&bm,0,&tr,&rp->rect,srcOr,0);
	if(rp->selected) {
		dspselect(rp);
	}
}

dsppicklist(rp)
DedItem	*rp;
{
	FrameRect(&rp->rect);
	drawcontrol(rp);
	if(rp->selected) {
		dspselect(rp);
	}
}

dspbox(rp)
DedItem	*rp;
{
    DMItem	item;

    item.rect = rp->rect;
    item.text = rp->text;
    item.value = rp->value;
    item.font = rp->font;
    item.attr = rp->attr;
    item.xfermode = rp->xfermode;
    item.fgColor = rp->fgColor;
    item.bkColor = rp->bkColor;
    item.fontsize = rp->fontsize;
#ifdef SIXTEENBITCHARS
    item.otherfont = rp->otherfont;
    item.othersize = rp->othersize;
#endif /* SIXTEENBITCHARS */
    
    DMDrawBox(&item);
    if(rp->selected) {
	dspselect(rp);
    }
}

dsptext(rp)
DedItem	*rp;
{
	drawtext(rp);
	if(rp->selected) {
		FrameRect(&rp->rect);
		dspselect(rp);
	}
}

dsptextedit(rp)
DedItem	*rp;
{
	drawte(rp);
	FrameRect(&rp->rect);
	if(rp->selected) {
	    FrameRect(&rp->rect);
	    dspselect(rp);
	}
}

dspcontrol(rp)
DedItem	*rp;
{
    drawcontrol(rp);
    if(rp->selected) {
	dspselect(rp);
    }
}

dspselect(rp)
DedItem	*rp;
{
    Rect	tr;
    Rect	*rectp;
    
    switch(rp->type) {
      case DMRADIOBUT:
      case DMCHECKBOX:
      case DMPUSHBUT:
      case DMDPUSHBUT:
      case DMSCROLLBAR:
      case DMPATBOX:
      case DMICON:
      case DMBITMAP:
	FrameRect(&rp->rect);
	break;
    }
    rectp = &rp->rect;
    SetRect(&tr,rectp->edge.right-XY,rectp->edge.bottom-XY,rectp->edge.right,rectp->edge.bottom);
    FillRect(&tr,(Pattern*)7);
    FrameRect(&rp->rect);
    rp->handle = tr;
}

dspall()
{
	int		i;
	DedItem	*rp;

	rp = &dialog[0];
	for(i=0; i<MAXDLG; i++,rp++) {
		if(rp->type) {
			display(rp);			
		}
	}
}

drawte(rp)
DedItem	*rp;
{
	Rect	tr;

	tr = rp->rect;
	InsetRect(&tr,3,3);
	TEUpdateErase(&tr,rp->id);
}

drawtext(rp)
DedItem	*rp;
{
	DMItem	item;
	item.rect = rp->rect;
	item.text = rp->text;
	item.value = rp->value;
	item.font = rp->font;
	item.attr = rp->attr;
	item.xfermode = rp->xfermode;
	item.fgColor = rp->fgColor;
	item.bkColor = rp->bkColor;
	item.fontsize = rp->fontsize;
#ifdef SIXTEENBITCHARS
	item.otherfont = rp->otherfont;
	item.othersize = rp->othersize;
#endif /* SIXTEENBITCHARS */

	DMDrawText(&item,0);
}

drawcontrol(rp)
DedItem	*rp;
{
    savefgColor = theForeColor;
    savebkColor = theBackColor;
    ForeColor(rp->fgColor);
    BackColor(rp->bkColor);

    DrawControl(rp->id);
    
    ForeColor(savefgColor);
    BackColor(savebkColor);
}

ControlID
dlgNewControl(wid,bRect,title,visible,value,min,max,pID,rCon,fgColor,bkColor)

short wid;
Rect *bRect;
char *title;
short visible, value, min, max;
short pID;
long rCon;
short fgColor, bkColor;
{
    void *id;
    
    savefgColor = theForeColor;
    savebkColor = theBackColor;
    ForeColor(fgColor);
    BackColor(bkColor);
    
    id = NewControl(wid,bRect,title,visible,value,min,max,pID,rCon);
    
    ForeColor(savefgColor);
    BackColor(savebkColor);
    
    return (id);
}

copy()
{
	freeclip();
	putinclip();
}

cut()
{
	freeclip();
	putinclip();
	deleteselected();
	sort();
}

paste()
{
	DedClip	*clip;
	DedItem	*dip;
	DedItem	*ndip;
	int		i;
	char	*cp1,*cp2;

	deselectall(0);
	clip = clipboard;
	for(i=0; i<MAXDLG && clip->dip; i++,clip++) {
		ndip = dupitem(clip->dip);
		ndip->selected = 1;
		display(ndip);
		dspselect(ndip);
	}
	sort();
}

freeclip()
{
	DedClip	*clip;
	int		i;

	clip = clipboard;
	for(i=0; i<MAXDLG; i++,clip++) {
		if(clip->dip) {
			if(clip->dip->name) {
				free(clip->dip->name);
			}
			if(clip->dip->text) {
				free(clip->dip->text);
			}
			free(clip->dip);
			clip->dip = 0;
		}
	}
}

putinclip()
{
	DedClip	*clip;
	DedItem	*dip;
	int		i;

	dip = dialog;
	clip = clipboard;
	for(i=0; i<MAXDLG; i++,dip++) {
		if(dip->selected && dip->type) {
			/*
			**	Make a copy of the Dialog Editor Item
			*/
			EnableItem(EDIT,PASTE);
			clip->dip = (DedItem*)malloc(sizeof(DedItem));		
			*clip->dip = *dip;
			clip->dip->name = (char*)malloc(strlen(dip->name));
			strcpy(clip->dip->name,dip->name);
			clip->dip->text = (char*)malloc(strlen(dip->text));
			strcpy(clip->dip->text,dip->text);
			clip++;
		}
	}
}

/*eject*/
enablemenus()
{
	DisableMenu(FFILE);
	DisableMenu(EDIT);
	DisableMenu(NEW);
	DisableMenu(OPTIONS);
	DisableMenu(BORDER);
	DisableMenu(GROUP);
	DisableMenu(FONT);
	DisableMenu(STYLE);
}

disablemenus()
{
	EnableMenu(FFILE);
	EnableMenu(EDIT);
	EnableMenu(NEW);
	EnableMenu(OPTIONS);
	EnableMenu(BORDER);
	EnableMenu(GROUP);
	EnableMenu(FONT);
	EnableMenu(STYLE);
}
/*eject*/
/*
**	Common TENew Func
*/
void *dlgTENew(rp)
DedItem	*rp;
{
	Rect	tr;
	void	*id;

	tr = rp->rect;
    InsetRect(&tr,3,3);
	doFontFaceSize(rp);
    id = TENew(&tr, &tr);
	if(rp->value & DMtecenterJust) {
		TESetJust(teJustCenter,id);
	}
	else if(rp->value & DMterightJust) {
		TESetJust(teJustRight,id);
	}	
	TECROnly(1,id);
    TESetText(rp->text,strlen(rp->text),id);
	TEUpdate(&tr,id);
	FrameRect(&rp->rect);
	return(id);
}

setdefinemode()
{
	CheckItem(OPTIONS, mode, 0);
	Event(mouseEvt,modedefine);
	Event(keyEvt,modedefine);
	mode = MODEDEFINE;
	SetCursor(&hand);
	CheckItem(OPTIONS, mode, 1);
}

setpointmode()
{
	CheckItem(OPTIONS, mode, 0);
	Event(mouseEvt,mouseevent);
	Event(keyEvt,keyevent);
	mode = MODEPOINT;
	InitCursor();
	CheckItem(OPTIONS, mode, 1);
}

setFontFaceSize(rp) 
DedItem		*rp;
{
#ifdef SIXTEENBITCHARS
	rp->otherfont = theOtherFont;
	rp->othersize = theOtherSize;
	FontFaceSize(curfont,rp->otherfont,curface,cursize,rp->othersize);
#else
	FontFaceSize(curfont,curface,cursize);
#endif /* SIXTEENBITCHARS */
	rp->font = curfont;
	rp->attr = curface;
	rp->fontsize = cursize;
}

doFontFaceSize(rp)
DedItem		*rp;
{
#ifdef SIXTEENBITCHARS
    rp->otherfont = theOtherFont;
    rp->othersize = theOtherSize;
    FontFaceSize(rp->font,rp->otherfont,rp->attr,rp->fontsize,rp->othersize);
#else
    FontFaceSize(rp->font,rp->attr,rp->fontsize);
#endif /* SIXTEENBITCHARS */
}

doFontFaceSize2(rp)
DedItem		*rp;
{
#ifdef SIXTEENBITCHARS
    rp->otherfont = theOtherFont;
    rp->othersize = theOtherSize;
    FontFaceSize(rp->font,rp->otherfont,-1,rp->fontsize,rp->othersize);
#else
    FontFaceSize(rp->font,-1,rp->fontsize);
#endif /* SIXTEENBITCHARS */
}

/*
** update_proto_list()
**
** If the char string "routine" is not in Routine[] then add it and
** return(1), else return(0).
*/
update_proto_list(routine)
char *routine;
{
    int i;

    for(i=0; Routines[i]; i++) {
	if(strcmp(Routines[i],routine) == 0) {
	    return(0);
	}
    }
    Routines[i++] = routine;
    Routines[i] = 0;
    return (1);
}

set_names(name)
char	name[300];
{
    char	*cp;

    cp = name;
    while (*cp && *cp != '.') /* Force '.c' suffix. */
	cp++;
    *cp++ = '.';
    *cp++ = 'c';
    *cp = 0;
    strcpy(filename,name);

    strcpy(hfilename,name);
    cp = hfilename;
    while (*cp && *cp != '.') /* Force '.h' suffix. */
	cp++;
    *cp++ = '.';
    *cp++ = 'h';
    *cp = 0;

    cp = strrchr(name,'/');	/* Dump the path... keep the file name only. */
    if(cp) 
	cp++; 
    else 
	cp = name;
    strcpy(dlgname,cp);
    if((cp = strpbrk(dlgname,"."))) { /* Knock off the '.h' suffix. */
	*cp = 0;
    }

    strcpy(dlgnameCaps,dlgname);
    cp = dlgnameCaps;
    while (*cp++) {
	if (*cp >= 'a' && *cp <= 'z') {
	    *cp -= 'a' - 'A';
	}
    }
}

