/*
**	D E F I N E S
*/
#define	FFILE		1
#define	FOPEN		1
#define	FCLOSE		2
#define	FSAVE		3
#define	FSAVEAS		4
#define	FQUIT		6

#define	SELECTALL	1
#define	DELETE		2
#define	EDIT		3
#define	CUT		4
#define	COPY		5
#define	PASTE		6
#define	DUP		7

#define NEW		4
#define	BOX		1
#define CHECKBOX	2
#define	CNTLBOX		3
#define RADIOBUT	5
#define	PUSHBUT		6
#define	DPUSHBUT	7
#define TEXT		9
#define TEXTEDIT	10
#define	SCROLLBAR	12
#define	PICKLIST	13
#define	ICON		15
#define	BITMAP		16

#define	OPTIONS		5
#define	MODEPOINT	1
#define	MODETEXT	2
#define	MODEDEFINE	3
#define	GRIDON		5
#define	SETGRID		6
#define	RUBBER		8
#define	OFFSETDP	9
#define	OBJINFO		11

#define	BORDER		6
#define	SHADOW		1
#define	SINGLE		2
#define	DOUBLE		3
#define	TRIPLE		4
#define	INVISABLE	5
#define	PENWIDTH1	7
#define	PENWIDTH2	8
#define	PENWIDTH3	9

#define	GROUP		7
#define	NONE0		1
#define	OTHER		2
#define	EXCLUSIVE1	4
#define	EXCLUSIVE2	5
#define	EXCLUSIVE3	6
#define	EXCLUSIVE4	7
#define	EXCLUSIVE5	8
#define	ACTIVATE1	10
#define	GENERAL1	12
#define	GENERAL2	13
#define	GENERAL3	14
#define	GENERAL4	15
#define	GENERAL5	16
#define	EXIT1		18
#define	EXIT2		19
#define	EXIT3		20
#define	EXIT4		21
#define	EXIT5		22

#define	FORECOLOR	1
#define	BACKCOLOR	0

#define	FONT		8

#define	STYLE		9
#define	Fnormal		1
#define	Fbold		2
#define	Funderline	3
#define	Fitalic		4
#define	Fghost		5
#define	Foutline	6

#define	MAXDLG		300
#define	MAXPD		30
#define	XY		7

#define	IMPORT		1
#define	TOUCH		1
#define	ENCLOSE		2

#define FFSnone 	0
#define	FFSone		1
#define FFSmany 	2
#define	FFSnomatch	(short)(0x8000)

#ifdef SIXTEENBITCHARS
#define CHINESE_FONT 13
#define CHINESE_FONT_SIZE 16
#define TAIWAN_FONT 13
#define TAIWAN_FONT_SIZE 15
extern short theOtherFont;
extern short theOtherSize;
#endif /* SIXTEENBITCHARS */


/* ------------------- */
/*  Allocated in .c  */
/* ------------------- */

/*
**	DIALOG EDITOR ITEM STRUCT
*/
typedef struct deditem {
	Rect	rect;		/* gadget size */
	Rect	tmp;		/* tmp gadget size */
	Rect	active;		/* gadget active area */
	Rect	handle;		/* handle area */
	byte	type;		/* CBOX or CONTROL etc */
	byte	group;		/* grouping for radio buttons, 255 reserved */
	byte	when;		/* tabbing sequence number */
	byte	xfermode;	/* Color transfer mode */
	short	fgColor;	/* Foreground color. */
	short	bkColor;	/* Background color. */
	int	keycode;	/* function key equivelent */
	short	value;		/* initial/final value */
	short	min;		/* min allowed value */
	short	max;		/* max allowed value */
	char	*text;		/* ASCII string */
	char	*name;		/* name */
	short	font;		/* font */
	short	fontsize;	/* font size */
	short	attr;		/* object attributes */
	char	prefill[30];	/* prefill function */
	char	validate[30];	/* validate function */
	short	cntlid;		/* controll ID */
	UINT	usercode;	/* any value for app use */
	byte	selected;	/* selected */
	void	*id;		/* control id */
#ifdef SIXTEENBITCHARS
	short	otherfont;
	short	othersize;
#endif /* SIXTEENBITCHARS */
} DedItem;

/*
**	E X T E R N S
*/
extern	int	dir_count;
extern	char	directory[];
extern	int	errno;
extern	DMItem	Dsaveas[];
extern	DMItem	Dcontrol[];
extern	DMItem	Dsbar[];
extern	DMItem	Dtextedit[];
extern  DMItem	Dbox[];
extern	DMItem	Dsavechg[];
extern	DMItem	Dgrid[];
extern	DMItem	Dtext[];
extern	DMItem	Dpat[];
extern	DMItem	Dpicklist[];
extern	DMItem	Derror[];
extern	DMItem	Dinfo[];
extern	DMItem	Dgroup[];
extern	long	dlgControl();

/*
**	F U N C T I O N S
*/
void		updateevent();
void		mouseevent();
void		windowevent();
void		menuevent();
void		keyevent();
char		*strchr();
short		rectwidth();
short		rectheight();
void		modetext();
void		modedefine();
void 		*dlgTENew();
DedItem		*onobject();
DedItem		*findslot();
DedItem		*dupitem();
ControlID dlgNewControl(short, Rect *, char *, short, short, short, short, short, long, short, short);

/*
** Clipboard
*/
typedef struct dedclip {
	DedItem	*dip;
} DedClip;


/*
** Got to have 'dedname[]' & 'dedtext[]' because the damn
** controls expect a pointer to text that does not move,
** but sort moves the text unless done like this
*/
/*eject*/
