/*
**  Test program for file-viewer library
*/

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <isc/window.h>
#include <isc/controls.h>
#include <isc/keycodes.h>
#include <isc/dlgman.h>
#include "moview.h"

static int state = 1;

static FView *FV;
static int mywindow;
static Rect myrect;
static char *fname;
static int	grafFd;

static void mykeyboard(EventRecord *);
static void myupdate(EventRecord *);

int
main (int argc, char *argv[])
{
	char *Myname;
	static int trapqfd;
	
	Myname = strrchr(argv[0],'/');
	if (Myname == NULL)
		Myname = argv[0];
	else
		Myname++;
	
 	/* initialize the graphics toolbox */
    if ((trapqfd = InitGraf()) < 0) 
	{
		char *msg = ": Error from InitGraf\n";
		write(2,Myname, strlen(Myname));
		write(2,msg,strlen(msg));
		return 1;
    }
    if ((grafFd = ConnectGraf((char *)0)) < 0) 
	{
		char *msg = ": Error from ConnectGraf\n";
		write(2,Myname, strlen(Myname));
		write(2,msg,strlen(msg));
		return 1;
    }
    SetRect(&myrect, 50, 50, 500, 300);
    mywindow = NewWindow(&myrect, "", showWindow, plainDBox, 
		frontWindow, 0, grafFd);

	fname = argv[1];

	if ((FV=FVOpen(40,80,32,48,5,9,8,fname,grafFd)) == NULL)
	{
		fprintf(stderr, "can't FVOpen '%s'\n", fname);
		exit(1);
	}
    Event(updateEvt, myupdate);
    Event(mouseEvt, VWmouse);
    Event(windowEvt, VWwindow);
    Event(menuEvt, VWmenu);
    Event(keyEvt, mykeyboard);
	Event(activateEvt, VWactivate);
	Event(noEvent, (void (*)())VWnoevent);
    (void) GetEvent(anyWindow, noEvent);
	Event(updateEvt, myupdate);
	Event(mouseEvt, NULL);
	Event(windowEvt, NULL);
	Event(menuEvt, NULL);
	Event(keyEvt, mykeyboard);
	Event(activateEvt, NULL);
	Event(noEvent, NULL);
    (void) GetEvent(anyWindow, noEvent);

}

static  void  myupdate(EventRecord *ep)
{
	if (ep->who == mywindow)
	{
		BeginUpdate(ep->who);
		SetPort(mywindow);
		EraseRect(&myrect);
		TextFont(9);
		TextFace(normalText);
		TextSize(36);
		MoveTo(0,100);
		DrawText("Foo Bar Bozo",0,12);
		if (state == 2)
		{
			TextFont(9);
			TextFace(normalText);
			TextSize(18);
			MoveTo(0,150);
			DrawText("State 2",0,7);
		}
		EndUpdate(ep->who);
	}
	else
		VWupdate(ep);
}

static void mykeyboard(EventRecord *ep)
{
	unsigned int key;

	if (ep->message & F_KEYUP)
		return;
	key = ep->message & ~F_KEYDOWN & ~F_KBDIII;

	if (key == (F_SHIFT | 'Q'))
	{
		if (state == 2)
		{
			exit(0);
		}
		else
		{
			VWClose(FV->VW);
			ReleaseEvent();
			state = 2;
			return;
		}
	}
	VWkeyboard(ep);
}
