/*
** Appletalk protocol packet formats.
*/

struct aarpmsg {
    short hwtype;
    short protocol2;
    char hwadrlen;
    char pradrlen;
    short function;
    struct etheraddr hwsataddr;
    unsigned char prsataddr[4];
    struct etheraddr hwdataddr;
    unsigned char prdataddr[4];
};

struct etalkmsg {
    unsigned char dstnode;
    unsigned char srcnode;
    unsigned char type;

    union {
	struct ddpshort {
	    unsigned char len1;
	    unsigned char len2;
	    unsigned char dsock;
	    unsigned char ssock;
	    unsigned char type;

	    unsigned char data;
	} s;
	struct ddplong {
	    unsigned char len1;
	    unsigned char len2;
	    unsigned char chk1;
	    unsigned char chk2;
	    unsigned char dnet1;
	    unsigned char dnet2;
	    unsigned char snet1;
	    unsigned char snet2;
	    unsigned char dnode;
	    unsigned char snode;
	    unsigned char dsock;
	    unsigned char ssock;
	    unsigned char type;

	    unsigned char data;
	} l;
    } ddp;
};

struct ddpdata {
    union {
	struct {
	    unsigned char rnet1;
	    unsigned char rnet2;
	    unsigned char idlen;
	    unsigned char rnode;
	    union {
		struct {
		    unsigned char zero1;
		    unsigned char zero2;
		    unsigned char hex82;
		    struct stuple {
			unsigned char net1;
			unsigned char net2;
			unsigned char distance;
		    } tuple;
		} rtmps;
		struct {
		    struct etuple {
			unsigned char rstart1;
			unsigned char rstart2;
			unsigned char distance;
			unsigned char rend1;
			unsigned char rend2;
			unsigned char hex82;
		    } tuple;
		} rtmpl;
	    } u2;
	} rtmpd;
	struct {
	    unsigned char function;
	} rtmpr;

	struct {		/* Appletalk Echo Protocol. */
	    unsigned char function;
	    unsigned char data;
	} aer;

	struct {		/* Name Binding Protocol. */
	    unsigned char function;
	    unsigned char nbpid;
	    struct nbptuple {
		unsigned char net1;
		unsigned char net2;
		unsigned char node;
		unsigned char sock;
		unsigned char enumer;
		unsigned char obj; /* Variable-lengthed */
	    } tuple;
	} nbp;

	struct {		/* Zone Info Protocol. */
	    unsigned char function;
	    unsigned char netcount;
	    unsigned char net1;
	    unsigned char net2;
	} zip;

	struct {		/* Appletalk Transaction Protocol */
	    unsigned char control;
	    unsigned char bitseq;
	    unsigned char tid1;
	    unsigned char tid2;
	    unsigned char user[4];
	    unsigned char data;
	} atp;

	struct {		/* Appletalk Data Stream Protocol. */
	    unsigned char sconnid[2];
	    unsigned char pfbseq[4];
	    unsigned char pnrseq[4];
	    unsigned char prwdw[2];
	    unsigned char descriptor;
	    unsigned char data;
	} adsp;
    } u;
};
