#! /bin/sh
#
#  NAME
#	sniffer.del7 - sniffer de-installation script
#
#	Copyright (c) 1996 ISC-BUNKER RAMO
#	  All Rights Reserved
#
#	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ISC-BR
#	The copyright notice above does not evidence any
#	actual or intended publication of such source code.
#	This Module contains Proprietary Information of
#	ISC-BR and should be treated as confidential.
#
#  DESCRIPTION
#       D-NIX Ethernet Sniffer installation script.
#
#  USER MODIFIABLE VARIABLES
#	None
#
#  EXIT CODES
#	 0: successful execution
#	 1: fatal error
#	 2: warning
#	 3: interruption
#

# ======================================================= #
#  User Modifiable Variables                              #
# ======================================================= #
NETPASS=${NETPASS:-iscisc}	# default netkey password
NODENAME=${NODENAME:-unknown}		# default system id

# ======================================================= #
#  WARNING: Users do not alter anything below this line.  #
# ======================================================= #

#
#  External variables imported from GENASYS
#
PKG=${PKG:-sniffer}		# package abbreivation
export PKG
ROOT=${ROOT:-`pwd`}
export ROOT
DISTDIR=${DISTDIR:-$ROOT/usr/adm/dist}
export DISTDIR
HISTORY=${HISTORY:-$DISTDIR/history}
export HISTORY
PKGDIR=${PKGDIR:-$DISTDIR/$PKG}	# package info directory
export PKGDIR
CLEAR=${CLEAR:-'echo "\n"'}
export CLEAR
NEWBOX=${NEWBOX:-FALSE}
export NEWBOX
BATCH=${BATCH:-FALSE}
export BATCH
VERBOSE=${VERBOSE:-TRUE}
export VERBOSE
PATH=${PATH:-":/bin:/usr/bin:/etc"}
export PATH
HARDNAME=${HARDNAME:-DNP-010}
export HARDNAME
SYSTYPE=${SYSTYPE:-DNP}
export SYSTYPE
CPUTYPE=${CPUTYPE:-M68010}
export CPUTYPE
BLDTYPE=${BLDTYPE:-ISC}
export BLDTYPE
RUNLEVEL=${RUNLEVEL:-0}
export RUNLEVEL
OSREL=${OSREL:-0}
export OSREL
OSVER=${OSVER:-0}
export OSVER
GENVER=${GENVER:-0}
export GENVER

#
#  Fixup target directory path (if needed)
#
if [ "$ROOT" = "/" ]
then
	ROOT=""
fi

#
#  Package variables and constants
#
PKGPROG=`basename $0`		# package install script
PKGVER='$Revision: 1.0 $'	# package RCS version
PKGNAME="Sniffer"		# package name
PKGTEMP=/tmp/$PKG.temp		# package tmp work file
PKGERRS=FALSE			# Fatal errors
PKGWARN=FALSE			# Warnings
PKGINTR=FALSE			# Interruptions
PKGBOOT=0			# 0  = Reboot not required

SYSIDFILE=/etc/systemid

#
#  Required files list
#
RQDFILES="\
	/bin/rm"

#
#  Display package version level
#
if [ $VERBOSE = TRUE ]
then	echo "D-NIX $PKGNAME De-installation Script  $PKGVER\n"
fi

#
#  Check required files list - all here?
#
NOFILE=FALSE
for file in $RQDFILES
do
	if [ ! -x $file ]
	then
		echo "sniffer: Required file $file not found"
		NOFILE=TRUE
	fi
done
if [ $NOFILE = TRUE ]
then
	exit 1
fi

#
#  Initialize trap for various interrupt conditions
#
trap 'PKGINTR=TRUE; exit 3' 1 2 3 15

#
#  Exit with appropriate status set
#
trap '  if   [ $PKGERRS = TRUE ]	# Fatal error
	then
		PKGBOOT=1
	elif [ $PKGINTR = TRUE ]	# Interruption
	then
		PKGBOOT=3
	elif [ $PKGWARN = TRUE ]	# Warning
	then
		PKGBOOT=`/bin/expr $PKGBOOT + 2`
	fi
	exit $PKGBOOT
	
	' 0

# ================================================= #
#  Sniffer specific stuff starts here               #
# ================================================= #

#
#  Remove devices & stuff
#
/bin/rm -f $ROOT/dev/sniffer $ROOT/dev/hdlcsniff $ROOT/dev/winsniff \
	$ROOT/usr/lib/sniffer/addresses

# ================================================= #
#  Sniffer specific stuff ends here                 #
# ================================================= #

exit 0
