/*
** Function to dump out an AARP protocol frame.
*/

#include <stdio.h>
#include <dnix/cheapdrv.h>
#include "atalk.h"
#include "protos.h"

char *aarps[] = {0, "Request", "Response", "Probe"};

dumpaarp(buf, len, rawdata)
void *buf;
int len;
int rawdata;			/* TRUE to dump data part of frame. */
{
    char from[14], to[14];
    unsigned char *cp;
    struct aarpmsg *aarp;

    aarp = (struct aarpmsg *) buf;
    printf("\tAARP\tOpcode: %s (%d)\n",
	   (aarp->function > sizeof(aarps)/sizeof(aarps[0]))
	   ? "??" : aarps[aarp->function], aarp->function);	   
    makename(aarp->hwsataddr.addr, from);
    makename(aarp->hwdataddr.addr, to);
    printf("\t\tFrom %-13.13s (%d.%d.%d.%d)\n", from, aarp->prsataddr[0],
	   aarp->prsataddr[1], aarp->prsataddr[2], aarp->prsataddr[3]);
    printf("\t\tTo   %-13.13s (%d.%d.%d.%d)\n", to, aarp->prdataddr[0],
	   aarp->prdataddr[1], aarp->prdataddr[2], aarp->prdataddr[3]);
    cp = (unsigned char *) &aarp[1];
    if (rawdata)
	hd(cp, len - (cp - (unsigned char *) buf), 0);
    return cp - (unsigned char *) buf;
}
