/*
** This module interprets the command streams sent by ncu.
*/

#include <stdio.h>
#include <sys/signal.h>
#include <sys/types.h>

#include "../ncu/pk_ncu.h"

int moreqjob;

dumpncuatobcmd(buf, size, qbit, mbit)
unsigned char *buf;
int size, qbit, mbit;
{
    unsigned char *cp;
    unsigned char *cpe;

    if (!qbit) {		/* Normal data - STDIN */
	if (size > 0) {
	    printf("STDIN data:\n");
	    hd(buf, size, 0);
	} else
	    printf("STDIN EOF\n");
    } else {			/* Q data */
	if (size > 0) {
	    dumpQ(buf, size);
	} else
	    printf("Q - NO COMMAND\n");
    }
    return size;
}

dumpQ(buf, size)
unsigned char *buf;
int size;
{
    switch (buf[0]) {
	
      case Q_CLRINV:
	printf("Q_CLRINV\n");
	hd(&buf[1], size - 1, 0);
	break;
		
      case Q_SIGNAL:
	printf("Q_SIGNAL - signal = %d\n", buf[1]);
	break;
		
      case Q_FLUSH:
	printf("Q_FLUSH\n");
	break;
		
      case Q_FMRQ:	/* Flush mark request */
	printf("Q_FMRQ\n");
	break;
		
      case Q_ERROR:
	printf("Q_ERROR - type = ");
	switch (buf[1]) {
	
	  case QE_USPEC:
	    printf("QE_USPEC\n");
	
	  case QE_CMD:
	    printf("QE_CMD\n");
	
	  case QE_PAR:
	    printf("QE_PAR\n");
	}
	hd(&buf[2], size - 2, 0);
	break;
		
      case Q_STTY:
	printf("Q_STTY\n");
	hd(&buf[1], size - 1, 0);
	break;
		
      case Q_SETC:
	printf("Q_SETC\n");
	hd(&buf[1], size - 1, 0);
	break;
		
      case Q_TERM3:
	printf("Q_TERM3\n");
	hd(&buf[1], size - 1, 0);
	break;
		
      case Q_T3NF:
	printf("Q_T3NF\n");
	hd(&buf[1], size - 1, 0);
	break;
		
      default:
	printf("Q - UNKNOWN [0x%X]\n", buf[0]);
	hd(&buf[1], size - 1, 0);
	break;
    }
}

dumpncubtoacmd(buf, size, qbit, mbit)
unsigned char *buf;
int size, qbit, mbit;
{
    if (!qbit) {		/* Normal data - STDOUT */
	if (size > 0) {
	    printf("STDOUT data:\n");
	    hd(buf, size, 0);
	} else
	    printf("STDOUT EOF\n");
    } else {			/* Q data */
	if (size > 0) {
	    dumpQ(buf);
	} else
	    printf("Q - NO COMMAND\n");
    }
    return size;
}

dumpncuatobint(buf, size)
unsigned char *buf;
int size;
{
    hd(&buf[1], size, 0);

    return size;
}

dumpncubtoaint(buf, size)
unsigned char *buf;
int size;
{
    hd(&buf[1], size, 0);

    return size;
}
