/*
** This module interprets the command streams sent by rx.
*/

#include <stdio.h>
#include <sys/signal.h>
#include <sys/types.h>

#include "../rx/pk_rx.h"

int moreqjob;

dumprxatobcmd(buf, size, qbit, mbit)
unsigned char *buf;
int size, qbit, mbit;
{
    unsigned char *cp;
    unsigned char *cpe;

    if (!qbit) {		/* Normal data - STDIN */
	if (size > 0) {
	    printf("STDIN data:\n");
	    hd(buf, size, 0);
	} else
	    printf("STDIN EOF\n");
    } else {			/* Q data */
	if (size > 0) {
	    switch (buf[0]) {
		
	      case Q_JOB:
		printf("Q_JOB cards:\n");
		cp = &buf[1];
		cpe =  cp + (size - 1);
		while (cp < cpe) {
		    printf("\t    %c: %s\n", *cp, cp + 1);
		    while (*cp++)
			;
		}
		if (mbit)
		    moreqjob = 1;
		else
		    moreqjob = 0;
		break;
		
	      case Q_SIERR:
		printf("Q_SIERR errno ");
		if (size == 2)
		    printf("%d\n", buf[1]);
		else
		    printf("?\n");
		break;
		
	      default:
		if (moreqjob) {
		    printf("More Q_JOB cards:\n");
		    cp = &buf[0];
		    cpe =  cp + (size - 1);
		    printf("\t    ...%s\n", cp);
		    while (*cp++)
			    ;
		    while (cp < cpe) {
			printf("\t    %c: %s\n", *cp, cp + 1);
			while (*cp++)
			    ;
		    }
		    if (mbit)
			moreqjob = 1;
		    else
			moreqjob = 0;
		} else {
		    printf("Q - UNKNOWN COMMAND [0x%X]\n", buf[0]);
		    hd(&buf[1], size - 1, 0);
		}
		break;
	    }
	} else
	    printf("Q - NO COMMAND\n");
    }
    return size;
}

dumprxbtoacmd(buf, size, qbit, mbit)
unsigned char *buf;
int size, qbit, mbit;
{
    if (!qbit) {		/* Normal data - STDOUT */
	if (size > 0) {
	    printf("STDOUT data:\n");
	    hd(buf, size, 0);
	} else
	    printf("STDOUT EOF\n");
    } else {			/* Q data */
	if (size > 0) {
	    switch (buf[0]) {
		
	      case Q_EXIT:
		printf("Q_EXIT status ");
		if (size == 2)
		    printf("%d\n", buf[1]);
		else
		    printf("?\n");
		break;
		
	      case Q_STDERR:
		if (size - 1 > 0) {
		    printf("Q_STDERR data:\n");
		    hd(&buf[1], size - 1, 0);
		} else
		    printf("Q_STDERR EOF\n");
		break;
		
	      default:
		printf("Q - UNKNOWN [0x%X]\n", buf[0]);
		hd(&buf[1], size - 1, 0);
		break;
	    }
	} else
	    printf("Q - NO COMMAND\n");
    }
    return size;
}

dumprxatobint(buf, size)
unsigned char *buf;
int size;
{
    if (size > 0) {
	switch (buf[0] & I_FMT) {
	    
	  case I_SIG:
	    printf("I_SIG: ");
	    switch (buf[0] & ~I_FMT) {
	      case SIGINT: printf("SIGINT"); break;
	      case SIGQUIT: printf("SIGQUIT"); break;
	      case SIGPIPE: printf("SIGPIPE"); break;
	      case SIGTERM: printf("SIGTERM"); break;
	      default: printf("Illegal signal %d", buf[0] & ~I_FMT); break;
	    }
	    printf("\n");
	    break;
	    
	  case I_SOERR:
	    printf("I_SOERR errno %d\n", buf[0] & ~I_FMT);
	    break;
	    
	  case I_SEERR:
	    printf("I_SEERR errno %d\n", buf[0] & ~I_FMT);
	    break;
	    
	  default:
	    printf("UNKNOWN [0x%X]\n", buf[0]);
	    hd(&buf[1], size - 1, 0);
	    break;
	}
    } else {
	printf("NO COMMAND\n");
    }
    return size;
}

dumprxbtoaint(buf, size)
unsigned char *buf;
int size;
{
    if (size > 0) {
	switch (buf[0]) {
	    
	  case I_RDON:
	    printf("I_RDON\n");
	    break;
	    
	  case I_RDOFF:
	    printf("I_RDOFF\n");
	    break;
	    
	  default:
	    printf("UNKNOWN [0x%X]\n", buf[0]);
	    hd(&buf[1], size - 1, 0);
	    break;
	}
    } else {
	printf("NO COMMAND\n");
    }
    return size;
}
