/*
** This module interprets the command streams sent to WindowMan.
*/

#include <stdio.h>
#include <sys/types.h>
#include <isc/window.h>
#include <isc/cd_clunkdraw.h>

#include "gfcodes.h"

dumpwmcmd(buf, size, qbit)
unsigned char *buf;
int size, qbit;
{
    int flag;
    unsigned char *cp, *cp0;
    int fc, len;
    int i, x, y;
    int windowid, windowid2;
    WindowRecord *wptr;
    struct wcb *wcb;
    Rect *rect;
    Point point;
    RgnPtr argn;
    PolyPtr apoly;
    int isvisible, goAwayFlag, box;
    void dumppat(), dumppat2();
    void *malloc();
    struct scrapstuff *sp;
    short align[512];		/* To ensure alignment. */
	
    i = sizeof(align);
    if (size < i)
	i = size;
    memcpy(align, buf, i);
    cp = (unsigned char *) align;
    while (size >= 2) {
	printf("\t\t");
	if ((long) cp & 1) {	/* Sanity check!  If it's odd then we */
	  barf:
	    printf("CORRUPTED... Abandoning the rest of it.\n");
	    return cp - (unsigned char *) align;
	}
	len = *((short *) cp)++;
	if (len <= 0)
	    goto barf;		/* Don't tell anybody I did this! */
	if (len + 2 > size) {
	    break;
	}
	size -= len + 2;
	cp0 = cp + len;
	fc = *((short *) cp)++;
	switch (fc) {
	  case GF_SystemSetup:
	    printf("SystemSetup\n");
	    break;
	  case GF_GetFontTable:
	    printf("GetFontTable\n");
	    break;
	  case GF_GetFontList:
	    printf("GetFontList\n");
	    break;
	  case GF_GetFontSizes:
	    printf("GetFontSizes\n");
	    break;
	  case GF_SetEventRecorder:
	    printf("SetEventRecorder %d \"%s\"\n", *(short *) cp,
		   (char *) &((short *) cp)[1]);
	    break;
	  case GF_WaitEventRecorder:
	    printf("WaitEventRecorder\n");
	    break;
	  case GF_LockWM:
	    printf("LockWM\n");
	    break;
	  case GF_MouseMode:
	    printf("MouseMode $%08X\n", *((long *) cp));
	    break;
	  case GF_AckEvent:
	    printf("AckEvent ");
	    dumpevent((EventRecord *) cp);
	    break;

	  case GF_ZeroScrap:
	    printf("ZeroScrap\n");
	    break;

	  case GF_PutScrap:	/* Start accumulating scrap info. */
	    x = *((long *) cp)++;
	    y = *((long *) cp)++;
	    printf("PutScrap %d '%4.4s'\n", x, &y);
	    break;

	  case GF_GetScrap:
	    printf("GetScrap ");
	    {
		short flag;
		unsigned long maxlen, length, *type;

		flag = *((short *) cp)++; /* TRUE if actually reading scrap. */
		maxlen = *((unsigned long *) cp)++;
		type = ((unsigned long *) cp)++;
		printf("%d '%4.4s' %s\n", maxlen, type, flag ? "Get":"Check");
	    }
	    break;

	  case GF_PublishScrap:
	    printf("PublishScrap %d\n", *((short *) cp));
	    break;

	  case GF_MoveCursor:
	    x = *((short *) cp)++;
	    y = *((short *) cp)++;
	    printf("MoveCursor %d %d\n", x, y);
	    break;
	  case GF_NewWindow:
	    windowid = *((short *) cp)++;
	    rect = ((Rect *)cp)++;
	    isvisible = *((short *) cp)++;
	    box = *((short *) cp)++;
	    i = *((short *) cp)++; /* 'Behind' parameter. */
	    goAwayFlag = *((short *) cp)++;
	    printf("NewWindow \"%s\" %d %d %d %d %d ", cp,
		   windowid, isvisible, box, i, goAwayFlag);
	    dumprect(rect);
	    break;
	  case GF_DisposeWindow:
	    windowid = *((short *) cp);
	    printf("DisposeWindow %d\n", windowid);
	    break;
	  case GF_SetWTitle:
	    windowid = *((short *) cp)++;
	    printf("SetWTitle %d \"%s\"\n", windowid, cp);
	    break;
	  case GF_HideWindow:
	    windowid = *((short *) cp);
	    printf("HideWindow %d\n", windowid);
	    break;
	  case GF_ShowWindow:
	    windowid = *((short *) cp);
	    printf("ShowWindow %d\n", windowid);
	    break;
	  case GF_SelectWindow:
	    windowid = *((short *) cp);
	    printf("SelectWindow %d\n", windowid);
	    break;
	  case GF_SendBehind:
	    windowid = *((short *) cp)++;
	    windowid2 = *((short *) cp);
	    printf("SendBehind %d %d\n", windowid, windowid2);
	    break;
	  case GF_MoveWindow:
	    windowid = *((short *)cp)++;
	    printf("MoveWindow %d %d %d %d\n", windowid, ((short *) cp)[0],
		   ((short *) cp)[1], ((short *) cp)[2]);
	    break;
	  case GF_SizeWindow:
	    windowid = *((short *) cp)++;
	    printf("SizeWindow %d %d %d %d\n", windowid, ((short *) cp)[0],
		   ((short *) cp)[1], ((short *) cp)[2]);
	    break;
	  case GF_ZoomWindow:
	    windowid = *((short *) cp)++;
	    rect = ((Rect *)cp)++;
	    printf("ZoomWindow %d %d ", windowid, *((short *) cp));
	    dumprect(rect);
	    break;

	  case GF_IconifyWindow:
	    windowid = *((short *) cp)++;
	    printf("IconifyWindow %d\n", windowid);
	    break;

	  case GF_UnIconifyWindow:
	    windowid = *((short *) cp)++;
	    printf("UnIconifyWindow %d\n", windowid);
	    break;

	  case GF_Notify:
	    windowid = *((short *) cp)++;
	    printf("Notify %d %d", windowid, *(short *) cp);
	    break;

	  case GF_WindowStyle:
	    printf("WindowStyle %d\n", *((short *) cp));
	    break;

	  case GF_GetWPtr:
	    windowid = *((short *) cp);
	    printf("GetWPtr %d\n", windowid);
	    break;

	  case GF_BeginUpdate:
	    windowid = *((short *) cp);
	    printf("BeginUpdate %d\n", windowid);
	    break;
	  case GF_BeginUpdateRect:
	    windowid = *((short *) cp)++;
	    printf("BeginUpdateRect %d ", windowid);
	    dumprect((Rect *) cp);
	    break;
	  case GF_EndUpdate:
	    windowid = *((short *) cp);
	    printf("EndUpdate %d\n", windowid);
	    break;
	  case GF_InvalRect:
	    printf("InvalRect ");
	    dumprect((Rect *)cp);
	    break;
	  case GF_ValidRect:
	    printf("ValidRect ");
	    dumprect((Rect *)cp);
	    break;
	  case GF_SetPort:
	    windowid = *((short *) cp);
	    printf("SetPort %d\n", windowid);
	    break;
	  case GF_SetPorts:
	    windowid = *((long *) cp);
	    printf("SetPorts $%08X\n", windowid);
	    break;
	  case GF_SetOrigin:
	    printf("SetOrigin %d %d\n", ((short *)cp)[0], ((short *)cp)[1]);
	    break;
	  case GF_ClipRect:
	    printf("ClipRect ");
	    dumprect((Rect *)cp);
	    break;
	  case GF_ClipRectSect:
	    printf("ClipRectSect ");
	    dumprect((Rect *)cp);
	    break;
	  case GF_ClipRectUnion:
	    printf("ClipRectUnion ");
	    dumprect((Rect *)cp);
	    break;
	  case GF_ClipRectDiff:
	    printf("ClipRectDiff ");
	    dumprect((Rect *)cp);
	    break;
	  case GF_ClipRectXor:
	    printf("ClipRectXor ");
	    dumprect((Rect *)cp);
	    break;
	  case GF_BackPat:
	    printf("BackPat ");
	    dumppat2(cp);
	    break;
	  case GF_InitCursor:
	    printf("InitCursor\n");
	    break;
	  case GF_SetCursor:
	    printf("SetCursor\n");
/*	    wcb->mousecursor = *((Cursor *)cp); */
	    break;
	  case GF_HideCursor:
	    printf("HideCursor\n");
	    break;
	  case GF_ShowCursor:
	    printf("ShowCursor\n");
	    break;
	  case GF_ObscureCursor:
	    printf("ObscureCursor\n");
	    break;
	  case GF_ShieldCursor:
	    rect = ((Rect *)cp)++;
	    printf("ShieldCursor %d %d ",((short *)cp)[0],((short *)cp)[1]);
	    dumprect(rect);
	    break;
	  case GF_PlotIcon:
	    printf("PlotIcon "); /* (Icon *)(cp+sizeof(Rect)) */
	    dumprect((Rect *)cp);
	    break;
	  case GF_ScreenRes:
	    printf("ScreenRes\n");
	    break;
	  case GF_GetPen:
	    printf("GetPen\n");
	    break;
	  case GF_GetPenState:
	    printf("GetPenState\n");
	    break;
	  case GF_SetPenState:
	    printf("SetPenState ");
/*	    dumppenstate((PenState *)cp); /*  */
	    break;
	  case GF_PenSize:
	    printf("PenSize %d %d\n", ((short *) cp)[0], ((short *) cp)[1]);
	    break;
	  case GF_PenMode:
	    printf("PenMode %d\n", *((short *) cp));
	    break;
	  case GF_PenPat:
	    printf("PenPat ");
	    dumppat2(cp);
	    break;
	  case GF_PenNormal:
	    printf("PenNormal\n");
	    break;
	  case GF_MoveTo:
	    printf("MoveTo %d %d\n", ((short *) cp)[0], ((short *) cp)[1]);
	    break;
	  case GF_Move:
	    printf("Move %d %d\n", ((short *) cp)[0], ((short *) cp)[1]);
	    break;
	  case GF_LineTo:
	    printf("LineTo %d %d\n", ((short *) cp)[0], ((short *) cp)[1]);
	    break;
	  case GF_Line:
	    printf("Line %d %d\n", ((short *) cp)[0], ((short *) cp)[1]);
	    break;
	  case GF_GetPixel:
	    printf("GetPixel\n");
	    break;
	  case GF_SetPixel:
	    printf("SetPixel %d %d\n", ((short *) cp)[0], ((short *) cp)[1]);
	    break;
	  case GF_TextFont:
	    printf("TextFont %d\n", *((short *) cp));
	    break;
	  case GF_TextFace:
	    printf("TextFace $%X\n", *((short *) cp));
	    break;
	  case GF_TextSize:
	    printf("TextSize %d\n", *((short *) cp));
	    break;
	  case GF_TextMode:
	    printf("TextMode %d\n", *((short *) cp));
	    break;
	  case GF_TextRotate:
	    printf("TextRotate %d\n", *((short *) cp));
	    break;
	  case GF_SpaceExtra:
	    printf("SpaceExtra $%04X.04X\n", ((unsigned short *) cp)[0],
		   ((unsigned short *) cp)[1]);
	    break;
	  case GF_TextExtra:
	    printf("TextExtra $%04X.04X\n",  ((unsigned short *) cp)[0],
		   ((unsigned short *) cp)[1]);
	    break;
	  case GF_DrawText:
	    len = *((short *) cp)++;
	    printf("DrawText \"%.*s\"\n", len, (char *)cp);
	    break;
	  case GF_TextWidth:
	    len = *((short *) cp)++;
	    printf("TextWidth \"%.*s\"\n", len, (char *)cp);
	    break;
	  case GF_GetFontInfo:
	    printf("GetFontInfo\n");
	    break;
	  case GF_ForeColor:
	    printf("ForeColor %d\n", *(short *) cp);
	    break;
	  case GF_BackColor:
	    printf("BackColor %d\n", *(short *) cp);
	    break;
	  case GF_ColorBit:
	    printf("ColorBit %d\n", *(short *) cp);
	    break;
	  case GF_SetRGBColor:
	    {
		unsigned short index, red, green, blue;
		index = *((unsigned short *) cp)++;
		red = *((unsigned short *) cp)++;
		green = *((unsigned short *) cp)++;
		blue = *((unsigned short *) cp)++;
		printf("SetRGBColor %d R=%d G=%d B=%d\n", index,
		       red, green, blue);
	    }
	    break;
	  case GF_FrameRect:
	    printf("FrameRect ");
	    dumprect((Rect *) cp);
	    break;
	  case GF_PaintRect:
	    printf("PaintRect ");
	    dumprect((Rect *) cp);
	    break;
	  case GF_EraseRect:
	    printf("EraseRect ");
	    dumprect((Rect *) cp);
	    break;
	  case GF_InvertRect:
	    printf("InvertRect ");
	    dumprect((Rect *) cp);
	    break;
	  case GF_FillRect:
	    printf("FillRect ");
	    dumprect2((Rect *) &cp[sizeof(short)]);
	    dumppat(cp);
	    break;
	  case GF_FrameOval:
	    printf("FrameOval ");
	    dumprect((Rect *) cp);
	    break;
	  case GF_PaintOval:
	    printf("PaintOval ");
	    dumprect((Rect *) cp);
	    break;
	  case GF_EraseOval:
	    printf("EraseOval ");
	    dumprect((Rect *) cp);
	    break;
	  case GF_InvertOval:
	    printf("InvertOval ");
	    dumprect((Rect *) cp);
	    break;
	  case GF_FillOval:
	    printf("FillOval ");
	    dumprect2((Rect *) &cp[sizeof(short)]);
	    dumppat(cp);
	    break;
	  case GF_FrameRoundRect:
	    printf("FrameRoundRect %d %d ",
		   ((short *) (cp + sizeof(Rect)))[0],
		   ((short *) (cp + sizeof(Rect)))[1]);
	    dumprect((Rect *) cp);
	    break;
	  case GF_PaintRoundRect:
	    printf("PaintRoundRect %d %d ",
		   ((short *) (cp + sizeof(Rect)))[0],
		   ((short *) (cp + sizeof(Rect)))[1]);
	    dumprect((Rect *) cp);
	    break;
	  case GF_EraseRoundRect:
	    printf("EraseRoundRect %d %d ",
		   ((short *) (cp + sizeof(Rect)))[0],
		   ((short *) (cp + sizeof(Rect)))[1]);
	    dumprect((Rect *) cp);
	    break;
	  case GF_InvertRoundRect:
	    printf("InvertRoundRect %d %d ",
		   ((short *) (cp + sizeof(Rect)))[0],
		   ((short *) (cp + sizeof(Rect)))[1]);
	    dumprect((Rect *) cp);
	    break;
	  case GF_FillRoundRect:
	    x = *((short *) cp)++; /* Width. */
	    y = *((short *) cp)++; /* Height. */
	    printf("FillRoundRect %d %d ", x, y);
	    dumprect2((Rect *) &cp[sizeof(short)]);
	    dumppat(cp);
	    break;
	  case GF_FrameArc:
	    printf("FrameArc %d %d ",
		   ((short *) (cp + sizeof(Rect)))[0],
		   ((short *) (cp + sizeof(Rect)))[1]);
	    dumprect((Rect *) cp);
	    break;
	  case GF_FrameWedge:
	    printf("FrameWedge %d %d ",
		   ((short *) (cp + sizeof(Rect)))[0],
		   ((short *) (cp + sizeof(Rect)))[1]);
	    dumprect((Rect *) cp);
	    break;
	  case GF_PaintArc:
	    printf("PaintArc %d %d ",
		   ((short *) (cp + sizeof(Rect)))[0],
		   ((short *) (cp + sizeof(Rect)))[1]);
	    dumprect((Rect *) cp);
	    break;
	  case GF_EraseArc:
	    printf("EraseArc %d %d ",
		   ((short *) (cp + sizeof(Rect)))[0],
		   ((short *) (cp + sizeof(Rect)))[1]);
	    dumprect((Rect *) cp);
	    break;
	  case GF_InvertArc:
	    printf("InvertArc %d %d ",
		   ((short *) (cp + sizeof(Rect)))[0],
		   ((short *) (cp + sizeof(Rect)))[1]);
	    dumprect((Rect *) cp);
	    break;
	  case GF_FillArc:
	    x = *((short *) cp)++; /* Width. */
	    y = *((short *) cp)++; /* Height. */
	    printf("FillArc %d %d ", x, y);
	    dumprect2((Rect *) &cp[sizeof(short)]);
	    dumppat(cp);
	    break;
	  case GF_ScrollRect:
	    rect = ((Rect *)cp)++;
	    printf("ScrollRect %d %d %d ", ((short *) cp)[0],
		   ((short *) cp)[1], ((short *) cp)[2]);
	    dumprect(rect);
	    break;
	  case GF_CopyBits:
	  case GF_CopyBits2:
	    doCopyBits((char *) cp);
	    break;
	    
	  case GF_FramePoly:
	    printf("FramePoly ");
	    apoly = (PolyPtr) cp;
	    dumppoly(&apoly);
	    break;

	  case GF_PaintPoly:
	    printf("PaintPoly ");
	    apoly = (PolyPtr) cp;
	    dumppoly(&apoly);
	    break;

	  case GF_ErasePoly:
	    printf("ErasePoly ");
	    apoly = (PolyPtr) cp;
	    dumppoly(&apoly);
	    break;

	  case GF_InvertPoly:
	    printf("InvertPoly ");
	    apoly = (PolyPtr) cp;
	    dumppoly(&apoly);
	    break;

	  case GF_FillPoly:
	    printf("FillPoly ");
	    if ((i = validpat(*((short *) cp)++)) >= 0)
		printf("Pat #%d ", i);
	    else {
		printf("Pat ");
		for (i=0; i<sizeof(Pattern); i++)
		    printf("%02X", *cp++);
	    }
	    printf(" ");
	    apoly = (PolyPtr) cp;
	    dumppoly(&apoly);
	    break;

	  case GF_BeginRegion:
	    printf("BeginRegion\n");
	    break;

	  case GF_MoreRegion:
	    printf("MoreRegion\n");
	    break;

	  case GF_FrameRgn:
	    printf("FrameRgn\n");
	    break;

	  case GF_PaintRgn:
	    printf("PaintRgn\n");
	    break;

	  case GF_EraseRgn:
	    printf("EraseRgn\n");
	    break;

	  case GF_InvertRgn:
	    printf("InvertRgn\n");
	    break;

	  case GF_FillRgn:
	    printf("FillRgn ");
	    if ((i = validpat(*((short *) cp)++)) >= 0)
		printf("Pat #%d ", i);
	    else {
		printf("Pat ");
		for (i=0; i<sizeof(Pattern); i++)
		    printf("%02X", *cp++);
	    }
	    printf("\n");
	    break;

	  case GF_SetClip:
	    printf("SetClip\n");
	    break;

	  case GF_SetClipSect:
	    printf("SetClipSect\n");
	    break;

	  case GF_SetClipUnion:
	    printf("SetClipUnion\n");
	    break;

	  case GF_SetClipDiff:
	    printf("SetClipDiff\n");
	    break;

	  case GF_SetClipXor:
	    printf("SetClipXor\n");
	    break;

	  case GF_InvalRgn:
	    printf("InvalRgn\n");
	    break;

	  case GF_ValidRgn:
	    printf("ValidRgn\n");
	    break;

	  case GF_DrawText16:
	    len = *((short *) cp)++;
	    printf("DrawText16 %d\n", len);
	    break;
	    
	  case GF_TextWidth16:
	    len = *((short *) cp)++;
	    printf("TextWidth16 %d\n", len);
	    break;
	    
	  case GF_HiliteRect:
	    printf("HiliteRect ");
	    if ((i = validpat(*((short *) cp)++)) >= 0) {
		printf("%d %d ", *(short *) (cp+sizeof(Rect)), i);
		dumprect((Rect *)cp);
	    } else {		/* Explicit pattern passed. */
		printf("%d ", *(short *) (cp+sizeof(Rect)+sizeof(Pattern)));
		dumprect2((Rect *)cp);
		dumppat((Pattern *) (cp+sizeof(Rect)));
	    }
	    break;
	    
	  case GF_HiliteClear:
	    printf("HiliteClear\n");
	    break;
	    
	  case GF_GetHdwrType:
	    printf("GetHdwrType\n");
	    break;

	  case GF_GetWManVrsns:
	    printf("GetWManVrsns\n");
	    break;

	  case GF_GetUserTime:
	    printf("Getusertime\n");
	    break;

	  case GF_SetKbdLEDs:
	    i = *((short *) cp)++;
	    printf("SetKbdLEDs %d\n", i);
	    break;

	  case GF_SetKbdXlate:
	    printf("SetKbdXlate %d\n", *(short *) cp);
	    break;

	  case GF_TextWidHit:
	    len = *((short *) cp)++;
	    i = *((short *) cp)++;
	    printf("TextWidHit %d \"%*.s\"\n", i, len, cp);
	    break;
	    
	  case GF_TextWidths:
	    {
		short startoff, endoff;
		startoff = *((short *) cp)++;
		endoff = *((short *) cp)++;
		printf("TextWidths \"%*.s\" \"%*.s\"\n", startoff, cp,
		       endoff - startoff, cp + startoff);
	    }
	    break;
	  case GF_DrawGrowIcon:
	    windowid = *((short *) cp)++;
	    printf("DrawGrowIcon %d\n", windowid);
	    break;
	    
	  case GF_Bell:
	    printf("Bell\n");
	    break;

	  case GF_DrawJustText:
	    {
		short hflag, vflag, count;
		
		hflag = *((short *) cp)++;
		vflag = *((short *) cp)++;
		rect = ((Rect *)cp)++;
		count = *((short *) cp)++;
		printf("DrawJustText %d %d \"%.*s\" ", hflag, vflag,
		       count, cp);
		dumprect(rect);
	    }
	    break;
	  case GF_SetApplCursor:
	    printf("SetApplCursor\n");
	    break;
	  case GF_MoveApplCursor:
	    x = *((short *) cp)++;
	    y = *((short *) cp)++;
	    printf("MoveApplCursor %d %d\n", x, y);
	    break;
	  case GF_HideApplCursor:
	    printf("HideApplCursor\n");
	    break;
	  case GF_ShowApplCursor:
	    printf("ShowApplCursor\n");
	    break;
	  case GF_NewMenu:
	    printf("NewMenu %d \"%s\"\n", *((short *)cp), (char *)&cp[2]);
	    break;
	  case GF_DisposeMenu:
	    printf("DisposeMenu %d\n", *((short *)cp));
	    break;
	  case GF_DisableMenu:
	    printf("DisableMenu %d\n", *((short *)cp));
	    break;
	  case GF_EnableMenu:
	    printf("EnableMenu %d\n", *((short *)cp));
	    break;
	  case GF_AppendMenu:
	    printf("AppendMenu %d \"%s\"\n", *((short *)cp), (char *)&cp[2]);
	    break;
	  case GF_DeleteMenu:
	    printf("DeleteMenu %d\n", *((short *)cp));
	    break;
	  case GF_BeginMenu:
	    printf("BeginMenu %d\n", *((short *)cp));
	    break;
	  case GF_EndMenu:
	    printf("EndMenu %d\n", *((short *)cp));
	    break;
	  case GF_NoMenuKeyXlate:
	    printf("NoMenuKeyXlate\n");
	    break;
	  case GF_SetItem:
	    printf("SetItem %d %d \"%s\"\n", *((short *)cp), ((short *)cp)[1],
		   (char *)&cp[4]);
	    break;
	  case GF_SetItemMark:
	    printf("SetItemMark %d %d %d\n", *((short *)cp),
		   ((short *)cp)[1], ((short *)cp)[2]);
	    break;
	  case GF_DisableItem:
	    printf("DisableItem %d %d\n", *((short *)cp), ((short *)cp)[1]);
	    break;
	  case GF_EnableItem:
	    printf("EnableItem %d %d\n", *((short *)cp), ((short *)cp)[1]);
	    break;
	  case GF_SetItemStyle:
	    printf("SetItemStyle %d %d %d\n", *((short *)cp),
		   ((short *)cp)[1], ((short *)cp)[2]);
	    break;
	  case GF_SetItemKey:
	    printf("SetItemKey %d %d $%08X\n", *((short *)cp),
		   ((short *)cp)[1], ((long *)cp)[1]);
	    break;
	    
	  case GF_GetMenuFlash:
	    printf("GetMenuFlash\n");
	    break;

	  case GF_GetDblClickTime:
	    printf("GetDblClickTime\n");
	    break;

	  case GF_SoundBite:
	    len = *((short *) cp)++;
	    printf("SoundBite \"%*.s\"\n", len, cp);
	    break;

	  case GF_PicComment:
	    printf("PicComment\n");
	    break;

	  default:
	    printf("Unknown! (%d)\n", fc);
	    break;
	}
	cp = cp0;
    }
    return size;
}

dumpwmint(buf, size)
unsigned char *buf;
int size;
{
    hd(buf, size, 0);
    return size;
}

dumprect(rp)
Rect *rp;
{
    printf("T=%d L=%d B=%d R=%d\n", rp->edge.top, rp->edge.left,
	   rp->edge.bottom, rp->edge.right);
}

dumprect2(rp)
Rect *rp;
{
    printf("T=%d L=%d B=%d R=%d ", rp->edge.top, rp->edge.left,
	   rp->edge.bottom, rp->edge.right);
}

validpat(i)
int i;
{
    if (i >= 0 && i < 256) {	/* For built-in pattern? */
	if (i >= 64) {		/* Also range-check it. */
	    i = 0;
	}
    }
    return i;
}

static void
dumppat(cp)
unsigned char *cp;
{
    short i;

    if ((i = validpat(*((short *) cp)++)) >= 0)
	printf("Pat #%d\n", i);
    else {
	cp += sizeof(Rect);
	printf("Pat ");
	for (i=0; i<sizeof(Pattern); i++) {
	    printf("%02X", *cp++);
	}
	printf("\n");
    }
}


static void
dumppat2(cp)
unsigned char *cp;
{
    short i;

    if ((i = validpat(*((short *) cp)++)) >= 0)
	printf("Pat #%d\n", i);
    else {
	printf("Pat ");
	for (i=0; i<sizeof(Pattern); i++) {
	    printf("%02X", *cp++);
	}
	printf("\n");
    }
}

doCopyBits(cp)
char *cp;
{
    int mode, width;
    Rect *srect, *drect;

    mode = *((short *) cp)++;
    width = *((short *) cp)++;
    srect = ((Rect *) cp)++;
    drect = ((Rect *) cp)++;
    printf("CopyBits ");
    if (mode & 256)
	printf("(packed) ");
    dumprect2(srect);
    printf(" to ");
    dumprect2(drect);
    printf(" width %d, mode %d\n", width, mode & 255);
}

dumpevent(ep)
EventRecord *ep;
{
    printf("who: %d, what: %d, msg: $%08X, when: %d, ", ep->who, ep->what,
	   ep->message, ep->when);
    dumprect(&ep->where);
}

dumppoly(pp)
PolyPtr pp;
{
    printf("\n");
}
