|
| Subroutine to calculate the IP checksum, from RFC 1071
|
| short ipcksum(register void *sp, register int bytecnt);
|
	.globl _ipcksum

_ipcksum:
	moveml <d2,d3>,-(sp)
	rorl #1,d1		| Get # of shorts, and save even/odd bit.
	subl d0,d0		| Clears both D0 and X bit.
	bras $1

$2:	movw (a1)+,d2		| Ones-complement addition of shorts.
	addxw d2,d0
$1:	dbra d1,$2
	clrw d2			| Handle final carry, if any.
	addxw d2,d0

	lsll #1,d1		| One byte left?
	bccs $3			| Probably done at this point.

	movb (a1)+,d2		| Ones-complement addition of final byte.
	rolw #8,d2		| (Put it in correct column [big-endian].)
	addw d2,d0
	bccs $3			| Handle final carry, if any.
	addqw #1,d0

$3:	moveml (sp)+,<d2,d3>
	notw d0
	rts

	.end
