/*
** Parse the output from a Verilog simulation and put it into a
** sniffer packet file.  More-or-less equivalent to Verilog's
** $readmemh system task, or an inverse hd program.
*/

#include <stdio.h>

char *progname;
int lineno, comline;

error(chr)
int chr;
{
    fprintf(stderr, "%s: Syntax error in line %d, '%c'\n",
	    progname, lineno, chr);
    exit(1);
}

main(argc, argv)
int argc;
char *argv[];
{
    int ii, jj, kk, comment;
    char cc;

    progname = argv[0];
    comment = 0;
    lineno = 1;
    jj = 0;
    while ((ii = getchar()) >= 0) {
	if (ii == '\r' || ii == ' ' || ii == '_')
	    continue;
	if (ii == '\n')
	    lineno++;

	switch (comment) {
	  case 0:
	    if (ii == '/') {
		if ((ii = getchar()) == '/')
		    comment = 2;
		else if (ii == '*') {
		    comment = 1;
		    comline = lineno;
		} else
		    error(ii);
	    } else if (ii >= '0' && ii <= '9'
		       || ii >= 'A' && ii <= 'F'
		       || ii >= 'a' && ii <= 'f') {
		if (ii > '9')
		    ii = (ii & 0x0F) + 9;
		else
		    ii = ii & 0x0F;
		if (!jj)
		    kk = ii << 4;
		else {
		    kk = kk | ii;
		    putchar(kk);
		}
		jj = !jj;
	    } else if (ii != '\n')
		error(ii);
	    break;

	  case 1:
	    if (ii == '*') {
		if ((ii = getchar()) == '/')
		    comment = 0;
		else
		    ungetc(ii, stdin);
	    }
	    break;

	  case 2:
	    if (ii == '\n')
		comment = 0;
	    break;
	}
    }
    if (comment == 1) {
	fprintf(stderr, "%s: Unclosed comment begun in line %d\n",
		progname, comline);
	exit(2);
    }
    return 0;
}
