/*
** Bits set to indicate control code:
*/
#define		CONTROL		0xC0

/*
** Window line device id  bits:
*/
#define		KBD_ID		0x00
#define		VAL_ID		0x10
#define		DOC_ID		0x20
#define		SRW_ID		0x30
#define		SDO_ID		0x18
#define		PIN_ID		0x08
#define		AUX_ID		0x20
#define		DEVICE		0x38 

/*
** Sub codes for keyboard subdevices:
*/
#define		KB_SWR		0xB4
#define		KB_PIN		0xB2
#define		NO_SUB		0
#define		KB_MAG_STATUS	0xB5	/* status of card reader */

/*
** Control codes:
*/
#define		STX		0x0
#define		ETX		0x1
#define		RESET		0x2
#define		RESYNC		0x3
#define		ACK		0x4
#define		PNM_REQ		0x5
#define		CODE		0x7	

/*
**	Doc Printer data message types:
*/
#define	PRT_HDR_LR	0xB1	/* Print header left/right */
#define	PRT_HDR_AX	0xB2	/* Print header aux */
#define	PRT_DATA_LR	0xB3	/* Print data left/right */
#define	PRT_DATA_AX	0xB4	/* Print data aux */
#define	AX_REQ_OK	0xB5	/* Aux request OK */
#define AX_REQ_NOK	0xB6	/* Aux request not OK */
#define	SIG_HDR_LR	0xB7	/* Signature header left/right */
#define	SIG_HDR_AX	0xB8	/* Signature header aux */
#define	SIG_DATA_LR	0xB9	/* Signature data left/right */
#define	SIG_DATA_AX	0xBA	/* Signature data aux */
#define	IDENTIFY_LR	0xBB	/* Identify left/right */
#define	IDENTIFY_AX	0xBC	/* Identify aux */

/*
**	Doc Printer vertical tab commands
*/
#define	DN_LINES	0x80	/* Vertical tab down x lines */
#define	UP_LINES	0x81	/* Vertical tab up x lines */
#define	DN_STEPS	0x82	/* Vertical tab down x steps */
#define UP_STEPS	0x83	/* Vetrical tab up x steps */

/*
**	Doc_hdr array defines
*/
#define	LR	0		/* L/R teller doc_hdr array index */
#define AX	1		/* Aux teller doc_hdr array index */

/*
** keyboard conversation
**
** keyboard => processor
*/
#define	KBD_STATUS_START 0xB1	/* start of keyboard status data */
#define	KBD_EXPANDED	 0xBF	/* indicate the following data */
										/* is and expanded-set packed		*/
/*
** keyboard status byte bit definitions
** byte one of the two byte status
*/
#define	KBD_SUPV_KEY 5		/* bit supervisor key flag */
#define	KBD_KEY1 5		/* locking type key #1 */
#define	KBD_KEY2 4		/* locking type key #2 */
#define	KBD_KEY3 3		/* locking type key #3 */
#define	KBD_KEY4 2		/* locking type key #4 */

/*
** keyboard status byte bit definitions
** byte two of the two byte status
*/
#define	KBD_CAP_LOCK 6		/* bit cap lock key flag */
#define KBD_ALT 3		/* bit alt key flag */
#define	KBD_CTRL 2		/* bit control key flag */
#define	KBD_LSHIFT 1		/* bit left shift key flag */
#define	KBD_RSHIFT 0		/* bit right shift key flag */
#define KBD_ANY_SHIFTS 0xF	/* kbd shift key mask */

/*
** pin pad 
*/
#define	PIN_DATA_START 0xB2	/* pin pad data starting byte */

/*
** shared reader/writer
*/
#define MAG_READ_START 0xB4	/* start of mag card read data */
#define	MAG_READ_ERROR 0xB5	/* start of mag card read error */
#define	MAG_TIMEOUT 'T'		/* mag card timeout error code */
#define	MAG_PARITY 'P'		/* mag card parity error code */
#define	MAG_LRC 'L'		/* mag card lrc error code */
#define MAG_INVAL 0x0E
#define MAG_AOK 0x0B
#define MAG_ERR 0x0C

/*
** keyboard mag card reader track selection codes...
** these codes are sent to the device...
*/
#define		KBD_TRK_DEFAULT	0x10	
#define		KBD_TRK_1		0x11
#define		KBD_TRK_2		0x12
#define		KBD_TRK_3		0x13
/*
** keyboard magnetic card reader status value
*/
#define		KB_MAG_TIMEOUT		0x54
#define		KB_MAG_PARITY		0x50
#define		KB_MAG_LRC		0x4C
#define		KB_MAG_BAD_TRK		0x57
#define		KB_MAG_OK_TRK		0x59


/*
** pnm keyboard codes
*/
#define	PNM_START_RSP 0xBE	/* start of pnm response */
#define	PNM_LEN_PN 11		/* length of firmware part number */
#define	PNM_NUM_ROT 2		/* number of rotary switches (max) */
#define	PNM_LEN_PERIPHERAL_STS	2 /* length of perifperal status */
#define	PNM_LEN_FUTURE 8	/* number of bytes left for future */
				/* expansion if needed */


/*
** keyboard conversation
**
** processor => keyboard 
*/
#define	KBD_BELL 0xA		/* beeper 1 to 10 = number of */
										/* tenths of a second to ring bell	*/
#define KBD_PNM_REQUEST 0xC5	/* pnm request code */
#define	KBD_STS_REQUEST 'S'	/* status request */
#define	KBD_MODE_STAND 0x21	/* set standard mode request */
#define	KBD_MODE_EXTEND 0x22	/* set extended mode request */
