/*
**
** Test the graphics library.
**
*/

#include <stdio.h>
#include <isc/window.h>
#include <isc/keycodes.h>

#define WIDTH (420)		/* Window definitions. */
#define HIGTH (275)

int loopcnt;
int xpos = 50;
int ypos = 50;
char *path;

int current;
Rect winrect;

#define fgpattern ((Pattern *)15)
#define bgpattern ((Pattern *)40)

void updateevent();
void keyevent();

main(argc, argv)
int argc;
char *argv[];
{
    int i, j;
    int trapqfd, fd;
    int window;
    char *argp;

    while (--argc > 0) {
	argp = *++argv;
	if (*argp == '-') {
	    argp++;
	    switch (*argp++) {
	      case 'x':
		xpos = atoi(argp);
		break;
	      case 'y':
		ypos = atoi(argp);
		break;
	      case 'l':
		loopcnt = atoi(argp);
		break;
	    }
	} else {
	    path = argp;
	}
    }

    if ((trapqfd = InitGraf()) < 0) { /* Initialize graphics toolbox. */
/*	fprintf(stderr,"Error %d in GrafInit\n",-trapqfd); /*  */
	exit(1);
    }
    if ((fd = ConnectGraf(path)) < 0) {	/* Initialize graphics toolbox. */
/*	fprintf(stderr,"Error %d in ConnectGraf\n",-fd); /*  */
	exit(1);
    }
    SetRect(&winrect, xpos, ypos, xpos+WIDTH, ypos+HIGTH);
    window = NewWindow(&winrect, "Test Window", hideWindow, documentProc, 
		       frontWindow, noOptions, fd);
    SetPort(window);
    BackPat(bgpattern);
    ShowWindow(window);
    BeginUpdate(window);	/* No initial update event. */
    EndUpdate(window);
    SetRect(&winrect, 0, 0, WIDTH, HIGTH);

    Event(updateEvt, updateevent);
    Event(keyEvt, keyevent);
    staticinfo();

    SetRect(&winrect, 50, 101, 300, HIGTH-21);
    if (loopcnt) {
	while (loopcnt-- > 0) {
	    if (CheckKey(window)) {
		break;
	    }
	    for (j = '0'; j < '3'; j++) {
		FillRect(&winrect, fgpattern);
		dynamicinfo(current = j);
	    }
	}
    } else {
	FillRect(&winrect, fgpattern);
	dynamicinfo(current = '0');
	GetEvent(anyWindow, noEvent);
    }
}

void
keyevent(ep)
EventRecord *ep;
{
    int key;

    if (ep->message & F_KEYUP)
	return;
    key = ep->message & F_KEYMASK;
    if (key == 'q' || key == 'Q')
	ReleaseEvent();
    else {
	FillRect(&winrect, fgpattern);
	dynamicinfo(current = key);
    }
}

void
updateevent(ep)
EventRecord *ep;
{
#if 0
    printf("Update event rect (%d, %d, %d, %d)\n",ep->where.edge.left,
	   ep->where.edge.top,ep->where.edge.right,ep->where.edge.bottom);
    fflush(stdout);
#endif

    BeginUpdate(ep->who);
    staticinfo();
    dynamicinfo(current);
    EndUpdate(ep->who);
}

staticinfo()
{
    Rect rect;

    SetRect(&rect, 140, 10, WIDTH-140, 40);
    FillRect(&rect, fgpattern);
    FrameRect(&rect);
    TextFont(8);
    TextSize(14);
    centerstr(&rect,"Menu Select");

    SetRect(&rect, 20, 40, 120, 80);
    FillRect(&rect, fgpattern);
    FrameRect(&rect);
    TextFont(7);
    TextSize(12);
    MoveTo(30,55);
    DrawString(" Teller ");
    MoveTo(30,70);
    DrawString(" Application ");

    SetRect(&rect, 20, 100, WIDTH-20, HIGTH-20);
    FillRect(&rect, fgpattern);
    FrameRect(&rect);
    TextFont(0);
}

dynamicinfo(select)
int select;
{
/*    TextExtra(Int2Fix(-1));	/*  */
    switch(select) {
      case '0':
	MoveTo(50,120);	DrawString("0)  SALES");
	MoveTo(50,140);	DrawString("1)  OPEN/SERVICE");
	MoveTo(50,160);	DrawString("2)  TELLER APPLICATIONS");
	MoveTo(50,180);	DrawString("3)  SALES");
	MoveTo(50,200);	DrawString("4)  OPEN/SERVICE");
	MoveTo(50,220);	DrawString("5)  TELLER APPLICATIONS");
	break;
      case '1':
	MoveTo(50,120);	DrawString("0)  INVESTMENT COUNSELOR");
	MoveTo(50,140);	DrawString("1)  DEPOSIT SERVICES");
	MoveTo(50,160);	DrawString("2)  CREDIT SERVICES");
	MoveTo(50,180);	DrawString("3)  RETIREMENT PLANS");
	MoveTo(50,200);	DrawString("4)  BUSINESS ACCOUNTS");
	MoveTo(50,220);	DrawString("5)  OTHER PRODUCTS");
	MoveTo(50,240);	DrawString("6)  ADMINISTRATIVE FUNCTIONS");
	break;
      case '2':
	MoveTo(50,120);	DrawString("0)  Cash Check");
	MoveTo(50,140);	DrawString("1)  Checking Deposit");
	MoveTo(50,160);	DrawString("2)  Savings Deposit");
	MoveTo(50,180);	DrawString("3)  Savings Withdrawal");
	MoveTo(50,200);	DrawString("4)  Money Exchange");
	break;
      default:
	MoveTo(50,120); DrawString("Select 0 - 2 or q to quit");
	break;
    }
    TextExtra(0);
}

centerstr(rect, string)
Rect *rect;
char *string;
{
    short width, height, startat;

    width = rect->edge.right - rect->edge.left;
    height = rect->edge.bottom - rect->edge.top;
    startat = rect->edge.left + width/2 - StringWidth(string)/2;
    MoveTo(startat, rect->edge.top + height/2 + 6);
    DrawString(string);
}
