/*
**
** Test the Text Editor.
**
*/
#include <stdio.h>
#include <errno.h>
#include <isc/window.h>
#include <isc/keycodes.h>
#include <isc/textedit.h>

#define	FIELDCOUNT	7
#define XWINL 0
#define XWINR 640
#define YWINT 25
#define YWINB 435

char	buffer[FIELDCOUNT][32000];		/* Text buffer. */
TERec	*tarray[FIELDCOUNT];
Rect	destRect[FIELDCOUNT],
	viewRect[FIELDCOUNT];
short	just[FIELDCOUNT];
short	crOnly[FIELDCOUNT];
short	autoView[FIELDCOUNT];
short	lineHeight[FIELDCOUNT];

short	tnumber;

TERec *terec;			/* Text edit record pointer. */

void doupdate(EventRecord *ep);			/* Event handling routines. */
void dokey(EventRecord *ep);
int doIkey();
void domouse(EventRecord *ep);
void doactivate(EventRecord *ep);

main(argc, argv)
int argc;
char *argv[];
{
    short i, wordbrk();
    int trapqfd, wmfd;
    int mywindow;
    char *sysid;
    Rect winrect;
    char	*text;
    FontInfo	finfo;

    sysid = 0;
    if (argc == 2)
	sysid = argv[1];

    /*
    **	Initialize the graphics toolbox.
    */

    if ((trapqfd = InitGraf()) < 0) {
	fprintf(stderr, "%s: Error %d in InitGraf().\n", 
		argv[0], -trapqfd);
	exit(1);
    }

    /*
    **	Establish a connection to a window manager.
    */

    if ((wmfd = ConnectGraf(sysid)) < 0) {
	fprintf(stderr, "%s: Error %d in ConnectGraf().\n", 
		argv[0], -wmfd);
	exit(1);
    }

    SetRect(&winrect, XWINL, YWINT, XWINR, YWINB);
    mywindow = NewWindow(&winrect, "Text Editor Test",
			       showWindow, dBoxProc, frontWindow, 
			       noOptions, wmfd);

    SetPort(mywindow);
    if (mywindow < 0) {
	fprintf(stderr, "Window Create failed, errno=%d.\n", errno);
	exit(3);
    }
    tnumber = 0;

#if 0
    SetKbdXlate(1);		/* Ask for international keys. */
#endif

    Event(updateEvt, doupdate);
    Event(keyEvt, dokey);
    Event(mouseEvt, domouse);
    Event(activateEvt, doactivate);

    TEInit();

    tnumber = 0;
    SetRect(&destRect[tnumber], 10, 10, 630, 200);
    SetRect(&viewRect[tnumber], 10, 10, 630, 200);
    TextFont(0);
    /* Create text edit buffer. */
    tarray[tnumber] = TENew(&destRect[tnumber], &viewRect[tnumber]);
    autoView[tnumber] = 1;
    LocalGetFontInfo(theFont, theFace, theSize, &finfo);
    lineHeight[tnumber] = finfo.ascent + finfo.descent + finfo.leading;
    just[tnumber] = 0;
    TELeading(1, tarray[tnumber]);
    SetWordBreak(wordbrk, tarray[tnumber]);
    strcpy(buffer[tnumber],
	"F1  - Set a 30 line string\n"
	"F2  - TEGetText and TESetSelect\n"
	"F3  - Set a 1 line string\n"
	"F4  - Scroll up a line plus a pixel\n"
	"F5  - Scroll down a line plus a pixel\n"
	"F6  - Toggle left, center and right justification\n"
	"F7  - PINScroll up a line plus a pixel\n"
	"F8  - PINScroll down a line plus a pixel\n"
	"F9  - SetKbdXlate(0)\n"
	"F10 - SetKbdXlate(1)\n"
	"F11 - Toggle Carriage Return Only mode\n"
	"F12 - Toggle Auto View mode\n"
	"Now is the time for all good men to come to the aid of their country.\n"
    	"Line 1\nLine 2\nLine 3\nLine 4\nLine 5\nLine 6\nLine 7\nLine 8\nLine 9\nLine 10\nLine 11\nLine 12\nLine 13\nLine 14\nLine 15\nThe quick brown fox jumps over the lazy dog's back!\nTo restore the coordinates of the document to what they were before the ScrollRect, you can use the SetOrigin procedure.  In Figure 22, suppose that before the ScrollRect the top left corner of the document was at coordinates (100, 100)."
    	"  After ScrollRect(r, 10, 20...), the coordinates of the document are offset by the specified values.  You could call SetOrigin(90, 80) to offset the coordinate system to compensate for the scroll (see Figure 14 in the \"coordinates in GrafPorts\" section for an illustration)."
    	"  The document itself doesn't move as a result of SetOrigin, but the pen and clipRgn move down and to the right, and are restored to their original position relative to the document.  Notice that updateRgn will still need to be redrawn.\n");

    i = strlen(buffer[tnumber]);
    text = buffer[tnumber] + i;
    while (text + i < buffer[tnumber] + sizeof(buffer[tnumber])) {
	strncpy(text, buffer[tnumber], i);
	text += i;
	    *text = '\0';
    }

    TEAutoView(0, tarray[tnumber]);
    TESetText(buffer[tnumber], sizeof(buffer[tnumber]), tarray[tnumber]);
    TESetSelect(0, 0, tarray[tnumber]);
    TEAutoView(1, tarray[tnumber]);
    TESelView(tarray[tnumber]);

    /* second text edit field	*/
    tnumber++;
    TextFace(underlineText);
    LocalGetFontInfo(theFont, theFace, theSize, &finfo);
    lineHeight[tnumber] = finfo.ascent + finfo.descent;
    SetRect(&destRect[tnumber], 120, 210, 630, 210 + lineHeight[tnumber]); 
    SetRect(&viewRect[tnumber], 120, 210, 630, 210 + lineHeight[tnumber]);
    tarray[tnumber] = TENew(&destRect[tnumber], &viewRect[tnumber]);
	autoView[tnumber] = 1;
    just[tnumber] = 0;
    SetWordBreak(wordbrk, tarray[tnumber]);
    strcpy(buffer[tnumber], "This is a test of the emergency broadcast system.");
    TECROnly(1, tarray[tnumber]);
    crOnly[tnumber] = 1;
    TESetText(buffer[tnumber], 128, tarray[tnumber]); /* Put this string in. */

    /* third text edit field	*/
    tnumber++;
    TextFace(normalText);
    SetRect(&destRect[tnumber], 120, 238, 630, 252);
    SetRect(&viewRect[tnumber], 120, 238, 430, 252);
    tarray[tnumber] = TENew(&destRect[tnumber], &viewRect[tnumber]);
    autoView[tnumber] = 1;
    LocalGetFontInfo(theFont, theFace, theSize, &finfo);
    lineHeight[tnumber] = finfo.ascent + finfo.descent + finfo.leading;
    TESetJust(-1, tarray[tnumber]);
    just[tnumber] = -1;
    SetWordBreak(wordbrk, tarray[tnumber]);
    strcpy(buffer[tnumber],
	"This is a right entry test of the emergency broadcast system.");
    TECROnly(1, tarray[tnumber]);
    crOnly[tnumber] = 1;
    TESetText(buffer[tnumber], 128, tarray[tnumber]); /* Put this string in. */

    /* fourth text edit field	*/
    tnumber++;
    TextFont(5);
    TextSize(9);
    SetRect(&destRect[tnumber], 10, 265, 110, 350);
    SetRect(&viewRect[tnumber], 10, 265, 110, 350);
    tarray[tnumber] = TENew(&destRect[tnumber], &viewRect[tnumber]);
    autoView[tnumber] = 1;
    LocalGetFontInfo(theFont, theFace, theSize, &finfo);
    lineHeight[tnumber] = finfo.ascent + finfo.descent + finfo.leading;
    just[tnumber] = 0;
    SetWordBreak(wordbrk, tarray[tnumber]);
    strcpy(buffer[tnumber], "This stuff is cramped into a narrow rectangle.");
    TESetText(buffer[tnumber], 128, tarray[tnumber]); /* Put this string in. */

    /* fifth text edit field    */
    tnumber++;
    TextFont(2);
    TextSize(18);
    TextFace(italicText);
    SetRect(&destRect[tnumber], 125, 260, 625, 354);
    SetRect(&viewRect[tnumber], 120, 265, 630, 349);
    tarray[tnumber] = TENew(&destRect[tnumber], &viewRect[tnumber]);
    autoView[tnumber] = 1;
    LocalGetFontInfo(theFont, theFace, theSize, &finfo);
    lineHeight[tnumber] = finfo.ascent + finfo.descent + finfo.leading;
    just[tnumber] = 0;
    SetWordBreak(wordbrk, tarray[tnumber]);
    strcpy(buffer[tnumber],
	"This destRect is taller and narrower than the viewRect\n"
    	"Press ESC to exit\n\n");
    TESetText(buffer[tnumber], 4096, tarray[tnumber]); /* Put this string in. */

    /* sixth text edit field	*/
    tnumber++;
    TextFont(0);
    TextSize(12);
    TextFace(normalText);
    SetRect(&destRect[tnumber], 10, 375, 360, 400);
    SetRect(&viewRect[tnumber], 15, 370, 355, 405);
    tarray[tnumber] = TENew(&destRect[tnumber], &viewRect[tnumber]);
    autoView[tnumber] = 1;
    LocalGetFontInfo(theFont, theFace, theSize, &finfo);
    lineHeight[tnumber] = finfo.ascent + finfo.descent + finfo.leading;
    just[tnumber] = 0;
    SetWordBreak(wordbrk, tarray[tnumber]);
    strcpy(buffer[tnumber],
	"This destRect is shorter and wider than the viewRect\n");
    TESetText(buffer[tnumber], 4096, tarray[tnumber]); /* Put this string in. */

    /* seventh text edit field	*/
    tnumber++;
    TextFont(8);
    TextSize(14);
    TextFont(italicText);
    SetRect(&destRect[tnumber], 370, 370, 630, 405);
    SetRect(&viewRect[tnumber], 370, 370, 630, 405);
    tarray[tnumber] = TENew(&destRect[tnumber], &viewRect[tnumber]);
    autoView[tnumber] = 1;
    LocalGetFontInfo(theFont, theFace, theSize, &finfo);
    lineHeight[tnumber] = finfo.ascent + finfo.descent + finfo.leading;
    just[tnumber] = 0;
    SetWordBreak(wordbrk, tarray[tnumber]);
    strcpy(buffer[tnumber], "This rectangle is the bottom right one.\n");
    TESetText(buffer[tnumber], 4096, tarray[tnumber]); /* Put this string in. */

    TextFont(normalText);
    tnumber = 0;
    terec = tarray[0];
    (void) GetEvent(anyWindow, noEvent);
}

short
wordbrk(text, charPos)		/* Custom Text Edit word-break routine. */
char *text;
short charPos;
{
    if (text[charPos] == ' ' || text[charPos] == '/' || text[charPos] == '\n')
	return 1;
    return 0;
}


void dokey(ep)
EventRecord *ep;
{
    short key, i, j;
    Rect rect;

    if (ep->message & F_KEYUP)
	return;
    key = ep->message & F_KEYMASK;

    if (ep->message & F_FUNC) {
	if (key == '\t') {
	    TEDeactivate(tarray[tnumber]);
	    if (++tnumber >= FIELDCOUNT)
	    	tnumber = 0;
	    terec = tarray[tnumber];
		TEActivate(terec);
	} else if (key == K_ESC) {
	    for (i = 0; i < FIELDCOUNT; i++) {
		key = TEGetText(buffer[i], tarray[i]);
		buffer[i][key] = 0;
		if (key > 60)
		    buffer[i][60] = '\0';
		for (j = 0; j < 60; j++)
		    if (buffer[i][j] == '\n')
			buffer[i][j] = '\0';
		printf("buffer[%d] (%d chars):\n     '%s'\n",
		    i, key, buffer[i]);
	    }
	    exit(0);
	} else if (key == K_F1) {
	    static int x = 7;
	    puts("assigning 30 line string");
	    strcpy(buffer[tnumber], "Line 1\nLine 2\nLine 3\nLine 4\nLine 5\nLine 6\nLine 7\nLine 8\nLine 9\nLine 10\nLine 11\nLine 12\nLine 13\nLine 14\nLine 15\nLine 16\nLine 17\nLine 18\nLine 19\nLine 20\nLine 21\nLine 22\nLine 23\nLine 24\nLine 25\nLine 26\nLine 27\nLine 28\nLine 29\nLine 30");
	    TESetText(buffer[tnumber], sizeof(buffer[tnumber]), terec);
	    TESetSelect(7, x++, terec);
		TESelView(terec);
	} else if (key == K_F2) {
	    printf("TEGetText & TESetSelect\n");
	    key = TEGetText(buffer[tnumber], terec);
	    TESetSelect(0, 0, terec);
		TESelView(terec);
	} else if (key == K_F3) {
	    puts("assigning string");
	    strcpy(buffer[tnumber], "This is now different more.");
	    key = StringLen(buffer[tnumber]);
	    TESetText(buffer[tnumber], sizeof(buffer[tnumber]), terec);
	    TESetSelect(key - 5, key, terec);
/*	    TEUpdate(&viewRect[tnumber], terec); /*  */
InvalRect(&viewRect[tnumber]);
	} else if (key == K_F4) {
	    printf("scroll -(lineHeight[tnumber] + 1)\n");
	    TEScroll(0, -(lineHeight[tnumber] + 1), terec);
	} else if (key == K_F5) {
	    printf("scroll lineHeight + 1\n");
	    TEScroll(0, lineHeight[tnumber] + 1, terec);
	} else if (key == K_F6) {
	    if (just[tnumber] == 1)
		just[tnumber] = -1;
	    else
		just[tnumber]++;
	    TESetJust(just[tnumber], terec);
	    TECalText(terec);
	    TESelView(terec);
	    InvalRect(&viewRect[tnumber]);
	    printf("setting terec->just to %d\n", just[tnumber]);
	} else if (key == K_F7) {
	    printf("TEPinScroll -(lineHeight[tnumber] + 1)\n");
	    TEPinScroll(0, -(lineHeight[tnumber] + 1), terec);
	} else if (key == K_F8) {
	    printf("TEPinScroll lineHeight[tnumber] + 1\n");
	    TEPinScroll(0, lineHeight[tnumber] + 1, terec);
	} else if (key == K_F9) {
	    printf("SetKbdXlate(0)\n");
	    SetKbdXlate(0);
	} else if (key == K_F10) {
	    printf("SetKbdXlate(1)\n");
	    SetKbdXlate(1);
	} else if (key == K_F11) {
	    if (crOnly[tnumber])
		TEAutoWrap(1, terec);
	    else
		TEAutoWrap(0, terec);
	    crOnly[tnumber] ^= 1;
	    TECalText(terec);
	    TESelView(terec);
/*	    TEUpdate(&viewRect[tnumber], terec); /*  */
InvalRect(&viewRect[tnumber]);
	    printf("crOnly is now %s\n", crOnly[tnumber] ? "ON" : "OFF");
	} else if (key == K_F12) {
	    if (autoView[tnumber])
		TEAutoView(0, terec);
	    else
		TEAutoView(1, terec);
	    autoView[tnumber] ^= 1;
	    printf("autoView is now %s\n", autoView[tnumber] ? "ON" : "OFF");
	} else if (key == K_BACKSP || key == K_BCKSP2) {
	    ObscureCursor();
	    TEKey(ep->message, terec);
	} else {
	    ObscureCursor();
	    TEKey(ep->message, terec);
	}
    } else {
	if (key == 0x67 && ep->message & F_CTRL) {	/* control-G	*/
		TESpillGuts(terec);
	} else if (key == 0x68 && ep->message & F_CTRL) {
	    /* test K_BCKSP2 from control H	*/
	    ep->message = K_BCKSP2 | F_FUNC;
	    TEKey(ep->message, terec);
	} else {
	    ObscureCursor();
	    TEKey(ep->message, terec);
	}
    }
}

void domouse(ep)
EventRecord *ep;
{
    static int toggle = 0;
    short	i;

    if (ep->message & F_KEYDOWN) {
	for (i = 0; i < FIELDCOUNT; i++) {
	    if (PtInRect(&ep->where.corner.topLeft, &viewRect[i])) {
		if (i != tnumber) {
		    TEDeactivate(terec);
		    tnumber = i;
		    terec = tarray[tnumber];
		    TEActivate(terec);
			return;
		}
	    }
	}
	if (ep->message & F_SHIFT) {
	    /* TEClick in extend mode	*/
	    TEClick(&ep->where.corner.topLeft, 1, terec);
	} else { 
	    /* TEClick in non-extend mode	*/
	    TEClick(&ep->where.corner.topLeft, 0, terec);
	}
    }
}

void doactivate(ep)
EventRecord *ep;
{
    if (ep->message & 1)
	TEActivate(terec);
    else
	TEDeactivate(terec);
}

void doupdate(ep)
EventRecord *ep;
{
	Rect	textrect,
			frame1,
			frame2;
	short	i;

    SetPort(ep->who);
    BeginUpdateRect(ep->who, &ep->where);

    for (i = 0; i < FIELDCOUNT; i++) {
	TEUpdateErase(&ep->where, tarray[i]);
	frame1 = destRect[i];
	frame2 = viewRect[i];
	InsetRect(&frame1, -3, -3);
	InsetRect(&frame2, -2, -2);
	FrameRect(&frame1);
	FrameRect(&frame2);
    }

    SetRect(&textrect, 10, 210, 110, 252);
    TextFont(0);
    TextSize(12);
    TextFace(normalText);
    TextBox("This text is displayed in a text box, although it's "
	"a little too big to fit in one chunk, so it should cause "
	"some problems!", 123, &textrect, teJustCenter);
    InsetRect(&textrect, -2, -2);
    FrameRect(&textrect);
    EndUpdate(ep->who);
}

/* Prototype of what got buried in the Window Manager with V2.20 */
#if 0
/*
** Translate ALT-key sequences into the extended character set.  This method
** is modeled after the Macintosh's, mostly because we use the same glyph set
** and I haven't seen any better way to do this.
**
** Algorithm:
**
** First, always substitute any alt-characters directly using the plain
** substitution tables.  If the result is zero, it's a dead key.  Remember
** this fact for step three.
**
** Second, if a dead-key prefix has been set, search the appropriate composite
** translation table for a match on this current character.  If found, emit
** the translated character and clear the dead-key state.  If not found, emit
** the dead-key prefix and then the current character.  In either case we
** then exit.
**
** Third, if the dead-key indicator from step one is set, search the dead-key
** prefix table for a match on the current (untranslated) character.  If found,
** set the appropriate dead-key prefix status, and hold onto this character
** (in case the next character doesn't complete a composite key sequence).
**
** Currently there is no translation that will give you the codes $FC-$FF.
** Maybe later.
*/

/*
** Composite search tables.  For each dead key prefix, the second character is
** looked for in here.  If found, it is substituted.  A 0 terminates the list,
** and in that case the saved dead key character is emitted followed by the
** current character (unmodified).
*/

/* Via Alt-n */
unsigned char tilde[] = {'a', 0x8B, 'o', 0x9B, 'n', 0x96,
		     'A', 0xCC, 'O', 0xCD, 'N', 0x84, '~', '~', 0};
/* Via Alt-backquote */
unsigned char grave[] = {'a', 0x88, 'e', 0x8F, 'i', 0x93, 'o', 0x98,
			     'u', 0x9D, 'A', 0xCB, '\`', '\`', 0};
/* Via Alt-e */
unsigned char acute[] = {'a', 0x87, 'e', 0x8E, 'i', 0x92, 'o', 0x97,
			     'u', 0x9C, 'E', 0x83, 0xAB, 0xAB, 0};
/* Via Alt-u */
unsigned char dieresis[] = {'a', 0x8A, 'e', 0x91, 'i', 0x95, 'o', 0x9A,
			      'u', 0x9F, 'y', 0xD8, 'A', 0x80,
			      'O', 0x85, 'U', 0x86, 0xAC, 0xAC, 0};
/* Via Alt-i */
unsigned char circumflex[] = {'a', 0x89, 'e', 0x90, 'i', 0x94, 'o', 0x99,
				  'u', 0x9E, '^', '^', 0};

/*
** Dead-key table cross-reference.  The low-numbered translations in the
** substitution table refer to these entries.  The accent field contains
** the translated accent character to emit if there's an invalid dead-key
** sequence typed.
*/

struct deads {
    unsigned char accent;
    unsigned char *table;
} deadkeys[] = {
    '~', tilde,			/* On 'n'. */
    '\`', grave,		/* On '`'. */
    0xAB, acute,		/* On 'e'. */
    0xAC, dieresis,		/* On 'u'. */
    '^', circumflex		/* On 'i'. */
};

/*
** Regular Alt-key lookup table.  One entry for each character from 0x20 to
** 0x7F.  Direct lookup for substitution.  The dead keys have already been
** taken care of.  The comment shows the translation in standard fonts.
** Parenthesized comments show the translation in Times Roman (a more
** complete font than normal).  Refer to the PostScript Language Reference
** Manual for more information on the Times Roman font.  Looked-up values
** less than 0x20 refer to the relevent member of the deadkeys array.
*/

unsigned char substitutes[96] = {
    0xCA, /* Space -> Non-breaking space. */
    0xDA, /* ! (Vertical Bar.) */
    0xAE, /* " -> 'AE' combination. */
    0xDC, /* # (Single opening guillemot symbol.) */
    0xDD, /* $ (Single closing guillemot symbol.) */
    0xDE, /* % ('fi' ligature.) */
    0xE0, /* & (Double dagger.) */
    0xBE, /* ' -> 'ae' combination.. */
    0xE1, /* ( (Centered dot.) */
    0xE2, /* ) (Baseline single quote, looks like a comma.) */
    0xA1, /* * -> Degrees symbol. */
    0xB1, /* + -> Plusminus symbol. */
    0xB2, /* , -> Lessequals symbol. */
    0xD0, /* - -> Minus sign, or en-dash. */
    0xB3, /* . -> Greaterequals symbol. */
    0xD6, /* / -> Divide sign. */

    0xBC, /* 0 -> Ordmasculine, a raised 'o' with an underline. */
    0xC1, /* 1 -> Upside down '!'. */
    0xAA, /* 2 -> Trademark symbol. */
    0xA3, /* 3 -> Pounds Sterling symbol. */
    0xA2, /* 4 -> Cents sign. */
    0xB0, /* 5 -> Infinity symbol. */
    0xA4, /* 6 -> Section symbol (Capital 'S' with centered ring, sort of.) */
    0xA6, /* 7 -> Paragraph symbol. */
    0xA5, /* 8 -> Bullet symbol. */
    0xBB, /* 9 -> Ordfeminine, a raised 'a' with an underline. */
    0xF2, /* : ('U' with acute accent.) */
    0xC9, /* ; -> Ellipses. */
    0xF8, /* < (Macron, overbar accent mark.) */
    0xAD, /* = -> Inequality. */
    0xF9, /* > (Breve, cupped accent mark.) */
    0xC0, /* ? -> Upside down '?'. */

    0xDB, /* @ (Currency symbol, a ring with 4 diagonal radials.) */
    0x81, /* A -> A-ring. */
    0xF5, /* B (Dotless i.) */
    0x82, /* C -> C-cedilla */
    0xEB, /* D ('I' with circumflex [caret] accent.) */
    0xE4, /* E (Per-thousands.) */
    0xEC, /* F ('I' with dieresis accent [umlaut].) */
    0xED, /* G ('I' with grave accent.) */
    0xEE, /* H ('O' with acute accent.) */
    0xE9, /* I ('E' with grave accent.) */
    0xEF, /* J ('O' with circumflex accent.) */
    0xF0, /* K (Fruit.) */
    0xF1, /* L ('O' with grave accent.) */
    0xF7, /* M (Tilde accent mark.) */
    0xF6, /* N (Circumflex accent mark.) */
    0xAF, /* O -> 'O' with slash. */

    0xB8, /* P -> Uppercase pi. */
    0xCE, /* Q -> 'OE' combination. */
    0xE5, /* R ('A' with circumflex accent.) */
    0xEA, /* S ('I' with acute accent.) */
    0xE6, /* T ('E' with circumflex accent.) */
    0xE8, /* U ('E' with dieresis accent.) */
    0xD7, /* V -> Hollow diamond. */
    0xE3, /* W (Baseline double quotes.) */
    0xF4, /* X ('U' with grave accent.) */
    0xE7, /* Y ('A' with acute accent.) */
    0xF3, /* Z ('U' with circumflex accent.) */
    0xD2, /* [ -> Opening double quotes. */
    0xC7, /* \ -> Opening guillemot (a << mark). */
    0xD4, /* ] -> Opening single quote. */
    0xDF, /* ^ ('fl' ligature.) */
    0xD1, /* _ -> Em-dash. */

    0x01, /* ` is a dead key, grave accent. */
    0x8C, /* a -> a-ring. */
    0xBA, /* b -> Integral. */
    0x8D, /* c -> c-cedilla. */
    0xB6, /* d -> Lowercase delta. */
    0x02, /* e is a dead key, acute accent. */
    0xC4, /* f -> Florin symbol, a script 'f'. */
    0xA9, /* g -> Copyright symbol. */
    0xFA, /* h (Dot accent mark) */
    0x04, /* i is a dead key, circumflex accent. */
    0xC6, /* j -> Capital delta. */
    0xFB, /* k (Ring accent mark.) */
    0xC2, /* l -> Hollerith not symbol. */
    0xB5, /* m -> lowercase mu. */
    0x00, /* n is a dead key, tilde accent. */
    0xBF, /* o -> o with slash. */

    0xB9, /* p -> Lowercase pi. */
    0xCF, /* q -> 'oe' combination. */
    0xA8, /* r -> Registered trademark symbol. */
    0xA7, /* s -> Ess-tset, german double 's'. */
    0xA0, /* t -> Dagger */
    0x03, /* u is a dead key, dieresis accent. */
    0xC3, /* v -> Radical symbol. */
    0xB7, /* w -> Uppercase sigma. */
    0xC5, /* x -> Approximately-equals symbol. */
    0xB4, /* y -> Yen sign. */
    0xBD, /* z -> Uppercase omega. */
    0xD3, /* { -> Closing double quotes. */
    0xC8, /* | -> Closing guillemot. */
    0xD5, /* } -> Closing single quote. */
    0xD9, /* ~ ('Y' with dieresis accent.) */
    0x00  /* Delete is never seen here (it's an FKEY) */
}; /* (Non-typable characters in Times: 0xFC is the cedilla accent,
       0xFD is hungarumlaut accent, 0xFE is ogonek accent, 0xFF is empty.) */

doIkey(ep)			/* International character input routine. */
EventRecord *ep;
{
    static EventRecord savedkey;
    static unsigned char *deadkey = 0; /* Points to dead-key xlate table. */
    EventRecord thiskey;
    long flags;
    short key;
    unsigned char subbed, *p;
    struct deads *pdeads;

    thiskey = *ep;		/* Save the event record. */
    flags = ep->message & F_FLAGMASK;
    if (flags & F_KEYUP)
	return;
    key = ep->message & F_KEYMASK;
    pdeads = 0;			/* First substitute for any plain chars. */
    if (!(flags & F_FUNC) && flags & F_ALT && key >= ' ' && key <= 0x7F) {
	flags &= ~F_ALT;
	subbed = substitutes[key - ' '];
	if (subbed > ' ')
	    key = subbed;
	else {			/* Is a dead key. */
	    pdeads = &deadkeys[subbed];
	    if (deadkey)	/* If one's already in sequence, switch to */
		key = pdeads->accent; /* the accent character just in case. */
	}
    }
    if (p = deadkey) {		/* Step 2: Already processed a dead key? */
	deadkey = 0;		/* Yes, cancel dead-key status. */
	pdeads = 0;
	while (1) {		/* Search for a translation. */
	    if (!*p) {		/* No translation found, */
		dokey(&savedkey); /* spit out the dead-key prefix followed */
		break;		/* by the current character. */
	    }
	    if (*p++ == key) {	/* Found a translation? */
		key = *p;	/* Yes, substitute. */
		break;
	    }
	    p++;
	}
    }
    if (pdeads) {		/* Step 3: Fresh dead-key typed? */
	deadkey = pdeads->table; /* Set up for xlate on next key, */
	savedkey = *ep;		/* and save this key in case that */
	savedkey.message = flags | pdeads->accent; /* translate fails, */
	return;			/* but switch the keycode to that of the */
    }				/* bare accent itself. */
    thiskey.message = flags | key;
    dokey(&thiskey);		/* Spit out a character. */
}
#endif
