/*
**
** Test the Pie charting calls.
**
*/

#include <stdio.h>
#include <errno.h>
#include <isc/window.h>

#define XWINL 40		/* Window definitions. */
#define XWINR 400
#define YWINT 50
#define YWINB 250

HdwrType HdwrRecord;

main(argc, argv)
int argc;
char *argv[];
{
    short i;
    int trapqfd, wmfd, doupdate();
    Rect winrect;
    int mywindow;
    char *sysid;

    if (argc == 2)
	sysid = argv[1];

    /*
    **	Initialize the graphics toolbox.
    */

    if ((trapqfd = InitGraf()) < 0) {
	fprintf(stderr, "%s: Error %d in InitGraf().\n", 
		argv[0], -trapqfd);
	exit(1);
    }

    /*
    **	Establish a connection to a window manager.
    */

    if ((wmfd = ConnectGraf(sysid)) < 0) {
	fprintf(stderr, "%s: Error %d in ConnectGraf().\n", 
		argv[0], -wmfd);
	exit(1);
    }

    SetRect(&winrect, XWINL, YWINT, XWINR, YWINB);
    mywindow = NewWindow(&winrect, "Test Pie Chart",
			       showWindow, documentProc, frontWindow, 
			       noOptions, wmfd);
    SetPort(mywindow);
    if (mywindow < 0) {
	fprintf(stderr, "Window Create failed, errno=%d.\n", errno);
	exit(3);
    }

    Event(updateEvt, doupdate);
    GetHdwrType(&HdwrRecord);
    (void) GetEvent(anyWindow, 1<<keyEvt);

    DisposeWindow(mywindow);
    EndGraf();
}

doupdate(ep)
EventRecord *ep;
{
    SetPort(ep->who);
    BeginUpdate(ep->who);
    stats();
    EndUpdate(ep->who);
}

stats()
{
    Rect scratch;

    SetRect(&scratch, 10, 10, 180, 180);
    FillArc(&scratch, 0, 65, blackPattern);
    FillArc(&scratch, 65, 30, dkgreyPattern);
    FillArc(&scratch, 95, 200, greyPattern);
    FillArc(&scratch, 295, 10, ltgreyPattern);
    FrameOval(&scratch);
}
