/*
** Test the polygon collection routines.
*/

#include <stdio.h>
#include <malloc.h>
#include <errno.h>
#include <isc/window.h>

#define XWINL 40		/* Window definitions. */
#define XWINR 560
#define YWINT 40
#define YWINB 240

main(argc, argv)
int argc;
char *argv[];
{
    int i, window;
    int trapqfd, fd;
    Rect winrect, myrect;
    PolyHandle mypoly;

    if ((trapqfd = InitGraf()) < 0) { /* Initialize graphics toolbox. */
	fprintf(stderr, "%s: Error %d in InitGraf().\n", argv[0], -trapqfd);
	exit(1);
    }
    if ((fd = ConnectGraf(0)) < 0) {	/* Initialize graphics toolbox. */
	fprintf(stderr, "%s: Unable to connect to Window Manager (Error #%d in ConnectGraf).\n", 
		argv[0], -fd);
	exit(1);
    }

    SetRect(&winrect, XWINL, YWINT, XWINR, YWINB); /* Make our WM window. */
    window = NewWindow(&winrect, "Polygon Collection Test", showWindow,
		       noGrowDocProc, frontWindow, noOptions, fd);
    SetPort(window);
    mypoly = OpenPoly();	/* Make polygon to test WM poly delivery. */
    drawstar();
    ClosePoly();

/*
** We have to copy the polygon elsewhere before we use it because polygons
** are collected in the graphics command buffer, and they'll be destroyed
** if we don't save them immediately after creation.
*/

    mypoly = DupePoly(mypoly);
    PaintPoly(mypoly);
    OffsetPoly(mypoly, 50, 0);
    InvertPoly(mypoly);
    KillPoly(mypoly);
    FlushWindow();
    sleep(3);
    DisconnectGraf(fd);		/* Disconnect from the WM. */
    EndGraf();			/* Shut down graphics hookup. */
}

drawstar()			/* For making a polygon. */
{
    MoveTo(12, 100);
    LineTo(50, 0);
    LineTo(88, 100);
    LineTo(0, 30);
    LineTo(100, 30);
    LineTo(12, 100);
}
