/*
** Test the font list routines.
*/

#include <stdio.h>
#include <errno.h>
#include <isc/window.h>

main(argc, argv)
int argc;
char *argv[];
{
    int trapqfd, fd, i, j;
    unsigned char available[128], *p;
    FontList *flp;

    if ((trapqfd = InitGraf()) < 0) { /* Initialize graphics toolbox. */
	fprintf(stderr, "%s: Error %d in InitGraf().\n", argv[0], -trapqfd);
	exit(1);
    }
    if ((fd = ConnectGraf(0)) < 0) {	/* Initialize graphics toolbox. */
	fprintf(stderr, "%s: Unable to connect to Window Manager (Error #%d in ConnectGraf).\n", 
		argv[0], -fd);
	exit(1);
    }

    flp = GetFontList(&i);	/* Get font list (into malloc space). */
    printf("Found %d fonts.\n", i);
    while (i--) {
	printf("Font %d is named \"%.15s\", ", flp->fontnum, flp->fontname);
	j = GetFontSizes(flp->fontnum, available, sizeof(available));
	if (j > 1)
	    printf("available in sizes");
	else
	    printf("available in size");
	p = available;
	while (j--)
	    printf(" %d", *p++);
	printf(".\n");
	flp++;
    }
}
