/*
**
** Test the graphics library.
**
*/

#include <stdio.h>
#include <isc/window.h>
#include <isc/keycodes.h>

#define WIDTH (600)				/* Window definitions. */
#define HIGTH (400)

int loopcnt;
int xpos = 20;
int ypos = 50;
char *path;

int current;

int updateevent();

main(argc, argv)
int argc;
char *argv[];
{
	int i, j;
	int trapqfd, fd;
	Rect winrect;
	int window;
	char *argp;

	while (--argc > 0) {
		argp = *++argv;
		if (*argp == '-') {
			argp++;
			switch (*argp++) {
				case 'x':
					xpos = atoi(argp);
					break;
				case 'y':
					ypos = atoi(argp);
					break;
				case 'l':
					loopcnt = atoi(argp);
					break;
			}
		}
		else {
			path = argp;
		}
	}
	if ((trapqfd = InitGraf()) < 0) {		/* Initialize graphics toolbox. */
		fprintf(stderr,"Error %d in GrafInit\n",-trapqfd);
		exit(1);
	}
	if ((fd = ConnectGraf(path)) < 0) {		/* Initialize graphics toolbox. */
		fprintf(stderr,"Error %d in ConnectGraf\n",-fd);
		exit(1);
	}
	SetRect(&winrect, xpos, ypos, xpos+WIDTH, ypos+HIGTH);
	window = NewWindow(&winrect, "Test Window", showWindow, documentProc, frontWindow, noOptions, fd);
	SetPort(window);

	Event(updateEvt,updateevent);

	while ((j = GetKey(window)) != EOF
	  && (j &= F_KEYMASK) != 'q' && j != 'Q') {
		SetRect(&winrect, 0, 0, WIDTH, HIGTH);
		EraseRect(&winrect);
		staticinfo();
	}
}

updateevent(ep)
EventRecord *ep;
{
	BeginUpdate(ep->who);
	staticinfo();
	EndUpdate(ep->who);
}

staticinfo()
{
	int i, x, y;
	int xbias = WIDTH/2;
	int ybias = HIGTH-20;
	MoveTo(1,ybias);
	LineTo(WIDTH-2,ybias);
	MoveTo(xbias,1);
	LineTo(xbias,HIGTH-2);
	for (i = -xbias; i < WIDTH - xbias; i++) {
		x = xbias + i;
		y = ybias-(i*i)/100;
		if (y >= 0) {
			SetPixel(x,y);
		}
	}
}
