/*
** Test Event Recorder on/off logic and ER waiting logic.  Note, must be
** root for these functions to work.
*/

#include <stdio.h>
#include <isc/window.h>

main(argc, argv)
int argc;
char *argv[];
{
    int i, mywindow;
    long l;
    int trapqfd, wmfd;
    char *itoa(), namebuf[160];
    Rect rect;

    /*
     **	Initialize the graphics toolbox.
     */
    if ((trapqfd = InitGraf()) < 0) { /* Initialize graphics toolbox. */
	strcpy(namebuf, argv[0]);
	strcat(namebuf, ": Error ");
	strcat(namebuf, itoa(-trapqfd));
	strcat(namebuf, " in InitGraf().\n");
	write(2, namebuf, StringLen(namebuf));
	exit(1);
    }
    if ((wmfd = ConnectGraf(0)) < 0) {	/* Initialize graphics toolbox. */
	strcpy(namebuf, argv[0]);
	strcat(namebuf, ": Unable to connect to Window Manager (Error #");
	strcat(namebuf, itoa(-wmfd));
	strcat(namebuf, " in ConnectGraf).\n");
	write(2, namebuf, StringLen(namebuf));
	exit(1);
    }
    switch (argc) {
      case 1:
	i = SetEventRecorder(0, "");
	printf("Recorder off.\n");
	break;
      case 2:
	i = SetEventRecorder(2, argv[1]);
	printf("Playing back: %s\n", argv[1]);
	break;
      case 3:
	i = SetEventRecorder(1, argv[2]);
	/*
	 **	Create dummy window in front to trigger the start of recording.
	 */
#if 0
	SetRect(&rect, 0, 0, 0, 0);
	mywindow = NewWindow(&rect, "Start Recorder", hideWindow,
			     documentProc, frontWindow, noOptions, wmfd);
	DisposeWindow(mywindow);	/* Delete the window. */
#endif
	printf("Recording on into: %s\n", argv[2]);
	break;
    }
    printf("Former event file position: %d\n", i);
    i = WaitEventRecorder(&l);
    printf("FilePos at ER finish: %d, timestamp of ER finish: $%08X\n", i, l);
    DisconnectGraf(wmfd);	/* Disconnect from Window Manager. */
    EndGraf();			/* Un-init graphics toolbox. */
    exit(0);
}

char *
itoa(val)
int val;
{
    static char buf[20];
    char *p;
    int test;

    p = buf;
    test = 1000000;
    if (val < 0) {
	val = -val;
	*p++ = '-';
    }
    while (test > val)
	test /= 10;
    if (val)
	while (test) {
	    *p++ = val / test + '0';
	    val %= test;
	    test /= 10;
	}
    else
	*p++ = '0';
    *p = 0;
    return buf;
}
