/*
**
** Test the WP6/WEB color model.
**
*/

#include <isc/window.h>

#define XWINL 10		/* Window definitions. */
#define XWINR 630
#define YWINT 50
#define YWINB 340

/* Color palette indices. */
#define WHITE 0
#define BLACK 1
#define BEIGE 3
#define ORANGE 6

#define RED 8
#define MAGENTA 9
#define DKBLUE 10
#define YELLOW 11
#define CYAN 12
#define GREEN 13

#define PRINT(x,y,s)	{ MoveTo(x,y); DrawString(s); }

Rect winrect;

void doupdate(), dokey();

main()
{
    int i, j, window;
    int trapqfd, fd;

    if ((trapqfd = InitGraf()) < 0) { /* Initialize graphics toolbox. */
	exit(1);
    }
    if ((fd = ConnectGraf(0)) < 0) {	/* Initialize graphics toolbox. */
	exit(2);
    }
    SetRect(&winrect, XWINL, YWINT, XWINR, YWINB);
    window = NewWindow(&winrect, "WP6/WEB Color Model Test", showWindow,
		       documentProc, frontWindow, noOptions, fd);
    SetPort(window);

    OffsetRect(&winrect, -XWINL, -YWINT);
    Event(updateEvt, doupdate);
    Event(keyEvt, dokey);
    SetRGBColor(RED, 0xFFFF, 0, 0);
    SetRGBColor(MAGENTA, 0xFFFF, 0, 0xFFFF);
    SetRGBColor(DKBLUE, 0x7400, 0xA800, 0xFFFF);
    SetRGBColor(YELLOW, 0xFFFF, 0xFFFF, 0);
    SetRGBColor(CYAN, 0, 0xFFFF, 0xFFFF);
    SetRGBColor(GREEN, 0, 0xFFFF, 0);
    GetEvent(anyWindow, noEvent);
    exit(0);
}

void
doupdate(ep)
EventRecord *ep;
{
    BeginUpdate(ep->who);
    staticinfo();
    EndUpdate(ep->who);
}

void
dokey(ep)
EventRecord *ep;
{
    exit(0);
}

static Pattern zero = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};
static Pattern fifteen = {0, 0, 0, 0, 0, 0, 0, 0};
static Pattern thirtythree = {0xF0, 0xF0, 0xF0, 0xF0, 0x0F, 0x0F, 0x0F, 0x0F};
static Pattern forty = {0xFF, 0x80, 0x80, 0x80, 0xFF, 8, 8, 8};

staticinfo()			/* Do the display. */
{
    Rect titlerect, menurect, textrect;
    short i, j;
    char *message = "This is a Test....This is only a Test...Had this been a "
	"real emergency we wouldn't ha";

    ForeColor(BLACK);
    BackColor(WHITE);

    SetRect(&titlerect, 230, 20, 410, 70);
    FillRect(&winrect, &forty);

    TextFont(8);
    TextSize(14);
    TextMode(srcCopy);
    PRINT(30, 50, " Text on ");
    PRINT(30, 65, " Pattern ");
    TextFont(0);
    TextSize(12);
    TextMode(srcOr);
    SetRect(&menurect, 20, 100, 600, 270);
    FillRect(&menurect, &fifteen);
    FrameRect(&menurect);
    InsetRect(&menurect, 1, 1);
    TextFont(9);
    TextSize(18);
    BackColor(BEIGE);
    EraseRect(&titlerect);
    FrameRect(&titlerect);
    centerstr(&titlerect, "Text on Color");
    BackColor(WHITE);

    EraseRect(&menurect);	/* Remove foreground information. */
    textrect = menurect;	/* Put up foreground strips. */
    i = (textrect.edge.bottom - textrect.edge.top)/5;
    textrect.edge.bottom = textrect.edge.top + i;
    ForeColor(BLACK);
    TextFont(0);
    TextSize(12);
    MoveTo(textrect.edge.left+2, textrect.edge.top + 18);
    DrawString(message);

    ForeColor(MAGENTA);
    OffsetRect(&textrect, 0, i);
    FillRect(&textrect, &zero);
    ForeColor(BLACK);
    FrameRect(&textrect);
    MoveTo(textrect.edge.left+2, textrect.edge.top + 18);
    DrawString(message);

    ForeColor(CYAN);
    OffsetRect(&textrect, 0, i);
    FillRect(&textrect, &zero);
    ForeColor(BLACK);
    FrameRect(&textrect);
    MoveTo(textrect.edge.left+2, textrect.edge.top + 18);
    DrawString(message);

    ForeColor(DKBLUE);
    OffsetRect(&textrect, 0, i);
    FillRect(&textrect, &zero);
    ForeColor(BLACK);
    FrameRect(&textrect);
    ForeColor(YELLOW);
    MoveTo(textrect.edge.left+2, textrect.edge.top + 18);
    DrawString(message);
    ForeColor(BLACK);

    ForeColor(YELLOW);
    OffsetRect(&textrect, 0, i);
    FillRect(&textrect, &zero);
    ForeColor(BLACK);
    FrameRect(&textrect);
    ForeColor(DKBLUE);
    MoveTo(textrect.edge.left+2, textrect.edge.top + 18);
    DrawString(message);

    ForeColor(BLACK);

    textrect = menurect;
    i = 29;
    textrect.edge.right = textrect.edge.left + i - 2;	/* (Makes swatches.) */


    OffsetRect(&textrect, i, 0);	/* invert */
    InsetRect(&textrect, 1, 1);
    InvertRect(&textrect);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    heading(textrect.edge.left, textrect.edge.top, "Inv");
    OffsetRect(&textrect, i, 0);

    PenPat(&thirtythree);
    swatch(&textrect, i, srcCopy, "sC");

    PenPat(&thirtythree);
    swatch(&textrect, i, srcOr, "sO");

    PenPat(&thirtythree);
    swatch(&textrect, i, srcXor, "sX");

    PenPat(&thirtythree);
    swatch(&textrect, i, srcBic, "sB");

    PenPat(&thirtythree);
    swatch(&textrect, i, notSrcCopy, "nSC");

    PenPat(&thirtythree);
    swatch(&textrect, i, notSrcOr, "nSO");

    PenPat(&thirtythree);
    swatch(&textrect, i, notSrcXor, "nSX");

    PenPat(&thirtythree);
    swatch(&textrect, i, notSrcBic, "nSB");

    OffsetRect(&textrect, i, 0);

    PenPat(&zero);
    swatch(&textrect, i, srcCopy, "sC");

    PenPat(&zero);
    swatch(&textrect, i, srcOr, "sO");

    PenPat(&zero);
    swatch(&textrect, i, srcXor, "sX");

    PenPat(&zero);
    swatch(&textrect, i, srcBic, "sB");

    PenPat(&zero);
    swatch(&textrect, i, notSrcCopy, "nSC");

    PenPat(&zero);
    swatch(&textrect, i, notSrcOr, "nSO");

    PenPat(&zero);
    swatch(&textrect, i, notSrcXor, "nSX");

    PenPat(&zero);
    swatch(&textrect, i, notSrcBic, "nSB");

    ForeColor(BLACK);
    BackColor(WHITE);
}

centerstr(rect, string)
Rect *rect;
char *string;
{
    short width, height, startat;

    width = rect->edge.right - rect->edge.left;
    height = rect->edge.bottom - rect->edge.top;
    startat = rect->edge.left + width/2 - StringWidth(string)/2;
    MoveTo(startat, rect->edge.top + height/2 + 6);
    DrawString(string);
}

heading(left, top, string)
int left, top;
char *string;
{
    int flag;

    flag = StringLen(string) > 2; /* Compress (visually) longer strings. */
    TextFont(0);
    TextSize(12);
    MoveTo(left + 2, top - 5);
    TextFace(outlineText);
    if (flag)
	TextExtra(Int2Fix(-1));
    DrawString(string);
    MoveTo(left + 3, top - 5);
    TextFace(normalText);
    TextExtra(Int2Fix(flag ? 1 : 2));
    ForeColor(ORANGE);
    DrawString(string);
    TextExtra(0);
}

swatch(rect, i, mode, string)
Rect *rect;
int i, mode;
char *string;
{
    OffsetRect(rect, i, 0);
    InsetRect(rect, 1, 1);
    PenMode(mode);
    ForeColor(DKBLUE);
    BackColor(YELLOW);
    PaintRect(rect);
    ForeColor(BLACK);
    BackColor(WHITE);
    PenPat(&zero);
    PenMode(srcCopy);
    InsetRect(rect, -1, -1);
    FrameRect(rect);
    heading(rect->edge.left, rect->edge.top, string);
}
