/*
**
** Test Dithered Colors.
**
*/

#include <isc/window.h>

#define XWINL 10		/* Window definitions. */
#define XWINR 630
#define YWINT 50
#define YWINB 440

/* Color palette indices. */
#define WHITE 0
#define BLACK 1

#define RED 8
#define GREEN 9
#define BLUE 10
#define GRAY 11
#define MAGENTA 12
#define YELLOW 13
#define CYAN 14

Rect winrect;

void doupdate(), dokey();

main()
{
    int i, j, window;
    int trapqfd, fd;

    if ((trapqfd = InitGraf()) < 0) { /* Initialize graphics toolbox. */
	return 1;
    }
    if ((fd = ConnectGraf(0)) < 0) {	/* Initialize graphics toolbox. */
	return 2;
    }
    SetRect(&winrect, XWINL, YWINT, XWINR, YWINB);
    window = NewWindow(&winrect, "Dithered Colors Test", showWindow,
		       documentProc, frontWindow, noOptions, fd);
    SetPort(window);

    Event(updateEvt, doupdate);
    Event(keyEvt, dokey);
    SetRGBColor(RED, 0xFFFF, 0x6000, 0x6000);
    SetRGBColor(GREEN, 0, 0xFFFF, 0);
    SetRGBColor(BLUE, 0, 0x6000, 0xFFFF);
    SetRGBColor(GRAY, 0xC000, 0xC000, 0xC000);
    SetRGBColor(MAGENTA, 0xFFFF, 0, 0xFFFF);
    SetRGBColor(YELLOW, 0xFFFF, 0xFFFF, 0);
    SetRGBColor(CYAN, 0, 0xFFFF, 0xFFFF);

    GetEvent(anyWindow, noEvent);
    return 0;
}

void
doupdate(ep)
EventRecord *ep;
{
    BeginUpdate(ep->who);
    staticinfo();
    EndUpdate(ep->who);
}

void
dokey(ep)
EventRecord *ep;
{
    ReleaseEvent();
}

staticinfo()			/* Do the display. */
{
    int i, j, width;
    Rect textrect;

    TextFont(2);
    TextSize(18);
    TextMode(srcOr);
    for (j=RED; j<=BLUE; j++) {
	SetRect(&textrect, 18, 16, 194, 36);
	width = (textrect.edge.right - textrect.edge.left) / 2;
	OffsetRect(&textrect, (j-RED) * 200, 0);
	for (i=0; i<16; i++) {	/* Sweep pattern from solid to empty. */
	    PenMode(srcOr);
	    ForeColor(j);
	    PenPat((Pattern *) i);
	    PaintRect(&textrect);
	    PenMode(notSrcBic);
	    BackColor(WHITE);
	    PaintRect(&textrect);
	    BackColor(MAGENTA + (j - RED));
	    textrect.edge.left += width;
	    PaintRect(&textrect);
	    textrect.edge.left -= width;
	    
	    ForeColor(BLACK);
	    BackColor(WHITE);
	    MoveTo(textrect.edge.left + 6, textrect.edge.top + 15);
	    DrawString("This is a test, Pat.");
	    OffsetRect(&textrect, 0, 22);
	}
    }
}
