/*
** Test TI34010 extra transfer modes.  Assumes a 256 color display.
*/

#include <isc/window.h>

void doupdate(), dokey();

Rect winrect, scratch;

struct BITOBJ {			/* Header for included Data Dictionary */
    short version;		/* bitmap object. */
    short rowBytes;
    short width;
    short height;
    short hres;
    short vres;
    short flags;
    short compress;
};
extern struct BITOBJ holly;
extern char hollybits[];

BitMap source;
Rect view;

main(argc, argv)
int argc;
char *argv[];
{
    int i, j, window;
    int trapqfd, fd;
    EventRecord *ep;
    FontInfo finfo;

    if ((trapqfd = InitGraf()) < 0) { /* Initialize graphics toolbox. */
	return 1;
    }
    if ((fd = ConnectGraf(0)) < 0) {	/* Initialize graphics toolbox. */
	return 2;
    }
    source.rowBytes = holly.rowBytes;
    SetRect(&source.bounds, -10, -10, holly.width-10, holly.height-10);
    source.baseAddr = hollybits;

    Event(updateEvt, doupdate);
    Event(keyEvt, dokey);
    SetRect(&winrect, 0, 40, 640, 480);
    scratch = winrect;
    OffsetRect(&scratch, -winrect.edge.left, -winrect.edge.top);
    window = NewWindow(&winrect, "TI34010 Test", showWindow,
		       documentProc, frontWindow, noOptions, fd);
    SetPort(window);
    GetEvent(anyWindow, noEvent);
    return 0;
}

void
doupdate(ep)
EventRecord *ep;
{
    Rect foo;
    int color, level;

    foo = scratch;
    BeginUpdate(ep->who);
    ForeColor(color = 8);
    FillRect(&foo, blackPattern);
    PenMode(srcAddPin);		/* Add with Saturation transfer mode. */
    ForeColor(1);
    level = 256;
    SetRGBColor(color++, level << 7, level << 7, level << 7);
    while (color < 256) {
	switch (color % 4) {
	  case 0:
	    SetRGBColor(color++, level << 7, level << 7, level << 7);
	    break;
	  case 1:
	    SetRGBColor(color++, level << 7, 0, 0);
	    break;
	  case 2:
	    SetRGBColor(color++, 0, level << 7, 0);
	    break;
	  case 3:
	    SetRGBColor(color++, 0, 0, level << 7);
	    break;
	}
	if (!EmptyRect(&foo)) {
	    PaintRect(&foo);
	    InsetRect(&foo, 1, 1);
	}
	if (level < 512)
	    level++;
    }
    SetRGBColor(255, ~0, ~0, ~0); /* Maximum white. */
    ForeColor(color = 64);
    view = source.bounds;
    OffsetRect(&view, 40, 40);
    CopyBits(&source, 0, &source.bounds, &view, srcAddPin, 0);
    ForeColor(color += 32);
    OffsetRect(&view, source.bounds.edge.right, 0);
    CopyBits(&source, 0, &source.bounds, &view, srcAddPin, 0);
    ForeColor(color += 32);
    OffsetRect(&view, source.bounds.edge.right, 0);
    CopyBits(&source, 0, &source.bounds, &view, srcAddPin, 0);

    OffsetRect(&view, -2*source.bounds.edge.right,
	       source.bounds.edge.bottom + 80);
    ForeColor(color += 32);
    CopyBits(&source, 0, &source.bounds, &view, srcAddPin, 0);
    ForeColor(color += 32);
    OffsetRect(&view, source.bounds.edge.right, 0);
    CopyBits(&source, 0, &source.bounds, &view, srcAddPin, 0);
    ForeColor(color += 32);
    OffsetRect(&view, source.bounds.edge.right, 0);
    CopyBits(&source, 0, &source.bounds, &view, srcAddPin, 0);

    EndUpdate(ep->who);
}

void
dokey(ep)
EventRecord *ep;
{
    ReleaseEvent();
}
