/*
**
** Test the ReleaseEvent stuff.
**
*/

#include <isc/window.h>
#include <isc/keycodes.h>

#define XWINL 100		/* For creating our window. */
#define XWINR 400
#define YWINT 100
#define YWINB 200

void updateevent();		/* Forward declare event handlers. */
void keyboardevent();

int mywindow;			/* The window we'll be using. */
int level;
Rect levels[4];

main(argc, argv)
int argc;
char *argv[];
{
    short i;
    int trapqfd, wmfd;
    Rect winrect, button;
    char *sysid;

    if (argc == 2)		/* Allow an override of where to send */
	sysid = argv[1];	/* our window. */

    /*
    **	Initialize the graphics toolbox.
    */

    if ((trapqfd = InitGraf()) < 0) {
	exit(1);
    }

    /*
    **	Establish a connection to a window manager.
    */

    if ((wmfd = ConnectGraf(sysid)) < 0) {
	exit(2);
    }

    SetRect(&winrect, XWINL, YWINT, XWINR, YWINB);
    mywindow = NewWindow(&winrect, "ReleaseEvent Test",
			 showWindow, documentProc, frontWindow, 
			 noOptions, wmfd);
    SetPort(mywindow);
    if (mywindow < 0) {
	exit(3);
    }

    Event(updateEvt, updateevent); /* Bind the standard event handlers. */
    Event(keyEvt, keyboardevent);

    for (i=0; i<sizeof(levels)/sizeof(levels[0]); i++) {
	SetRect(&levels[i], (i+1) * 50, 25, (i+1) * 50 + 25, 50);
	FrameRect(&levels[i]);
    }
    (void) GetEvent(anyWindow, noEvent); /* Get events until time to quit. */
    exit(0);
}

/*
** Handle keyboard input from the operator.  Here we use it to test various
** features of the controls.
*/

void
keyboardevent(ep)
EventRecord *ep;
{
    short key, i;
    Rect rect;

    if (ep->message & F_KEYUP)
	return;
    key = ep->message & F_KEYMASK;
    if (key == K_ESC) { /* Quit? */
	ReleaseEvents();	/* Makes the GetEvent()s return. */
    } else if (key == K_ENTER) {
	if (level < sizeof(levels)/sizeof(levels[0])) {
	    FillRect(&levels[level++], blackPattern);
	    GetEvent(anyWindow, noEvent);
	    if (level > 0) {
		EraseRect(&levels[--level]);
		FrameRect(&levels[level]);
		FlushWindow(); nap(200);
	    }
	}
    } else if (key == K_BACKSP) {
	ReleaseEvent();
    } else {
	Bell();
    }
}

/*
** On an update event we always call DrawControls.  It will try to draw all
** of the visible controls associated with this window.
**
** We have to draw _everything_ that's supposed to be visible in the window at
** this time.  Here that is only the controls, which DrawControls does for us.
*/

void
updateevent(ep)
EventRecord *ep;
{
    SetPort(ep->who);
    BeginUpdate(ep->who);
    EndUpdate(ep->who);
}
