/*
**
** Test the Window Manager's Chinese font display.
**
*/

#include <stdio.h>
#include <isc/window.h>
#include <isc/keycodes.h>

#define WIDTH (600)		/* Window definitions. */
#define HEIGHT (400)

static int xpos = 32;
static int ypos = 48;
static int size = 16;
static char *path;

void updateevent();
int startchar;

main(argc, argv)
int argc;
char *argv[];
{
    int i, j;
    int trapqfd, fd;
    Rect winrect;
    int window;
    char *argp;

    startchar = 1600;
    while (--argc > 0) {
	argp = *++argv;
	if (*argp == '-') {
	    argp++;
	    switch (*argp++) {
	      case 's':
		if (!*argp)
		    --argc, argp = *++argv;
		size = atoi(argp);
		break;
	      case 'x':
		if (!*argp)
		    --argc, argp = *++argv;
		xpos = atoi(argp);
		break;
	      case 'y':
		if (!*argp)
		    --argc, argp = *++argv;
		ypos = atoi(argp);
		break;
	    }
	}
	else {
	    path = argp;
	}
    }
    if ((trapqfd = InitGraf()) < 0) { /* Initialize graphics toolbox. */
	fprintf(stderr, "Error %d in GrafInit\n", -trapqfd);
	exit(1);
    }
    if ((fd = ConnectGraf(path)) < 0) {	/* Initialize graphics toolbox. */
	fprintf(stderr, "Error %d in ConnectGraf\n", -fd);
	exit(1);
    }
    SetRect(&winrect, xpos, ypos, xpos+WIDTH, ypos+HEIGHT);
    window = NewWindow(&winrect, "Chinese Display", showWindow, documentProc,
		       frontWindow, noOptions, fd);
    SetPort(window);
    TextFont(13);
    TextSize(size);

    Event(updateEvt, updateevent);

    while ((j = GetKey(window)) != EOF
      && (j &= F_KEYMASK) != 'q' && j != 'Q') {
	SetRect(&winrect, 0, 0, WIDTH, HEIGHT);
	EraseRect(&winrect);
	startchar += 1000;
	staticinfo();
    }
}

void
updateevent(ep)
EventRecord *ep;
{
    BeginUpdate(ep->who);
    staticinfo();
    EndUpdate(ep->who);
}

staticinfo()			/* Do the display. */
{
    int i;
    unsigned short charbuf[40];

    for (i=0; i<27; i++)
	charbuf[i] = i+startchar;
    for (i=0; i<20; i++) {
	MoveTo(0, i*26+20);
	DrawText16(charbuf, 0, 27);
    }
}
