/*
**
** Test the graphics library.
**
*/

#include <stdio.h>
#include <isc/window.h>
#include <isc/keycodes.h>

#define XWINL 10		/* Window definitions. */
#define XWINR 630
#define YWINT 50
#define YWINB 340

#define print(x,y,s)	{ MoveTo(x,y); DrawString(s); }

static char *systemid;

int updateevent();

Rect winrect;

main(argc, argv)
int argc;
char *argv[];
{
    int i, j;
    int trapqfd, fd;
    int window;
    char *argp;

    if (argc == 2) {
	systemid = argv[1];
    }
    if ((trapqfd = InitGraf()) < 0) { /* Initialize graphics toolbox. */
	fprintf(stderr, "Error %d in InitGraf().\n", -trapqfd);
	exit(1);
    }
    if ((fd = ConnectGraf(systemid)) < 0) { /* Initialize graphics toolbox. */
	fprintf(stderr, "Error %d in ConnectGraf().\n", -fd);
	exit(1);
    }
    SetRect(&winrect, XWINL, YWINT, XWINR, YWINB);
    window = NewWindow(&winrect, "Color Demo", showWindow, documentProc,
		       frontWindow, noOptions, fd);
    SetRect(&winrect, -32000, -32000, 32000, 32000);
    SetPort(window);

    Event(updateEvt, updateevent);

    while ((j = GetKey(window)) != EOF
      && (j &= F_KEYMASK) != 'q' && j != 'Q') {
	staticinfo();
    }
    HiliteClear();
    DisposeWindow(window);
    EndGraf();
    exit(0);
}

updateevent(ep)
EventRecord *ep;
{
    BeginUpdate(ep->who);
    staticinfo();
    EndUpdate(ep->who);
}

staticinfo()			/* Do the display. */
{
    Rect titlerect, menurect, textrect;
    short i, j;

    SetRect(&titlerect, 230, 20, 410, 70);
    FillRect(&winrect, (Pattern *) 10);
#if 0
    EraseRect(&titlerect);
    FrameRect(&titlerect);
    HiliteRect(&titlerect, (Pattern *) 0, 1);
    TextFont(9);
    TextSize(18);
    centerstr(&titlerect, "Menu Select");
#endif

    TextFont(8);
    TextSize(14);
    TextMode(srcCopy);
    print(30, 50, " Teller ");
    print(30, 65, " Application ");
    TextFont(0);
    TextSize(12);
    TextMode(srcOr);
    SetRect(&menurect, 20, 100, 600, 270);
    FillRect(&menurect, (Pattern *) 15);
    FrameRect(&menurect);
    InsetRect(&menurect, 1, 1);
#if 0
    SetRect(&textrect, 50, 101, 300, YWINB-YWINT-21);
    HiliteRect(&menurect, (Pattern *) 7, 3);
    for (i=0; i<10; i++) {
	for (j=0; j<3; j++) {
	    FillRect(&textrect, (Pattern *) 15);
	    switch (j) {
	      case 0:
		print(50, 120, "0)  SALES");
		print(50, 140, "1)  OPEN/SERVICE");
		print(50, 160, "2)  TELLER APPLICATIONS");
		print(50, 180, "3)  SALES");
		print(50, 200, "4)  OPEN/SERVICE");
		print(50, 220, "5)  TELLER APPLICATIONS");
		break;

	      case 1:
		print(50, 120, "0)  INVESTMENT COUNSELOR");
		print(50, 140, "1)  DEPOSIT SERVICES");
		print(50, 160, "2)  CREDIT SERVICES");
		print(50, 180, "3)  RETIREMENT PLANS");
		print(50, 200, "4)  BUSINESS ACCOUNTS");
		print(50, 220, "5)  OTHER PRODUCTS");
		print(50, 240, "6)  ADMINISTRATIVE FUNCTIONS");
		break;

	      case 2:
		print(50, 120, "0)  Cash Check");
		print(50, 140, "1)  Checking Deposit");
		print(50, 160, "2)  Savings Deposit");
		print(50, 180, "3)  Savings Withdrawal");
		print(50, 200, "4)  Money Exchange");
		break;
	    }
	}
    }
    (void) sleep(2);
#endif

    TextFont(9);
    TextSize(18);
    EraseRect(&titlerect);
    FrameRect(&titlerect);
    centerstr(&titlerect, "Color Permutations");
    HiliteRect(&titlerect, (Pattern *) 0, 1);

    HiliteRect(&menurect, (Pattern *) 15, 3); /* Wipe out existing hilighting here. */
    EraseRect(&menurect);	/* Remove foreground information. */
    textrect = menurect;	/* Put up foreground strips. */
    i = (textrect.edge.bottom - textrect.edge.top)/5;
    textrect.edge.bottom = textrect.edge.top + i;
    TextFont(2);
    TextSize(18);
    MoveTo(textrect.edge.left+2, textrect.edge.top + 18);
    DrawString("This\325s what happens to foreground text over background swatches.");

    OffsetRect(&textrect, 0, i);
    FillRect(&textrect, (Pattern *) 0);
    FrameRect(&textrect);
    OffsetRect(&textrect, 0, i);
    FillRect(&textrect, (Pattern *) 5);
    FrameRect(&textrect);
    OffsetRect(&textrect, 0, i);
    FillRect(&textrect, (Pattern *) 7);
    FrameRect(&textrect);
    OffsetRect(&textrect, 0, i);
    FillRect(&textrect, (Pattern *) 10);
    FrameRect(&textrect);
    OffsetRect(&textrect, 0, i);

    textrect = menurect;
    i = (textrect.edge.right - textrect.edge.left)/13; /* Put up highlight strips. */
    textrect.edge.right = textrect.edge.left + i;	/* (Makes swatches.) */
    OffsetRect(&textrect, i, 0);
    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 0, 1);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);
    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 0, 2);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);
    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 0, 3);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);

    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 5, 1);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);
    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 5, 2);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);
    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 5, 3);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);

    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 7, 1);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);
    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 7, 2);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);
    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 7, 3);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);

    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 10, 1);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);
    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 10, 2);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);
    InsetRect(&textrect, 1, 1);
    HiliteRect(&textrect, (Pattern *) 10, 3);
    InsetRect(&textrect, -1, -1);
    FrameRect(&textrect);
    OffsetRect(&textrect, i, 0);
}

centerstr(rect, string)
Rect *rect;
char *string;
{
    short width, height, startat;

    width = rect->edge.right - rect->edge.left;
    height = rect->edge.bottom - rect->edge.top;
    startat = rect->edge.left + width/2 - StringWidth(string)/2;
    MoveTo(startat, rect->edge.top + height/2 + 6);
    DrawString(string);
}
