/*
** Prototypes for all the functions in vterm.
*/

#ifndef lint			/* Old lint. */
	/* System functions. */
#ifdef _lint			/* DCC doesn't like this one? */
	extern int rdnix(...);
#endif
	extern void *malloc(long);
	extern void *relloc(void *, long);
	extern void free(void *);
	extern int kill(int, int);
	extern int fork(void);
	extern void setpgrp(void);
	extern int dup(int);
	extern int getppid(void);
	extern int open(char *, int, ...);
	extern int close(int);
	extern int stat(char *, struct stat *);
	extern int write(int, char *, int);
	extern void chdir(char *);
	extern char *getenv(char *);
	extern void exit(int);
	extern void nap(int);
	extern char *strcat(char *, char *);
	extern char *strcpy(char *, char *);
	extern char *strncat(char *, char *, int);
	extern char *strncpy(char *, char *, int);
	extern char *strtok(char *, char *);

	/* vt220.c  */
	void init_vt220(struct vtcb *vtcb);
	void makecopies(struct vtcb *vtcb);
	void vt220(struct vtcb *vtcb, BYTE *buf, int bc);
	void close_vt220(struct vtcb *vtcb);
	void NormDisp(BYTE ch);
	void dopend(unsigned int flag);

	/* vthandle.c  */
	void handlerinit(void);
	void handlerread(void);
	void tqread(void);
	void poll(struct vtcb *vtcb);
	int checkprot(register struct nwblock *hndl);
	int invalid_vtcb(struct vtcb *vtcb);
	void tqdone(struct nwblock *hndl, int it_rpar, int it_rn);
	void termhreq(int reqnum, long status, int mode);
	int newrd(register struct vtcb *vtcb, register struct nwblock *hndl, int readcheck);
	void termrdreq(register struct vtcb *vtcb, register int reqnum, int rpar);
	int handlerdone(struct nwblock *hndl, int it_rpar, int it_rn);
	void hotcopies(register struct vtcb *vtcb, char *names);
	struct connect *copyconn(char *name);
	void delcopyconn(struct connect *);
	void deletehotcopies(register struct vtcb *vtcb);
	void new_history(register struct vtcb *vtcb);
	void restartflow(struct vtcb *vtcb);
	void close_all(void);
	void dispose_vt220(struct vtcb *vtcb);

	/* vtmain.c  */
	int main(int argc, char *argv[]);
	struct vtcb *findvtcb(int windowid, struct vidcopy **vcpp);
	void takeoutfd(int);
	void updateevent(EventRecord *ep);
	void draw_icon(struct vtcb *vtcb);
	void activate_vt220(EventRecord *ep);
	void keyevent(EventRecord *ep);
	void startspan(register struct vtcb *vtcb,
		       register short row, register short col);
	void dospan(register struct vtcb *vtcb,
		    register short *row, register short *col);
	void endspan(struct vtcb *vtcb);
	void removespan(struct vtcb *vtcb);
	void mouseevent(EventRecord *ep);
	void windowevent(EventRecord *ep);
	void fixisckeys(long *keycode);
	int count_ready(struct vtcb *vtcb, BYTE *kybuffer);
	int vt220_rdchk(struct vtcb *vtcb);
	int terminate(struct vtcb *vtcb, BYTE *kybuffer, int wrcount);
	int vt220_rdtimer(struct vtcb *vtcb, int rpar, int rn);
	void doabort(void);
	void dodebug(void);
	int myatoi(register char *p);
	void doiconify(struct vtcb *vtcb);
	void douniconify(struct vtcb *vtcb);

	/* vtmenu.c  */
	void Menu_init(struct vtcb *vtcb);
	void Menu_kill(void);
	void menuevent(EventRecord *ep);
	void niceme(void);

	/* vtokt.c  */

	/* vtsubs.c  */
	void scrapevent(EventRecord *ep);
	void killscrap(void);
	void fetchscrap(void);
	void writescrap(void);
	void copy(void);
	void paste(void);
	void VCursor(struct vtcb *vtcb, int mode);
	void cursortoggle(struct vtcb *vtcb);
	void identify(void);
	void addbuffer(struct vtcb *vtcb, int ch);
	int  rmbuffer(struct vtcb *vtcb);
	void repaint(struct vtcb *vtcb, EventRecord *ep);
	void home(void);
	void cul(int nlines, int scrollflag);
	void cdl(int nlines, int scrollflag);
	void cbc(int nchars);
	void scroll(int direction, int dead_line, int open_line, int nlines);
	void clear(int row, int col, int nchars);
	void blockclr(int row, int nrows);
	void blockfill(int row, int nrows);
	void insert(int nchars);
	void delete(int nchars);
	void Reset_termio(struct vtcb *vtcb);
	void simsgttyb(struct vtcb *vtcb, int rn);
	void Reset_vt220(struct vtcb *vtcb);
#endif
