/*******************************************************************
**
**  Video Terminal Output Keyboard Translation tables
**   Common to both KBD-II and KBD-III
**
**	$Header: /usr/users/window/vterm/RCS/vtokt.c,v 1.7 1992/05/20 20:08:46 jimc Exp $	
**
*******************************************************************/

#include <isc/window.h>
#include <sys/types.h>		/* System types. */
#include <dnix/ireq.h>
#include <termio.h>
#include <isc/vterm.h>
#include "vtcb.h"

char	*out_table[] = {

		0,0,			/* 00 - 01 */
		"\002",				/* 02 Shift-K_TAB */
		0,0,0,0,0,			/* 03 - 07 */
		"\177",				/* 08 K_BCKSP2 ( kbd-ii ) */
		"\011",				/* 09 K_TAB */
		0,0,0,				/* 0A - 0C */
		"\r",				/* 0D K_ENTER */
		0,0,				/* 0E - 0F */

		0,0,0,0,0,0,0,0,	/* 10 - 17 */
		0,0,0,				/* 18 - 1A */
		"\033",				/* 1b K_ESC */
		0,0,0,0,			/* 1C - 1F */

		0,0,0,0,0,0,0,0,	/* 20 - 27 */
		0,0,0,				/* 28 - 2A */
		"\033Om",			/* 2B K_NPLUS */
		"\033Ol",			/* 2C K_NCOMMA ( Faked by SHIFT K_NPLUS/K_NMINUS) */
		"\033Om",			/* 2D K_NMINUS */
		"\033On",			/* 2E K_NDOT */
		0,					/* 2F */

		"\033Op",			/* 30 K_NPAD0 */
		"\033Oq",			/* 31 K_NPAD1 */
		"\033Or",			/* 32 K_NPAD2 */
		"\033Os",			/* 33 K_NPAD3 */
		"\033Ot",			/* 34 K_NPAD4 */
		"\033Ou",			/* 35 K_NPAD5 */
		"\033Ov",			/* 36 K_NPAD6 */
		"\033Ow",			/* 37 K_NPAD7 */
		"\033Ox",			/* 38 K_NPAD8 */
		"\033Oy",			/* 39 K_NPAD9 */
		0,0,0,0,0,0,		/* 3A - 3F */

		"\033[1~",			/* 40 K_HOME */
		"\033[A",			/* 41 K_UP */
		"\033[B",			/* 42 K_DOWN */
		"\033[C",			/* 43 K_LEFT */
		"\033[D",			/* 44 K_RIGHT */
		"\033OP",			/* 45 K_PF1 */
		"\033OQ",			/* 46 K_PF2 */
		"\033OR",			/* 47 K_PF3 */
		"\033OS",			/* 48 K_PF4 */
		0,0,0,0,0,0,0,		/* 49 - 4F */

		0,					/* 50 */
		"\033[2~",			/* 51 K_INSERT ( 101-KBD ) */
		"\033[3~",			/* 52 K_DELETE ( 101-KBD ) */
		"\033[4~",			/* 53 K_END ( 101-KBD ) */
		"\033[5~",			/* 54 K_PGUP ( 101-KBD ) */
		"\033[6~",			/* 55 K_PGDN ( 101-KBD ) */
		"\033[7~",			/* 56 K_PRNTSCRN ( kbd-ii ) */
		"\033[10~",			/* 57 K_RESET ( kbd-ii ) */
		"\033[13~",			/* 58 K_SEND ( kbd-ii ) */
		"\033[14~",			/* 59 K_CLRFLD ( kbd-ii ) */
		0,0,0,0,			/* 5A - 5D */
		"\033[Ol",			/* 5E K_NPAD00 ( kbd-ii ) */
		"\033[90~",			/* 5F K_BREAK */

		0,					/* 60 */
		"\033[20~",			/* 61 K_F1 */
		"\033[21~",			/* 62 K_F2 */
		"\033[22~",			/* 63 K_F3 */
		"\033[23~",			/* 64 K_F4 */
		"\033[24~",			/* 65 K_F5 */
		"\033[25~",			/* 66 K_F6 */
		"\033[26~",			/* 67 K_F7 */
		"\033[27~",			/* 68 K_F8 */
		"\033[28~",			/* 69 K_F9 */
		"\033[29~",			/* 6a K_F10 */
		"\033[30~",			/* 6b K_F11 */
		"\033[31~",			/* 6c K_F12 */
		"\033[11~",			/* 6d K_F13 ( kbd-ii ) */
		"\033[12~",			/* 6e K_F14 ( kbd-ii ) */
		0,					/* 6F */
		0,0,0,0,0,0,0,0,	/* 70 - 77 */
		0,0,0,0,			/* 78 - 7B */
		0,					/* 7C */
		"\023",				/* 7D K_SCROLL */
		"\033OM",			/* 7E K_NPENTER */
		"\177",				/* 7F K_BACKSP */

};

BYTE	 ctrl_xlate[] = {
		NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,		/* 0x00-0x07 */
		NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,		/* 0x08-0x0F */
		NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,		/* 0x10-0x17 */
		NOCODE,	NOCODE,	NOCODE,	0x60,	NOCODE,	NOCODE,	NOCODE,	NOCODE,		/* 0x18-0x1F */
		0x00,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,		/* 0x20-0x27 */
		NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	0x1F,	NOCODE,	0x1F,		/* 0x28-0x2F */
		NOCODE,	NOCODE,	0x00,	0x1B,	0x1C,	0x1D,	0x1E,	0x1F,		/* 0x30-0x37 */
		0x7F,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	NOCODE,	0x1F,		/* 0x38-0x3F */
		0x00,	0x01,	0x02,	0x03,	0x04,	0x05,	0x06,	0x07,		/* 0x40-0x47 */
		0x08,	0x09,	0x0A,	0x0B,	0x0C,	0x0D,	0x0E,	0x0F,		/* 0x48-0x4F */
		0x10,	0x11,	0x12,	0x13,	0x14,	0x15,	0x16,	0x17,		/* 0x50-0x57 */
		0x18,	0x19,	0x1A,	0x1B,	0x1C,	0x1D,	0x1E,	0x1F,		/* 0x58-0x5F */
		0x1E,	0x01,	0x02,	0x03,	0x04,	0x05,	0x06,	0x07,		/* 0x60-0x67 */
		0x08,	0x09,	0x0A,	0x0B,	0x0C,	0x0D,	0x0E,	0x0F,		/* 0x68-0x6F */
		0x10,	0x11,	0x12,	0x13,	0x14,	0x15,	0x16,	0x17,		/* 0x70-0x77 */
		0x18,	0x19,	0x1A,	NOCODE,	NOCODE,	NOCODE,	0x1E,	NOCODE		/* 0x78-0x7F */
};
