/*
** Bit packing stuff.  See Macintosh Technical Note #171 for more information.
*/

#include "../clunkdraw.h"

void
PackBits(srcin, destin, srccount)
const char **srcin;             /* Pointer to source & dest bitmap pntrs. */
char **destin;
register short srccount;        /* Count of source bytes to pack. */
{
    register short i, packcount, nonpackcount;
    register const char *src, *p;
    register char *dest, match;

    while (srccount > 127) {    /* Too much for a single run at it, */
        PackBits(srcin, destin, 127); /* do it in pieces. */
        srccount -= 127;
    }
    dest = *destin;
    p = src = *srcin;
    nonpackcount = packcount = 0;
    while (i = srccount--) {    /* While there is data to pack. */
        if ((p[0] == p[1]) && (p[0] == p[2]) && i > 2) { /* A run of >= 3? */
            if (nonpackcount) { /* Any non-packable accumulated yet? */
                *dest++ = nonpackcount - 1; /* Stuff in a count byte */
                while (nonpackcount--) /* and blow out non-packed data. */
                    *dest++ = *src++; /* (To get all this out of the way of */
            }                         /*  the packed data first.) */
            match = *src;
            while (*p++ == match && i--) /* Find length of run. */
                packcount++;
            *dest++ = 1 - packcount; /* Stuff in a repeat byte. */
            srccount -= (packcount-1); /* Decrement count by what's packed. */
            nonpackcount = packcount = 0;
            *dest++ = match;    /* Copy the byte to repeat. */
            src = --p;          /* Move to uncompressed data. */
        } else {                /* Not a run. */
            nonpackcount++;     /* Increment the count of non-packeds. */
            p++;
        }
    }
    if (nonpackcount) {         /* Any leftover non-packable? */
        *dest++ = nonpackcount - 1; /* Stuff in a count byte */
        while (nonpackcount--) /* and blow out non-packed data. */
            *dest++ = *src++;
    }
    *srcin = src;               /* Update source & dest pointers. */
    *destin = dest;
}
