// Imagemagick sucks, and can't seem to eat MacPaint files reliably.
// Save the given bitmap to a PBM interchange file.  Bulky, but safe?

#include "../clunkdraw.h"
#include <stdio.h>
#include <stdlib.h>

static void
binstr(int val, char *buf)
{
   int mask;

   for (mask = 128; mask; mask >>= 1) {
      if (val & mask)
         *buf++ = '1';
      else
         *buf++ = '0';
   }
   *buf++ = 0;
}

void
SaveToPBMFile(const BitMap *sbits, const char *fName)
{
   int x, y;
   unsigned char *s;
   char buf[10];
   FILE *fp;

   if (!sbits || sbits->bpp != 1) return;
   if (!(fp = fopen(fName, "w")))
      return;

   fprintf(fp, "P1\n");         // Portable Bit Map.
   fprintf(fp, "%d %d\n", sbits->rowBytes * 8, RectHeight(&sbits->bounds));
   for (y = 1; y <= RectHeight(&sbits->bounds); y++) {
      fprintf(fp, "# Line %d\n", y);
      s = sbits->baseAddr + ((y-1) * sbits->rowBytes);
      for (x = 0; x < sbits->rowBytes; x++) {
         binstr(*s++, buf);
         fputs(buf, fp);
      }
      fprintf(fp, "\n");
   }
   fclose(fp);
}
