// Save the given pixmap to a stream in PPM (bulky) format.

#include "../clunkdraw.h"
#include <stdio.h>

void
_SaveToStream(const BitMap *sbits, FILE *fp)
{
   int x, y, pix;

   fprintf(fp, "P3\n");         // Portable Pixel Map.
   fprintf(fp, "%d %d\n", sbits->rowBytes / 2, RectHeight(&sbits->bounds));
   fprintf(fp, "63\n"); // 6 bits of range per emitted {R, G, B} value.
   for (y = 0; y < RectHeight(&sbits->bounds); y++) {
      fprintf(fp, "# Line %d\n", y + 1);
      for (x = 0; x < sbits->rowBytes / 2; x++) {
         pix = GetPixel(x, y); // RGB565 pixel.
         fprintf(fp, "%2d %2d %2d  ", (pix >> 10) & 0x3E, // R is bits [15:11]
                                      (pix >> 5) & 0x3F,  // G is bits [10:5]
                                      (pix << 1) & 0x3E); // B is bits [4:0]
      }
      fprintf(fp, "\n");
   }
}
