/*
** Bit packing stuff.  See Macintosh Technical Note #171 for more information.
*/

#include "../clunkdraw.h"

void
UnpackBits(srcin, destin, destcount)
const char **srcin;             /* Pointer to source & dest bitmap pntrs. */
char **destin;
register short destcount;       /* Count of dest bytes to unpack into. */
{
    register short repcnt;
    register const S8 *src;
    register char *dest, copy;

    while (destcount > 127) {   /* Too much for a single run at it, */
        UnpackBits(srcin, destin, 127); /* do it in pieces. */
        destcount -= 127;
    }
    dest = *destin;
    src = *srcin;
    while (destcount > 0) {     /* While there is packed data. */
        if (*src < 0) {         /* We have a repeat count. */
            repcnt = 1 - *src++;
            if ((destcount -= repcnt) >= 0) { /* Sanity check. */
                copy = *src++;
                while (repcnt--)
                    *dest++ = copy;
            }
        } else {                /* We have a raw piece. */
            repcnt = 1 + *src++;
            if ((destcount -= repcnt) >= 0) { /* Sanity check. */
                while (repcnt--)
                    *dest++ = *src++;
            }
        }
    }
    *srcin = src;               /* Update source & dest pointers. */
    *destin = dest;
}
