#define CONTROLS_SOURCE
#include "../clunkdraw.h"
#include "cmcontrols.h"

int
TrackControl(theControl, thePoint, actionProc)
ControlID theControl;
Point *thePoint;
void (*actionProc)(ControlID theControl, int partCode);
{
   EventRecord evt;
   int ii, jj;
   long savemouse, when, lastwhen;
   Point hit;

   hit = *thePoint;             /* Save from other events! (Private copy.) */
   when = lastwhen = 0; /* For scrollbar pacing. */
   if (ii = jj = TestControl(theControl, &hit)) {
#if 0
      savemouse = theMouseMode; /* We want nearly all mousies, including */
      if (theControl->contrlDefProc == scrollBarProc) /* autorepeats. */
         MouseMode(mouseStream | F_KEYDOWN | F_KEYUP | F_MOUSE1);
      else                      /* Only these for non scroll bars. */
         MouseMode(F_KEYDOWN | F_KEYUP | F_MOUSE1);
#endif
      HiliteControl(theControl, jj); /* Highlight the control part. */
      do {
         if (ii == inThumb) {   /* Handle elevator drags. */
            if (ii = (int)(*theControl->cdefproc)(theControl->contrlDefProc,
                                                  theControl, dragCntl, &hit)) {
               /* Move it ii pixels worth. */
               (*theControl->cdefproc)(theControl->contrlDefProc,
                                       theControl, posCntl, (void *)ii);
               ii = inThumb; /* Mouse was released in the thumb. */
            }
            break;              /* Finish tracking routine. */
         }
         if (actionProc && jj == ii) {  /* Do we need to do external proc? */
                                /* Don't call an action proc for a scrollbar */
                                /* if it hasn't been long enough yet. */
            if (theControl->contrlDefProc != scrollBarProc ||
                when >= (lastwhen + (long) theControl->contrlData)) {
               lastwhen = when; /* Re-start pacing timer. */
               if (actionProc == (void (*)()) -1) /* Drag procedure? */
                  actionProc = theControl->contrlAction;
               if (actionProc && actionProc != (void (*)()) -1) {
                  (*actionProc)(theControl, jj); /* Do drag. */
               }
            }
         }
         GetNextEvent(1<<mouseEvt, &evt); /* Mouse event. */
         hit = evt.where.corner.topLeft;
         when = evt.when;
         jj = TestControl(theControl, &hit);
         HiliteControl(theControl, (jj == ii) ? jj : 0); /* Track w/hilite. */
         if (!(evt.message & (F_KEYUP | F_MOUSE1))) { /* Lost track */
            jj = 0;             /* of the mouse (window swap, bugs, etc)? */
            break;              /* Bail out gracefully then. */
         }
      } while (!(evt.message & F_KEYUP));   /* Done tracking on mouseup. */
      HiliteControl(theControl, 0); /* Un-hilight the control part. */
#if 0
      MouseMode(savemouse);     /* Restore appl's mouse mode. */
#endif
      return (jj == ii) ? jj : 0;
   }
   return 0;
}
