#include "../../clunkdraw.h"

int
main(int argc, char *argv[])
{
   ControlID btn1, btn2, rad1, rad2, rad3, chk1, chk2, chk3, hscr, vscr, c;
   Rect br, br2;
   EventRecord evt;
   int inPart;

   InitGraf2();
   InitCursor();
   FrameRect(&thePort->portRect);
   InitControls();
   SetRect(&br, 100, 40, 180, 60);
   btn1 = NewControl(thePort, &br, "Cancel", 1, 0, 0, 1, pushButProc, 0);
   OffsetRect(&br, 0, 40);
   br.edge.bottom += 8;
   btn2 = NewControl(thePort, &br, "OK", 1, 0, 0, 1, defButProc, 0);

   OffsetRect(&br, 0, 40);
   br.edge.bottom -= 12;
   br2 = br;
   rad1 = NewControl(thePort, &br, "One", 1, 1, 0, 1, radioButProc, 0);
   OffsetRect(&br, 0, 16);
   rad2 = NewControl(thePort, &br, "of", 1, 0, 0, 1, radioButProc, 0);
   OffsetRect(&br, 0, 16);
   rad3 = NewControl(thePort, &br, "Three", 1, 0, 0, 1, radioButProc, 0);

   OffsetRect(&br2, 100, 0);
   chk1 = NewControl(thePort, &br2, "Off", 1, 0, 0, 1, checkBoxProc, 0);
   OffsetRect(&br2, 0, 16);
   chk2 = NewControl(thePort, &br2, "On", 1, 1, 0, 1, checkBoxProc, 0);
   OffsetRect(&br2, 0, 16);
   chk3 = NewControl(thePort, &br2, "Mixed", 1, 2, 0, 2, checkBoxProc, 0);

   br = thePort->portRect;
   br.edge.top -= 1;
   br.edge.left = br.edge.right - 17;
   br.edge.bottom -= 16;
   vscr = NewControl(thePort, &br, "vs", 1, 0, 0, 1, scrollBarProc, 0);

   br2 = thePort->portRect;
   br2.edge.top = br2.edge.bottom - 17;
   br2.edge.left -= 1;
   br2.edge.right -= 16;
   hscr = NewControl(thePort, &br2, "hs", 1, 0, 0, 10, scrollBarProc, 0);
   SetCtlValues(hscr, 3, 5);

   while (GetNextEvent(anyEvent, &evt)) { // Run our test 'dialog'.
      if (evt.what == mouseEvt && evt.message & F_KEYDOWN) {
	 do { // Not a loop, just used for early exit.
	    if (TestControl(c = btn1, &evt.where.corner.topLeft)) break;
	    if (TestControl(c = btn2, &evt.where.corner.topLeft)) break;
	    if (TestControl(c = rad1, &evt.where.corner.topLeft)) break;
	    if (TestControl(c = rad2, &evt.where.corner.topLeft)) break;
	    if (TestControl(c = rad3, &evt.where.corner.topLeft)) break;
	    if (TestControl(c = chk1, &evt.where.corner.topLeft)) break;
	    if (TestControl(c = chk2, &evt.where.corner.topLeft)) break;
	    if (TestControl(c = chk3, &evt.where.corner.topLeft)) break;
	    if (TestControl(c = hscr, &evt.where.corner.topLeft)) break;
	    if (TestControl(c = vscr, &evt.where.corner.topLeft)) break;
	    c = 0;
	 } while (0);
	 if (c) { // Mouse-down in a control?
	    inPart = TrackControl(c, &evt.where.corner.topLeft,
				  (void (*)(void *, int)) -1);
	    switch (inPart) {
	       case inButton:
		  if (c == btn1) { /* Cancel, restore all control values. */
		     SetCtlValue(rad1, 1);
		     SetCtlValue(rad2, 0);
		     SetCtlValue(rad3, 0);
		     SetCtlValue(chk1, 0);
		     SetCtlValue(chk2, 1);
		     SetCtlValue(chk3, 2);
		     SetCtlValue(vscr, 0);
		     SetCtlValues(hscr, 3, 5);
		  }
		  if (c == btn2) { /* OK, time to quit. */
		     ReleaseEvent();
		     EndCursor();
		  }
		  break;

	       case inCheckBox:	/* Or radio button. */
		  if (c == rad1 || c == rad2 || c == rad3) {
		     SetCtlValue(rad1, 0);
		     SetCtlValue(rad2, 0);
		     SetCtlValue(rad3, 0);
		     SetCtlValue(c, 1);
		  }
		  if (c == chk1 || c == chk2 || c == chk3) {
		     SetCtlValue(c, !GetCtlValue(c));
		  }
		  break;

	       case inUpButton:
		  SetCtlValue(c, GetCtlValue(c) - 1);
		  break;

	       case inDownButton:
		  SetCtlValue(c, GetCtlValue(c) + 1);
		  break;

	       case inPageUp:
		  SetCtlValue(c, GetCtlValue(c) - 2);
		  break;

	       case inPageDown:
		  SetCtlValue(c, GetCtlValue(c) + 2);
		  break;

	       case inThumb: break;
	    }
	 }
      }
   }

   SaveToPPMFile(&thePort->portBits, "junk.ppm");
   EndGraf2();
   return 0;
}
