#include "../clunkdraw.h"
#include "cdcurs.h"
#define FALSE 0

/*
** HideCursor removes the cursor from the screen, restoring the
** bits under it, and decrements the cursor level (which
** InitCursor initialized to 0).  Every call to HideCursor should
** be balanced by a subsequent call to ShowCursor.
**
** Currently only works with 16-bit color displays, because that's
** the only one I have that works 'live'.  (Mouse cursors are not
** currently useful on E-Paper displays.)
*/

void
HideCursor(void)
{
   int ii, jj, x, y;
   U16 saveFg;
   GrafPtr tp;

   if (_CrsrInited) {
      if (_CrsrVis) {
         if ((tp = thePort) && tp->portBits.bpp == 16) {
            saveFg = tp->fgColor;
            for (ii = 0, y = _CrsrRect.edge.top;
                         y < _CrsrRect.edge.bottom; y++, ii++) {
               for (jj = 0, x = _CrsrRect.edge.left;
                            x < _CrsrRect.edge.right; x++, jj++) {
                  // Restore the under-Cursor screen bits.
                  tp->fgColor = _CrsrSave[ii][jj];
                  (*tp->_SetPix)(tp, x, y);
               }
            }
            tp->fgColor = saveFg;
         }
         _CrsrVis = FALSE;
      }
      _CrsrState--;
   }
}
