#include "../clunkdraw.h"
#include "cdcurs.h"
#define TRUE 1
#define FALSE 0

/*
** If the cursor and the given rectangle intersect, ShieldCursor
** hides the cursor.  If they don't intersect, the cursor remains
** visible unless the mouse moves, in which case it's hidden
** automatically by the cursor tracking routines.
**
** This is so the drawing library doesn't get burdened with continually
** hiding and showing the cursor, if it's drawing in places where the
** cursor is not.
**
** Like HideCursor, ShieldCursor decrements the cursor level and
** should be balanced by a call to ShowCursor.
*/

void
ShieldCursor(const Rect *shieldRect, const Point *offsetPt)
{
   Rect r;

   if (_CrsrInited) {
#if 0 // This isn't working right in this environment.
      r = *shieldRect;
      OffsetRect(&r, -offsetPt->h, -offsetPt->v);
      if (SectRect(&_CrsrRect, &r, &r)) {
         HideCursor();
         _CrsrShielded = FALSE;
      } else {
         _CrsrShielded = TRUE;
      }
#else // For now, in ultra-simple world, just Hide.
      HideCursor();
#endif
   }
}
