#include <linux/spi/spidev.h>

#define EPD_3in7_WIDTH       280
#define EPD_3in7_HEIGHT      480

#define SPI_CS_Mode_LOW 0     // Chip Select 0
#define SPI_CS_Mode_HIGH 1    // Chip Select 1
#define SPI_CS_Mode_NONE 3    // No CS, control it yourself
#define SPI_BIT_ORDER_LSBFIRST 0  // LSB First
#define SPI_BIT_ORDER_MSBFIRST 1  // MSB First

int EPD_RST_PIN;  // Low is reset.
int EPD_DC_PIN;   // Data/Command selection pin, low is command.
int EPD_CS_PIN;   // SPI chip select, active low.
int EPD_BUSY_PIN; // Low is busy.

// Remember the last state these output pins are in.
int lastRstPinState;
int lastDcPinState;
int lastCsPinState;

U8 bits;

struct spi_ioc_transfer tr;
int spiFd;
U8 spiMode;

void EPD_SPI_Init(void);
void EPD_SPI_Exit(void);
void EPD_3in7_1Gray_Init(void);
void EPD_3in7_1Gray_Clear(void);
void EPD_3in7_4Gray_Init(void);
void EPD_3in7_4Gray_Clear(void);
void EPD_3in7_1Gray_Display(const U8 *Image);
void EPD_3in7_1Gray_Display_Part(const U8 *Image, int Xstart, int Ystart, int Xend, int Yend);
void EPD_3in7_4Gray_Display(const U8 *Image);
void EPD_3in7_Sleep(void);
void EPD_3in7_DeepSleep(void);
void EPD_Delay_ms(int xms);
