#include "../clunkdraw.h"
#include "../winds/cdwmdata.h"
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <linux/input.h>
#define TRUE 1
#define FALSE 0

static int efd = -1;
static Point mousePos;
static long mouseBtns;

Boolean
GetNextEvent(int eventMask, EventRecord *evt)
{
   struct input_event ievt;
   WindowPeek p;
   int ii;

   while (1) {
      // Looking for any Update Events?
      if (eventMask & (1 << updateEvt)) {
         for (p = WindowList; p; p = p->nextWindow) {
            if (!EmptyRgn(p->updateRgn)) {
               if (evt) {
                  evt->who = (WindowPtr)p;
                  evt->what = updateEvt;
                  evt->message = (long)(void *)p->updateRgn;
                  evt->when = time(0);
                  evt->where = (*p->updateRgn)->rgnBBox;
               }
               return TRUE;
            }
         }
      }

      if (eventMask & (1 << mouseEvt | 1 << keyEvt)) {
         if (efd < 0)
            efd = open("/dev/input/event0", O_RDONLY|O_CLOEXEC);
         if (efd >= 0) {
            ii = read(efd, &ievt, sizeof ievt);
            if (ii != sizeof ievt) {
               close(efd);
               efd = -1;
               return FALSE;
            }
            switch (ievt.type) {
               case EV_REL:        /* Relative mouse move. */
                  switch (ievt.code) {
                     case REL_X:
                        mousePos.h += ievt.value;
                        break;

                     case REL_Y:
                        mousePos.v += ievt.value;
                        break;
                  }

                  // This next needs some work with regard to windows, etc.
                  mousePos = PinRect(&thePort->portRect, &mousePos);
                  _MoveCursor(&mousePos);

                  if (eventMask & (1 << mouseEvt)) {
                     if (evt) {
                        evt->who = 0;
                        evt->what = mouseEvt;
                        evt->message = mouseBtns;
                        evt->when = time(0);
                        evt->where.corner.topLeft = mousePos;
                        evt->where.corner.botRight = mousePos;
                     }
                     return TRUE;
                  }
                  break;

               case EV_KEY:        /* Mouse button. */
                  if (ievt.value == 1)
                     switch (ievt.code) {
                        case BTN_LEFT:   mouseBtns |= F_MOUSE1; break;
                        case BTN_RIGHT:  mouseBtns |= F_MOUSE2; break;
                        case BTN_MIDDLE: mouseBtns |= F_MOUSE3; break;
                     }
                  else
                     switch (ievt.code) {
                        case BTN_LEFT:   mouseBtns &= ~F_MOUSE1; break;
                        case BTN_RIGHT:  mouseBtns &= ~F_MOUSE2; break;
                        case BTN_MIDDLE: mouseBtns &= ~F_MOUSE3; break;
                     }
                  if (eventMask & (1 << mouseEvt)) {
                     if (evt) {
                        evt->who = 0;
                        evt->what = mouseEvt;
                        evt->message = (ievt.value == 1) ? F_KEYDOWN : F_KEYUP;
                        evt->message |= mouseBtns;
                        evt->when = time(0);
                        evt->where.corner.topLeft = mousePos;
                        evt->where.corner.botRight = mousePos;
                     }
                     return TRUE;
                  }
                  break;
            }
         }
      }
   }
}

void
ReleaseEvent()
{
   if (efd >= 0)
      close(efd);
}
