// If you want a small installation, copy this file and remove fonts you don't
// need.

#include "../clunkdraw.h"
#include "../fonts/cdfont.h"

// Array of included fonts.  All 169 of them, by default.  If you want
// a smaller executable, provide your own array with this name, with
// only the fonts you want.
const FontTableEntry EmbeddedFonts[170] = {
    { 0, 12, &LaCenter12_Font},
    { 1, 12, &Spangle12_Font},
    { 2, 18, &Pullman18_Font},
    { 3,  9, &CleElum9_Font}, { 3, 12, &CleElum12_Font},
    { 4, 12, &Woodland12_Font},
    { 5,  9, &OtisOrchards9_Font},
    { 6, 12, &Chicago12_Font}, { 6, 18, &Chicago18_Font},
                               { 6, 24, &Chicago24_Font},
    { 7, 12, &LosAngeles12_Font}, { 7, 24, &LosAngeles24_Font},
    { 8, 12, &Venice12_Font}, { 8, 14, &Venice14_Font}, { 8, 24, &Venice24_Font},
                              { 8, 28, &Venice28_Font},
    { 9, 18, &London18_Font}, {9, 36, &London36_Font},
    {10,  9, &Courier9_Font}, {10, 10, &Courier10_Font},
                              {10, 12, &Courier12_Font},
                              {10, 14, &Courier14_Font},
                              {10, 18, &Courier18_Font},
                              {10, 20, &Courier20_Font},
                              {10, 24, &Courier24_Font},
                              {10, 30, &Courier30_Font},
                              {10, 40, &Courier40_Font},
    {11, 18, &Athens18_Font}, {12,  9, &Symbol9_Font},  {12, 12, &Symbol12_Font},
                              {12, 18, &Symbol18_Font}, {12, 24, &Symbol24_Font},
//  {13,  0, 0}, // There is no GB font, #13, because it really is a
//   ;           // Great Big Chinese font.  Huge.  Too big for us.
    {14, 14, &Richland14_Font},
    {15, 12, &Pasco12_Font},
    {16, 16, &Kennewick16_Font},
    {17, 16, &Umatilla16_Font},
    {18, 18, &Aberdeen18_Font},
    {19, 12, &Baghdad12_Font},
    {20,  7, &Ballard7_Font},
    {21,  7, &Smallville7_Font}, {21,  9, &Smallville9_Font},
    {22,  8, &Wallingford8_Font},
    {23,  5, &Geneva5_Font}, {23,  6, &Geneva6_Font}, {23,  7, &Geneva7_Font},
                             {23,  8, &Geneva8_Font}, {23,  9, &Geneva9_Font},
                             {23, 10, &Geneva10_Font}, {23, 12, &Geneva12_Font},
                             {23, 14, &Geneva14_Font}, {23, 16, &Geneva16_Font},
                             {23, 18, &Geneva18_Font}, {23, 20, &Geneva20_Font},
                             {23, 21, &Geneva21_Font}, {23, 24, &Geneva24_Font},
                             {23, 27, &Geneva27_Font}, {23, 28, &Geneva28_Font},
                             {23, 30, &Geneva30_Font}, {23, 32, &Geneva32_Font},
                             {23, 36, &Geneva36_Font}, {23, 40, &Geneva40_Font},
    {24,  9, &NewYork9_Font}, {24, 10, &NewYork10_Font},
                              {24, 12, &NewYork12_Font},
                              {24, 14, &NewYork14_Font},
                              {24, 18, &NewYork18_Font},
                              {24, 20, &NewYork20_Font},
                              {24, 24, &NewYork24_Font},
                              {24, 36, &NewYork36_Font},
    {25,  9, &Monaco9_Font}, {25, 12, &Monaco12_Font},
    {26, 18, &Mobile18_Font},
    {27,  7, &TimesRoman7_Font}, {27,  9, &TimesRoman9_Font},
                                 {27, 10, &TimesRoman10_Font},
                                 {27, 12, &TimesRoman12_Font},
                                 {27, 14, &TimesRoman14_Font},
                                 {27, 18, &TimesRoman18_Font},
                                 {27, 24, &TimesRoman24_Font},
    {28,  9, &Helvetica9_Font}, {28, 10, &Helvetica10_Font},
                                {28, 12, &Helvetica12_Font},
                                {28, 14, &Helvetica14_Font},
                                {28, 18, &Helvetica18_Font},
                                {28, 24, &Helvetica24_Font},
    {29, 10, &ZapfDingbats10_Font}, {29, 12, &ZapfDingbats12_Font},
                                    {29, 14, &ZapfDingbats14_Font},
                                    {29, 18, &ZapfDingbats18_Font},
                                    {29, 24, &ZapfDingbats24_Font},
    {30, 10, &TimesBold10_Font}, {30, 12, &TimesBold12_Font},
                                 {30, 14, &TimesBold14_Font},
                                 {30, 18, &TimesBold18_Font},
                                 {30, 24, &TimesBold24_Font},
    {31, 12, &TimesItalic12_Font}, {31, 14, &TimesItalic14_Font},
                                   {31, 18, &TimesItalic18_Font},
                                   {31, 24, &TimesItalic24_Font},
    {32, 10, &TimesBoldItalic10_Font}, {32, 12, &TimesBoldItalic12_Font},
                                      {32, 14, &TimesBoldItalic14_Font},
                                      {32, 18, &TimesBoldItalic18_Font},
                                      {32, 24, &TimesBoldItalic24_Font},
    {33, 10, &AvantGarde10_Font}, {33, 12, &AvantGarde12_Font},
                                  {33, 14, &AvantGarde14_Font},
                                  {33, 18, &AvantGarde18_Font},
                                  {33, 24, &AvantGarde24_Font},
    {34, 10, &Bookman10_Font}, {34, 12, &Bookman12_Font},
                               {34, 14, &Bookman14_Font},
                               {34, 18, &Bookman18_Font},
                               {34, 24, &Bookman24_Font},
    {35, 10, &HelveticaNarrow10_Font}, {35, 12, &HelveticaNarrow12_Font},
                                       {35, 14, &HelveticaNarrow14_Font},
                                       {35, 18, &HelveticaNarrow18_Font},
                                       {35, 24, &HelveticaNarrow24_Font},
    {36, 10, &NewCenturySchoolbook10_Font},
                                          {36, 12, &NewCenturySchoolbook12_Font},
                                          {36, 14, &NewCenturySchoolbook14_Font},
                                          {36, 18, &NewCenturySchoolbook18_Font},
                                          {36, 24, &NewCenturySchoolbook24_Font},
    {37, 10, &Palatino10_Font}, {37, 12, &Palatino12_Font},
                                {37, 14, &Palatino14_Font},
                                {37, 18, &Palatino18_Font},
                                {37, 24, &Palatino24_Font},
    {38, 10, &ZapfChancery10_Font}, {38, 12, &ZapfChancery12_Font},
                                    {38, 14, &ZapfChancery14_Font},
                                    {38, 18, &ZapfChancery18_Font},
                                    {38, 24, &ZapfChancery24_Font},
    {39,  9, &Albuquerque9_Font}, {39, 10, &Albuquerque10_Font},
                                  {39, 12, &Albuquerque12_Font},
                                  {39, 18, &Albuquerque18_Font},
                                  {39, 20, &Albuquerque20_Font},
                                  {39, 24, &Albuquerque24_Font},
    {40,  9, &Bodoni9_Font}, {40, 10, &Bodoni10_Font}, {40, 12, &Bodoni12_Font},
                             {40, 14, &Bodoni14_Font}, {40, 18, &Bodoni18_Font},
                             {40, 20, &Bodoni20_Font}, {40, 24, &Bodoni24_Font},
    {41, 12, &Eire12_Font}, {41, 24, &Eire24_Font},
    {42, 24, &SunnyvaleHeadlines24_Font}, {42, 36, &SunnyvaleHeadlines36_Font},
                                          {42, 48, &SunnyvaleHeadlines48_Font},
                                          {42, 72, &SunnyvaleHeadlines72_Font},
    {43, 24, &ParisHeadlines24_Font}, {43, 36, &ParisHeadlines36_Font},
                                      {43, 48, &ParisHeadlines48_Font},
                                      {43, 72, &ParisHeadlines72_Font},
    {44, 24, &NewYorkHeadlines24_Font}, {44, 36, &NewYorkHeadlines36_Font},
                                        {44, 48, &NewYorkHeadlines48_Font},
                                        {44, 72, &NewYorkHeadlines72_Font},
    {45, 12, &MosEisley12_Font}, {45, 24, &MosEisley24_Font},
    {46, 14, &Luxembourg14_Font}, {46, 18, &Luxembourg18_Font},
                                  {46, 24, &Luxembourg24_Font},
                                  {46, 36, &Luxembourg36_Font},
                                  {46, 48, &Luxembourg48_Font},
    {50, 16, &CRTFontBold16_Font},
    {0, 0, 0} // End marker
};
