// Handle (indirect Pointer) logic.

#include "../clunkdraw.h"
#include <stdlib.h> // For calloc

// Unlike in the Mac, we currently only support one master pointer block.
// Mac will chain in new blocks as necessary.  We find that unnecessary.
//
#define NHANDLES 250            /* Number of handles (maximum) allowed. */

/*
** Watch out, this routine malloc's a master pointer block and never frees it.
** If this ends up being a problem you'll have to change something.
*/

static Ptr *handles;

Handle
NewHandle(size_t size)
{
   short ii;
   Handle h;

   if (!handles)            /* No master pointer table for handles? */
      handles = calloc(NHANDLES, sizeof(Ptr));
   /* Now that our initial housekeeping's done, search out an empty master
      pointer for the request made of us.  Allocate a handle and return it
      as well as filling that master pointer.
   */
   for (h = handles, ii=0; ii<NHANDLES; ii++) { /* Find an empty slot. */
      if (!*h) {
         *h = calloc(1, size);
         return h;
      }
      h++;
   }
   return NULL;
}
