#include "../clunkdraw.h"
#ifdef DEBUG
#include <stdio.h>
#endif

void
_BuildLine(rect, negative, p)
register Rect *rect;            /* What line segment to build. */
register short negative;        /* If line is of negative slope. */
register short *p;              /* Where to build it. */
{
    register short x, y, deltax, deltay;
    register long i, j, t1, t2, d; /* Avoid overflow. */

    x = 0;
    y = 0;
    deltax = rect->edge.right - rect->edge.left;
    deltay = rect->edge.bottom - rect->edge.top;

    if (deltax == deltay) {     /* Special case 45-degree diagonals. */
        i = 0;
        deltax++;
        while (deltax--)
            *p++ = i++;
    } else {                    /* Non-45-degree diagonal line. */
        d = deltay - deltax;    /* Initial difference used as decision var. */
        t1 = (short) 2 * deltax; /* X step amount. */
        t2 = (short) 2 * deltay; /* Y step amount. */

        j = deltax + deltay;
        for (i = 0; i<j; i++) {
            if (negative && deltax > deltay) { /* Hokey shit to make this */
                p[y] = x;       /* line drawer do the same lines as the */
#ifdef DEBUG                    /* optimized one.  This could use some work! */
                fprintf(stderr, "P[%d] = %d, ", y, x);
#endif
            }
            if (d > 0) {        /* If next y closer to line, */
                if (deltay > deltax) {
                    p[y] = x;
#ifdef DEBUG
                    fprintf(stderr, "P[%d] = %d, ", y, x);
#endif
                }
                y++;            /* plot next Y coordinate and */
                d -= t1;        /* step in X direction. */
            } else {            /* Else next x is closer to line. */
                if (!negative && deltax > deltay) {
                    p[y] = x;
#ifdef DEBUG
                    fprintf(stderr, "P[%d] = %d, ", y, x);
#endif
                }
                x++;            /* Plot next X coord and */
                d += t2;        /* step in Y direction. */
            }
        }
        p[deltay] = deltax;
#ifdef DEBUG
        fprintf(stderr, "P[%d] = %d.\n", deltay, deltax);
#endif
    }
}
