#include "../clunkdraw.h"
#include "../rgn/cdrgn.h"

/*
** BuildLRgn builds a fake region data structure from a list of data points
** (provided by BuildLine) that describe a line.
*/

void
_BuildLRgn(rect, neg, line, p)
register Rect *rect;            /* What to make a line region from. */
short neg;                      /* Flag for negative-slope lines. */
register short *line;           /* Line control point list. */
register short *p;              /* Where to make it. */
{
    register short i, j, start, stop;
    register short *lastpt;
    short *save1, *save2, nullpt;
    Rect tempr;

    save1 = p;
    p++;                        /* Skip over the size field. */
    tempr = *rect;
    tempr.edge.right++;
    tempr.edge.bottom++;
    *((Rect *) p) = tempr;      /* Dummy region's bounding box. */
    p += sizeof tempr / sizeof *p;
    save2 = p;
    j = tempr.edge.bottom - tempr.edge.top; /* How many scanlines to do. */

    nullpt = END_TAG;           /* So we get the first region segment. */
    lastpt = &nullpt;
    stop = 0;
    for (i=0; i<j; i++) {
        if (*line != *lastpt) { /* Don't output unnecessary region segs. */
            lastpt = line;
            *p++ = tempr.edge.top + i;
            start = stop;
            stop = *line;
            if (neg) {          /* Handle reversed-slope lines. */
                if ((stop - start) < 1)
                    stop = start + 1;
                if (i == (j - 1)) /* On last pass thru, use edge fer sure. */
                    *p++ = tempr.edge.left;
                else
                    *p++ = tempr.edge.right - stop; /* Start scanline. */
                *p++ = tempr.edge.right - start; /* Stop scanline. */
            } else {            /* Positive sloped line. */
                if ((stop - start) < 1)
                    stop = start + 1;
                else
                    stop++;
                *p++ = tempr.edge.left + start; /* Start scanline. */
                *p++ = tempr.edge.left + stop;  /* Stop scanline. */
            }
            *p++ = END_TAG;     /* End-of-scanline marker. */
        }
        line++;
    }
    if (save2 == p)             /* No actual data? */
        *save1 = sizeof(RegionHdr); /* Re-size it then. */
    else {
        *p++ = END_TAG;         /* End-of-region marker. */
        *save1 = (char *) p - (char *) save1; /* Plug in real size. */
    }
}
