// GetPixel looks at the pixel associated with the given coordinate
// point and returns True if it's black or False if it's white.  The
// selected pixel is immediately below and to the right of the point
// whose coordinates are given in h and v, in the local coordinates of
// the current grafPort.  There's no guarantee that the specified pixel
// actually belongs to the port, however, it may have been drawn by a
// port overlapping the current one.  To see if the point indeed belongs
// to the current port, you could call PtInRgn(pt, thePort^.visRgn).
//

#include "../clunkdraw.h"

int
GetPixel(int h, int v)
{
   GrafPtr tp;

   if (!(tp = thePort)) return 0;
   return (*tp->_GetPix)(tp, h, v);
}
