#define MENUS_SOURCE
#include "../clunkdraw.h"
#include "menus.h"
#include <stdlib.h>

/* Append items to pulldown menu */

void
AppendMenu(mp, menuID, data)
MenuInfo *mp;                   /* Menu linkage root */
int menuID;                     /* Desired menu ID. */
char *data;
{
   int ch, mark, style, disable, itemNo;
   long key;
   char *q, *ptr;
   MenuItem *ip;

   if (mp = _FindMenu(mp, menuID)) {
      itemNo = 1;
      ip = mp->items;           /* Find end of menu items so we can add */
      if (ip) {                 /* to the list. */
         itemNo++;
         while (ip->nextItem) {
            ip = ip->nextItem;
            itemNo++;
         }
      }
      style = key = disable = mark = 0;
      while (ch = *data++) {
         switch (ch) {
            case ';':           /* Item delimiter. */
            case '\n':
               break;

            case '!':           /* Mark with next character. */
               mark = *data++;
               break;

            case '/':           /* Keyboard equivalent. */
               key = *data++;
               if (key >= 'a' && key <= 'z') /* Force to uppercase. */
                  key &= ~('a' - 'A');
               key |= F_CTRL;
               break;

            case '(':           /* Disable next item. */
               disable++;
               break;

            case '<':           /* Set item's style. */
               switch (*data++) {
               case 'B':
                  style = boldText;
                  break;

               case 'I':
                  style = italicText;
                  break;

               case 'U':
                  style = underlineText;
                  break;

               case 'O':
                  style = outlineText;
                  break;

               case 'X':
                  style = strikeoutText;
                  break;
               }
               break;

            default:            /* Normal textual item. */
               if (ip) {        /* Insert new item into menu linked list. */
                  ip->nextItem = (MenuItem *) malloc((unsigned)
                                                     sizeof(MenuItem));
                  ip = ip->nextItem;
               } else {
                  ip = mp->items = (MenuItem *) malloc((unsigned)
                                                       sizeof(MenuItem));
               }
               ip->keyEquivalent = key; /* Item's contents. */
               ip->menuMark = mark;
               ip->itemStyle = style;
               ip->nextItem = (MenuItem *) 0;
               if (!disable && ch != '-') { /* Mark it enabled if possible. */
                  mp->enabled |= (1<<itemNo);
               }
               itemNo++;
               mp->numberItems++;
               q = data--;      /* Note that data points 1 past first char. */
               while (*q && *q != ';' && *q != '\n') {  /* Find the end of */
                  q++;          /* item's text. */
               }
               ip->itemLen = q - data;
               ptr = ip->itemTitle = malloc((unsigned) ip->itemLen);
               while (data < q) { /* Copy the string. */
                  *ptr++ = *data++;
               }
               mark = style = key = disable = 0; /* Prepare for next item. */
               break;
         }
      }
      _CalcMenuSize(mp);
   }
}
