#define MENUS_SOURCE
#include "../clunkdraw.h"
#include "menus.h"

/* Calculate the size of a Menu */

void
_CalcMenuSize(mp)
MenuInfo *mp;           /* Pointer to Menu to calculate size of. */
{
   GrafPtr savePort;
   MenuItem *ip;
   int height, width, ii;
   unsigned char keyBuf[8];     /* For keyboard equivalent string. */

   savePort = _MenuSetup();     /* Work in Window Manager's port. */
   height = _MV.fontInfo.ascent + _MV.fontInfo.descent + _MV.fontInfo.leading
          + 3;
   height *= mp->numberItems;
   height += 2;                 /* Compensate for rectangle frame. */
   width = 0;
   ip = mp->items;
   while (ip) {                 /* Find the widest item. */
      TextFace(ip->itemStyle);
      ii = TextWidth(ip->itemTitle, 0, ip->itemLen);
      if (ip->keyEquivalent) {  /* Include keyboard equivalents. */
         unsigned char *p;
         p = _MenuKeystr(ip->keyEquivalent, keyBuf);
         TextFace(normalText);
         ii += TextWidth((char *) keyBuf, 0, p - keyBuf)
             + _MV.fontInfo.widMax + 3;
      }
      if (ii>width)
         width = ii;
      ip = ip->nextItem;
   }
   width += 2 * _MV.chWidth;        /* Left & right margins. */
   _MenuRestore(savePort);
   mp->menuHeight = height;
   mp->menuWidth = width;
}
