#define MENUS_SOURCE
#include "../clunkdraw.h"
#include "menus.h"
#include <stdlib.h>

/* Close an open menu and restore screen.  Will leave menu highlighted. */

void
CloseMenu()
{
   int ii;

   if (_MV.dstBits.baseAddr) {
      if (_MV.OpenedMenu) {
#if 1                           /* Temporarily do menu updates the hard way. */
         WindowPtr wPtr;        /* Only until bidirectional color CopyBits */
         RgnHandle tempRgn;     /* starts working. */

         wPtr = FrontWindow();
         tempRgn = NewRgn();
         RectRgn(tempRgn, &_MV.dstBits.bounds);
         PaintBehind((WindowPeek) wPtr, tempRgn);
         DisposeRgn(tempRgn);
//       checkUpdates();
#else
         ii = RestoreScreenBits(&_MV.dstBits.bounds);
         if (!ii) {
            CopyBits(&_MV.dstBits, _MV.srcBits,
                     &_MV.dstBits.bounds, &_MV.dstBits.bounds,
                     srcCopy, (RgnHandle) 0);
         }
#endif
         free(_MV.dstBits.baseAddr);
      }
   }
   _MV.OpenedMenu = 0;
   _MV.TheMenuItem = 0;
}
