#define MENUS_SOURCE
#include "../clunkdraw.h"
#include "menus.h"

/* Draw the menu bar according to menu list */

void
DrawMenuBar(mp)
MenuInfo *mp;           /* Menu linkage root */
{
   GrafPtr savePort;

   savePort = _MenuSetup();     /* Work in Window Manager's port. */
   SetRect(&_MV.menuRect, 0, 0,
           _MV.mbarWidth ? _MV.mbarWidth : _MV.scrnWidth, _MV.mbarHeight-1);
   EraseRect(&_MV.menuRect);        /* Display empty menu bar. */
   MoveTo(_MV.menuRect.edge.left, _MV.menuRect.edge.bottom);
   LineTo(_MV.menuRect.edge.right, _MV.menuRect.edge.bottom);

   SystemMenu->nextMenu = mp;
   mp = SystemMenu;
   MoveTo(8, _MV.fontInfo.ascent + _MV.fontInfo.leading + 1);
   _MV.MenuCount = 0;
   while (mp) {
                                /* We also fill in the data structures that */
                                /* describe the mouse click limits for each */
      mp->leftCoord = thePort->pnLoc.h + _MV.chWidth/2 - 1; /* menu. */
      Move(_MV.chWidth + 1, 0);
      DrawString(mp->menuTitle); /* Draw each title. */
      _MV.menuRect.edge.left = thePort->pnLoc.h;
      _MV.mbarWidth = mp->rightCoord = _MV.menuRect.edge.left + _MV.chWidth/2
                    + 3;
      _MV.menuRect.edge.right = _MV.mbarWidth + _MV.chWidth + 1;
      EraseRect(&_MV.menuRect);
      if (!(mp->enabled & 1)) { /* Entire menu disabled? */
         _InvertMenu(mp->menuID, 1); /* Yes, gray it. */
      }
      mp = mp->nextMenu;
      _MV.MenuCount++;          /* Count number of menus */
   }
   if (_MV.mbarWidth < _MV.displayStart) {
      _MenuDisplay(_MV.displayStart, _MV.displayEnd, _MV.displayText, NULL, 0);
   } else {
      _MenuDisplay(_MV.mbarWidth, _MV.scrnWidth, NULL, NULL, 0);
   }
   _MenuRestore(savePort);      /* Restore proper WM stuff. */
   _MV.TheMenu = 0;             /* None are highlighted yet. */
   HiliteMenu(_MV.PendingEndmenu);
   _MV.TheMenu = 0;
}
