#define MENUS_SOURCE
#include "../clunkdraw.h"
#include "menus.h"
#include <stdio.h>

void
DumpMenu(mp)
MenuInfo *mp;
{
   int itemNo;
   MenuItem *m;

   (void) printf(" Menu Pointer: $%08X\n", mp);
   if (mp) {
      (void) printf("  Menu ID: %d\n", mp->menuID);
      (void) printf("  Width: %d pixels\n", mp->menuWidth);
      (void) printf("  Height: %d pixels\n", mp->menuHeight);
      (void) printf("  Number of items: %d\n", mp->numberItems);
      (void) printf("  Item Enabling bitmask: $%08X\n",mp->enabled);
      (void) printf("  Title: %s @ $%08X\n", mp->menuTitle,
                     mp->menuTitle);
      m = mp->items;
      itemNo = 1;
      while (m) {
         fprintf(stderr,"   Item %2d: %s, Key: $%08X, Mark: $%02X, "
                 "Style: $%02X, Length: %d,\n\t    Ptr to next: $%08X,"
                 " Ptr to title: $%08X\n",
                 itemNo, m->itemTitle, m->keyEquivalent, m->menuMark,
                 m->itemStyle, m->itemLen, m->nextItem, m->itemTitle);
         m = m->nextItem;
         itemNo++;
      }
      (void) printf("  Pointer to next menu: %08X\n", mp->nextMenu);
      (void) printf("  Left title coordinate: %d\n", mp->leftCoord);
      (void) printf("  Right title coordinate: %d\n", mp->rightCoord);
   }
   (void) printf("\n");
}

