#define MENUS_SOURCE
#include "../clunkdraw.h"
#include "menus.h"

/* Hilite an item in a menu */

int
_InvertMitem(itemID, flag)
int itemID;
int flag;                       /* TRUE if stomping out a gray thing. */
{
   MenuInfo *mp;
   int jj, height;
   unsigned long enabled;

   if (mp = _FindMenu(_MV.SystemMenu, _MV.OpenedMenu)) {
      if (itemID > 0
          && itemID <= mp->numberItems) { /* Item exists in menu? */
         height = _MV.fontInfo.ascent + _MV.fontInfo.descent
                + _MV.fontInfo.leading + 3;
         jj = (itemID - 1) * height;
         SetRect(&_MV.menuRect, mp->leftCoord + 1, jj,
                 mp->leftCoord + mp->menuWidth - 1, jj);
         _MV.menuRect.edge.top += _MV.mbarHeight;
         _MV.menuRect.edge.bottom += (_MV.mbarHeight + height);
         enabled = mp->enabled;
         if (enabled & 1
             && enabled & 1<<itemID) { /* Menu & Item enabled? */
            if (!flag)          /* Highlighting. */
               InvertRect(&_MV.menuRect);
            return 1;           /* Valid menu item. */
         } else {               /* Item's disabled. */
            if (flag)           /* Are we gray-ing? */
               PaintRect(&_MV.menuRect);
            return 0;           /* Disabled menu item. */
         }
      }
   }
   return -1;                   /* Invalid menu item. */
}
