#define MENUS_SOURCE
#include "../clunkdraw.h"
#include "menus.h"

unsigned char *                 /* Make keyboard equivalent string... */
_MenuKeystr(keyCode, where)     /* Returns pointer to the base character. */
long keyCode;                   /* Keycode to make string from. */
unsigned char *where;           /* Buffer to work in. */
{
   unsigned char *p;
   int scratch;

   p = where;
   if (keyCode & F_CTRL)
      *p++ = 0x1A;              /* The control key marker in font #2. */
   if (keyCode & F_ALT)
      *p++ = 0x1B;              /* The alt key marker in font #2. */
   if (keyCode & F_FUNC) {
      scratch = (keyCode & 0xFF) - K_F1 + 1;
      *p++ = 0x1C;              /* The func key marker in font #2. */
      if (scratch >= 10)
         *p++ = scratch / 10 + '0';
      *p++ = scratch % 10 + '0';
   } else
      *p++ = keyCode & F_KEYMASK;
   *p = 0;
   return p - 1;                /* Return pointer to the character itself. */
}
