#define MENUS_SOURCE
#include "../clunkdraw.h"
#include "menus.h"
#include <stdlib.h>

/*
** Create a new menu.
*/

void
NewMenu(mproot, menuID, menuTitle)
MenuInfo **mproot;              /* Pointer to menu linkage root */
int menuID;                     /* Desired menu ID. */
char *menuTitle;                /* Pointer to menu's title text. */
{
   MenuInfo *mp, *mp0;
   char *q;

   mp0 = NULL;
   mp = *mproot;
   while (mp) {                 /* Find where to insert the new menu into */
      if (menuID <= mp->menuID) { /* the list (they're sorted by number). */
         break;
      }
      mp0 = mp;
      mp = mp->nextMenu;
   }
   if (mp == NULL || menuID != mp->menuID) { /* Do we need a new menu? */
      mp = (MenuInfo *) malloc((unsigned) sizeof(MenuInfo)); /* Create 1. */
      if (mp0) {
         mp->nextMenu = mp0->nextMenu; /* Insert into middle or */
         mp0->nextMenu = mp;
      } else {                  /* insert onto the front of the list. */
         mp->nextMenu = *mproot;
         *mproot = mp;
      }
   } else {                     /* Replacing an existing menu, */
      free(mp->menuTitle);      /* kill off its title and all the items. */
      _FreeMenuItems(mp);
   }
   mp->menuID = menuID;         /* Fill in empty menu structure. */
   mp->menuWidth = 0;
   mp->menuHeight = 0;
   mp->numberItems = 0;
   mp->enabled = 1;
   q = mp->menuTitle = malloc((unsigned) StringLen(menuTitle) + 1);
   while (*q++ = *menuTitle++)  /* Copy the string. */
      ;
   mp->items = (MenuItem *) 0;
}
