#define MENUS_SOURCE
#include "../clunkdraw.h"
#include "menus.h"
#include <stdlib.h>

/* Draw the items in a menu. */

void
OpenMenu(mp)
MenuInfo *mp;           /* Menu block pointer */
{
   GrafPtr savePort;
   MenuItem *ip;
   int ii, jj, bump, width, itemNo;
   long size;
   unsigned char keyBuf[8];     /* For key-equivalent drawing. */
   Rect scratch;

   savePort = _MenuSetup();     /* Work in Window Manager's port. */
   HiliteMenu(_MV.OpenedMenu = mp->menuID);
   _MV.dstBits.baseAddr = 0;    /* (In case there're no items at all.) */
   if (mp->numberItems) {       /* Any items?  Yes, save away under-menu bits. */
      SetRect(&_MV.menuRect, mp->leftCoord, _MV.mbarHeight - 1,
              mp->leftCoord + mp->menuWidth+1, _MV.mbarHeight + mp->menuHeight);
#if 0
      SectRect(&_MV.menuRect, &thePort->portRect, &_MV.menuRect);
      _MV.saveMenuTop = _MV.menuRect.edge.top = _MV.menuRect.edge.bottom;
      _MV.menuRect.edge.right = _MV.menuRect.edge.left + mp->menuWidth;
      _MV.menuRect.edge.bottom = _MV.saveMenuTop + mp->menuHeight;
      _MV.menuRect.edge.bottom += (mp->menuHeight + 1);
      _MV.menuRect.edge.right++;
#endif
      _MV.srcBits = &thePort->portBits;
      scratch = _MV.menuRect;
      SectRect(&scratch, &thePort->portRect, &scratch);
      width = (((scratch.edge.right - scratch.edge.left) + 0x0F) >> 3) & ~1;
      _MV.dstBits.rowBytes = width;
#if 0
      if (srcBits->rowBytes & 1) { /* Color screen? */
         width <<= (i = (srcBits->rowBytes & 0x0F)) >> 1; /* Yes. */
         dstBits.rowBytes = (width << 3) | i;
      }
#endif
      _MV.dstBits.bounds = scratch;
      size = (_MV.dstBits.bounds.edge.bottom -
              _MV.dstBits.bounds.edge.top) * width;
      _MV.dstBits.baseAddr = malloc((unsigned long) size);
      ii = 0; // = SaveScreenBits(&scratch);
      if (!ii) {
         CopyBits(_MV.srcBits, &_MV.dstBits, &scratch, &scratch, srcCopy,
                  (RgnHandle) 0);
      }
      _MV.menuRect.edge.right--;    /* Un-compensate for drop-shadow. */
      _MV.menuRect.edge.bottom--;
#ifdef SLOWMENU
      _MV.menuRect.edge.bottom = _MV.menuRect.edge.top;
      bump = mp->menuHeight >> 3;
      for (jj=8; jj--; ) {      /* Zoom out the roll-down menu. */
         EraseRect(&_MV.menuRect);
         _MV.menuRect.edge.bottom += bump;
/*              menuRect.edge.top += bump; /*  */
      }
      _MV.menuRect.edge.top = _MV.saveMenuTop; /* Restore full menu rectangle. */
      _MV.menuRect.edge.bottom = _MV.saveMenuTop + mp->menuHeight;
#endif

      EraseRect(&_MV.menuRect);     /* Draw the menu itself. */
      FrameRect(&_MV.menuRect);
      MoveTo(_MV.menuRect.edge.left + 2, _MV.menuRect.edge.bottom); /* Drop */
      LineTo(_MV.menuRect.edge.right, _MV.menuRect.edge.bottom); /* shadow. */
      LineTo(_MV.menuRect.edge.right, _MV.menuRect.edge.top + 3);

      PenPat(&syspats[7]);      /* Gray pattern (for dividing lines). */
      ii = _MV.menuRect.edge.left + 4;
      jj = _MV.fontInfo.ascent + _MV.fontInfo.leading + 2;
      bump = jj + _MV.fontInfo.descent + 1;
      jj += _MV.menuRect.edge.top;
      ip = mp->items;
      itemNo = 1;
      TextFont(_MV.menuFont);
      TextSize(_MV.menuFontSize);
      while (ip) {              /* For each item in the menu... */
         if (*(ip->itemTitle) == '-') { /* Dividing lines for non-items. */
            PenMode(srcOr);
            MoveTo(_MV.menuRect.edge.left, jj - (_MV.mbarHeight >> 1) + 2);
            LineTo(_MV.menuRect.edge.right - 1, jj - (_MV.mbarHeight >> 1) + 2);
         } else {               /* Is a real textual item. */
            if (ip->menuMark) {
               MoveTo(ii, jj);  /* Draw menu mark (if any). */
               DrawChar(ip->menuMark);
            }
            MoveTo(ii + _MV.chWidth, jj); /* A little space after checkmark. */
            if (ip->itemStyle)
               TextFace(ip->itemStyle);
            DrawText(ip->itemTitle, 0, ip->itemLen); /* Item title. */
            if (ip->itemStyle)
               TextFace(normalText);
            if (ip->keyEquivalent) { /* Draw keyboard equivalents. */
               unsigned char *p;
               p = _MenuKeystr(ip->keyEquivalent, keyBuf);
               MoveTo(_MV.menuRect.edge.right - (_MV.fontInfo.widMax - 1)
                      - TextWidth((char *) keyBuf, 0, p - keyBuf), jj);
               DrawText((char *) keyBuf, 0, (p - keyBuf) + 1);
            }
            PenMode(srcBic);
            (void) _InvertMitem(itemNo, 1); /* Gray out item if disabled. */
         }
         itemNo++;
         jj += bump;
         ip = ip->nextItem;
      }
   }
   PenNormal();
   SetPort(savePort);
}
