#define MENUS_SOURCE
#include "../clunkdraw.h"
#include "menus.h"
#include <time.h>

/*
** Timer event service routine.  Call once every second.
*/

void
MenuTick()
{
   short notify;                /* Notify is a flag for time format change. */
   short hour, minute, second;
   long clock;
   char buf[40], *p, *p2;
   static short lastClockMode = -1;
   static short lastNotify = 0;
   static short firstTime = 1;
   static long tZone;           /* # minutes offset from GMT. */

#if 0
   dnix(F_NOWAIT | F_NAP, 1000, 0, 0, 0, 0, trapfd, &menuTime); /* Start */
   timerRunning = 1;            /* the once-a-second timer. */

   if (wmlocked)
      return;
#endif
   buf[0] = buf[20] = 0;
   if (_MV.clockMode && _MV.mbarWidth < _MV.clockStart) {
      if (firstTime) {          /* Find out our time zone offset from GMT. */
//         tZone = gettimezone();
         firstTime = 0;
      }
      time(&clock);
      clock += tZone;
      clock -= 619315200L;      /* Cut off a large chunk of time.  */
      while (clock > 0)         /* Ultra-cheap time=>struct conversion. */
         clock -= 22118400L;    /* (Cheezy modulo, smaller than normal.) */
      clock += 22118400L;
      while (clock > 0)
         clock -= 86400L;
      clock += 86400L;
      hour = DivS(clock, 3600);
      clock = ModS(clock, 3600);
      minute = (short) clock / (short) 60;
      second = (short) clock % (short) 60;
      if (_MV.clockMode >= CLOCK12HS) {
         if (hour == 0) hour += 12;
         if (hour > 12) hour -= 12;
      }
      p = buf;
      *p++ = (hour < 10) ? (' ' - '0') : (hour / 10);   /* All clock modes: */
      *p++ = hour % 10;
      *p++ = ':' - '0';
      *p++ = minute / 10;
      *p++ = minute % 10;
      if (_MV.clockMode == CLOCK12HAP) { /* Only AM/PM mode: */
         p2 = &buf[20];
         *p2++ = (hour < 12) ? 'A' : 'P';
         *p2++ = 'M';
         *p2 = 0;
      } else if (_MV.clockMode & 1) { /* CLOCK24HS and CLOCK12HS modes: */
         *p++ = ':' - '0';
         *p++ = second / 10;
         *p++ = second % 10;
      }
      *p = 0;
      while (p != buf)          /* Turn it into a printable string. */
         *--p += '0';
   }
   if ((notify = (lastClockMode != _MV.clockMode)) || _MV.clockMode)
      if (_MV.mbarWidth < _MV.clockStart)
         _MenuDisplay(_MV.clockStart, _MV.clockEnd, buf, &buf[20], notify);
   lastClockMode = _MV.clockMode;
   if (!_MV.OpenedMenu) {       /* Handle notification timer. */
      buf[0] = notify = 0; /// = getnotifychar();
      if (lastNotify != notify) {
         if (!*buf)             /* No more in list, get original menu title, */
            *buf = *SystemMenu->menuTitle; /* (assumed single char.) */
         buf[1] = 0;
         _MenuDisplay(20, _MV.SystemMenu->rightCoord, buf, 0, 0);
      }
      lastNotify = notify;
   } else if (_MV.kbdNav) {     /* Timeout the keyboard menu system? */
                                /* We do this so a WM can't be left locked */
                                /* for 'too long', since this can wedge */
                                /* vterms and other important things that */
                                /* have far-reaching consequences. */
      if (!--_MV.kbdNav) {
         MenuKey(K_RESET | F_KEYDOWN | F_FUNC);
         _MV.ExitingMenu = 0;
//         unlockUpdates();
      }
   }
}
