/*
** ClosePoly tells Clunkdraw to stop saving the definition of the currently
** open polygon and computes the polyBBox rectangle.  You should perform one
** and only one ClosePoly for every OpenPoly.  ClosePoly calls ShowPen,
** balancing the HidePen call made by OpenPoly.
**
** This implementation only supports one collected polygon per grafport.  If
** you need more than one you have to copy it to someplace else in memory
** yourself.  Imaging of polygons has no such restriction, only the collection
** of polygons is limited.
*/

#include "../clunkdraw.h"

void
ClosePoly()
{
    Rect bbox;
    register PolyPtr pp;
    register Point *p;
    register short i;
    GrafPtr tp;

    tp = thePort;
    if (!tp->polySave)
        return;
    pp = *tp->polySave;
    tp->polySave = 0;
    ShowPen();
    bbox.edge.left = bbox.edge.top = 32767; /* Calculate polygon's */
    bbox.edge.right = bbox.edge.bottom = -32768;
    p = &pp->polyPoints;        /* bounding box. */
    i = (unsigned short) (pp->polySize - sizeof(PolyHdr)) / sizeof(Point);
    while (i--) {               /* Number of points. */
        if (p->h > bbox.edge.right)
            bbox.edge.right = p->h;
        if (p->h < bbox.edge.left)
            bbox.edge.left = p->h;
        if (p->v > bbox.edge.bottom)
            bbox.edge.bottom = p->v;
        if (p->v < bbox.edge.top)
            bbox.edge.top = p->v;
        p++;
    }
    pp->polyBBox = bbox;
}
