#include "../clunkdraw.h"
#include "cdpoly.h"
#include <alloca.h>

void
_DrawPoly(poly, verb, arg)
PolyHandle poly;
void (*verb)();                 /* Function to call with the result. */
void *arg;                      /* Optional argument to the verb function. */
{
    short tBmaxx;               /* Maximum number of x entries for each y,
                                   including room for END_TAG. */
    short tBmaxy;               /* Maximum number of y entries, w/ END_TAG. */
    short xtern;
    unsigned long size1;
    PolyPtr pp;
    RgnPtr polyRgn;
    RgnHandle resultRgn;

    pp = *poly;                 /* Create space for output buffer. */
    tBmaxx = (2 * (pp->polySize - sizeof(PolyHdr)))
           / sizeof(Point) + 2; /* Room for y & end tag. */
    tBmaxy = pp->polyBBox.edge.bottom
           - pp->polyBBox.edge.top + 2; /* Room for end tag. */
    size1 = MulU(tBmaxy, tBmaxx);
    size1 *= sizeof(short);
    size1 += sizeof(PolyHdr);
    polyRgn = (RgnPtr) alloca(size1); /* Space for output region. */
    _BuildPolyRgn(poly, polyRgn); /* Build region for filling polygons */
    resultRgn = &polyRgn;
    if (verb == UnionRgn) {
        GrafPtr tp;

        tp = thePort;
        UnionRgn(resultRgn, tp->rgnSave, tp->rgnSave);
    } else
        (*verb)(resultRgn, arg);
}
