#include "../clunkdraw.h"
#include <stdio.h>

void
DumpPoly(poly, label)
PolyHandle poly;
const char *label;
{
   PolyPtr pp;
   Point *pps;
   int size;

   if (!(pp = *poly)) return;
   printf("%sPolygon Data:\n"
          "Size: %4d,  Top: %4d, Left: %4d, Bottom: %4d, Right: %4d\n", label,
          pp->polySize, pp->polyBBox.edge.top, pp->polyBBox.edge.left,
          pp->polyBBox.edge.bottom, pp->polyBBox.edge.right);
   size = pp->polySize - sizeof(PolyHdr);
   if (size <= 0) return;
   pps = &pp->polyPoints;
   printf("MoveTo: %4d, %4d\n", pps->h, pps->v);
   pps++;
   size -= sizeof *pps;
   while (size > 0) {
      printf("LineTo: %4d, %4d\n", pps->h, pps->v);
      pps++;
      size -= sizeof *pps;
   }
}
