/*
** OffsetPoly moves the polygon on the coordinate plane, a distance of dh
** horizontally and dv vertically.  This doesn't affect the screen unless you
** subsequently call a routine to draw the polygon.  If dh and dv are positive,
** the movement is to the right and down; if either is negative, the
** corresponding movement is in the opposite direction.  The polygon retains
** its shape and size.
*/

#include "../clunkdraw.h"

void
OffsetPoly(poly, dh, dv)
PolyHandle poly;
register short dh, dv;
{
    PolyPtr pp;
    register Point *p;
    register short ii;

    pp = *poly;
    if (!pp)                    /* Protect against bozo actions. */
        return;
    p = &pp->polyPoints;
    ii = (unsigned short) (pp->polySize - sizeof(PolyHdr)) / sizeof(Point);
    OffsetRect(&pp->polyBBox, dh, dv);
    while (ii--) {               /* Number of points. */
        p->h += dh;
        p->v += dv;
        p++;
    }
}
