#include "../clunkdraw.h"
#include <stdio.h>
#define FALSE 0

void
DumpPort(GrafPtr tp)
{
    char buf[128];

    if (!tp) {
        printf("DumpPort(): No port.\n");
        return;
    }
    DumpBMap(&tp->portBits, "BitMap ");
    {
       printf("Device: %d", tp->device);
       if (tp->device == 1) printf(" (Rotated Monochrome E-Paper)");
       if (tp->device == 2) printf(" (RGB565 TFT LCD)");
       puts(".");
    }
    DumpRect(&tp->portRect, "Port ");
    DumpRgn(tp->visRgn, "Visible ");
    DumpRgn(tp->clipRgn, "Clipping ");
//    printf("Color bits: %d.\n", tp->colrBit);
    printf("Foreground Color: $%04X.\n", tp->fgColor & 0xFFFF);
    printf("Background Color: $%04X.\n", tp->bkColor & 0xFFFF);
    DumpPattern(&tp->bkPat, "Background Pattern: ");
    printf("Pen Location, X: %d, Y: %d.\n", tp->pnLoc.h, tp->pnLoc.v);
    printf("Pen Size, X: %d, Y: %d.\n", tp->pnSize.h, tp->pnSize.v);
    printf("Pen Transfer Mode: ");
    DumpMode(tp->pnMode);
    DumpPattern(&tp->pnPat, "Pen Pattern: ");
    printf("Text Font: %d.\n", tp->txFont);
    printf("Text Face: $%02X", tp->txFace);
    DumpFace(tp->txFace);
    puts(".");
    printf("Text Size: %d%s\n", tp->txSize,
           tp->fontPtr ? " (loaded)." : ".");
    printf("Text Transfer Mode: ");
    DumpMode(tp->txMode);
    printf("Text Rotation: %d degrees CCW.\n", tp->txRotate);
    printf("SpaceExtra: %s (16.16 Fixed Point $%04lX.%04lX).\n",
           FixS32ToStr(buf, sizeof buf, tp->spExtra, 65536, 6, FALSE),
           HiWord(tp->spExtra) & 0xFFFF, LoWord(tp->spExtra) & 0xFFFF);
    printf("TextExtra: %s (16.16 Fixed Point $%04lX.%04lX).\n",
           FixS32ToStr(buf, sizeof buf, tp->txExtra, 65536, 6, FALSE),
           HiWord(tp->txExtra) & 0xFFFF, LoWord(tp->txExtra) & 0xFFFF);
    printf("Accumulating polygon: ");
    if (tp->polySave)
       DumpPoly(tp->polySave, "");
    else
       printf("None\n");
}
