/*
** Initialize Clunkdraw for work with 2.2" 16-bit RGB565 color LCD display.
**
** This display is hooked to a Linux frame buffer, so we map it into our
** space so that anything we draw on it is 'live' at all times.  No flushing
** required.
*/
#include "../clunkdraw.h"
#include "cdport.h"
#include "../driver/cdtftrpi.h"
#include <stdlib.h>

int
InitGraf2()
{
   int ii;

   ii = TFT_SPI_Init(&screenBits); // Connect to the TFT RGB565 SPI display.
   if (!ii)
      ii = InitGraf(screenBits.bounds.edge.right, screenBits.bounds.edge.bottom,
                    BPP(16));
   screenPort.port.device = 2;
   return ii;
}

void
EndGraf2()
{
   screenBits.baseAddr = 0;     // It was mmap'd, don't try to free it.
   EndGraf();
   TFT_SPI_End();
}
