#include "../clunkdraw.h"
#include "../font/cdfontm.h"
#include "cdport.h"

const Pattern white  = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
const Pattern black  = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};
const Pattern gray   = {0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55};
const Pattern ltGray = {0x88, 0x22, 0x88, 0x22, 0x88, 0x22, 0x88, 0x22};
const Pattern dkGray = {0xDD, 0x77, 0xDD, 0x77, 0xDD, 0x77, 0xDD, 0x77};

extern const FontRec LaCenter12_Font;

void
InitPort(port)                  /* Init a graphics port. */
GrafPtr port;
{
    SetPort(port);

    port->device = 0;
    port->portBits = screenBits;
    port->portRect = screenBits.bounds;
//    RectRgn(port->visRgn, &screenBits.bounds);
                                /* This setting of the clipRgn is something */
                                /* of a hack.  We use 30000 so that the */
                                /* offsetting done later by the Window Mgr */
                                /* won't cause clipping.  In obscure cases */
                                /* of large, off-screen bitmaps this could */
                                /* happen anyway.  Tough shit. */
//    SetRectRgn(port->clipRgn, -30000, -30000, 30000, 30000);
    port->pnLoc.h = 0;
    port->pnLoc.v = 0;
    port->pnVis = 0;            /* Pen is visible (>= 0). */
    port->txFont = 0;
    port->txFace = 0;           /* Plain text. */
    port->txSize = 12;          /* System font size. */
    port->txMode = srcOr;
    port->txRotate = 0;         /* No text rotation. */
    port->_fontHook = 0;        /* No font-fetching (yet). */
    port->spExtra = port->txExtra = 0;
    port->fontPtr = &LaCenter12_Font; /* The default font. */
    port->fgColor = 1;          /* Foreground = black. */
    port->bkColor = 0;          /* Background = white. */
    port->bkPat = white;
    port->fillPat = black;
//    if (port->polySave)
//      KillPoly(port->polySave);
//    if (port->rgnSave) {
//      DisposeRgn(port->rgnSave);
//      port->rgnSave = NULL;
//    }
    PenNormal();
}
