BitMap screenBits;
// The screen Port is actually a Window structure, just in case we use
// things like Controls in the default Port.
WindowRecord screenPort;

// Cursor hooks.
void (*_ShieldCursHook)(const Rect *shieldRect, const Point *offsetPt);
void (*_ShowCursHook)(void);

// We use multiple indirect-function-pointer routines that are
// used by all drawing, which are poked into the GrafPort by
// the device-setting code.  (The functions that set thePort.device.)
// There are several choices for the bit (pixel) setter:
//
// _SetBit:       Sets in-memory monochrome (1-bit) pixel to black (1).
// _EPSetBit:     Sets 3.7" E-Paper (1-bit) pixel to black.  Includes rotation.
// _RGB565SetBit: Sets RGB565 (16-bit) pixel to foreground color.
//
// There are analogous routines for 'clearing' and 'inverting' pixels.
// This should be no slower than the initial naive implementations'
// subroutine calls, yet will allow one Clunkdraw library to work with
// all these devices and formats.  Neither display panel is 'live',
// both require external code to push the pixel maps to physical hardware.
// Clunkdraw just takes care of making the correct memory contents.

void _SetBit(GrafPtr tp, int x, int y);
void _ClearBit(GrafPtr tp, int x, int y);
void _FlipBit(GrafPtr tp, int x, int y);

void _Set2Bit(GrafPtr tp, int x, int y);
void _Clear2Bit(GrafPtr tp, int x, int y);
void _Flip2Bit(GrafPtr tp, int x, int y);

void _Set4Bit(GrafPtr tp, int x, int y);
void _Clear4Bit(GrafPtr tp, int x, int y);
void _Flip4Bit(GrafPtr tp, int x, int y);

void _Set8Bit(GrafPtr tp, int x, int y);
void _Clear8Bit(GrafPtr tp, int x, int y);
void _Flip8Bit(GrafPtr tp, int x, int y);
