/*
** Given the slope dh/dv of a line, AngleFromSlope returns the angle formed
** by that line and the y-axis.  The angle returned is between 1 and 180
** (inclusive), in degrees measured clockwise from 12 o'clock.
**
** AngleFromSlope is meant for use when speed is much more important than
** accuracy -- its integer result is guaranteed to be within one degree of
** the correct answer, but not necessarily within half a degree.  However,
** the equation
**
**      AngleFromSlope(SlopeFromAngle(x)) == x
**
** is true for all x except 0 (although its reverse is not).
**
** Note:  SlopeFromAngle(0) is 0, and AngleFromSlope(0) is 180.
*/

#include "../clunkdraw.h"
#include "cdangles.h"

short
AngleFromSlope(slope)
Fixed slope;
{
    union fixtrig workval;
    short negative, angle;

    if (negative = (slope < 0))
        slope = -slope;
    slope -= 500L;              /* Subtract 0.007629 */
    angle = -1;
    while (1) {
        angle++;
        workval.words[MSW] = 0;
        _tlookup(&workval, angle);
        if (slope <= workval.fixval)
            break;
    }
    return negative ? angle : 180 - angle;
}
