#include "../clunkdraw.h"
#include "cdrect.h"

// FillRect fills the specified rectangle with the given pattern (in srcCopy
// mode).  The grafPort's pnPat, pnMode, and bkPat are all ignored; the pen
// location is not changed.
void
FillRect(const Rect *r, const Pattern *fillPat)
{
   GrafPtr tp;
   Pattern savePat;

   if (!(tp = thePort) || !fillPat) return;
   if (tp->pnVis < 0) return;
   savePat = tp->pnPat;
   tp->pnPat = *fillPat;
   _DrawRect(r, _FillRBit);
   tp->pnPat = savePat;
}
