// InvertRect inverts the pixels enclosed by the specified rectangle.  Every
// white pixel becomes black and every black pixel becomes white.  The
// grafPort's pnPat, pnMode and bkPat are ignored; the pen location is not
// changed.

#include "../clunkdraw.h"

void
InvertRect(const Rect *r)
{
   PenState penSave;

   if (!thePort)
      return;
   GetPenState(&penSave);
   PenMode(srcXor);
   PenPat(&black);
   PaintRect(r);
   SetPenState(&penSave);
}
