/*
** Pt2Rect returns the smallest rectangle that encloses the two given points.
*/

#include "../clunkdraw.h"

void
Pt2Rect(point1, point2, rect)
const Point *point1, *point2;
Rect *rect;
{
    Rect scratch;

    scratch.edge.top = point1->v;
    scratch.edge.bottom = point2->v;
    if (scratch.edge.bottom < scratch.edge.top) {
        scratch.edge.top = point2->v;
        scratch.edge.bottom = point1->v;
    }
    scratch.edge.left = point1->h;
    scratch.edge.right = point2->h;
    if (scratch.edge.right < scratch.edge.left) {
        scratch.edge.left = point2->h;
        scratch.edge.right = point1->h;
    }
    *rect = scratch;
}
