/*
** Given an angle, SlopeFromAngle returns the slope dh/dv of the line forming
** that angle with the y-axis (dh/dv is the horizontal change divided by the
** vertical change between any two points on the line).  The angle is treated
** modulo 180, and is in degrees measured from 12 o'clock; positive degrees
** are measured clockwise, negative degrees are measured counterclockwise (for
** example, 90 degrees is a 3 o'clock and -90 degrees is at 9 o'clock).
** Positive y is down; positive x is to the right.
**
** SlopeFromAngle(45) == 0xFFFF0000 (read as -1 in Fixed type).
** AngleFromSlope(0xFFFF0000) == 45.
**
** This is more-or-less a fixed-point Tangent routine.
*/

#include "../clunkdraw.h"
#include "cdangles.h"

Fixed
SlopeFromAngle(angle)
short angle;
{
    union fixtrig retval;

    if ((angle %= 180) < 0)
        angle += 180;
    retval.words[MSW] = 0x8000; /* Result is assumed negative at first. */
    _tlookup(&retval, angle);
    return retval.fixval;
}
