#include "../clunkdraw.h"
#include "cdangles.h"

/*
** Tables used to look up angles in.
*/

static const char bytetab[] = {
    0x01,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x03,0x03,0x03,0x03,0x04,
    0x04,0x04,0x05,0x05,0x06,0x07,0x08,0x09,0x0B,0x0E,0x13,0x1C,0x39,0xFF
};

static const short angletab[] = {
    0x0000,0x0478,0x08F1,0x0D6B,0x11E7,0x1666,0x1AE8,0x1F6F,
    0x23FA,0x288C,0x2D24,0x31C3,0x366A,0x3B1A,0x3FD4,0x4498,
    0x4968,0x4E44,0x532E,0x5826,0x5D2D,0x6245,0x676E,0x6CAA,
    0x71FB,0x7760,0x7CDC,0x8270,0x881E,0x8DE7,0x93CD,0x99D2,
    0x9FF7,0xA640,0xACAD,0xB341,0xB9FF,0xC0E9,0xC802,0xCF4E,
    0xD6CF,0xDE8A,0xE681,0xEEB9,0xF737,0x0000,0x0919,0x1287,
    0x1C51,0x267F,0x3117,0x3C22,0x47AA,0x53B9,0x605B,0x6D9B,
    0x7B89,0x8A35,0x99AF,0xAA0E,0xBB68,0xCDD6,0xE177,0xF66E,
    0x0CE1,0x24FE,0x3EFC,0x5B19,0x799F,0x9AE7,0xBF5B,0xE77A,
    0x13E3,0x4556,0x7CC7,0xBB68,0x02C2,0x54DB,0xB462,0x2501,
    0xABD9,0x5051,0x1D88,0x24F3,0x83AD,0x6E17,0x4CF5,0x14BD,
    0xA2D7,0x4A30,0xFFFF
};

void
_tlookup(retval, angle)
union fixtrig *retval;
short angle;
{
    if (angle > 90) {           /* Fold into 0..90 degrees. */
        angle = -(angle - 180);
        retval->words[MSW] = 0;
    }
    if (angle >= 45) {          /* Fold into first octant for table lookup. */
        retval->words[MSW]++;   /* From 45 to 63 tan(ang) is >= 1 & < 2. */
        if (angle >= 64) {      /* At 64 degrees, we need real digits. */
            if ((retval->bytes[MSWLSB] = bytetab[angle - 63]) < 0)
                retval->bytes[MSWMSB] |= 0x7F;
        }
    }
    retval->words[LSW] = angletab[angle];
    if (retval->fixval < 0) {
        retval->bytes[MSWMSB] &= ~0x80;
        retval->fixval = -retval->fixval;
    }
}
