/*
** CopyRgn copies the mathematical structure of srcRgn into dstRgn; that is, it
** makes a duplicate copy of srcRgn.  Once this is done, srcRgn may be altered
** (or even disposed of) without affecting dstRgn.  CopyRgn does _not_ create
** the destination region; space must already have been allocated for it.
*/

#include "../clunkdraw.h"
#include <string.h> // For memmove

void
CopyRgn(RgnHandle srcRgn, RgnHandle dstRgn) /* Copy one region over the other. */
{
   int size;

   if (dstRgn && srcRgn && *dstRgn != *srcRgn) { /* Not if they aren't real */
      size = (*srcRgn)->rgnSize;
      SetHandleSize((Handle)dstRgn, size);
      memmove(*dstRgn, *srcRgn, size);
   }
}
