#include "../clunkdraw.h"
#include "cdrgn.h"
#include <stdio.h>

void
DumpRgn(rgn, label)
RgnHandle rgn;
const char *label;
{
   RgnPtr rp;
   short *rps;
   int size;

   if (!rgn || !(rp = *rgn)) {printf("%s no region\n", label); return;}
   printf("%s Region Data:\n"
          "Size: %4d,  Top: %4d, Left: %4d, Bottom: %4d, Right: %4d (%dh %dw)\n",
          label, rp->rgnSize, rp->rgnBBox.edge.top, rp->rgnBBox.edge.left,
          rp->rgnBBox.edge.bottom, rp->rgnBBox.edge.right,
          RectHeight(&rp->rgnBBox), RectWidth(&rp->rgnBBox));
   size = rp->rgnSize - sizeof(RegionHdr);
   if (size < 0) puts("Too small!");
   if (size <= 0) return;
   rps = &rp->rgnData;
   while (*rps != END_TAG && size > 0) {
      printf("Y: %4d, X:", *rps++);
      size -= sizeof *rps;
      while (*rps != END_TAG && size > 0) {
         printf("%4d..%4d, ", rps[0], rps[1]);
         rps += 2;
         size -= 2 * sizeof *rps;
      }
      puts(size ? "$7FFF" : "");
      rps++;                    // Skip over the end-of-X-list
      size -= sizeof *rps;      // marker.
      if (*rps == END_TAG)
         printf("Y: $7FFF");
   }
   puts("");
   rps++; size -= 2;
   if (size > 0) {              // Any leftovers?
      printf("Extra: ");
      while (size > 0) {        // There shouldn't be any.
         size -= sizeof *rps;
         printf("$%4X", *rps++);
         if (size > 0) putchar(',');
      }
      puts("");
   }
}
