#include "../clunkdraw.h"
#define TRUE 1
#define FALSE 0

Boolean
EqualRgn(RgnHandle rgn1, RgnHandle rgn2)
{
   short *p, *q;
   int size;

   if (rgn1 == rgn2 || *rgn1 == *rgn2) return TRUE;
   if (!rgn1 && !rgn2) return TRUE; // Both non-existant, then equal.
   if (!rgn1 || !rgn2) return FALSE; // Either non-existant, then not equal.
   if (EmptyRgn(rgn1) && EmptyRgn(rgn2)) return TRUE; // Both empty, then equal.
   size = (*rgn1)->rgnSize;
   if (size != (*rgn2)->rgnSize) return FALSE; // Different sizes, not equal.
   size /= sizeof(short);
   p = &(*rgn1)->rgnSize;
   q = &(*rgn2)->rgnSize;
   while (size--)               // Compare structures for exact match.
      if (*p++ != *q++) return FALSE; // Any mismatch means not equal.
   return TRUE;                 // Ran the gauntlet, then equal.
}
