// Find the beginning of the region scanline that covers the given
// Y (local) coordinate.  For use on clipping regions that begin
// above where we start drawing.  (By design we should never begin
// drawing where the region hasn't started yet, due to the SectRect
// we have done with all the bounding rectangles.)

#include "../clunkdraw.h"
#include "cdrgn.h"

void
_FastForward(const short **ps, int y)
{
   const short *p;

   p = *ps;
   while (*p != END_TAG) {
      if (*p >= y)
         break;
      *ps = p++;      // This scanline is not yet too far.  Move to it
                      // and skip to the next one.
      while (*p != END_TAG)
         p += 2;        // Skip each X segment.
      p++;           // Skip the End-of-X marker.
   }
}
