//
// FrameRgn draws an outline just inside the specified region, using the
// current grafPort's pen pattern, mode, and size.  The outline is as wide as
// the pen width and as tall as the pen height.  It's drawn with the pnPat,
// according to the pattern transfer mode specified by pnMode.  The outline
// will never go outside the region boundary.  The pen location is not changed
// by this procedure.
//
// Note:  FrameRgn actually does a CopyRgn, an InsetRgn, and a DiffRgn.

#include "../clunkdraw.h"

void
FrameRgn(RgnHandle rgn)
{
   GrafPtr tp;
   RgnHandle temp;

   if (!(tp = thePort)) return;
   if (tp->pnVis >= 0) {
      if (temp = NewRgn()) {
         CopyRgn(rgn, temp);
         InsetRgn(temp, tp->pnSize.h, tp->pnSize.v);
         DiffRgn(rgn, temp, temp);
         PaintRgn(temp);
         DisposeRgn(temp);
      }
   }
}
