#include "../clunkdraw.h"
#include "cdrgn.h"

void
MapRgn(rgn, srcRect, dstRect)
RgnHandle rgn;
const Rect *srcRect, *dstRect;
{
    Point pt;
    short *p;

    if ((*rgn)->rgnSize != sizeof(RegionHdr)) {
        p = &(*rgn)->rgnData;
        while (*p != END_TAG) { /* Do each scanline of the region. */
            pt.v = *p;
            MapPt(&pt, srcRect, dstRect);
            *p++ = pt.v;
            while (*p != END_TAG) { /* Do each X pair of the scanline. */
                pt.h = *p;
                MapPt(&pt, srcRect, dstRect);
                *p++ = pt.h;
                pt.h = *p;
                MapPt(&pt, srcRect, dstRect);
                *p++ = pt.h;
            }
            p++;                /* Bump to next Y coordinate. */
        }
    }
    MapRect(&(*rgn)->rgnBBox, srcRect, dstRect);
}
