#include "../clunkdraw.h"
#include "cdrgn.h"

short *                         // Check for duplicate output scanline.
_CheckDups(short **anchor, short **lastout, short *outptr)
{
   short *p, *q, ii, jj;

   ii = *anchor - *lastout;     // Length of previous scanline.
   jj = outptr - *anchor;       // Length of this scanline
   if (ii-- != jj) {            // Lines differ in length,
      *lastout = *anchor;       // keep this output line.
      *anchor = outptr;
   } else {                     // Same length, are they the same?
      p = *anchor + 1;          // (Skip Y bytes, they're not the same
      q = *lastout + 1;         //  and we don't care.)
      while (ii--) {            // Check all the X byte markers.
         if (*p++ != *q++) {    // Any differences?
            *lastout = *anchor; // Yes, keep the output line.
            *anchor = outptr;
            break;
         }
      }
   }
   return *anchor;
}

void                            // Clean up the output region.
_WrapUp(Rect *lasso, short *outbuf, Rect *urect, short *outptr, RgnHandle dstRgn)
{
   short scanline;
   RgnPtr scratch;

   lasso->edge.top = ((Region *) outbuf)->rgnData;
   lasso->edge.bottom = urect->edge.bottom;
   while (outptr[-1] == END_TAG && outptr[-3] == END_TAG &&
          outptr > &outbuf[5]) { // Is the last scanline empty?
      outptr -= 2;              // Yes, trim it off.
      lasso->edge.bottom = *outptr;
   }
   *outptr++ = END_TAG;         // Put on END_OF_REGION tag.
   scanline = (char *) outptr - (char *) outbuf; // Calculate region's
   if (scanline >= 20) {        // size (in bytes).
      if (scanline == 20) {     // Consists of a single scanline, must be
         RectRgn(dstRgn, lasso); // only a rectangle then.
      } else {                  // Is a for-real complex region.
         ((Region *) outbuf)->rgnSize = scanline; // Put in size.
         ((Region *) outbuf)->rgnBBox = *lasso; // Put in bounding Rect.
         scratch = (RgnPtr) outbuf; // Copy to its final resting place!
         CopyRgn(&scratch, dstRgn);
      }
   } else {                     // Is an empty result (no valid scanlines).
      SetEmptyRgn(dstRgn);
   }
}
