//
// RectInRgn checks whether the given rectangle intersects the specified
// region, and returns TRUE if the intersection encloses at least one bit,
// or FALSE if not.
//
// Note: RectInRgn will sometimes return TRUE when the rectangle merely
//       intersects the region's enclosing rectangle.  If you need to know
//       exactly whether a given rectangle intersects the actual region, you
//       can use RectRgn to set the rectangle to a region, and call SectRgn to
//       see whether the two regions intersect.  If the result of SectRgn is an
//       empty region, then the rectangle doesn't intersect the region.

#include "../clunkdraw.h"
#define FALSE 0

Boolean
RectInRgn(const Rect *r, RgnHandle rgn)
{
   Rect scratch;

   if (!rgn || !*rgn) return FALSE;
   return SectRect(r, &(*rgn)->rgnBBox, &scratch);
}
