/*
** EraseRoundRect paints the specified rounded-corner rectangle with the
** current grafPort's background pattern bkPat (in srcCopy mode).
**
** OvalWidth and ovalHeight specify the diameters of curvature for the
** corners.  The grafPort's pnPat and pnMode are ignored; the pen location
** is not changed.
*/

#include "../clunkdraw.h"
#include "cdrrect.h"

void
EraseRoundRect(rect, ovalWidth, ovalHeight)
const Rect *rect;
int ovalWidth, ovalHeight;
{
    Rect ovlRect;
    GrafPtr tp;

    ovlRect.edge.left = ovlRect.edge.top = 0;
    ovlRect.edge.right = ovalWidth;
    ovlRect.edge.bottom = ovalHeight;
    _DrawRRect(rect, &ovlRect, EraseRgn, 0);
}
