/*
** FillRoundRect fills the specified rounded-corner rectangle with the
** given pattern (in srcCopy mode).  OvalWidth and ovalHeight specify the
** diameters of curvature for the corners.  The grafPort's pnPat, pnMode and
** bkPat are all ignored; the pen location is not changed.
*/

#include "../clunkdraw.h"
#include "cdrrect.h"

void
FillRoundRect(rect, ovalWidth, ovalHeight, pattern)
const Rect *rect;
int ovalWidth, ovalHeight;
const Pattern *pattern;
{
    Rect ovlRect;
    GrafPtr tp;

    ovlRect.edge.left = ovlRect.edge.top = 0;
    ovlRect.edge.right = ovalWidth;
    ovlRect.edge.bottom = ovalHeight;
    _DrawRRect(rect, &ovlRect, FillRgn, (void *) pattern);
}
