/*
** FrameRoundRect draws an outline just inside the specified rounded-corner
** rectangle, using the current grafPort's pen pattern, mode, and size.
** OvalWidth and ovalHeight specify the diameters of curvature for the corners.
** The outline is as wide as the pen width and as tall as the pen height.  It's
** drawn with the pnPat, according to the pattern transfer mode specified by
** pnMode.  The pen location is not changed by this procedure.
*/

#include "../clunkdraw.h"
#include "cdrrect.h"

void
FrameRoundRect(rect, ovalWidth, ovalHeight)
const Rect *rect;
int ovalWidth, ovalHeight;
{
    Rect ovlRect;
    GrafPtr tp;

    tp = thePort;
    ovlRect.edge.left = ovlRect.edge.top = 0;
    ovlRect.edge.right = ovalWidth;
    ovlRect.edge.bottom = ovalHeight;
    _DrawRRect(rect, &ovlRect, FrameRgn, 0);
}
