/*
** InvertRoundRect inverts the pixels enclosed by the specified rounded-corner
** rectangle:  Every white pixel becomes black and every black pixel becomes
** white.  OvalWidth and ovalHeight specify the diameters of curvature for the
** corners.  The grafPort's pnPat, pnMode, and bkPat are all ignored; the pen
** location is not changed.
*/

#include "../clunkdraw.h"
#include "cdrrect.h"

void
InvertRoundRect(rect, ovalWidth, ovalHeight)
const Rect *rect;
int ovalWidth, ovalHeight;
{
    Rect ovlRect;
    GrafPtr tp;

    ovlRect.edge.left = ovlRect.edge.top = 0;
    ovlRect.edge.right = ovalWidth;
    ovlRect.edge.bottom = ovalHeight;
    _DrawRRect(rect, &ovlRect, InvertRgn, 0);
}
