/*
** PaintRoundRect paints the specified rounded-corner rectangle with the
** current grafPort's pen pattern and mode.  OvalWidth and ovalHeight specify
** the diameters of curvature for the corners.
**
** The rounded-corner rectangle is filled with the pnPat, according to the
** pattern transfer mode specified by pnMode.  The pen location is not changed
** by this procedure.
*/

#include "../clunkdraw.h"
#include "cdrrect.h"

void
PaintRoundRect(rect, ovalWidth, ovalHeight)
const Rect *rect;
int ovalWidth, ovalHeight;
{
    Rect ovlRect;
    GrafPtr tp;

    ovlRect.edge.left = ovlRect.edge.top = 0;
    ovlRect.edge.right = ovalWidth;
    ovlRect.edge.bottom = ovalHeight;
    _DrawRRect(rect, &ovlRect, PaintRgn, 0);
}
