// Test the various numeric conversion functions.

#include "../clunkdraw.h"
#include <stdio.h>
#define TRUE 1
#define FALSE 0

void
conversiontest()
{
   char buf[64], *s;
   int ii, scale;
   U32 dw;
   U64 qw;
   char *p;

   dw = 1;
   scale = 1;
   for (ii = 0; ii < 4; ii++) {
      s = FixU32ToStr(buf, sizeof buf, dw, scale, 0, FALSE);
      puts(s);
      if (StrToFixU32(s, &p, scale, FALSE) != dw)
         puts("Err");
      puts(FixU32ToStr(buf, sizeof buf, dw, scale, 0, TRUE));
      scale *= 10;
   }
   dw = ~0;
   scale = 1;
   for (ii = 0; ii < 4; ii++) {
      s = FixU32ToStr(buf, sizeof buf, dw, scale, 0, FALSE);
      puts(s);
      if (StrToFixU32(s, &p, scale, FALSE) != dw)
         puts("Err");
      puts(FixU32ToStr(buf, sizeof buf, dw, scale, 0, TRUE));
      puts(FixU32ToStr(buf, sizeof buf, dw, scale, ii - 1, TRUE));
      scale *= 10;
   }
   puts("End 1");

   qw = ~0;
   scale = 1;
   for (ii = 0; ii < 4; ii++) {
      s = FixU64ToStr(buf, sizeof buf, qw, scale, 0, FALSE);
      puts(s);
      if (StrToFixU64(s, &p, scale, FALSE) != qw)
         puts("Err");
      puts(FixU64ToStr(buf, sizeof buf, qw, scale, 0, TRUE));
      puts(FixU64ToStr(buf, sizeof buf, qw, scale, ii - 1, TRUE));
      scale *= 10;
   }
   puts("End 2");

   qw -= 1005;
   puts(FixU64ToStr(buf, sizeof buf, qw, scale / 10, 0, FALSE));
   puts(FixU64ToStr(buf, sizeof buf, qw, scale / 10, 0, TRUE));
   puts("End 3");

   dw = 0xA8000; // Should be shown as 10.5
   puts(FixU32ToStr(buf, sizeof buf, dw, 65536, 0, FALSE));
   dw = 0xAC000; // Should be shown as 10.75
   puts(FixU32ToStr(buf, sizeof buf, dw, 65536, 0, FALSE));
   dw = 0xA4000; // Should be shown as 10.25
   puts(FixU32ToStr(buf, sizeof buf, dw, 65536, 0, FALSE));
   dw = 0xA2000; // Should be shown as 10.125
   puts(FixU32ToStr(buf, sizeof buf, dw, 65536, 0, FALSE));
   dw = 0x641000; // Should be shown as 100.0625
   puts(FixU32ToStr(buf, sizeof buf, dw, 65536, 0, FALSE));
   dw = 0x640800; // Should be shown as 100.03125
   puts(FixU32ToStr(buf, sizeof buf, dw, 65536, 0, FALSE));
   dw = 0x80019000; // Should be shown as 32,769.5625
   puts(FixU32ToStr(buf, sizeof buf, dw, 65536, 0, TRUE));
   dw = 3; // Should be shown as 1.5
   puts(FixU32ToStr(buf, sizeof buf, dw, 2, 0, FALSE));
   dw = 0x80008000; // Should be shown as -32,767.5
   puts(FixS32ToStr(buf, sizeof buf, (long)dw, 65536, 0, TRUE));
   qw = 1; // Should be shown as 0.0000152587890625
   puts(FixU64ToStr(buf, sizeof buf, qw, 65536, 0, TRUE));
   puts(FixU64ToStr(buf, sizeof buf, qw, 65536, 5, TRUE)); // shown as 0.00001
   qw = 0x80000000; // Should be shown as 0.0000152587890625
   puts(FixU64ToStr(buf, sizeof buf, qw, 1ULL<<47, 0, TRUE));
}
