// Test the various math functions.
procedure mathtest;
var
   a, b, c       : Fixed;
   scratch       : Rect;
   hit           : Point;
   angle, angle2 : smallInt;
begin
   a := Int2Fix(2);
   b := Int2Fix(3);
   c := FixMul(a, b);
   WriteLn('  a: ', FixedS32ToStr(a, 65536, 6, False));
   WriteLn('  b: ', FixedS32ToStr(b, 65536, 6, False));
   WriteLn('a*b: ', FixedS32ToStr(c, 65536, 6, False));
   WriteLn;

   c := FixRatio(2, 3);
   WriteLn(' 2/3: ', FixedS32ToStr(c, 65536, 6, False));
   c := FixRatio(-2, 3);
   WriteLn('-2/3: ', FixedS32ToStr(c, 65536, 6, False));
   c := FixRatio(2, 0);
   WriteLn(' 2/0: ', FixedS32ToStr(c, 65536, 6, False),
           ' ($', HexStr(c, 8), ')');
   c := FixRatio(-2, 0);
   WriteLn('-2/0: ', FixedS32ToStr(c, 65536, 6, False),
           ' ($', HexStr(c, 8), ')');
   c := FixRatio(20, 20);
   WriteLn('20/20: ', FixedS32ToStr(c, 65536, 6, False));

   SetRect(scratch, 10, 20, 30, 40);
   SetPt(hit, 30, 20);
   PtToAngle(scratch, hit, angle);
   WriteLn('Angle: ', angle);

   SetRect(scratch, 10, 20, 30, 40);
   SetPt(hit, 25, 20);
   PtToAngle(scratch, hit, angle);
   WriteLn('Angle: ', angle);

   SetRect(scratch, 10, 20, 30, 40);
   SetPt(hit, 20, 20);
   PtToAngle(scratch, hit, angle);
   WriteLn('Angle: ', angle);

   SetRect(scratch, 10, 20, 50, 40);
   SetPt(hit, 50, 20);
   PtToAngle(scratch, hit, angle);
   WriteLn('Angle: ', angle);

   SetRect(scratch, 10, 20, 50, 40);
   SetPt(hit, 40, 20);
   PtToAngle(scratch, hit, angle);
   WriteLn('Angle: ', angle);

   SetRect(scratch, 10, 20, 50, 40);
   SetPt(hit, 30, 20);
   PtToAngle(scratch, hit, angle);
   WriteLn('Angle: ', angle);
   for angle := 0 to 360 do begin
      a := SlopeFromAngle(angle);
      b := SlopeFromAngle(-angle);
      angle2 := AngleFromSlope(a);
      WriteLn('Slope from Angle ', angle,
              ' is ', FixedS32ToStr(a, 65536, 6, False),
              ' (', FixedS32ToStr(b, 65536, 6, False),
              '), back to Angle ', angle2);
   end;
end;
