/*
** Hack to XOR two pbm files, for comparing the output of the
** C vs Pascal Clunkdraw libraries.
*/

#include <stdio.h>
#include <string.h>

int
main(int argc, char *argv[])
{
   char buf1[BUFSIZ], buf2[BUFSIZ], *p1, *p2;
   FILE *f1, *f2;
   int ii;

   if (argc != 3) {
      puts("Usage: pbmxor file1 file2");
      return 1;
   }
   if (!(f1 = fopen(argv[1], "r"))) {
      puts("Error: can't open file 1");
      return 2;
   }
   if (!(f2 = fopen(argv[2], "r"))) {
      puts("Error: can't open file 2");
      return 3;
   }
   for (ii=0; ii<2; ii++) {
      if (!fgets(buf1, sizeof buf1, f1)) {
         puts("Error reading file 1");
         return 4;
      }
      if (!fgets(buf2, sizeof buf2, f2)) {
         puts("Error reading file 2");
         return 5;
      }
      if (strcmp(buf1, buf2)) {
         puts("Error: files have different headers");
         return 6;
      }
      if (buf1[0] == 'P' && buf1[1] != '1') {
         puts("Error: not a P1 PBM file");
         return 7;
      }
      fputs(buf1, stdout);
   }
   while (fgets(buf1, sizeof buf1, f1)) {
      if (!fgets(buf2, sizeof buf2, f2)) {
         puts("Error: files have different sizes");
         return 8;
      }
      if (buf1[0] == '#') {
         fputs(buf1, stdout);
         continue;
      }
      for (p1=buf1, p2=buf2; *p1; p1++,p2++) {
         if (*p1 == '1' || *p1 == '0') {
            if (*p1 == *p2)
               putchar('0');
            else
               putchar('1');
         }
      }
      putchar('\n');
   }
   return 0;
}
