#include "../clunkdraw.h"
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/input.h>

/*
** Test Clunkdraw's cursor system.
*/
int
main(int argc, char *argv[])
{
   Point mouse;
   int fd, ii;
   struct input_event evt;
   Rect r;

   InitGraf2();
   InitCursor();
   if ((fd = open("/dev/input/event0", O_RDONLY)) >= 0) {
      SetPt(&mouse, 0, 0);
      while ((ii = read(fd, &evt, sizeof evt)) > 0) {
         if (ii != sizeof evt)
            continue;
         switch (evt.type) {
            case EV_REL:        /* Relative mouse move. */
               switch (evt.code) {
                  case REL_X:
                     mouse.h += evt.value;
                     break;

                  case REL_Y:
                     mouse.v += evt.value;
                     break;

                  case REL_WHEEL: /* We don't have a keyboard (yet). */
                     ObscureCursor();
                     DrawChar(evt.value > 0 ? 'T' : 'j');
                     continue;
               }
               mouse = PinRect(&thePort->portRect, &mouse);
               _MoveCursor(&mouse);
               break;

            case EV_KEY:        /* Mouse button. */
               switch (evt.code) {
                  case BTN_LEFT:
                     if (evt.value == 1) {
                        SetRect(&r, mouse.h, mouse.v, mouse.h, mouse.v);
                        InsetRect(&r, -3, -3);
                        PaintOval(&r);
                        MoveTo(mouse.h, mouse.v);
                     }
                  break;

                  case BTN_RIGHT:
                     if (evt.value == 1) {
                        LineTo(mouse.h, mouse.v);
                     }
                  break;

                  case BTN_MIDDLE:
                     if (evt.value == 1) {
                        EraseRect(&thePort->portRect);
                     }
                  break;
               }
               break;
         }
      }
      close(fd);
   }
   EndCursor();
   EndGraf2();

   return 0;
}
