// SpaceExtra sets the current grafPort's spExtra field, which specifies the
// average number of pixels by which to widen each space in a line of text.
// This is useful when text is being fully justified (that is, aligned with
// both a left and a right margin).  The initial spExtra setting is 0.
//
// SpaceExtra will also accept a negative parameter, but be careful not to
// narrow spaces so much that the text is unreadable.  Spaces widened more
// than a certain amount won't look good.  For this reason you should probably
// limit SpaceExtra to a reasonable value, and distribute the rest of any
// necessary extra pixels among the regular characters using TextExtra.
// This is a common typographical technique, incidentally.  The appropriate
// limit will depend on the font size, and to a lesser degree, its appearance.

#include "../clunkdraw.h"

void
SpaceExtra(Fixed extra)
{
   GrafPtr tp;

   if (!(tp = thePort)) return;
   tp->spExtra = extra;
}
