// TextExtra sets the current grafPort's txExtra field, which specifies the
// average number of pixels by which to widen each character in a line of text.
// This is useful when text is being fully justified (that is, aligned with
// both a left and a right margin).  The initial txExtra setting is 0.
//
// TextExtra will also accept a negative parameter, but be careful not to
// narrow gaps so much that the text is unreadable.  Use this when there
// aren't enough space characters to absorb the necessary extra pixels and
// still look good, or for simulating condensed or expanded text styles.

#include "../clunkdraw.h"

void
TextExtra(Fixed extra)
{
   GrafPtr tp;

   if (!(tp = thePort)) return;
   tp->txExtra = extra;
}
