// TextRotate sets the current grafPort's rotation field for drawing text
// (thePort^.txRotate).  The value is in degrees of counterclockwise rotation.
// Text is imaged and spun in that direction, and the pen moves appropriately
// so that successive strings appear along the (new) angled baseline.
//
// Currently limited to multiples of 90 degrees only.

#include "../clunkdraw.h"

void
TextRotate(int degreesCCW)
{
   GrafPtr tp;

   if (!(tp = thePort)) return;
   while (degreesCCW > 360) // Allow 360, forces 2-stage drawing.
      degreesCCW -= 360;
   while (degreesCCW < 0)
      degreesCCW += 360;
   tp->txRotate = degreesCCW;
}
