// TextWidHit returns the index of the closest character 'hit' by the passed
// horizontal offset.  It is used for finding where in a string a mouse hit
// occurs.  It returns both a rounded index (low word) and a truncated index
// (high word).

#include "../clunkdraw.h"
#define FALSE 0

Fixed
TextWidHit(const char *s, short byteCount, short hoffset)
{
   int ii, jj, width, lastwidth;

   ii = -1;
   jj = 1;
   lastwidth = 0;
   if (hoffset >= 0) {
      do {
         width = TextWidth(s, 0, ii);
         if (width >= hoffset)
            break;
         lastwidth = width; // Find hit char.
         if (++ii >= byteCount)
            break;
      } while (FALSE);
      if ((lastwidth + (width - lastwidth) >> 1) < hoffset)
         jj = ii;       // Round to nearest character boundary.
      else
         jj = ii - 1;
   } else {
       ii = -1;
       jj = -1;
   }
   return (ii << 16) | jj;
}
