#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"
#include <stdlib.h>

/*
* _TEAddStarts - re-allocate a larger lineStart array
*/
int
_TEAddStarts(pTE, count)
TERec *pTE;
int count;
{
   int *newPtrs;

   /* allocate space for new pointers */
   newPtrs = malloc(sizeof(int) * (pTE->lsCount + count));
   if (!newPtrs) {      /* no memory, everything is broken      */
      if (pTE->lineStarts) {
         free(pTE->lineStarts);
         pTE->lineStarts = 0;
      }
      if (pTE->hText) {
         free(pTE->hText);
         pTE->hText = 0;
      }
      pTE->teLength = pTE->teMaxLen = 0;
      _TESetSelect(0, 0, pTE);
      TECalText(pTE);
      return -1;
   }

   if (pTE->lineStarts) {
        /* there is already some space allocated, save it off and free it */
      BlockMove(pTE->lineStarts, newPtrs, sizeof(int) * pTE->lsCount);
      free(pTE->lineStarts);
   }

   pTE->lineStarts = newPtrs;
   pTE->lsCount += count;
   return 0;
}
