#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"

/*
* TEDelete - remove text within current selection
*/
void
TEDelete(pTE)
TERec *pTE;
{
   int saveLine, thisLine, oldStart;

   if (pTE->selStart != pTE->selEnd) { /* Delete selection? */
      saveLine = pTE->cursorLine;
      oldStart = pTE->lineStarts[saveLine];
      _TEDelete(pTE); /* Yes. */
      thisLine = _TESelLine(pTE, pTE->selStart);
      if (thisLine < saveLine && pTE->redrawStart != -1 &&
          pTE->redrawStart > pTE->lineStarts[thisLine]) {
         /* delete may have changed wrap point on the           */
         /* line in front of the cursor, redraw the whole line  */
         pTE->redrawStart = pTE->lineStarts[thisLine];
      }
      if (pTE->redrawStart > 0 && oldStart > pTE->lineStarts[thisLine]) {
         /* deletion of white space caused text to be moved             */
         /* to the previous line, so redraw the previous line   */
         pTE->redrawStart = pTE->lineStarts[thisLine - 1];
      }
      _TEUpdate(&pTE->destRect, pTE, 1); /* Re-draw. */
   }
}
