#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"

/*
* _TEHit - determine which character is under a Point
*/
int
_TEHit(pt, pTE, outside, oneLine, round)
Point *pt;
TERec *pTE;
int outside;
Boolean oneLine;
int round;
{
   int xPos, lineNo, centerCount, charCount, offset, adj, vHit, pixLen;
   char *pText;
   Point work;
   long lOffset;

   work = *pt;

   /* calculate the line under the cursor */
   vHit = work.v - pTE->destRect.edge.top + pTE->vOffset;
   lineno = vHit / pTE->lineHeight;

   if (oneLine) { /* do it one line at a time */
      if (lineNo < 0)
         lineNo = -1;
      if (lineNo > pTE->dispLines)
         lineNo = pTE->dispLines;
   }

   /* round it back if it's above the top edge of the rectangle */
   if (vHit < 0 &&
       work.v < pTE->destRect.edge.top && (lineno + pTE->firstLine) > 0) {
      lineNo--;
   }

   /* don't scroll around if not in autoView mode */
   if (!outside) {
      if (lineNo < 0)
         lineNo = 0;
      if (lineNo >= pTE->dispLines)
         lineNo = pTE->dispLines - 1;
      if (work.h < pTE->viewRect.edge.left)
         work.h = pTE->viewRect.edge.left;
      if (work.h > pTE->viewRect.edge.right)
         work.h = pTE->viewRect.edge.right;
   }
   if (pTE->just != teJustLeft)
      work.h += pTE->leanRight;

   /* make it relative to the linestarts array */
   lineNo += pTE->firstLine;

   /* adjust out of range values */
   if (lineNo < 0)
      lineNo = 0;
   if (lineNo > pTE->nLines) {
      pTE->cursorLine = pTE->nLines - 1;
      lineNo = pTE->nLines;
   }

   /* get textwidth from last visible line if beyond end */
   if (lineNo >= pTE->nLines)
      adj = 1;
   else
      adj = 0;

   /* get number of chars, including a trailing wordbreak character */
   charCount = _TELineChars(pTE, lineNo - adj, 1);

   /* build a pointer to the current line */
   pText = pTE->hText + pTE->lineStarts[lineNo - adj];

   /* calculate x position within rectangle */
   if (pTE->just == teJustLeft)
      xPos = pTE->destRect.edge.left;
   else {            /* get length used in calculating display size */
      centerCount = _TELineChars(pTE, lineno - adj, 0);

      pixLen = _TETextWidth(pTE, pText, centerCount);
      if (pTE->just == teJustCenter)
         xPos = ((pTE->destRect.edge.right + pTE->destRect.edge.left) >> 1)
              - (pixlen >> 1);
      else
         xPos = pTE->destRect.edge.right - pixlen;
   }

   xPos -= pTE->hOffset;
   pTE->cursorLine = lineNo - adj;

   if (ptext[0] == '\n')
      return pTE->lineStarts[lineNo];
   lOffset = TextWidHit(pText, charCount, work.h - xPos);
   /* round the result if requested, otherwise use truncated value */
   if (round)
      offset = LoWord(lOffset);
   else
      offset = HiWord(lOffset);
   offset += pTE->lineStarts[lineNo - adj];

   if (offset < pTE->lineStarts[lineNo - adj])
      return pTE->lineStarts[lineNo - adj];
   return offset;
}
