#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"

/*
* TEInsert - insert text at current cursor position
*/
void
TEInsert(text, len, pTE)
char *text;         /* Pointer to new text to insert. */
long len;           /* Length of new text to insert.  */
TERec *pTE;
{
   int ii, jj, lineNo, start, sizeChange, startLine;
   char *p;

   if (pTE->teMaxLen == 0) {
      Bell();
      return;
   }
   if ((long)pTE->teLength + (long)len <= (long)pTE->teMaxLen) {
      /* there's room for the insert */
      ii = pTE->teLength + len;
      /* set up vars for determining what has actually changed */
      start = pTE->selStart;    /* start location of insert */
      sizeChange = len - (pTE->selEnd - pTE->selStart);
      startLine = pTE->lineStarts[_TESelLine(pTE, pTE->selStart)];

      jj = pTE->selEnd;
      p = pTE->hText;
      BlockMove(&p[jj], &p[jj+len], pTE->teLength - jj); /* Open hole first. */
      BlockMove(text, &p[jj], len); /* Insert the character(s).  */
      pTE->teLength = ii;
      pTE->selEnd += len;
      pTE->selStart = pTE->selEnd;

      _TECalText(start, sizeChange, pTE);
      /* don't leave selEnd on a newline */
      if (len && text[len - 1] == '\n') {
         /* newline at the end of the inserted text, */
         /* put the cursor on the following line        */

         /* find the line containing the newline */
         pTE->cursorLine = -1;
         pTE->cursorLine = _TESelLine(pTE, pTE->selEnd) + 1;
      }
      lineNo = _TESelLine(pTE, pTE->selStart);
      if (startLine < pTE->lineStarts[lineNo]) {
         /* insert of white char caused chars left of the cursor        */
         /* to move to the previous line, so the previous line will     */
         /* have to be re-drawn                                 */
         pTE->redrawStart = startLine;
      }

      lineNo = _TESelLine(pTE, pTE->selEnd);
      if (lineNo > pTE->cursorLine &&
          pTE->redrawStart > pTE->lineStarts[lineNo]) {
         /* insert forced a word wrap, so update from the beginning     */
         /* of the word that wrapped    to insure that the end of the   */
         /* previous line gets erased                           */
         pTE->redrawStart = pTE->lineStarts[lineNo];
      }
      _TEUpdate(&pTE->destRect, pTE, 1); /* Re-draw. */

      if (lineNo < pTE->nLines - 1 &&
          pTE->hText[pTE->lineStarts[lineNo + 1]] == '\n' &&
          pTE->selEnd == pTE->lineStarts[lineNo +1]) {
         /* don't leave cursor on a newline */
         pTE->selEnd--;
         pTE->selStart = pTE->selEnd;
      }
   } else
      Bell();
}
