#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"

/*
* _TEInvertRect - Internal text edit routine to invert the selection
*                 range.  (This range may consist of up to 3 rectangles.)
*                 (The selRect in the TERec structure isn't a true
*                 rectangle.  It's really the top left and bottom right
*                 corners of these 3 rectangles.)
*/
void
_TEInvertRect(pTE, hiRect)
TERec *pTE;
Rect *hiRect;
{
   int height, lines, right;
   Rect hRect;

   height = hiRect->edge.bottom - hiRect->edge.top;
   lines = height / pTE->lineHeight;
   if (lines == 1) { /* only one line to contend with */
      InvertRect(hiRect);
   } else {
      right = pTE->destRect.edge.right;
      /* adjust right edge in right justification mode     */
      /* so that the cursor will display proplerly when dragging */
      if (pTE->just == rightJustify)
         right--;

      /* do the (possibly partial) top line first */
      SetRect(&hRect, hiRect->edge.left, hiRect->edge.top,
              right, hiRect->edge.top + pTE->lineHeight);
      InvertRect(&hRect);

      /* catch the full-width block in the middle */
      if (lines > 2) {
         SetRect(&hRect, pTE->destRect.edge.left,
                 hiRect->edge.top + pTE->lineHeight, right,
                 hiRect->edge.bottom - pTE->lineHeight);
         InvertRect(&hRect);
      }
      /* do the (possibly partial) bottom line last */
      SetRect(&hRect, pTE->destRect.edge.left,
              hiRect->edge.bottom - pTE->lineHeight, hiRect->edge.right,
              hiRect->edge.bottom);
      InvertRect(&hRect);
   }
}
