#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"
#include <stdlib.h>

/*
* TENew - initialize a new textedit record
*/
TERec *
TENew(destRect, viewRect)
Rect *destRect;
Rect *viewRect;
{
   TERec *p;
   FontInfo finfo;
   int ii, *teptr;

   /* allocate and zero out a TERec structure */
   p = (TERec *) calloc(1, sizeof(TERec)); /* Create edit record storage. */
   if (!p)
      return 0;

   /* set up TERec's font information */
   GetFontInfo(&finfo);
   p->txFont = thePort->txFont;
   p->txFace = thePort->txFace;
   p->txSize = thePort->txSize;
   p->fontAscent = finfo.ascent;
   if (p->txFace & italicText)
      p->leanRight = finfo.ascent >> 1;
   p->leading = finfo.leading;
   p->lineHeight = finfo.ascent + finfo.descent + finfo.leading;
   p->widMax = finfo.widMax;
   /* save the pixel width of a space */
   p->spaceWidth = _TETextWidth(p, " ", 1);

   /* set up non-zero defaults */
   p->wordBreak = _TEWrdBrk;
   p->autoView = 1;
   p->redrawStart = p->redrawEnd = -1;

   p->destRect = *destRect;
   p->viewRect = *viewRect;

   /* set up initial pointer array */
   if (_TEAddStarts(p, PTRCOUNT)) {
      /* AddStarts failed to get memory */
      free(p);
      return 0;
   }
   return p;
}
