#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"

/*
* _TEPixFromLeft - calculate the number of pixels from the left
*                  margin to the left edge of a given character in a string
*/
int
_TEPixFromLeft(pTE, str, len, chLoc)
TERec *pTE;
char *str;
int len;
int chLoc;
{
   int strWid,          /* skipped string width */
       wsWid,           /* white space width    */
       textWid;         /* pixel width of text  */

   /* calc # of pixels from left of line to left of character */
   strWid = _TETextWidth(pTE, str, chLoc);

   if (pTE->just == leftJustify) {
      /* no white space to the left of the text, add 1 for the cursor */
      return strWid + 1;
   }

   /* calculate the total text width of the entire string on this line */
   textWid = _TETextWidth(pTE, str, len);

   /* calculate the width of white space left of the string */
   if (pTE->just == centerJustify)
      wsWid = (pTE->destRect.edge.right - pTE->destRect.edge.left -
               textWid + 1) >> 1;
   else /* teJustRight */
      wsWid = pTE->destRect.edge.right - textWid
            - pTE->destRect.edge.left - 1;
   return strWid + wsWid - pTE->leanRight;
}
