#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"

/*
* _TEScroll - scroll the display the given number of pixels
*/
void
_TEScroll(h, v, pTE, pinFlag)
int h;
int v;
TERec *pTE;
Boolean pinFlag;
{
   Rect scrollRect;
   int maxFirstLine;

   if (v) {     /* adjust settings for partially displayed line */
      if (pTE->vOffset) {
         pTE->firstLine++;
         pTE->vOffset = pTE->lineHeight - pTE->vOffset;
      }
      /* adjust vertical offset */
      pTE->vOffset += v;
      if (v < 0) {    /* vertical < 0, scroll the display up */
         while (pTE->vOffset <= -pTE->lineHeight) {
            /* more than a line, adjust indicators */
            pTE->vOffset += pTE->lineHeight;
            pTE->firstLine++;
         }

         /* adjust settings for partially displayed line */
         if (pTE->vOffset) {
            pTE->firstLine--;
            pTE->vOffset = pTE->lineHeight - pTE->vOffset;
         }

         while (pTE->vOffset >= pTE->lineHeight) {
            pTE->firstLine++;
            pTE->vOffset -= pTE->lineHeight;
         }

         /* scroll display back up so the last line shows */
         maxFirstLine = pTE->nLines - 1;
         if (pinFlag && pTE->firstLine > 0) {
            maxFirstLine -=
               (((pTE->destRect.edge.bottom - pTE->destRect.edge.top) /
                 pTE->lineHeight) - 1);
            if (maxFirstLine < 0)
               maxFirstLine = 0;
         }
         while (pTE->firstLine > maxFirstLine) {
            v += pTE->lineHeight;
            pTE->firstLine--;
         }
         if (pTE->vOffset && pTE->firstLine == maxFirstLine) {
            /* adjust out the partial first line */
            v += pTE->vOffset;
            pTE->vOffset = 0;
         }

         if (pTE->vOffset < 0) {
            v -= pTE->vOffset;
            pTE->vOffset = 0;
         }
      } else if (v > 0) {       /* vertical > 0, scroll the display down */
         while (pTE->vOffset >= pTE->lineHeight) {
            pTE->vOffset -= pTE->lineHeight;
            pTE->firstLine--;
         }
         while (pTE->firstLine < 0) {
            v -= pTE->lineHeight;
            pTE->firstLine++;
         }

         /* adjust settings for partially displayed line */
         if (pTE->vOffset) {
            pTE->firstLine--;
            pTE->vOffset = pTE->lineHeight - pTE->vOffset;
         }

         if (pTE->firstLine < 0) {
            pTE->firstLine = 0;
            v -= (pTE->lineHeight - pTE->vOffset);
            pTE->vOffset = 0;
         }
      }
   }
   pTE->hOffset -= h;
   if (pTE->hOffset < 0 && pTE->just != rightJustify) {
      h += pTE->hOffset;
      pTE->hOffset = 0;
   }
   if (v || h) {             /* count the number of displayed lines */
      _TEDispLines(pTE);

      /* update the display */
      SectRect(&pTE->viewRect, &pTE->destRect, &scrollRect);
      ScrollRect(&scrollRect, h, v, (void *)-1);

      /* update the selrect coordinates */
      pTE->selRect.edge.top += v;
      pTE->selRect.edge.bottom += v;
      pTE->selRect.edge.left += h;
      pTE->selRect.edge.right += h;

      /* turn the cursor back on, because it'll end up in an area        */
      /* which doesn't get redrawn if it's in a line that was scrolled */
      if (pTE->active && pTE->selEnd == pTE->selStart)
         _TEHilite(pTE, 2, 1);

      if (v) {
         scrollRect = pTE->viewRect;
         if (v < 0) {
            /* scroll up, update bottom of screen */
            scrollRect.edge.top = scrollRect.edge.bottom + v;
         } else {
            /* scroll down, update top */
            scrollRect.edge.bottom = scrollRect.edge.top + v;
         }
         SectRect(&pTE->viewRect, &scrollRect, &scrollRect);
         SectRect(&scrollRect, &pTE->destRect, &scrollRect);
         _TEUpdate(&scrollRect, pTE, 1);
         ValidRect(&scrollRect);
      }
      if (h) {
         scrollRect = pTE->viewRect;
         if (h < 0) {           /* scroll left, update right of screen */
            scrollRect.edge.left = scrollRect.edge.right + h;
         } else {               /* scroll right, update left */
            scrollRect.edge.right = scrollRect.edge.left + h;
         }
         SectRect(&pTE->viewRect, &scrollRect, &scrollRect);
         SectRect(&scrollRect, &pTE->destRect, &scrollRect);
         _TEUpdate(&scrollRect, pTE, 1);
         ValidRect(&scrollRect);
      }
      pTE->redrawStart = -1;
   }
}
