#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"

/*
* _TESelLine - Internal text edit routine, which returns the number
*              of the line in the current display which contains
*              the given offset.
*/
int
_TESelLine(pTE, offset)
TERec *pTE;
int offset;
{
   int count, adj;

   count = pTE->nLines >> 1;
   adj = pTE->nLines >> 2;

   if (offset <= 0)
      return 0;              /* special case for first byte of text */

   /* last line of file */
   if (offset >= pTE->lineStarts[pTE->nLines])
      return pTE->nLines - 1;

   /* perform a binary search to find the line which    */
   /* contains the given offset                 */
   for (;;) {
      if (pTE->lineStarts[count] > offset) {
         /* this line follows the offset, back up a little */
         count -= adj;
      } else if (pTE->lineStarts[count] <= offset &&
                 pTE->lineStarts[count + 1] >= offset) {

         /* the offset is in between these two lines */

         /* check for next line starting on current offset */
         if (pTE->lineStarts[count + 1] == offset) {
            if (pTE->cursorLine == count + 1 ||
                pTE->hText[pTE->lineStarts[count + 1] - 1] == '\n') {
               return count + 1;
            }
         } else if (pTE->lineStarts[count] == offset) {
            if (pTE->cursorLine == count - 1) {
               return count - 1;
            }
         }
         return count;
      } else {
         count += adj;
      }
      /* cut the current offset in half */
      if ((adj >>= 1) == 0)
         adj = 1;
   }
}
