#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"

/*
* _TESelView - shift text display so that cursor is visible
*/
void
_TESelView(scrollFlag, pTE)
Boolean scrollFlag;
TERec *pTE;
{
   int lineNo, newFirstLine, newV, bottom, h, hShift, v, x,
       rectWidth, totWidth, selChar, adjusted;

   /* this routine does nothing if scrollflag is set to 0 or if no text */
   if (!scrollFlag || !pTE->hText)
      return;

   if (pTE->autoView == 2)      /* special setting for selection by dragging */
      selChar = pTE->selStart;
   else                         /* normal setting, align display with selEnd */
      selChar = pTE->selEnd;

   /* get the line number that the cursor's on */
   lineNo = _TESelLine(pTE, selChar);

   /* set up vertical offset if above or below display */
   adjusted = 0;
   v = 0;
   if (lineNo < pTE->firstLine) {
      v = (pTE->firstLine - lineNo) * pTE->lineHeight + pTE->vOffset;
      adjusted = 1;
   } else if (lineNo >= pTE->firstLine + pTE->dispLines) {
      v = ((pTE->firstLine + pTE->dispLines - 1) - lineNo) * pTE->lineHeight;
   }

   /* calculate the first line number and v offset AFTER the scroll */
   newFirstLine = pTE->firstLine;
   newV = v;
   while (newV >= pTE->lineHeight) {
      newFirstLine--;
      newV -= pTE->lineHeight;
   }
   while (newV <= -pTE->lineHeight) {
      newFirstLine++;
      newV += pTE->lineHeight;
   }

   if (!adjusted &&
       pTE->destRect.edge.bottom - pTE->destRect.edge.top >= pTE->lineHeight) {
        /* adjust so cursor line will be completely displayed AFTER scroll */
      if (!adjusted && lineNo == newFirstLine && pTE->vOffset) {
            /* partial line at top, scroll down to disp complete top line */
         v += pTE->vOffset;
      } else {
            /* calculate the bottom pixel of the cursor line after scroll */
         bottom = pTE->destRect.edge.top - pTE->vOffset + newV
                + (pTE->lineHeight * (lineNo - newFirstLine + 1));

         if (bottom > pTE->destRect.edge.bottom) {
                /* bottomline is partially obscured, scroll a little more */
            v -= (bottom - pTE->destRect.edge.bottom);
         }
      }
   }

   h = 0;
   if (pTE->just != centerJustify) {
        /* calculate the width from the left of the string to the cursor */
      x = _TETextWidth(pTE, pTE->hText + pTE->lineStarts[lineNo],
                       selChar - pTE->lineStarts[lineNo]);

      /* set up coordinates to scroll things into view */
      rectWidth = pTE->destRect.edge.right - pTE->destRect.edge.left - 1;
      hShift = rectWidth >> 2;

      if (pTE->just == leftJustify) {
         while (x + h - pTE->hOffset > rectWidth) { /* have to shift it left */
            h -= hShift;
         }
         while (x + h - pTE->hOffset < 0) { /* have to shift it right */
            h += hShift;
         }
      } else if (pTE->just == rightJustify) {
         /* calculate the total string width */
         totWidth = _TETextWidth(pTE, pTE->hText + pTE->lineStarts[lineNo],
                                 _TELineChars(pTE, lineNo, 1));
         while (totWidth - x - h + pTE->hOffset > rectWidth)
            h += hShift;        /* shift it right */

         while (totWidth - x - h + pTE->hOffset < 0)
            h -= hShift;        /* shift it left */
      }
   }
   if (h || v)
      _TEScroll(h, v, pTE, 0);
}
