#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"

/*
* _TESetSelect - internal routine to set up selStart and selEnd
*/
void
_TESetSelect(selStart, selEnd, pTE)
int selStart;
int selEnd;
TERec *pTE;
{
   static int cursorLine = -1;

   if (selStart < 0)    /* Validate the requested selection. */
      selStart = 0;
   else if (selStart > pTE->teLength)
      selStart = pTE->teLength;
   else if (selStart > pTE->teMaxLen)
      selStart = pTE->teMaxLen;

   if (selEnd < selStart)
      selEnd = selStart;
   else if (selEnd > pTE->teLength)
      selEnd = pTE->teLength;
   else if (selEnd > pTE->teMaxLen)
      selEnd = pTE->teMaxLen;

   if (selEnd == pTE->teLength) { /* put cursor on last line */
      pTE->cursorLine = pTE->nLines - 1;
   } else if (selEnd && pTE->hText[selEnd - 1] == '\n') {
        /* end of selection is a newline, bump cursor to next line */
      pTE->cursorLine = _TESelLine(pTE, selEnd);

        /* move it to the following line if it hit on the lower line */
      if (pTE->lineStarts[pTE->cursorLine] < selEnd)
         pTE->cursorLine++;
   }

   if (selStart != pTE->selStart || selEnd != pTE->selEnd ||    /* changed? */
       pTE->cursorLine != cursorLine) {/* not changed, but maybe cursor moved*/
      cursorLine = pTE->cursorLine;
      pTE->selStart = selStart;
      pTE->selEnd = selEnd;

      if (pTE->active)
         _TEHilite(pTE, 2, 1);    /* Change visual selection. */
   }
}
