#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"
#include <stdlib.h>

/*
* _TESetText - allocate memory and set up a TERec for a block of text
*/
void
_TESetText(text, maxLength, selPoint, pTE)
char *text;             /* Work in this text buffer.            */
int maxLength;          /* How big the buffer is.               */
int selPoint;           /* set select at beginning or end       */
TERec *pTE;
{
   int ii, jj;

   /* validate maxlength for above max or below min */
   if (maxLength < 0 || maxLength > MAXLINES)
      maxLength = MAXLINES;

   if (ii = pTE->active)        /* If active, take down old hilighting. */
      _TEHilite(pTE, 0, 1);

   if (pTE->hText)              /* Dispose of old text buffer. */
      free(pTE->hText);

   pTE->hText = malloc(maxLength); /* Get a new one. */
   if (pTE->hText) {
      pTE->teMaxLen = maxLength;
      jj = StringLen(text);
      if (jj > maxLength)
         jj = maxLength;
      pTE->teLength = jj;
      BlockMove(text, pTE->hText, jj);
   } else {
      pTE->teMaxLen = pTE->teLength = 0;
   }

   if (selPoint)
      pTE->selStart = pTE->selEnd = pTE->teLength;
   else
      pTE->selStart = pTE->selEnd = 0;
   pTE->lastselStart = -1;
   pTE->lastselEnd = -1;
   pTE->hOffset = pTE->vOffset = 0;     /* back to the top left corner  */

   TECalText(pTE);
   _TESelView(pTE->autoView, pTE);
   if (ii)                      /* If active, re-hilight buffer. */
      _TEHilite(pTE, 1, 1);
}
