#define TEXTEDIT_SOURCE
#include "../clunkdraw.h"
#include "texted.h"

/*
* _TEUpDown - move cursor up or down
*/
void
_TEUpDown(pTE, rawKey)
TERec *pTE;
int rawKey;
{
   Point pt;
   int selLine, offset, ii, lineHeight, firstLine;

   lineHeight = pTE->lineHeight;
   firstLine = pTE->firstLine;

   if (rawKey == K_UP)
      offset = pTE->selStart;
   else
      offset = pTE->selEnd;

   selLine = _TESelLine(pTE, offset) - firstLine;

   /* calculate the current x/y coordinates of offset */
   pt.v = pTE->destRect.edge.top - pTE->vOffset
        + (lineHeight >> 1) + (lineHeight * selLine);
   pt.h = pTE->destRect.edge.left - pTE->hOffset
        + _TEPixFromLeft(pTE, pTE->hText + pTE->lineStarts[selLine + firstLine],
                         _TELineChars(pTE, selLine + firstLine, 0),
                         offset - pTE->lineStarts[selLine + firstLine]);

   if (rawKey == K_UP) {
      pt.v -= lineHeight;
   } else {
      pt.v += lineHeight;
    }

   ii = _TEHit(&pt, pTE, 1, 0, 1);
   if (ii >= 0) {
      TESetSelect(ii, ii, pTE);
   }
}
