#define PTRCOUNT 32
#define MAXLINES 32000

char *TEscrap;
long TEscrapSize;
int  TEdclickTime;

/*
** Low-level structures.
*/

struct TERec {
        Rect destRect;          /* Rectangle text is drawn in.          */
        Rect viewRect;          /* Rectangle drawing is clipped with.   */
        Rect selRect;           /* Current selection rectangle.         */
        Boolean active;         /* TRUE if highlighted (active).        */
        int (*wordBreak)();     /* Word break routine.                  */
        int lineHeight;         /* Total height of line (of caret).     */
        int widMax;             /* maximum character width              */
        int fontAscent;         /* Ascent of font.                      */
        int leading;            /* leading value of font                */
        int leadOpt;            /* option flag to split leading         */
        int spaceWidth;         /* pixel width of a ' '                 */
        int selStart;           /* Character index of selection start.  */
        int selEnd;             /* Character index of selection end.    */
        int lastselStart;       /* Char index of prev selection start   */
        int lastselEnd;         /* Char index of prev selection end     */
        int redrawStart;        /* first char to redraw                 */
        int redrawEnd;          /* last char to redraw                  */
        int just;               /* Justification flag.                  */
        int teLength;           /* Length (in characters) of text.      */
        int teMaxLen;           /* Maximum length (in char) of text.    */
        char *hText;            /* Pointer to the real text.            */
        int crOnly;             /* if non-zero, new line at Return only */
        int txFont;             /* Which font to use for text.          */
        int txFace;             /* Which font style to use for text.    */
        int txSize;             /* Which size font to use for text.     */
        int leanRight;          /* pixels italics lean past right edge  */
        int autoView;           /* automatic cursor tracking            */
        int vOffset;            /* pixels to offset first line from top */
        int hOffset;            /* pixels to offset lines from edge     */
        int firstLine;          /* Number of first line in display      */
        int dispLines;          /* number of lines in display           */
        int cursorLine;         /* line containing cursor               */
        int nLines;             /* number of lines of text              */
        int *lineStarts;        /* indexes to beginnings of lines       */
        int lsCount;            /* number of lineStart pointers alloc'd */
};

typedef struct TERec TERec;

/* prototypes for internal textedit routines    */
int  _TEHit(Point *pt, TERec *pTE, int outside, int oneLine, int round);
int  _TEScan(int dir, TERec *pTE, int offset);
void _TESetSelect(int selStart, int selEnd, TERec *pTE);
int  _TESelLine(TERec *pTE, int offset);
void _TEScroll(int h, int v, TERec *pTE, int pinFlag);
void _TESelView(int scrollFlag, TERec *pTE);
int  _TEDClickTime(void);
void _TESetText(char *text, int maxLength, int selPoint, TERec *pTE);
int  _TEPixFromLeft(TERec *pTE, char *str, int len, int chIdx);
int  _TELineChars(TERec *pTE, int lineNo, int trailSpace);
void _TECalText(int start, int len, TERec *pTE);
void _TEDispLines(TERec *pTE);
int  _TELineLength(TERec *pTE, char *str, int maxWidth, int bytesInString);
void _TEInvertRect(TERec *pTE, Rect *hiRect);
void _TEUpDown(TERec *pTE, int rawKey);
void _TEDelete(TERec *pTE);
void _TEPartialUpdate(TERec *pTE);
void _TEGoLeft(TERec *pTE);
void _TEGoRight(TERec *pTE);
void _TEBackSpace(TERec *pTE, long key);
void _TEBOL(TERec *pTE);
void _TEEOL(TERec *pTE);
void _TEUpdate(Rect *rUpdate, TERec *pTE, int doEraseFirst);
int  _TETextWidth(TERec *pTE, char *str, int len);
int  _TEAddStarts(TERec *pTE, int count);
void _TEHilite(TERec *pTE, int onOff, int clip);
void _TEDelChar(TERec *pTE);
Boolean _TEWrdBrk(char *text, int charPos);
