// FixMul returns the signed fixed-point product of a and b.  The result is
// computed modulo 65536, truncated, and signed according to the signs of a
// and b.  A positive overflow returns $7FFFFFFF, a negative returns $80000001.
// On the original 68010 this result had to be made out of an intermediate
// 64-bit product elaborately constructed with the 68010's 16x16=32 multiplier.
// It's a lot simpler here!

#include "../clunkdraw.h"

Fixed
FixMul(Fixed multiplicand, Fixed multiplier)
{
   long long product;

   product = (long long)multiplicand * (long long)multiplier;
   return product >> 16;
}
