/*
** CalcVisBehind calculates the visRgns of startWindow and all windows
** behind startWindow that intersect clobberedRgn.  It should be called
** after PaintBehind.
*/

#include "../clunkdraw.h"

void
CalcVisBehind(startWindow, clobberedRgn)
WindowPeek startWindow;
RgnHandle clobberedRgn;
{
    WindowPeek p;
#ifdef UNIONSTRUCT
    WindowPeek p;
#endif
    Rect scratch;
#ifdef UNIONSTRUCT
    short flag;
#endif

    if (p = startWindow) {      /* Quit if at first window or no windows. */
#ifdef UNIONSTRUCT
        flag = 0;
        if (flag) {
            UnionStruc = NewRgn(); /* Start accumulating the union of all */
            u = WindowList;     /* structure windows of windows in front of */
            while (u != p) {    /* the ones we're going to work on.  This is */
                if (u->visible) /* faster than re-doing this all the time. */
                    UnionRgn(UnionStruc, u->strucRgn, UnionStruc);
                u = u->nextWindow;
            }
        }
#endif
        while (p) {             /* For each window from here to the back... */
            CalcVis(p);
#ifdef UNIONSTRUCT
            if (flag)
                UnionRgn(UnionStruc, p->strucRgn, UnionStruc);
#endif
            while (p = p->nextWindow) { /* Go further back in window list. */
                if (p->visible) { /* Skip invisibles */
                    if (SectRect(&(*(p->contRgn))->rgnBBox,
                                 &(*clobberedRgn)->rgnBBox,
                                 &scratch)) { /* and out-of-bounds windows. */
                        break;  /* Cause a CalcVis on this window. */
                    }
#ifdef UNIONSTRUCT
                    if (flag)
                        UnionRgn(UnionStruc, p->strucRgn, UnionStruc);
#endif
                }
            }
        }
#ifdef UNIONSTRUCT
        if (flag)
            DisposeRgn(UnionStruc);
        UnionStruc = 0;         /* Used as a flag too. */
#endif
    }
}
