/*
** CalcVis calculates the visRgn of the given window by starting with its
** content region and subtracting the structure region of each window in
** front of it.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
CalcVis(theWindow)
WindowPeek theWindow;
{
    RgnHandle vr;

    if (theWindow) {
        vr = theWindow->port.visRgn;
        if (theWindow->visible) {
            SectRgn(GrayRgn, theWindow->contRgn, vr);
            _substructrgns(vr, theWindow);
            if (theWindow->port.device == 1) { // Handle e-paper rotated coords.
               OffsetRgn(vr,      // Move to local coordinates.
                         theWindow->port.portBits.bounds.edge.top,
                         theWindow->port.portBits.bounds.edge.left);
            } else {
               OffsetRgn(vr,      // Move to local coordinates.
                         theWindow->port.portBits.bounds.edge.left,
                         theWindow->port.portBits.bounds.edge.top);
            }
        } else
            SetEmptyRgn(vr);
        if (theWindow->saveVisRgn) /* Window being updated? */
            CopyRgn(vr, theWindow->saveVisRgn);
    }
}
