/*
** CheckUpdate is called by the Event Manager.  From the front to the back in
** the window list, it looks for a visible window that needs updating (that is,
** whose update region is not empty).  If it finds one it returns the WindowPtr
** for that window.  If it never finds such a window it returns 0.
**
** It must be called once with the theEvent argument set to 0 to initialize
** the chain, there will be a return value for this call as well.  Each call
** thereafter returns any succeeding dirty window.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

WindowPtr
CheckUpdate(window)
WindowPtr window;
{
    static WindowPeek p = 0;

    if (!window)
        p = WindowList;
    while (p) {
        if (p->visible) {
            if (!EmptyRgn(p->updateRgn)) {
                window = (WindowPtr) p;
                p = p->nextWindow;
                return window;
            }
        }
        p = p->nextWindow;
    }
    return (WindowPtr) p;
}
