/*
** DisposeWindow removes the given window from the screen and deletes it from
** the window list.  It releases the memory occupied by all data structures
** associated with the window, and the memory occupied by the window record
** itself.  Call this procedure when you're done with a window.
**
** Any update events for the window are discarded.  If the window was the
** frontmost window and there was another window behind it, the latter window
** is highlighted and an appropriate activate event is generated.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"
#include <stdlib.h> // For free

void
DisposeWindow(theWindow)
WindowPtr theWindow;
{
    CloseWindow(theWindow);
    free(theWindow);            /* Free its space. */
}
