/*
** Call DrawGrowIcon in response to an update or activate event involving a
** window that contains a size box in its content region.  If theWindow is
** active, DrawGrowIcon draws the size box; otherwise, it draws whatever is
** appropriate to show that the window temporarily cannot be sized.  The exact
** appearance and location of what's drawn depend on the window definition
** function.  For an active document window, DrawGrowIcon draws the size box
** icon in the bottom right corner of the portRect of the window's grafPort,
** along with the lines delimiting the size box itself.  It doesn't do anything
** with the scroll bar areas.  For an inactive document window DrawGrowIcon
** merely erases the size box icon.  The lines are still drawn around the icon.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
DrawGrowIcon(theWindow)
WindowPtr theWindow;
{
    GrafPtr savePort;

    GetPort(&savePort);         /* Work for now in Window Manager's port. */
    SetPort(WMgrPort);
    ClipRect(&(*((WindowPeek) theWindow)->strucRgn)->rgnBBox); /* Minimal */
    ClipAbove((WindowPeek) theWindow); /* clipping because we're trusting. */
    (void) MyWindow(0, (WindowPeek) theWindow, wDrawGIcon, 0);
    SetPort(savePort);
}
