/*
** If the update parameter is TRUE, DrawNew updates the area
**
**      (OldStructure XOR NewStructure) UNION (OldContent XOR NewContent)
**
** where OldStructure and OldContent are the structure and content regions
** saved by the SaveOld procedure, and NewStructure and NewContent are the
** current structure and content regions.  It erases the area and adds it to
** the window's update region.  If update is FALSE, it only erases the area.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
DrawNew(window, update)
WindowPeek window;
Boolean update;
{
    SaveUpdate = update;
    if (window->visible) {
        XorRgn(window->strucRgn, OldStrucRgn, OldStrucRgn);
        XorRgn(window->contRgn, OldContRgn, OldContRgn);
    }
    UnionRgn(OldContRgn, OldStrucRgn, OldStrucRgn);
    DisposeRgn(OldContRgn);
    PaintOne(window, OldStrucRgn);
    SaveUpdate = 1;
    PaintBehind(window->nextWindow, OldStrucRgn);
    CalcVisBehind(window, OldStrucRgn);
    DisposeRgn(OldStrucRgn);
}
