/*
** When a mouse-down event occurs, the system should call FindWindow with
** thePt equal to the point where the mouse button was pressed (in global
** coordinates).  FindWindow tells which part of which window, if any, the
** mouse button was pressed in.  If it was pressed in a window, the whichWindow
** parameter is set to the window pointer; otherwise, it's set to NULL.  The
** (short) integer returned by FindWindow is one of the following predefined
** constants:
**
**      inDesk = 0;
**      inMenuBar = 1;
**      inContent = 3;
**      inDrag = 4;
**      inGrow = 5;
**      inGoAway = 6;
**      inZoom = 7;
**      inSendtoBack = 8;
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

short
FindWindow(thePt, whichWindow)
Point *thePt;
WindowPtr *whichWindow;
{
    short hitval;
    WindowPeek p;
    GrafPtr savePort;

    *whichWindow = 0;
    if ((*GrayRgn)->rgnBBox.edge.top > thePt->v) /* Check for menu bar hit. */
        return inMenuBar;
    GetPort(&savePort);         /* Work for now in Window Manager's port. */
    SetPort(WMgrPort);
    hitval = inDesk;
    p = WindowList;             /* Search out visible window in window list. */
    while (p) {
        if (p->visible) {
            hitval = (long)MyWindow(0, p, wHit, (void *) thePt);
            if (hitval) {
                *whichWindow = (WindowPtr) p;
                hitval += 2;    /* Convert to proper returned values. */
                break;
            }
        }
        p = p->nextWindow;
    }
    SetPort(savePort);
    return hitval;
}
