/*
** Call GrowWindow to move a dotted resizing outline of theWindow around.
** Point delta tells how far to move it.  When sizing, call GrowWindow once
** with the old size and then once with the new size.  Call it once more to
** remove the outline altogether.  It returns TRUE if the window is being
** grown to an acceptable size.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

Boolean
GrowWindow(theWindow, delta, bounds, trackDrag)
WindowPtr theWindow;
const Point *delta;
const Rect *bounds;
int trackDrag;
{
    int retval;
    GrafPtr savePort;

    GetPort(&savePort);         /* Work for now in Window Manager's port. */
    SetPort(WMgrPort);
    SetClip(GrayRgn);
    ClipAbove((WindowPeek) theWindow);
    PenPat(&gray);
    PenMode(notSrcXor);
    retval = (long)MyWindow(0, (WindowPeek) theWindow, wGrow, (void *)delta);
    PenNormal();
    SetPort(savePort);
    return retval;
}
