/*
** HideWindow makes theWindow invisible.  If theWindow is the frontmost window
** and there's a window behind it, HideWindow also unhighlights theWindow,
** brings the window behind it to the front, highlights that window, and
** generates appropriate activate events.  If theWindow is already invisible,
** HideWindow has no effect.
*/

#include "../clunkdraw.h"
#define FALSE 0

void
HideWindow(theWindow)
WindowPtr theWindow;
{
    WindowPtr p;

    p = FrontWindow();          /* Find out the frontmost visible window. */
    ShowHide(theWindow, FALSE); /* Hide the given window. */
    if (theWindow == p) {       /* Hiding the frontmost? */
        HiliteWindow(theWindow, FALSE); /* Unhighlight it. */
        if (p = FrontWindow())  /* And activate the new frontmost window. */
            SelectWindow(p);
    }
}
