/*
** If hilite is TRUE, this procedure highlights theWindow if it's not already
** highlighted and has no effect if it is already highlighted.  If hilite is
** FALSE, HiliteWindow unhighlights theWindow if it is highlighted and has no
** effect if it's not highlighted.  The exact way a window is highlighted
** depends on the window definition function (the window type).
**
** Normally you won't have to call this procedure, since you should call
** SelectWindow to make a window active, and SelectWindow takes care of the
** necessary highlighting changes.  Highlighting a window that isn't the active
** window is contrary to good user interface design practices.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
HiliteWindow(theWindow, hilite)
WindowPtr theWindow;
Boolean hilite;                 /* TRUE to highlight, FALSE to unhilight. */
{
    GrafPtr savePort;

    if (hilite != ((WindowPeek) theWindow)->hilited) {
        ((WindowPeek) theWindow)->hilited = hilite;
        GetPort(&savePort);
        SetPort(WMgrPort);      /* Work in window manager's port. */
                /* Clip drawing to the structure region of the window. */
/*      SetClip(((WindowPeek) theWindow)->strucRgn); /* Deleted for speed. */
/*ClipRect(&WMgrPort.portRect); /* For speed, we draw unclipped into the */
                                /* Window Manager's port if we can.  This */
                                /* is possible because we trust the */
                                /* MyWindow() function. */
        ClipRect(&(*((WindowPeek) theWindow)->strucRgn)->rgnBBox); /* " */

                /* Don't draw over parts of windows that obscure us. */
        ClipAbove((WindowPeek) theWindow);
                /* Redraw the window frame with appropriate highlighting. */
        (void) MyWindow(0, (WindowPeek) theWindow, wDraw, 0);
        SetPort(savePort);
    }
}
