/*
** InitWindows initializes the Window Manager.  It creates the Window Manager
** port; you can get a pointer to this port with the GetWMgrPort procedure.
** InitWindows draws the desktop.  Call this routine once before all other
** Window Manager routines.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"
#include <stdlib.h> // For calloc

void
InitWindows()
{
   GrafPtr savePort;

   GetPort(&savePort);          /* Because of OpenPort(). */
   WindowList = (WindowPeek) 0; /* Init linked list of windows. */
   WMgrPort = calloc(1, sizeof(WindowRecord));
   OpenPort(WMgrPort);         /* Create the window mgr grafport. */
   if (savePort) {              // Propagate the hooks and etc. from first port.
      if ((WMgrPort->device = savePort->device) == 1)
         RotRect(&WMgrPort->portRect, &WMgrPort->portRect);
      WMgrPort->_fontHook = savePort->_fontHook;
      WMgrPort->_SetPix = savePort->_SetPix;
      WMgrPort->_ClearPix = savePort->_ClearPix;
      WMgrPort->_FlipPix = savePort->_FlipPix;
   }
   if (!WMgrPort->visRgn) {
      WMgrPort->visRgn = NewRgn();
      RectRgn(WMgrPort->visRgn, &WMgrPort->portRect);
   }
   if (!WMgrPort->clipRgn) {
      WMgrPort->clipRgn = NewRgn();
      RectRgn(WMgrPort->clipRgn, &WMgrPort->portRect);
   }
   DeskPattern = gray;          /* Desktop pattern. */
   GrayRgn = NewRgn();          /* Desktop region. */
   RectRgn(GrayRgn, &WMgrPort->portRect);
   SetClip(GrayRgn);
   FillRect(&WMgrPort->portRect, &DeskPattern); /* Paint the desktop. */
   SetPort(savePort);
   SaveUpdate = PaintWhite = 1;
   _menubar = 0;
}
