/*
** InvalRect accumulates the given rectangle into the update region of the
** window whose grafPort is the current port.  This tells the Window Manager
** that the rectangle has changed and must be updated.  The rectangle is given
** in local coordinates and is clipped to the window's content region.
**
** For example, suppose your application scrolls up text in a document window
** and wants to show new text added at the bottom of the window.  You can cause
** the added text to be redrawn by accumulating that area into the update
** region with InvalRect.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
InvalRect(badRect)
const Rect *badRect;
{
    _dovalinval(badRect, (RgnHandle) 0, UnionRgn);
}
