/*
** PaintBehind calls PaintOne for startWindow and all the windows behind
** startWindow, clipped to clobberedRgn.
**
** PaintBehind clears the variable PaintWhite before calling PaintOne, so
** clobberedRgn isn't erased.  (PaintWhite is re-set after the call to
** PaintOne.)
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
PaintBehind(startWindow, clobberedRgn)
WindowPeek startWindow;
RgnHandle clobberedRgn;
{
    GrafPtr savePort;
    RgnHandle scratch;
    WindowPeek p;
#ifdef UNIONSTRUCT
    WindowPeek u;
    short flag;
#endif

    GetPort(&savePort);         /* Work for now in Window Manager's port. */
    SetPort(WMgrPort);

    CopyRgn(clobberedRgn, WMgrPort->clipRgn); /* Re-paint the newly exposed */
    ClipAbove(startWindow);     /* desktop (if any). */
    scratch = NewRgn();
    CopyRgn(WMgrPort->clipRgn, scratch);
    _paintdesk();

    DiffRgn(scratch, WMgrPort->clipRgn, scratch);
    ClipRect(&WMgrPort->portRect);
    EraseRgn(scratch);          /* Blot out (re)exposed areas. */
    DisposeRgn(scratch);

    p = startWindow;
#ifdef UNIONSTRUCT
    flag = 0;
    if (flag) {
        UnionStruc = NewRgn();  /* Start accumulating the union of all the */
        u = WindowList;         /* structure windows of windows in front of */
        while (u != p) {        /* the ones we're going to work on.  This is */
            if (u->visible)     /* faster than re-doing this all the time. */
                UnionRgn(UnionStruc, u->strucRgn, UnionStruc);
            u = u->nextWindow;
        }
    }
#endif
    while (p) {                 /* While there are windows to do... */
        if (p->visible) { /* (Re-draw the insides if the bkPat's not white */
            PaintWhite = ((* (long *) &p->port.bkPat.bytes[0]) |
                          (* (long *) &p->port.bkPat.bytes[4]));
            PaintOne(p, clobberedRgn); /* re-paint the visible ones while */
#ifdef UNIONSTRUCT
            if (flag)
                UnionRgn(UnionStruc, p->strucRgn, UnionStruc);
#endif
        }
        p = p->nextWindow;      /* moving rearwards through the list. */
    }
#ifdef UNIONSTRUCT
    if (flag)
        DisposeRgn(UnionStruc);
    UnionStruc = 0;             /* Used as a flag too. */
#endif
    PaintWhite = 1;             /* Normal state. */
    SetPort(savePort);
}
