/*
** SaveOld saves the given window's current structure region and content region
** for the DrawNew operation (see below).  It must be balanced by a subsequent
** call to DrawNew.  It is _not_ nestable.
*/

#include "../clunkdraw.h"

static RgnHandle OldStrucRgn = 0;
static RgnHandle OldContRgn = 0;

void
SaveOld(window)
WindowPeek window;
{
    OldStrucRgn = NewRgn();
    CopyRgn(window->strucRgn, OldStrucRgn);
    OldContRgn = NewRgn();
    CopyRgn(window->contRgn, OldContRgn);
}
