/*
** SetWTitle sets theWindow's title to the given string, performing any
** necessary redrawing of the window frame.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
SetWTitle(theWindow, title)
WindowPtr theWindow;
char *title;
{
    RgnHandle scratch;
    GrafPtr savePort;
    char *p;

    GetPort(&savePort);
    SetPort(WMgrPort);          /* Work in window manager's port. */
    scratch = NewRgn();
    CopyRgn(((WindowPeek) theWindow)->strucRgn, scratch);
    DisposeHandle(((WindowPeek) theWindow)->titleHandle);
    p = 0;
    if (((WindowPeek) theWindow)->titleHandle = NewHandle(StringLen(title)+1))
        p = (char *) *((WindowPeek) theWindow)->titleHandle;
    TextFont(0);
    TextSize(0);
    ((WindowPeek) theWindow)->titleWidth = StringWidth(title);
    if (p)
        while (*p++ = *title++) /* Copy the title. */
            ;
    _newregions((WindowPeek) theWindow);        /* Frame area changed? */
    if (EqualRgn(scratch, ((WindowPeek) theWindow)->strucRgn)) {
        DiffRgn(scratch, ((WindowPeek) theWindow)->contRgn, scratch);
        PaintOne((WindowPeek) theWindow, scratch); /* No, only redraw it. */
    } else {                    /* Yes, redo all behind windows too. */
        UnionRgn(((WindowPeek) theWindow)->strucRgn, scratch, scratch);
        DiffRgn(scratch, ((WindowPeek) theWindow)->contRgn, scratch);
        PaintBehind((WindowPeek) theWindow, scratch);
        CalcVisBehind((WindowPeek) theWindow, scratch);
    }
    DisposeRgn(scratch);
    SetPort(savePort);
}
