/*
** If showFlag is TRUE, ShowHide makes theWindow visible if it's not already
** visible and has no effect if it's already visible.  If showFlag is FALSE,
** ShowHide makes theWindow invisible if it's not already invisible and has no
** effect if it is already invisible.  Unlike HideWindow and ShowWindow,
** ShowHide never changes the highlighting or front-to-back ordering of windows
** or generates activate events.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
ShowHide(theWindow, showFlag)
WindowPtr theWindow;
Boolean showFlag;
{
    GrafPtr savePort;

    if (((WindowPeek) theWindow)->visible != showFlag) {
        GetPort(&savePort);
        SetPort(WMgrPort);      /* Work in window manager's port. */
        SaveOld((WindowPeek) theWindow);
        ((WindowPeek) theWindow)->visible = showFlag;
        _newregions((WindowPeek) theWindow);
        DrawNew((WindowPeek) theWindow, 1);
        SetPort(savePort);
    }
}
