/*
** ShowWindow makes theWindow visible.  It does not change the front-to-back
** ordering of the windows.  Remember that if you previously hid the frontmost
** window with HideWindow, HideWindow will have brought the window behind it
** to the front; so if you then do a ShowWindow of the window you hid, it will
** no longer be frontmost.  If theWindow is already visible, ShowWindow has
** no effect.
**
** Note:  Although it's inadvisable, you can create a situation where the
**        frontmost window is invisible.  If you do a ShowWindow of such a
**        window, it will highlight the window if it's not already highlighted
**        and will generate an activate event to force this window from
**        inactive to active.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
ShowWindow(theWindow)
WindowPtr theWindow;
{
    WindowPeek p;

    p = WindowList;
    if (p == (WindowPeek) theWindow && !p->visible)
        SelectWindow(theWindow);
    ShowHide(theWindow, 1);
}
