/*
** SizeWindow enlarges or shrinks the portRect of theWindow's grafPort to the
** width and height specified by w and h, or does nothing if w and h are 0.
** The window's position on the screen does not change.  The new window frame
** is drawn; if the width of a document window changes, the title is again
** centered in the title bar, or is truncated if it no longer fits.  If
** fUpdate is TRUE, SizeWindow accumulates any newly created area of the
** content region into the update region; normally this is what you'll want.
** If you pass FALSE for fUpdate, you're responsible for the update region
** maintenence yourself.  For more information, see InvalRect and ValidRect.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
SizeWindow(theWindow, w, h, fUpdate)
WindowPtr theWindow;
int w, h;
int fUpdate;
{
    GrafPtr savePort;

    if (w || h) {
        if (h)
            theWindow->portRect.edge.bottom = theWindow->portRect.edge.top + h;
        if (w)
            theWindow->portRect.edge.right = theWindow->portRect.edge.left + w;
        if (((WindowPeek) theWindow)->visible) {
            GetPort(&savePort); /* Work for now in Window Manager's port. */
            SetPort(WMgrPort);
            SaveOld((WindowPeek) theWindow);
            _redo_wind(theWindow, fUpdate);
            SetPort(savePort);
        }
    }
}
