/*
** Whenever there's a mouse-down in one of the title-bar controls of theWindow
** (as reported by FindWindow), the application should repeatedly call TrackBox
** with thePt equal to the current mouse point (in global coordinates).  The
** partCode parameter should contain the value returned by FindWindow. TrackBox
** will take care of highlighting the proper part of the control, and will
** return TRUE or FALSE depending upon whether thePt is within the appropriate
** part of the title bar.  The application should stop calling TrackBox when
** the mouse button is released, and if the last returned value was TRUE (from
** the event containing the mouse-up) it should call TrackBox once more with an
** 'impossible' value for thePt.  This will clear the highlighting.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

Boolean
TrackBox(theWindow, thePt, partCode)
WindowPtr theWindow;
Point *thePt;
int partCode;
{
    GrafPtr savePort;
    int i;

    GetPort(&savePort);
    SetPort(theWindow);
    i = (long)MyWindow(0, (WindowPeek) theWindow, wHit, (void *) thePt) + 2;
    SetPort(WMgrPort);
    SetClip(GrayRgn);
    ClipAbove((WindowPeek) theWindow);
    (void) MyWindow(partCode, (WindowPeek)theWindow, wDraw,
                    (void *)(i == partCode));
    SetPort(savePort);
    return i == partCode;
}
