/*
** ValidRect removes goodRect from the update region of the window whose
** grafPort is the current port.  This tells the window manager that the
** application has already drawn the rectangle and to cancel any updates
** accumulated for that area.  The rectangle is clipped to the window's
** content region and is given in local coordinates.  Using ValidRect
** results in better performance and less redundant redrawing in the window.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
ValidRect(goodRect)
const Rect *goodRect;
{
    _dovalinval(goodRect, (RgnHandle) 0, DiffRgn);
}
