#include "../clunkdraw.h"

/*
** Internal function for ValidRect, InvalRect, ValidRgn, and InvalRgn.
** It does all the work.
*/

void
_dovalinval(theRect, theRegion, function)
const Rect *theRect;            /* Either the Rectangle or the */
RgnHandle theRegion;            /* Region to do. */
void (*function)();             /* Ptr to function to do [Union|Diff]Rgn. */
{
   GrafPtr tp;
   RgnHandle scratch;

   tp = thePort;
   scratch = NewRgn();
   if (theRegion)               /* Do both rectangles and regions as req'd. */
      CopyRgn(theRegion, scratch);
   else
      RectRgn(scratch, theRect);
   if (tp->device == 1) {       // Handle weird e-paper rotated coords.
      OffsetRgn(scratch,        // Move to global coordinates
                -tp->portBits.bounds.edge.top,   // (the same ones the
                -tp->portBits.bounds.edge.left); // updateRgn is in).
   } else {
      OffsetRgn(scratch,        /* Move to global coordinates */
                -tp->portBits.bounds.edge.left, /* (the same ones the */
                -tp->portBits.bounds.edge.top); /* updateRgn is in). */
   }
   SectRgn(scratch, ((WindowPeek) tp)->contRgn, scratch);
   (*function)(((WindowPeek) tp)->updateRgn, scratch,
               ((WindowPeek) tp)->updateRgn);
   DisposeRgn(scratch);
}
