/*
** ZoomWindow provides (in a single call) the action of both a MoveWindow and
** a SizeWindow.  A new rectangle (in global coordinates) is provided for it
** to change the window's content region to.  If the front parameter is TRUE,
** the window will be brought to the front; otherwise, the window is left where
** it is.  (This means a window can be zoomed without necessarily becoming the
** active window.
*/

#include "../clunkdraw.h"
#include "cdwmdata.h"

void
ZoomWindow(theWindow, newRect, makeFront)
WindowPtr theWindow;
const Rect *newRect;
Boolean makeFront;
{
    GrafPtr savePort;

    GetPort(&savePort);         /* Work for now in Window Manager's port. */
    SetPort(WMgrPort);
    _newregions((WindowPeek) theWindow);
    SaveOld((WindowPeek) theWindow);
    _move_Wcoords(theWindow, newRect->edge.left, newRect->edge.top,
                 (RgnHandle) 0);
    theWindow->portRect.edge.bottom = theWindow->portRect.edge.top +
        (newRect->edge.bottom - newRect->edge.top);
    theWindow->portRect.edge.right = theWindow->portRect.edge.left +
        (newRect->edge.right - newRect->edge.left);
    _redo_wind(theWindow, 1);
    if (makeFront) {            /* If making window frontmost then do so. */
        DragFlag = 1;           /* It moved too. */
        _doSelect(theWindow);
    }
    SetPort(theWindow);         /* For InvalRect. */
    InvalRect(&theWindow->portRect);
    SetPort(savePort);
}
